#!/usr/bin/python


#from stringTable import *

#-- For now  diable paos support
#from Schema import *

import strop

false,true = 0,1

AttributeNotOverloaded = "plugin.AttributeNotOverloaded"
RequiredAttributeMissing = "plugin.RequiredAttributeMissing"

Rect = ("left","top","width","hieght")



"""
Base class for all plugins. All plugins must derive off
of this class. It is derived off of DBobject which allows
it to be stored in the Paos database.
"""

#This is for when the plugin registry is ready.
#class plugin(DBobject):
#	def __init__(self):
#		DBobject.__init__(self)

class plugin:
	def __init__(self):
		pass


	# The returning string matches this plugin with its
	# xml tag counterpart. For example if nameOf() returns
      	# "foo" then it is responsible for implementing
      	# "<foo ... >" tags.
      	def nameOf(self):
		msg = "derived class must overload nameOf method!"
		raise AttributeNotOverloaded, msg

      	# Checks to see if a tag is valid. This supersedes the
      	# need for dtds. Each plugin may or may not validate. 
      	# If not we just return true. 				
      	def isValid(self, obj):
		return true

      	# Executes tag. We are issued a unique id which we must use
      	# for our messaging.
      	def call(self, obj, control):
		self.control = control

      	# Used for version control of objects
      	# return a tuple (major,minor) version numbers.
      	def version(self):
		return (0,0)
		
	def clone(self):
		return self

	def texthandler(self, obj):
		msg ="""
		If useText returns true you must overload 
		this method to capture the text
		"""		
		raise AttributeNotOverloaded, msg		

	# overload if you want to attach the text that follows a tag
	# to an attribute called text, processing of the widget will 
	# postponed until the end of the next piece of text in the xml
	# file. Text is anything not inside <>.
	#
	# Example:
	# 	We want to impliment a textbox so that it looks like this
	# in the xml file:
	#
	# <textbox left=100 top=100 width=200 hieght=200>
	# This text will be inside the text box, we must hold off on 
	# processing the textbox tag until we have assigned this text to 
	# an attribute called "text"
	# </textbox> 	
	def useText(self):
		return false





"""
	Qt specific XML plugins
"""


frame_flags = { 
	"NOFRAME"  :     0, 
	"BOX"      : 0x0001,
	"PANEL"    : 0x0002, 
	"WINPANEL" : 0x0003, 
	"HLINE"    : 0x0004,
        "VLINE"    : 0x0005, 
	"MSHAPE"   : 0x000f, 
	"PlAIN"    : 0x0010, 
	"RAISED"   : 0x0020,
	"SUNKEN"   : 0x0030,
	"MSHADOW"  : 0x00f0
	} 

from pythonqt import *
QtApp = Application()


"""
Qt family of plugins. 
"""
class qtplugin(plugin):
	def __init__(self, parent=None):	
		plugin.__init__(self)
		self.parent = parent
		self.prop = {}
		self._obj = None
		self.slottable = {}
		self.gridlayout = None
		
	def setMainWidget(self):		
#		global QtApp, TopNode
#		QtApp.setMainWidget(self.w)
#		TopNode = self.w

		self.control.mainwidget = self.w
		
	def setTopLevel(self, x):
		self.toplevel = x
		
	def getTopLevel(self):
		return self.toplevel

	def addSlot(self, signal, module, method):
		self.slottable[signal] = (module,method)

	def setParent(self, p):
		self.parent = p

	def getWidget(self):
		if hasattr(self,"w"):
			return self.w
		else:
			return None	

	def frameStyle(self, w, obj):
		if not hasattr(w,"setFrameStyle"): return
		global frame_flags
		
		flags = 0
		for (k,v) in frame_flags.items():
			if obj.has_key(k) == true:
				flags = flags + v
		
		w.setFrameStyle(flags)
		
	# determe if manditory attributs exist if they
	# do then add to prop dictionary	
	def hasManditoryAttributes(self, ref, obj):
		for r in ref:
			if obj.has_key(r) == false:
				print "Unable to find a match for ",r
				return false
			self.prop[r] = obj[r]							
		return true		

	def setCaption(self, w, obj):
		if obj.has_key("caption") == true:
			self.w.setCaption(obj["caption"])

	def setGeometry(self, obj):
		p,q = [], Rect 
		#("left","top","width","hieght")
		for k in q:
			if obj.has_key(k):
				p.append( obj[k] )
		if len(p) != len(q):
			if len(p) > 0:
				msg = """
Incomplete geometry specification. If you supply one of the
left,top,width or hieght parameters you must supply them all
				"""
				print msg 
				return false
			return true

		self.w.setGeometry(p[0], p[1], p[2], p[3])
		return true

	# returns the text associated with this widget.
	# This is usefule in widgets that have text associated
	# with them like labels, textboxes ect.
	def text(self, t=None):
		return ""		

	def call(self, obj, control):
		plugin.call(self, obj, control)
		self.create_layout(obj)
		self.add_to_layout(obj)

				
	
	# the add_to_layout adds this widget to  
	def add_to_layout(self, obj):
		try:
			if self.parent.gridlayout == None: return
		except:
			return
				
		if obj.has_key("add_to_layout") == false:
			return 	
			
		if obj.has_keys(("fromRow", "toRow", "fromCol", "toCol")) == true:
			fromRow,toRow,fromCol,toCol = \
				obj["fromRow"], obj["toRow"], \
				obj["fromCol"], obj["toCol"]
			self.parent.gridlayout.addMultiCellwidget(self.w, fromRow, toRow, fromCol, toCol)

		if obj.has_keys(("row", "col")) == true:
			row,col=obj["row"],obj["col"]
			self.parent.gridlayout.addMultiCellwidget(self.w, row, col)
			
	# the layout keyword creates a grid layout
	def create_layout(self, obj):
		if obj.has_key("layout") == false:
			return 	
		
		# rows or cols creates a layout
		rows, cols = 1, 1
		if obj.has_key("rows"):
			rows = strop.atoi( obj["rows"] )
		if obj.has_key("cols"):
			cols = strop.atoi( obj["cols"] )
				
		self.gridlayout = GridLayout( self.w, rows, cols )
