class QPixmap : public QPaintDevice
{
public:
  enum ColorMode { Auto, Color, Mono };

  QPixmap();
  %name(QPixmapSize) QPixmap(int w, int h, int depth=-1);
  //QPixmap (const QSize&, int depth=-1);
  %name(PixmapFile) QPixmap (const char* fileName, 
			     const char* format=0, ColorMode mode=Auto); 
  //%name(PixmapData) QPixmap (const char* xpm[]); 
  %name(PixmapCopy) QPixmap (const QPixmap&) ;
  ~QPixmap () ;
  //QPixmap& operator= (const QPixmap&); 
  //QPixmap& operator= (const QImage&) ;
  bool isNull () const ;
  int width () const ;


  int height () const ;
  //QSize size () const ;
  //QRect rect () const ;
  int depth () const ;
  //void fill (const QColor& fillColor=white); 
  //void fill (const QWidget*, int xofs, int yofs); 
  //void fill (const QWidget*, const QPoint& ofs) ;
  void resize (int width, int height) ;
  //void resize (const QSize&) ;
  const QBitmap* mask () const; 
  void setMask (const QBitmap&); 
  bool selfMask () const ;
  QBitmap createHeuristicMask (bool clipTight = TRUE) const; 
  //QPixmap xForm (const QWMatrix&) const ;
  //QImage convertToImage () const ;
  //bool convertFromImage (const QImage&, ColorMode mode=Auto); 
  bool load (const char* fileName, const char* format=0, ColorMode
	     mode=Auto) ;
  bool loadFromData (const uchar* buf, uint len, const char*
		     format=0, ColorMode mode=Auto); 
  bool save (const char* fileName, const char* format) const; 
  int serialNumber () const ;
  bool isOptimized () const ;
  void optimize (bool) ;
  virtual void detach (); 
  bool isQBitmap () const ;

  static int defaultDepth () ;
  //static QPixmap grabWindow (WId, int x=0, int y=0, int w=-1, int h=-1); 
  //QWMatrix trueMatrix (const QWMatrix&, int w, int h) ;
  const char* imageFormat (const char* fileName) ;
  bool isGloballyOptimized () ;
  void optimizeGlobally (bool) ;
};
