/*
 * FILE : pythonqt_wrap.c
 * 
 * This file was automatically generated by :
 * Simplified Wrapper and Interface Generator (SWIG)
 * Version 1.1  (Final)
 * 
 * Portions Copyright (c) 1995-1997
 * The University of Utah and The Regents of the University of California.
 * Permission is granted to distribute this file in any manner provided
 * this notice remains intact.
 * 
 * Do not make changes to this file--changes will be lost!
 *
 */


#define SWIGCODE
/* Implementation : PYTHON */

#define SWIGPYTHON
#include <string.h>
#include <stdlib.h>
/***********************************************************************
 * $Header:$
 * swig_lib/python/python.cfg
 *
 * This file contains coded needed to add variable linking to the
 * Python interpreter.   C variables are added as a new kind of Python
 * datatype.
 *
 * Also contains supporting code for building python under Windows
 * and things like that.
 *
 * $Log:$
 ************************************************************************/

#ifdef __cplusplus
extern "C" {
#endif
#include "Python.h"
#ifdef __cplusplus
}
#endif

/* Definitions for Windows/Unix exporting */
#if defined(__WIN32__)
#   if defined(_MSC_VER)
#	define EXPORT(a,b) __declspec(dllexport) a b
#   else
#	if defined(__BORLANDC__)
#	    define EXPORT(a,b) a _export b
#	else
#	    define EXPORT(a,b) a b
#	endif
#   endif
#else
#   define EXPORT(a,b) a b
#endif

#ifdef SWIG_GLOBAL
#ifdef __cplusplus
#define SWIGSTATIC extern "C"
#else
#define SWIGSTATIC
#endif
#endif

#ifndef SWIGSTATIC
#define SWIGSTATIC static
#endif

typedef struct {
  char  *name;
  PyObject *(*get_attr)(void);
  int (*set_attr)(PyObject *);
} swig_globalvar;

typedef struct swig_varlinkobject {
  PyObject_HEAD
  swig_globalvar **vars;
  int      nvars;
  int      maxvars;
} swig_varlinkobject;

/* ----------------------------------------------------------------------
   swig_varlink_repr()

   Function for python repr method
   ---------------------------------------------------------------------- */

static PyObject *
swig_varlink_repr(swig_varlinkobject *v)
{
  return PyString_FromString("<Global variables>");
}

/* ---------------------------------------------------------------------
   swig_varlink_print()

   Print out all of the global variable names
   --------------------------------------------------------------------- */

static int
swig_varlink_print(swig_varlinkobject *v, FILE *fp, int flags)
{

  int i = 0;
  fprintf(fp,"Global variables { ");
  while (v->vars[i]) {
    fprintf(fp,"%s", v->vars[i]->name);
    i++;
    if (v->vars[i]) fprintf(fp,", ");
  }
  fprintf(fp," }\n");
  return 0;
}

/* --------------------------------------------------------------------
   swig_varlink_getattr
 
   This function gets the value of a variable and returns it as a
   PyObject.   In our case, we'll be looking at the datatype and
   converting into a number or string
   -------------------------------------------------------------------- */

static PyObject *
swig_varlink_getattr(swig_varlinkobject *v, char *n)
{
  int i = 0;
  char temp[128];

  while (v->vars[i]) {
    if (strcmp(v->vars[i]->name,n) == 0) {
      return (*v->vars[i]->get_attr)();
    }
    i++;
  }
  sprintf(temp,"C global variable %s not found.", n);
  PyErr_SetString(PyExc_NameError,temp);
  return NULL;
}

/* -------------------------------------------------------------------
   swig_varlink_setattr()

   This function sets the value of a variable.
   ------------------------------------------------------------------- */

static int
swig_varlink_setattr(swig_varlinkobject *v, char *n, PyObject *p)
{
  char temp[128];
  int i = 0;
  while (v->vars[i]) {
    if (strcmp(v->vars[i]->name,n) == 0) {
      return (*v->vars[i]->set_attr)(p);
    }
    i++;
  }
  sprintf(temp,"C global variable %s not found.", n);
  PyErr_SetString(PyExc_NameError,temp);
  return 1;
}

statichere PyTypeObject varlinktype = {
/*  PyObject_HEAD_INIT(&PyType_Type)  Note : This doesn't work on some machines */
  PyObject_HEAD_INIT(0)              
  0,
  "varlink",                          /* Type name    */
  sizeof(swig_varlinkobject),         /* Basic size   */
  0,                                  /* Itemsize     */
  0,                                  /* Deallocator  */ 
  (printfunc) swig_varlink_print,     /* Print        */
  (getattrfunc) swig_varlink_getattr, /* get attr     */
  (setattrfunc) swig_varlink_setattr, /* Set attr     */
  0,                                  /* tp_compare   */
  (reprfunc) swig_varlink_repr,       /* tp_repr      */    
  0,                                  /* tp_as_number */
  0,                                  /* tp_as_mapping*/
  0,                                  /* tp_hash      */
};

/* Create a variable linking object for use later */

SWIGSTATIC PyObject *
SWIG_newvarlink(void)
{
  swig_varlinkobject *result = 0;
  result = PyMem_NEW(swig_varlinkobject,1);
  varlinktype.ob_type = &PyType_Type;    /* Patch varlinktype into a PyType */
  result->ob_type = &varlinktype;
  /*  _Py_NewReference(result);  Does not seem to be necessary */
  result->nvars = 0;
  result->maxvars = 64;
  result->vars = (swig_globalvar **) malloc(64*sizeof(swig_globalvar *));
  result->vars[0] = 0;
  Py_XINCREF((PyObject *) result);
  return ((PyObject*) result);
}

SWIGSTATIC void
SWIG_addvarlink(PyObject *p, char *name,
	   PyObject *(*get_attr)(void), int (*set_attr)(PyObject *p))
{
  swig_varlinkobject *v;
  v= (swig_varlinkobject *) p;
	
  if (v->nvars >= v->maxvars -1) {
    v->maxvars = 2*v->maxvars;
    v->vars = (swig_globalvar **) realloc(v->vars,v->maxvars*sizeof(swig_globalvar *));
    if (v->vars == NULL) {
      fprintf(stderr,"SWIG : Fatal error in initializing Python module.\n");
      exit(1);
    }
  }
  v->vars[v->nvars] = (swig_globalvar *) malloc(sizeof(swig_globalvar));
  v->vars[v->nvars]->name = (char *) malloc(strlen(name)+1);
  strcpy(v->vars[v->nvars]->name,name);
  v->vars[v->nvars]->get_attr = get_attr;
  v->vars[v->nvars]->set_attr = set_attr;
  v->nvars++;
  v->vars[v->nvars] = 0;
}



/*****************************************************************************
 * $Header:$
 *
 * swigptr.swg
 *
 * This file contains supporting code for the SWIG run-time type checking
 * mechanism.  The following functions are available :
 *
 * SWIG_RegisterMapping(char *origtype, char *newtype, void *(*cast)(void *));
 *
 *      Registers a new type-mapping with the type-checker.  origtype is the
 *      original datatype and newtype is an equivalent type.  cast is optional
 *      pointer to a function to cast pointer values between types (this
 *      is typically used to cast pointers from derived classes to base classes in C++)
 *      
 * SWIG_MakePtr(char *buffer, void *ptr, char *typestring);
 *     
 *      Makes a pointer string from a pointer and typestring.  The result is returned
 *      in buffer which is assumed to hold enough space for the result.
 *
 * char * SWIG_GetPtr(char *buffer, void **ptr, char *type)
 *
 *      Gets a pointer value from a string.  If there is a type-mismatch, returns
 *      a character string to the received type.  On success, returns NULL.
 *
 *
 * You can remap these functions by making a file called "swigptr.swg" in
 * your the same directory as the interface file you are wrapping.
 *
 * These functions are normally declared static, but this file can be
 * can be used in a multi-module environment by redefining the symbol
 * SWIGSTATIC.
 *****************************************************************************/

#include <stdlib.h>

#ifdef SWIG_GLOBAL
#ifdef __cplusplus
#define SWIGSTATIC extern "C"
#else
#define SWIGSTATIC
#endif
#endif

#ifndef SWIGSTATIC
#define SWIGSTATIC static
#endif


/* SWIG pointer structure */

typedef struct SwigPtrType {
  char               *name;               /* Datatype name                  */
  int                 len;                /* Length (used for optimization) */
  void               *(*cast)(void *);    /* Pointer casting function       */
  struct SwigPtrType *next;               /* Linked list pointer            */
} SwigPtrType;

/* Pointer cache structure */

typedef struct {
  int                 stat;               /* Status (valid) bit             */
  SwigPtrType        *tp;                 /* Pointer to type structure      */
  char                name[256];          /* Given datatype name            */
  char                mapped[256];        /* Equivalent name                */
} SwigCacheType;

/* Some variables  */

static int SwigPtrMax  = 64;           /* Max entries that can be currently held */
                                       /* This value may be adjusted dynamically */
static int SwigPtrN    = 0;            /* Current number of entries              */
static int SwigPtrSort = 0;            /* Status flag indicating sort            */
static int SwigStart[256];             /* Starting positions of types            */

/* Pointer table */
static SwigPtrType *SwigPtrTable = 0;  /* Table containing pointer equivalences  */

/* Cached values */

#define SWIG_CACHESIZE  8
#define SWIG_CACHEMASK  0x7
static SwigCacheType SwigCache[SWIG_CACHESIZE];  
static int SwigCacheIndex = 0;
static int SwigLastCache = 0;

/* Sort comparison function */
static int swigsort(const void *data1, const void *data2) {
	SwigPtrType *d1 = (SwigPtrType *) data1;
	SwigPtrType *d2 = (SwigPtrType *) data2;
	return strcmp(d1->name,d2->name);
}

/* Binary Search function */
static int swigcmp(const void *key, const void *data) {
  char *k = (char *) key;
  SwigPtrType *d = (SwigPtrType *) data;
  return strncmp(k,d->name,d->len);
}

/* Register a new datatype with the type-checker */

SWIGSTATIC 
void SWIG_RegisterMapping(char *origtype, char *newtype, void *(*cast)(void *)) {

  int i;
  SwigPtrType *t = 0,*t1;

  /* Allocate the pointer table if necessary */

  if (!SwigPtrTable) {     
    SwigPtrTable = (SwigPtrType *) malloc(SwigPtrMax*sizeof(SwigPtrType));
    SwigPtrN = 0;
  }
  /* Grow the table */
  if (SwigPtrN >= SwigPtrMax) {
    SwigPtrMax = 2*SwigPtrMax;
    SwigPtrTable = (SwigPtrType *) realloc((char *) SwigPtrTable,SwigPtrMax*sizeof(SwigPtrType));
  }
  for (i = 0; i < SwigPtrN; i++)
    if (strcmp(SwigPtrTable[i].name,origtype) == 0) {
      t = &SwigPtrTable[i];
      break;
    }
  if (!t) {
    t = &SwigPtrTable[SwigPtrN];
    t->name = origtype;
    t->len = strlen(t->name);
    t->cast = 0;
    t->next = 0;
    SwigPtrN++;
  }

  /* Check for existing entry */

  while (t->next) {
    if ((strcmp(t->name,newtype) == 0)) {
      if (cast) t->cast = cast;
      return;
    }
    t = t->next;
  }
  
  /* Now place entry (in sorted order) */

  t1 = (SwigPtrType *) malloc(sizeof(SwigPtrType));
  t1->name = newtype;
  t1->len = strlen(t1->name);
  t1->cast = cast;
  t1->next = 0;            
  t->next = t1;           
  SwigPtrSort = 0;
}

/* Make a pointer value string */

SWIGSTATIC 
void SWIG_MakePtr(char *_c, const void *_ptr, char *type) {
  static char _hex[16] =
  {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
   'a', 'b', 'c', 'd', 'e', 'f'};
  unsigned long _p, _s;
  char _result[20], *_r;    /* Note : a 64-bit hex number = 16 digits */
  _r = _result;
  _p = (unsigned long) _ptr;
  if (_p > 0) {
    while (_p > 0) {
      _s = _p & 0xf;
      *(_r++) = _hex[_s];
      _p = _p >> 4;
    }
    *_r = '_';
    while (_r >= _result)
      *(_c++) = *(_r--);
  } else {
    strcpy (_c, "NULL");
  }
  if (_ptr)
    strcpy (_c, type);
}

/* Define for backwards compatibility */

#define _swig_make_hex   SWIG_MakePtr 

/* Function for getting a pointer value */

SWIGSTATIC 
char *SWIG_GetPtr(char *_c, void **ptr, char *_t)
{
  unsigned long _p;
  char temp_type[256];
  char *name;
  int  i, len;
  SwigPtrType *sp,*tp;
  SwigCacheType *cache;
  char find[3];
  int  start, end;
  _p = 0;

  /* Pointer values must start with leading underscore */
  if (*_c == '_') {
      _c++;
      /* Extract hex value from pointer */
      while (*_c) {
	  if ((*_c >= '0') && (*_c <= '9'))
	    _p = (_p << 4) + (*_c - '0');
	  else if ((*_c >= 'a') && (*_c <= 'f'))
	    _p = (_p << 4) + ((*_c - 'a') + 10);
	  else
	    break;
	  _c++;
      }

      if (_t) {
	if (strcmp(_t,_c)) { 
	  if (!SwigPtrSort) {
	    qsort((void *) SwigPtrTable, SwigPtrN, sizeof(SwigPtrType), swigsort); 
	    for (i = 0; i < 256; i++) {
	      SwigStart[i] = SwigPtrN;
	    }
	    for (i = SwigPtrN-1; i >= 0; i--) {
	      SwigStart[SwigPtrTable[i].name[1]] = i;
	    }
	    for (i = 255; i >= 1; i--) {
	      if (SwigStart[i-1] > SwigStart[i])
		SwigStart[i-1] = SwigStart[i];
	    }
	    SwigPtrSort = 1;
	    for (i = 0; i < SWIG_CACHESIZE; i++)  
	      SwigCache[i].stat = 0;
	  }
	  
	  /* First check cache for matches.  Uses last cache value as starting point */
	  cache = &SwigCache[SwigLastCache];
	  for (i = 0; i < SWIG_CACHESIZE; i++) {
	    if (cache->stat) {
	      if (strcmp(_t,cache->name) == 0) {
		if (strcmp(_c,cache->mapped) == 0) {
		  cache->stat++;
		  *ptr = (void *) _p;
		  if (cache->tp->cast) *ptr = (*(cache->tp->cast))(*ptr);
		  return (char *) 0;
		}
	      }
	    }
	    SwigLastCache = (SwigLastCache+1) & SWIG_CACHEMASK;
	    if (!SwigLastCache) cache = SwigCache;
	    else cache++;
	  }
	  /* We have a type mismatch.  Will have to look through our type
	     mapping table to figure out whether or not we can accept this datatype */

	  start = SwigStart[_t[1]];
	  end = SwigStart[_t[1]+1];
	  sp = &SwigPtrTable[start];
	  while (start < end) {
	    if (swigcmp(_t,sp) == 0) break;
	    sp++;
	    start++;
	  }
	  if (start >= end) sp = 0;
	  /* Try to find a match for this */
	  if (sp) {
	    name = sp->name;
	    len = sp->len;
	    while (swigcmp(_t,sp) == 0) {
	      tp = sp->next;
	      /* Try to find entry for our given datatype */
	      while(tp) {
		if (tp->len >= 255) {
		  return _c;
		}
		strncpy(temp_type,tp->name,255);
		strncat(temp_type,_t+len,255-tp->len);
		if (strcmp(_c,temp_type) == 0) {
		  
		  strcpy(SwigCache[SwigCacheIndex].mapped,_c);
		  strcpy(SwigCache[SwigCacheIndex].name,_t);
		  SwigCache[SwigCacheIndex].stat = 1;
		  SwigCache[SwigCacheIndex].tp = tp;
		  SwigCacheIndex = SwigCacheIndex & SWIG_CACHEMASK;
		  
		  /* Get pointer value */
		  *ptr = (void *) _p;
		  if (tp->cast) *ptr = (*(tp->cast))(*ptr);
		  return (char *) 0;
		}
		tp = tp->next;
	      }
	      sp++;
	      /* Hmmm. Didn't find it this time */
	    }
	  }
	  /* Didn't find any sort of match for this data.  
	     Get the pointer value and return the received type */
	  *ptr = (void *) _p;
	  return _c;
	} else {
	  /* Found a match on the first try.  Return pointer value */
	  *ptr = (void *) _p;
	  return (char *) 0;
	}
      } else {
	/* No type specified.  Good luck */
	*ptr = (void *) _p;
	return (char *) 0;
      }
  } else {
    if (strcmp (_c, "NULL") == 0) {
	*ptr = (void *) 0;
	return (char *) 0;
    }
    *ptr = (void *) 0;	
    return _c;
  }
}

/* Compatibility mode */

#define _swig_get_hex  SWIG_GetPtr


#define SWIG_init    initpythonqtc

#define SWIG_name    "pythonqtc"

#include <qpixmap.h>
#include <qbitmap.h>
#include "Object.h"
 #include "Application.h"
 #include "Layout.h"
  #include "BoxLayout.h"
  #include "GridLayout.h"
 #include "Widget.h"
  #include "Button.h"
   #include "CheckBox.h"
   #include "PushButton.h"
   #include "RadioButton.h"
  #include "ComboBox.h"
  #include "Dialog.h"
   #include "TabDialog.h"
  #include "LineEdit.h"
  #include "Frame.h"
   #include "GroupBox.h"
    #include "ButtonGroup.h"
   #include "Label.h"
   #include "TableView.h"
    #include "ListBox.h"
    #include "MultiLineEdit.h"
  #include "ScrollBar.h"
#include "FileDialog.h"
#include "PopupMenu.h"
#include "MenuData.h"

static PyObject *_wrap_python_const_ArrowCursor;
static PyObject *_wrap_python_const_UpArrowCursor;
static PyObject *_wrap_python_const_CrossCursor;
static PyObject *_wrap_python_const_WaitCursor;
static PyObject *_wrap_python_const_IbeamCursor;
static PyObject *_wrap_python_const_SizeVerCursor;
static PyObject *_wrap_python_const_SizeHorCursor;
static PyObject *_wrap_python_const_SizeBDiagCursor;
static PyObject *_wrap_python_const_SizeFDiagCursor;
static PyObject *_wrap_python_const_SizeAllCursor;
static PyObject *_wrap_python_const_BlankCursor;
static PyObject *_wrap_python_const_LastCursor;
static PyObject *_wrap_python_const_BitmapCursor;
static PyObject *_wrap_python_const_CopyROP;
static PyObject *_wrap_python_const_OrROP;
static PyObject *_wrap_python_const_XorROP;
static PyObject *_wrap_python_const_EraseROP;
static PyObject *_wrap_python_const_NotCopyROP;
static PyObject *_wrap_python_const_NotOrROP;
static PyObject *_wrap_python_const_NotXorROP;
static PyObject *_wrap_python_const_NotEraseROP;
static PyObject *_wrap_python_const_NotROP;

#include "Object.h"
extern const char *ModalFileDialog(const char *,const char *,QWidget *,const char *);

#include "PopupMenu.h"

#include "PopupMenu.h"

#include "MenuData.h"
static PyObject *_wrap_python_const_QFont_Helvetica;
static PyObject *_wrap_python_const_QFont_Times;
static PyObject *_wrap_python_const_QFont_Courier;
static PyObject *_wrap_python_const_QFont_OldEnglish;
static PyObject *_wrap_python_const_QFont_System;
static PyObject *_wrap_python_const_QFont_AnyStyle;
static PyObject *_wrap_python_const_QFont_SansSerif;
static PyObject *_wrap_python_const_QFont_Serif;
static PyObject *_wrap_python_const_QFont_TypeWriter;
static PyObject *_wrap_python_const_QFont_Decorative;
static PyObject *_wrap_python_const_QFont_Light;
static PyObject *_wrap_python_const_QFont_Normal;
static PyObject *_wrap_python_const_QFont_DemiBold;
static PyObject *_wrap_python_const_QFont_Bold;
static PyObject *_wrap_python_const_QFont_Black;
static PyObject *_wrap_python_const_QFont_Latin1;
static PyObject *_wrap_python_const_QFont_ISO_8859_1;
static PyObject *_wrap_python_const_QFont_AnyCharSet;
static PyObject *_wrap_python_const_QPixmap_Auto;
static PyObject *_wrap_python_const_QPixmap_Color;
static PyObject *_wrap_python_const_QPixmap_Mono;
static PyObject *_wrap_python_const_QBitmap_Auto;
static PyObject *_wrap_python_const_QBitmap_Color;
static PyObject *_wrap_python_const_QBitmap_Mono;
static PyObject *_wrap_python_const_BoxLayout_LeftToRight;
static PyObject *_wrap_python_const_BoxLayout_RightToLeft;
static PyObject *_wrap_python_const_BoxLayout_TopToBottom;
static PyObject *_wrap_python_const_BoxLayout_BottomToTop;
static PyObject *_wrap_python_const_BoxLayout_Down;
static PyObject *_wrap_python_const_BoxLayout_Up;
static PyObject *_wrap_python_const_Widget_NoFocus;
static PyObject *_wrap_python_const_Widget_TabFocus;
static PyObject *_wrap_python_const_Widget_ClickFocus;
static PyObject *_wrap_python_const_Widget_StrongFocus;
static PyObject *_wrap_python_const_Button_NoFocus;
static PyObject *_wrap_python_const_Button_TabFocus;
static PyObject *_wrap_python_const_Button_ClickFocus;
static PyObject *_wrap_python_const_Button_StrongFocus;
static PyObject *_wrap_python_const_CheckBox_NoFocus;
static PyObject *_wrap_python_const_CheckBox_TabFocus;
static PyObject *_wrap_python_const_CheckBox_ClickFocus;
static PyObject *_wrap_python_const_CheckBox_StrongFocus;
static PyObject *_wrap_python_const_PushButton_NoFocus;
static PyObject *_wrap_python_const_PushButton_TabFocus;
static PyObject *_wrap_python_const_PushButton_ClickFocus;
static PyObject *_wrap_python_const_PushButton_StrongFocus;
static PyObject *_wrap_python_const_RadioButton_NoFocus;
static PyObject *_wrap_python_const_RadioButton_TabFocus;
static PyObject *_wrap_python_const_RadioButton_ClickFocus;
static PyObject *_wrap_python_const_RadioButton_StrongFocus;
static PyObject *_wrap_python_const_ComboBox_NoInsertion;
static PyObject *_wrap_python_const_ComboBox_AtTop;
static PyObject *_wrap_python_const_ComboBox_AtCurrent;
static PyObject *_wrap_python_const_ComboBox_AtBottom;
static PyObject *_wrap_python_const_ComboBox_AfterCurrent;
static PyObject *_wrap_python_const_ComboBox_BeforeCurrent;
static PyObject *_wrap_python_const_ComboBox_NoFocus;
static PyObject *_wrap_python_const_ComboBox_TabFocus;
static PyObject *_wrap_python_const_ComboBox_ClickFocus;
static PyObject *_wrap_python_const_ComboBox_StrongFocus;
static PyObject *_wrap_python_const_Dialog_NoFocus;
static PyObject *_wrap_python_const_Dialog_TabFocus;
static PyObject *_wrap_python_const_Dialog_ClickFocus;
static PyObject *_wrap_python_const_Dialog_StrongFocus;
static PyObject *_wrap_python_const_TabDialog_NoFocus;
static PyObject *_wrap_python_const_TabDialog_TabFocus;
static PyObject *_wrap_python_const_TabDialog_ClickFocus;
static PyObject *_wrap_python_const_TabDialog_StrongFocus;
static PyObject *_wrap_python_const_LineEdit_Normal;
static PyObject *_wrap_python_const_LineEdit_NoEcho;
static PyObject *_wrap_python_const_LineEdit_Password;
static PyObject *_wrap_python_const_LineEdit_NoFocus;
static PyObject *_wrap_python_const_LineEdit_TabFocus;
static PyObject *_wrap_python_const_LineEdit_ClickFocus;
static PyObject *_wrap_python_const_LineEdit_StrongFocus;
static PyObject *_wrap_python_const_Frame_NoFrame;
static PyObject *_wrap_python_const_Frame_Box;
static PyObject *_wrap_python_const_Frame_Panel;
static PyObject *_wrap_python_const_Frame_WinPanel;
static PyObject *_wrap_python_const_Frame_HLine;
static PyObject *_wrap_python_const_Frame_VLine;
static PyObject *_wrap_python_const_Frame_MShape;
static PyObject *_wrap_python_const_Frame_Plain;
static PyObject *_wrap_python_const_Frame_Raised;
static PyObject *_wrap_python_const_Frame_Sunken;
static PyObject *_wrap_python_const_Frame_MShadow;
static PyObject *_wrap_python_const_Frame_NoFocus;
static PyObject *_wrap_python_const_Frame_TabFocus;
static PyObject *_wrap_python_const_Frame_ClickFocus;
static PyObject *_wrap_python_const_Frame_StrongFocus;
static PyObject *_wrap_python_const_GroupBox_NoFrame;
static PyObject *_wrap_python_const_GroupBox_Box;
static PyObject *_wrap_python_const_GroupBox_Panel;
static PyObject *_wrap_python_const_GroupBox_WinPanel;
static PyObject *_wrap_python_const_GroupBox_HLine;
static PyObject *_wrap_python_const_GroupBox_VLine;
static PyObject *_wrap_python_const_GroupBox_MShape;
static PyObject *_wrap_python_const_GroupBox_Plain;
static PyObject *_wrap_python_const_GroupBox_Raised;
static PyObject *_wrap_python_const_GroupBox_Sunken;
static PyObject *_wrap_python_const_GroupBox_MShadow;
static PyObject *_wrap_python_const_GroupBox_NoFocus;
static PyObject *_wrap_python_const_GroupBox_TabFocus;
static PyObject *_wrap_python_const_GroupBox_ClickFocus;
static PyObject *_wrap_python_const_GroupBox_StrongFocus;
static PyObject *_wrap_python_const_ButtonGroup_NoFrame;
static PyObject *_wrap_python_const_ButtonGroup_Box;
static PyObject *_wrap_python_const_ButtonGroup_Panel;
static PyObject *_wrap_python_const_ButtonGroup_WinPanel;
static PyObject *_wrap_python_const_ButtonGroup_HLine;
static PyObject *_wrap_python_const_ButtonGroup_VLine;
static PyObject *_wrap_python_const_ButtonGroup_MShape;
static PyObject *_wrap_python_const_ButtonGroup_Plain;
static PyObject *_wrap_python_const_ButtonGroup_Raised;
static PyObject *_wrap_python_const_ButtonGroup_Sunken;
static PyObject *_wrap_python_const_ButtonGroup_MShadow;
static PyObject *_wrap_python_const_ButtonGroup_NoFocus;
static PyObject *_wrap_python_const_ButtonGroup_TabFocus;
static PyObject *_wrap_python_const_ButtonGroup_ClickFocus;
static PyObject *_wrap_python_const_ButtonGroup_StrongFocus;
static PyObject *_wrap_python_const_Label_NoFrame;
static PyObject *_wrap_python_const_Label_Box;
static PyObject *_wrap_python_const_Label_Panel;
static PyObject *_wrap_python_const_Label_WinPanel;
static PyObject *_wrap_python_const_Label_HLine;
static PyObject *_wrap_python_const_Label_VLine;
static PyObject *_wrap_python_const_Label_MShape;
static PyObject *_wrap_python_const_Label_Plain;
static PyObject *_wrap_python_const_Label_Raised;
static PyObject *_wrap_python_const_Label_Sunken;
static PyObject *_wrap_python_const_Label_MShadow;
static PyObject *_wrap_python_const_Label_NoFocus;
static PyObject *_wrap_python_const_Label_TabFocus;
static PyObject *_wrap_python_const_Label_ClickFocus;
static PyObject *_wrap_python_const_Label_StrongFocus;
static PyObject *_wrap_python_const_TableView_NoFrame;
static PyObject *_wrap_python_const_TableView_Box;
static PyObject *_wrap_python_const_TableView_Panel;
static PyObject *_wrap_python_const_TableView_WinPanel;
static PyObject *_wrap_python_const_TableView_HLine;
static PyObject *_wrap_python_const_TableView_VLine;
static PyObject *_wrap_python_const_TableView_MShape;
static PyObject *_wrap_python_const_TableView_Plain;
static PyObject *_wrap_python_const_TableView_Raised;
static PyObject *_wrap_python_const_TableView_Sunken;
static PyObject *_wrap_python_const_TableView_MShadow;
static PyObject *_wrap_python_const_TableView_NoFocus;
static PyObject *_wrap_python_const_TableView_TabFocus;
static PyObject *_wrap_python_const_TableView_ClickFocus;
static PyObject *_wrap_python_const_TableView_StrongFocus;
static PyObject *_wrap_python_const_ListBox_NoFrame;
static PyObject *_wrap_python_const_ListBox_Box;
static PyObject *_wrap_python_const_ListBox_Panel;
static PyObject *_wrap_python_const_ListBox_WinPanel;
static PyObject *_wrap_python_const_ListBox_HLine;
static PyObject *_wrap_python_const_ListBox_VLine;
static PyObject *_wrap_python_const_ListBox_MShape;
static PyObject *_wrap_python_const_ListBox_Plain;
static PyObject *_wrap_python_const_ListBox_Raised;
static PyObject *_wrap_python_const_ListBox_Sunken;
static PyObject *_wrap_python_const_ListBox_MShadow;
static PyObject *_wrap_python_const_ListBox_NoFocus;
static PyObject *_wrap_python_const_ListBox_TabFocus;
static PyObject *_wrap_python_const_ListBox_ClickFocus;
static PyObject *_wrap_python_const_ListBox_StrongFocus;
static PyObject *_wrap_python_const_MultiLineEdit_NoFrame;
static PyObject *_wrap_python_const_MultiLineEdit_Box;
static PyObject *_wrap_python_const_MultiLineEdit_Panel;
static PyObject *_wrap_python_const_MultiLineEdit_WinPanel;
static PyObject *_wrap_python_const_MultiLineEdit_HLine;
static PyObject *_wrap_python_const_MultiLineEdit_VLine;
static PyObject *_wrap_python_const_MultiLineEdit_MShape;
static PyObject *_wrap_python_const_MultiLineEdit_Plain;
static PyObject *_wrap_python_const_MultiLineEdit_Raised;
static PyObject *_wrap_python_const_MultiLineEdit_Sunken;
static PyObject *_wrap_python_const_MultiLineEdit_MShadow;
static PyObject *_wrap_python_const_MultiLineEdit_NoFocus;
static PyObject *_wrap_python_const_MultiLineEdit_TabFocus;
static PyObject *_wrap_python_const_MultiLineEdit_ClickFocus;
static PyObject *_wrap_python_const_MultiLineEdit_StrongFocus;
static PyObject *_wrap_python_const_ScrollBar_Horizontal;
static PyObject *_wrap_python_const_ScrollBar_Vertical;
static PyObject *_wrap_python_const_ScrollBar_NoFocus;
static PyObject *_wrap_python_const_ScrollBar_TabFocus;
static PyObject *_wrap_python_const_ScrollBar_ClickFocus;
static PyObject *_wrap_python_const_ScrollBar_StrongFocus;
static PyObject *_wrap_python_const_QMenuBar_Never;
static PyObject *_wrap_python_const_QMenuBar_InWindowsStyle;
static PyObject *_wrap_bitBlt(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPaintDevice * _arg0;
    int  _arg1;
    int  _arg2;
    QPaintDevice * _arg3;
    int  _arg4;
    int  _arg5;
    int  _arg6;
    int  _arg7;
    RasterOp  _arg8;
    int  _arg9;
    char * _argc0 = 0;
    char * _argc3 = 0;

    if(!PyArg_ParseTuple(args,"siisiiiiii:bitBlt",&_argc0,&_arg1,&_arg2,&_argc3,&_arg4,&_arg5,&_arg6,&_arg7,&_arg8,&_arg9)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPaintDevice_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of bitBlt. Expected _QPaintDevice_p.");
        return NULL;
        }
    }
    if (_argc3) {
        if (SWIG_GetPtr(_argc3,(void **) &_arg3,"_QPaintDevice_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 4 of bitBlt. Expected _QPaintDevice_p.");
        return NULL;
        }
    }
    bitBlt(_arg0,_arg1,_arg2,_arg3,_arg4,_arg5,_arg6,_arg7,_arg8,_arg9);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static PyObject *_wrap_ModalFileDialog(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    char * _arg0 = 0;
    char * _arg1 = 0;
    QWidget * _arg2 = 0;
    char * _arg3 = 0;
    char * _argc2 = 0;

    if(!PyArg_ParseTuple(args,"|ssss:ModalFileDialog",&_arg0,&_arg1,&_argc2,&_arg3)) 
        return NULL;
    if (_argc2) {
        if (SWIG_GetPtr(_argc2,(void **) &_arg2,"_QWidget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 3 of ModalFileDialog. Expected _QWidget_p.");
        return NULL;
        }
    }
    _result = (char *)ModalFileDialog(_arg0,_arg1,_arg2,_arg3);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

static QColor *new_QColor() {
    return new QColor();
}
static PyObject *_wrap_new_QColor(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _result;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,":new_QColor")) 
        return NULL;
    _result = (QColor *)new_QColor();
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColor_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QColor *new_QColor(int  _arg0,int  _arg1,int  _arg2) {
    return new QColor(_arg0,_arg1,_arg2);
}
static PyObject *_wrap_new_QColorRGB(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _result;
    int  _arg0;
    int  _arg1;
    int  _arg2;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"iii:new_QColorRGB",&_arg0,&_arg1,&_arg2)) 
        return NULL;
    _result = (QColor *)new_QColor(_arg0,_arg1,_arg2);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColor_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QColor *new_QColor(const char * _arg0) {
    return new QColor(_arg0);
}
static PyObject *_wrap_new_QColorName(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _result;
    char * _arg0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:new_QColorName",&_arg0)) 
        return NULL;
    _result = (QColor *)new_QColor(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColor_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QColor *new_QColor(const QColor * _arg0) {
    return new QColor(*_arg0);
}
static PyObject *_wrap_new_QColorCopy(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _result;
    QColor * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:new_QColorCopy",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_QColorCopy. Expected _QColor_p.");
        return NULL;
        }
    }
    _result = (QColor *)new_QColor(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColor_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static bool  QColor_isValid(QColor *obj) {
    bool  _result = (bool )obj->isValid();
    return _result;
}
static PyObject *_wrap_QColor_isValid(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QColor * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QColor_isValid",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColor_isValid. Expected _QColor_p.");
        return NULL;
        }
    }
    _result = (bool )QColor_isValid(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static bool  QColor_isDirty(QColor *obj) {
    bool  _result = (bool )obj->isDirty();
    return _result;
}
static PyObject *_wrap_QColor_isDirty(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QColor * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QColor_isDirty",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColor_isDirty. Expected _QColor_p.");
        return NULL;
        }
    }
    _result = (bool )QColor_isDirty(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  QColor_setNamedColor(QColor *obj,const char * _arg0) {
    obj->setNamedColor(_arg0);
}
static PyObject *_wrap_QColor_setNamedColor(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"ss:QColor_setNamedColor",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColor_setNamedColor. Expected _QColor_p.");
        return NULL;
        }
    }
    QColor_setNamedColor(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  QColor_rgb(QColor *obj,int * _arg0,int * _arg1,int * _arg2) {
    obj->rgb(_arg0,_arg1,_arg2);
}
static PyObject *_wrap_QColor_rgb(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _arg0;
    int * _arg1;
    int * _arg2;
    int * _arg3;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char * _argc2 = 0;
    char * _argc3 = 0;

    if(!PyArg_ParseTuple(args,"ssss:QColor_rgb",&_argc0,&_argc1,&_argc2,&_argc3)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColor_rgb. Expected _QColor_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_int_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QColor_rgb. Expected _int_p.");
        return NULL;
        }
    }
    if (_argc2) {
        if (SWIG_GetPtr(_argc2,(void **) &_arg2,"_int_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 3 of QColor_rgb. Expected _int_p.");
        return NULL;
        }
    }
    if (_argc3) {
        if (SWIG_GetPtr(_argc3,(void **) &_arg3,"_int_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 4 of QColor_rgb. Expected _int_p.");
        return NULL;
        }
    }
    QColor_rgb(_arg0,_arg1,_arg2,_arg3);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  QColor_setRgb(QColor *obj,int  _arg0,int  _arg1,int  _arg2) {
    obj->setRgb(_arg0,_arg1,_arg2);
}
static PyObject *_wrap_QColor_setRgb(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _arg0;
    int  _arg1;
    int  _arg2;
    int  _arg3;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"siii:QColor_setRgb",&_argc0,&_arg1,&_arg2,&_arg3)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColor_setRgb. Expected _QColor_p.");
        return NULL;
        }
    }
    QColor_setRgb(_arg0,_arg1,_arg2,_arg3);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static int  QColor_red(QColor *obj) {
    int  _result = (int )obj->red();
    return _result;
}
static PyObject *_wrap_QColor_red(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QColor * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QColor_red",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColor_red. Expected _QColor_p.");
        return NULL;
        }
    }
    _result = (int )QColor_red(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  QColor_green(QColor *obj) {
    int  _result = (int )obj->green();
    return _result;
}
static PyObject *_wrap_QColor_green(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QColor * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QColor_green",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColor_green. Expected _QColor_p.");
        return NULL;
        }
    }
    _result = (int )QColor_green(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  QColor_blue(QColor *obj) {
    int  _result = (int )obj->blue();
    return _result;
}
static PyObject *_wrap_QColor_blue(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QColor * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QColor_blue",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColor_blue. Expected _QColor_p.");
        return NULL;
        }
    }
    _result = (int )QColor_blue(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  QColor_hsv(QColor *obj,int * _arg0,int * _arg1,int * _arg2) {
    obj->hsv(_arg0,_arg1,_arg2);
}
static PyObject *_wrap_QColor_hsv(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _arg0;
    int * _arg1;
    int * _arg2;
    int * _arg3;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char * _argc2 = 0;
    char * _argc3 = 0;

    if(!PyArg_ParseTuple(args,"ssss:QColor_hsv",&_argc0,&_argc1,&_argc2,&_argc3)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColor_hsv. Expected _QColor_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_int_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QColor_hsv. Expected _int_p.");
        return NULL;
        }
    }
    if (_argc2) {
        if (SWIG_GetPtr(_argc2,(void **) &_arg2,"_int_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 3 of QColor_hsv. Expected _int_p.");
        return NULL;
        }
    }
    if (_argc3) {
        if (SWIG_GetPtr(_argc3,(void **) &_arg3,"_int_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 4 of QColor_hsv. Expected _int_p.");
        return NULL;
        }
    }
    QColor_hsv(_arg0,_arg1,_arg2,_arg3);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  QColor_setHsv(QColor *obj,int  _arg0,int  _arg1,int  _arg2) {
    obj->setHsv(_arg0,_arg1,_arg2);
}
static PyObject *_wrap_QColor_setHsv(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _arg0;
    int  _arg1;
    int  _arg2;
    int  _arg3;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"siii:QColor_setHsv",&_argc0,&_arg1,&_arg2,&_arg3)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColor_setHsv. Expected _QColor_p.");
        return NULL;
        }
    }
    QColor_setHsv(_arg0,_arg1,_arg2,_arg3);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static QColor  QColor_light(QColor *obj,int  _arg0) {
    QColor  _result = (QColor )obj->light(_arg0);
    return _result;
}
static PyObject *_wrap_QColor_light(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _result;
    QColor * _arg0;
    int  _arg1 = 112;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s|i:QColor_light",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColor_light. Expected _QColor_p.");
        return NULL;
        }
    }
    _result = new QColor (QColor_light(_arg0,_arg1));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QColor_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QColor  QColor_dark(QColor *obj,int  _arg0) {
    QColor  _result = (QColor )obj->dark(_arg0);
    return _result;
}
static PyObject *_wrap_QColor_dark(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _result;
    QColor * _arg0;
    int  _arg1 = 220;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s|i:QColor_dark",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColor_dark. Expected _QColor_p.");
        return NULL;
        }
    }
    _result = new QColor (QColor_dark(_arg0,_arg1));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QColor_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static uint  QColor_alloc(QColor *obj) {
    uint  _result = (uint )obj->alloc();
    return _result;
}
static PyObject *_wrap_QColor_alloc(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    uint * _result;
    QColor * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:QColor_alloc",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColor_alloc. Expected _QColor_p.");
        return NULL;
        }
    }
    _result = new uint (QColor_alloc(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_uint_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static uint  QColor_pixel(QColor *obj) {
    uint  _result = (uint )obj->pixel();
    return _result;
}
static PyObject *_wrap_QColor_pixel(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    uint * _result;
    QColor * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:QColor_pixel",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColor_pixel. Expected _QColor_p.");
        return NULL;
        }
    }
    _result = new uint (QColor_pixel(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_uint_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static PyObject *_wrap_QColor_lazyAlloc(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;

    if(!PyArg_ParseTuple(args,":QColor_lazyAlloc")) 
        return NULL;
    _result = (bool )QColor::lazyAlloc();
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static PyObject *_wrap_QColor_setLazyAlloc(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _arg0;

    if(!PyArg_ParseTuple(args,"i:QColor_setLazyAlloc",&_arg0)) 
        return NULL;
    QColor::setLazyAlloc(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static PyObject *_wrap_QColor_maxColors(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;

    if(!PyArg_ParseTuple(args,":QColor_maxColors")) 
        return NULL;
    _result = (int )QColor::maxColors();
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static PyObject *_wrap_QColor_numBitPlanes(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;

    if(!PyArg_ParseTuple(args,":QColor_numBitPlanes")) 
        return NULL;
    _result = (int )QColor::numBitPlanes();
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static PyObject *_wrap_QColor_enterAllocContext(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;

    if(!PyArg_ParseTuple(args,":QColor_enterAllocContext")) 
        return NULL;
    _result = (int )QColor::enterAllocContext();
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static PyObject *_wrap_QColor_leaveAllocContext(PyObject *self, PyObject *args) {
    PyObject * _resultobj;

    if(!PyArg_ParseTuple(args,":QColor_leaveAllocContext")) 
        return NULL;
    QColor::leaveAllocContext();
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static PyObject *_wrap_QColor_currentAllocContext(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;

    if(!PyArg_ParseTuple(args,":QColor_currentAllocContext")) 
        return NULL;
    _result = (int )QColor::currentAllocContext();
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static PyObject *_wrap_QColor_destroyAllocContext(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _arg0;

    if(!PyArg_ParseTuple(args,"i:QColor_destroyAllocContext",&_arg0)) 
        return NULL;
    QColor::destroyAllocContext(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static QColorGroup *new_QColorGroup() {
    return new QColorGroup();
}
static PyObject *_wrap_new_QColorGroup(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColorGroup * _result;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,":new_QColorGroup")) 
        return NULL;
    _result = (QColorGroup *)new_QColorGroup();
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColorGroup_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QColorGroup *new_QColorGroup(const QColor * _arg0,const QColor * _arg1,const QColor * _arg2,const QColor * _arg3,const QColor * _arg4,const QColor * _arg5,const QColor * _arg6) {
    return new QColorGroup(*_arg0,*_arg1,*_arg2,*_arg3,*_arg4,*_arg5,*_arg6);
}
static PyObject *_wrap_new_QColorGroupV(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColorGroup * _result;
    QColor * _arg0;
    QColor * _arg1;
    QColor * _arg2;
    QColor * _arg3;
    QColor * _arg4;
    QColor * _arg5;
    QColor * _arg6;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char * _argc2 = 0;
    char * _argc3 = 0;
    char * _argc4 = 0;
    char * _argc5 = 0;
    char * _argc6 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"sssssss:new_QColorGroupV",&_argc0,&_argc1,&_argc2,&_argc3,&_argc4,&_argc5,&_argc6)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_QColorGroupV. Expected _QColor_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of new_QColorGroupV. Expected _QColor_p.");
        return NULL;
        }
    }
    if (_argc2) {
        if (SWIG_GetPtr(_argc2,(void **) &_arg2,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 3 of new_QColorGroupV. Expected _QColor_p.");
        return NULL;
        }
    }
    if (_argc3) {
        if (SWIG_GetPtr(_argc3,(void **) &_arg3,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 4 of new_QColorGroupV. Expected _QColor_p.");
        return NULL;
        }
    }
    if (_argc4) {
        if (SWIG_GetPtr(_argc4,(void **) &_arg4,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 5 of new_QColorGroupV. Expected _QColor_p.");
        return NULL;
        }
    }
    if (_argc5) {
        if (SWIG_GetPtr(_argc5,(void **) &_arg5,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 6 of new_QColorGroupV. Expected _QColor_p.");
        return NULL;
        }
    }
    if (_argc6) {
        if (SWIG_GetPtr(_argc6,(void **) &_arg6,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 7 of new_QColorGroupV. Expected _QColor_p.");
        return NULL;
        }
    }
    _result = (QColorGroup *)new_QColorGroup(_arg0,_arg1,_arg2,_arg3,_arg4,_arg5,_arg6);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColorGroup_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QColor * QColorGroup_foreground(QColorGroup *obj) {
    const QColor & _result = obj->foreground();
    return (QColor *) &_result;
}
static PyObject *_wrap_QColorGroup_foreground(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _result;
    QColorGroup * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:QColorGroup_foreground",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColorGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColorGroup_foreground. Expected _QColorGroup_p.");
        return NULL;
        }
    }
    _result = (QColor *)QColorGroup_foreground(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColor_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QColor * QColorGroup_background(QColorGroup *obj) {
    const QColor & _result = obj->background();
    return (QColor *) &_result;
}
static PyObject *_wrap_QColorGroup_background(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _result;
    QColorGroup * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:QColorGroup_background",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColorGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColorGroup_background. Expected _QColorGroup_p.");
        return NULL;
        }
    }
    _result = (QColor *)QColorGroup_background(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColor_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QColor * QColorGroup_light(QColorGroup *obj) {
    const QColor & _result = obj->light();
    return (QColor *) &_result;
}
static PyObject *_wrap_QColorGroup_light(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _result;
    QColorGroup * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:QColorGroup_light",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColorGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColorGroup_light. Expected _QColorGroup_p.");
        return NULL;
        }
    }
    _result = (QColor *)QColorGroup_light(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColor_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QColor * QColorGroup_dark(QColorGroup *obj) {
    const QColor & _result = obj->dark();
    return (QColor *) &_result;
}
static PyObject *_wrap_QColorGroup_dark(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _result;
    QColorGroup * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:QColorGroup_dark",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColorGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColorGroup_dark. Expected _QColorGroup_p.");
        return NULL;
        }
    }
    _result = (QColor *)QColorGroup_dark(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColor_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QColor * QColorGroup_mid(QColorGroup *obj) {
    const QColor & _result = obj->mid();
    return (QColor *) &_result;
}
static PyObject *_wrap_QColorGroup_mid(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _result;
    QColorGroup * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:QColorGroup_mid",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColorGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColorGroup_mid. Expected _QColorGroup_p.");
        return NULL;
        }
    }
    _result = (QColor *)QColorGroup_mid(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColor_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QColor * QColorGroup_text(QColorGroup *obj) {
    const QColor & _result = obj->text();
    return (QColor *) &_result;
}
static PyObject *_wrap_QColorGroup_text(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _result;
    QColorGroup * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:QColorGroup_text",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColorGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColorGroup_text. Expected _QColorGroup_p.");
        return NULL;
        }
    }
    _result = (QColor *)QColorGroup_text(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColor_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QColor * QColorGroup_base(QColorGroup *obj) {
    const QColor & _result = obj->base();
    return (QColor *) &_result;
}
static PyObject *_wrap_QColorGroup_base(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _result;
    QColorGroup * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:QColorGroup_base",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColorGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColorGroup_base. Expected _QColorGroup_p.");
        return NULL;
        }
    }
    _result = (QColor *)QColorGroup_base(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColor_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QPalette *new_QPalette() {
    return new QPalette();
}
static PyObject *_wrap_new_QPalette(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPalette * _result;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,":new_QPalette")) 
        return NULL;
    _result = (QPalette *)new_QPalette();
    SWIG_MakePtr(_ptemp, (char *) _result,"_QPalette_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QPalette *new_QPalette(const QColor * _arg0) {
    return new QPalette(*_arg0);
}
static PyObject *_wrap_new_QPaletteColor(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPalette * _result;
    QColor * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:new_QPaletteColor",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_QPaletteColor. Expected _QColor_p.");
        return NULL;
        }
    }
    _result = (QPalette *)new_QPalette(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QPalette_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QPalette *new_QPalette(const QColorGroup * _arg0,const QColorGroup * _arg1,const QColorGroup * _arg2) {
    return new QPalette(*_arg0,*_arg1,*_arg2);
}
static PyObject *_wrap_new_QPaletteCG(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPalette * _result;
    QColorGroup * _arg0;
    QColorGroup * _arg1;
    QColorGroup * _arg2;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char * _argc2 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"sss:new_QPaletteCG",&_argc0,&_argc1,&_argc2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColorGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_QPaletteCG. Expected _QColorGroup_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QColorGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of new_QPaletteCG. Expected _QColorGroup_p.");
        return NULL;
        }
    }
    if (_argc2) {
        if (SWIG_GetPtr(_argc2,(void **) &_arg2,"_QColorGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 3 of new_QPaletteCG. Expected _QColorGroup_p.");
        return NULL;
        }
    }
    _result = (QPalette *)new_QPalette(_arg0,_arg1,_arg2);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QPalette_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QPalette *new_QPalette(const QPalette * _arg0) {
    return new QPalette(*_arg0);
}
static PyObject *_wrap_new_QPaletteCopy(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPalette * _result;
    QPalette * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:new_QPaletteCopy",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPalette_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_QPaletteCopy. Expected _QPalette_p.");
        return NULL;
        }
    }
    _result = (QPalette *)new_QPalette(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QPalette_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void delete_QPalette(QPalette *obj) {
    delete obj;
}
static PyObject *_wrap_delete_QPalette(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPalette * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:delete_QPalette",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPalette_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_QPalette. Expected _QPalette_p.");
        return NULL;
        }
    }
    delete_QPalette(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static QPalette  QPalette_copy(QPalette *obj) {
    QPalette  _result = (QPalette )obj->copy();
    return _result;
}
static PyObject *_wrap_QPalette_copy(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPalette * _result;
    QPalette * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:QPalette_copy",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPalette_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPalette_copy. Expected _QPalette_p.");
        return NULL;
        }
    }
    _result = new QPalette (QPalette_copy(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QPalette_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QColorGroup * QPalette_normal(QPalette *obj) {
    const QColorGroup & _result = obj->normal();
    return (QColorGroup *) &_result;
}
static PyObject *_wrap_QPalette_normal(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColorGroup * _result;
    QPalette * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:QPalette_normal",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPalette_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPalette_normal. Expected _QPalette_p.");
        return NULL;
        }
    }
    _result = (QColorGroup *)QPalette_normal(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColorGroup_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QColorGroup * QPalette_disabled(QPalette *obj) {
    const QColorGroup & _result = obj->disabled();
    return (QColorGroup *) &_result;
}
static PyObject *_wrap_QPalette_disabled(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColorGroup * _result;
    QPalette * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:QPalette_disabled",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPalette_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPalette_disabled. Expected _QPalette_p.");
        return NULL;
        }
    }
    _result = (QColorGroup *)QPalette_disabled(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColorGroup_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QColorGroup * QPalette_active(QPalette *obj) {
    const QColorGroup & _result = obj->active();
    return (QColorGroup *) &_result;
}
static PyObject *_wrap_QPalette_active(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColorGroup * _result;
    QPalette * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:QPalette_active",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPalette_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPalette_active. Expected _QPalette_p.");
        return NULL;
        }
    }
    _result = (QColorGroup *)QPalette_active(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColorGroup_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void  QPalette_setNormal(QPalette *obj,const QColorGroup * _arg0) {
    obj->setNormal(*_arg0);
}
static PyObject *_wrap_QPalette_setNormal(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPalette * _arg0;
    QColorGroup * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:QPalette_setNormal",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPalette_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPalette_setNormal. Expected _QPalette_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QColorGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QPalette_setNormal. Expected _QColorGroup_p.");
        return NULL;
        }
    }
    QPalette_setNormal(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  QPalette_setDisabled(QPalette *obj,const QColorGroup * _arg0) {
    obj->setDisabled(*_arg0);
}
static PyObject *_wrap_QPalette_setDisabled(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPalette * _arg0;
    QColorGroup * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:QPalette_setDisabled",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPalette_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPalette_setDisabled. Expected _QPalette_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QColorGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QPalette_setDisabled. Expected _QColorGroup_p.");
        return NULL;
        }
    }
    QPalette_setDisabled(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  QPalette_setActive(QPalette *obj,const QColorGroup * _arg0) {
    obj->setActive(*_arg0);
}
static PyObject *_wrap_QPalette_setActive(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPalette * _arg0;
    QColorGroup * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:QPalette_setActive",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPalette_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPalette_setActive. Expected _QPalette_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QColorGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QPalette_setActive. Expected _QColorGroup_p.");
        return NULL;
        }
    }
    QPalette_setActive(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static int  QPalette_serialNumber(QPalette *obj) {
    int  _result = (int )obj->serialNumber();
    return _result;
}
static PyObject *_wrap_QPalette_serialNumber(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QPalette * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QPalette_serialNumber",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPalette_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPalette_serialNumber. Expected _QPalette_p.");
        return NULL;
        }
    }
    _result = (int )QPalette_serialNumber(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static QCursor *new_QCursor() {
    return new QCursor();
}
static PyObject *_wrap_new_QCursor(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QCursor * _result;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,":new_QCursor")) 
        return NULL;
    _result = (QCursor *)new_QCursor();
    SWIG_MakePtr(_ptemp, (char *) _result,"_QCursor_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QCursor *new_QCursor(int  _arg0) {
    return new QCursor(_arg0);
}
static PyObject *_wrap_new_QCursorShape(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QCursor * _result;
    int  _arg0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"i:new_QCursorShape",&_arg0)) 
        return NULL;
    _result = (QCursor *)new_QCursor(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QCursor_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void delete_QCursor(QCursor *obj) {
    delete obj;
}
static PyObject *_wrap_delete_QCursor(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QCursor * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:delete_QCursor",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QCursor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_QCursor. Expected _QCursor_p.");
        return NULL;
        }
    }
    delete_QCursor(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static int  QCursor_shape(QCursor *obj) {
    int  _result = (int )obj->shape();
    return _result;
}
static PyObject *_wrap_QCursor_shape(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QCursor * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QCursor_shape",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QCursor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QCursor_shape. Expected _QCursor_p.");
        return NULL;
        }
    }
    _result = (int )QCursor_shape(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  QCursor_setShape(QCursor *obj,int  _arg0) {
    obj->setShape(_arg0);
}
static PyObject *_wrap_QCursor_setShape(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QCursor * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:QCursor_setShape",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QCursor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QCursor_setShape. Expected _QCursor_p.");
        return NULL;
        }
    }
    QCursor_setShape(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static PyObject *_wrap_QCursor_setPos(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _arg0;
    int  _arg1;

    if(!PyArg_ParseTuple(args,"ii:QCursor_setPos",&_arg0,&_arg1)) 
        return NULL;
    QCursor::setPos(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static QFont *new_QFont() {
    return new QFont();
}
static PyObject *_wrap_new_QFont(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont * _result;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,":new_QFont")) 
        return NULL;
    _result = (QFont *)new_QFont();
    SWIG_MakePtr(_ptemp, (char *) _result,"_QFont_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QFont *new_QFont(const char * _arg0,int  _arg1,int  _arg2,bool  _arg3) {
    return new QFont(_arg0,_arg1,_arg2,_arg3);
}
static PyObject *_wrap_new_QFontV(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont * _result;
    char * _arg0;
    int  _arg1 = 12;
    int  _arg2 = QFont::Normal;
    bool  _arg3 = FALSE;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s|iii:new_QFontV",&_arg0,&_arg1,&_arg2,&_arg3)) 
        return NULL;
    _result = (QFont *)new_QFont(_arg0,_arg1,_arg2,_arg3);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QFont_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QFont *new_QFont(const QFont * _arg0) {
    return new QFont(*_arg0);
}
static PyObject *_wrap_new_QFontCopy(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont * _result;
    QFont * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:new_QFontCopy",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_QFontCopy. Expected _QFont_p.");
        return NULL;
        }
    }
    _result = (QFont *)new_QFont(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QFont_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static char * QFont_family(QFont *obj) {
    char * _result = (char *)obj->family();
    return _result;
}
static PyObject *_wrap_QFont_family(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    QFont * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QFont_family",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_family. Expected _QFont_p.");
        return NULL;
        }
    }
    _result = (char *)QFont_family(_arg0);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

static void  QFont_setFamily(QFont *obj,const char * _arg0) {
    obj->setFamily(_arg0);
}
static PyObject *_wrap_QFont_setFamily(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"ss:QFont_setFamily",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_setFamily. Expected _QFont_p.");
        return NULL;
        }
    }
    QFont_setFamily(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static int  QFont_pointSize(QFont *obj) {
    int  _result = (int )obj->pointSize();
    return _result;
}
static PyObject *_wrap_QFont_pointSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QFont * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QFont_pointSize",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_pointSize. Expected _QFont_p.");
        return NULL;
        }
    }
    _result = (int )QFont_pointSize(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  QFont_setPointSize(QFont *obj,int  _arg0) {
    obj->setPointSize(_arg0);
}
static PyObject *_wrap_QFont_setPointSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:QFont_setPointSize",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_setPointSize. Expected _QFont_p.");
        return NULL;
        }
    }
    QFont_setPointSize(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static int  QFont_weight(QFont *obj) {
    int  _result = (int )obj->weight();
    return _result;
}
static PyObject *_wrap_QFont_weight(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QFont * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QFont_weight",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_weight. Expected _QFont_p.");
        return NULL;
        }
    }
    _result = (int )QFont_weight(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  QFont_setWeight(QFont *obj,int  _arg0) {
    obj->setWeight(_arg0);
}
static PyObject *_wrap_QFont_setWeight(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:QFont_setWeight",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_setWeight. Expected _QFont_p.");
        return NULL;
        }
    }
    QFont_setWeight(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  QFont_bold(QFont *obj) {
    bool  _result = (bool )obj->bold();
    return _result;
}
static PyObject *_wrap_QFont_bold(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QFont * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QFont_bold",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_bold. Expected _QFont_p.");
        return NULL;
        }
    }
    _result = (bool )QFont_bold(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  QFont_setBold(QFont *obj,bool  _arg0) {
    obj->setBold(_arg0);
}
static PyObject *_wrap_QFont_setBold(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont * _arg0;
    bool  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:QFont_setBold",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_setBold. Expected _QFont_p.");
        return NULL;
        }
    }
    QFont_setBold(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  QFont_italic(QFont *obj) {
    bool  _result = (bool )obj->italic();
    return _result;
}
static PyObject *_wrap_QFont_italic(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QFont * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QFont_italic",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_italic. Expected _QFont_p.");
        return NULL;
        }
    }
    _result = (bool )QFont_italic(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  QFont_setItalic(QFont *obj,bool  _arg0) {
    obj->setItalic(_arg0);
}
static PyObject *_wrap_QFont_setItalic(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont * _arg0;
    bool  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:QFont_setItalic",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_setItalic. Expected _QFont_p.");
        return NULL;
        }
    }
    QFont_setItalic(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  QFont_underline(QFont *obj) {
    bool  _result = (bool )obj->underline();
    return _result;
}
static PyObject *_wrap_QFont_underline(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QFont * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QFont_underline",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_underline. Expected _QFont_p.");
        return NULL;
        }
    }
    _result = (bool )QFont_underline(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  QFont_setUnderline(QFont *obj,bool  _arg0) {
    obj->setUnderline(_arg0);
}
static PyObject *_wrap_QFont_setUnderline(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont * _arg0;
    bool  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:QFont_setUnderline",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_setUnderline. Expected _QFont_p.");
        return NULL;
        }
    }
    QFont_setUnderline(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  QFont_strikeOut(QFont *obj) {
    bool  _result = (bool )obj->strikeOut();
    return _result;
}
static PyObject *_wrap_QFont_strikeOut(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QFont * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QFont_strikeOut",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_strikeOut. Expected _QFont_p.");
        return NULL;
        }
    }
    _result = (bool )QFont_strikeOut(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  QFont_setStrikeOut(QFont *obj,bool  _arg0) {
    obj->setStrikeOut(_arg0);
}
static PyObject *_wrap_QFont_setStrikeOut(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont * _arg0;
    bool  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:QFont_setStrikeOut",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_setStrikeOut. Expected _QFont_p.");
        return NULL;
        }
    }
    QFont_setStrikeOut(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  QFont_fixedPitch(QFont *obj) {
    bool  _result = (bool )obj->fixedPitch();
    return _result;
}
static PyObject *_wrap_QFont_fixedPitch(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QFont * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QFont_fixedPitch",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_fixedPitch. Expected _QFont_p.");
        return NULL;
        }
    }
    _result = (bool )QFont_fixedPitch(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  QFont_setFixedPitch(QFont *obj,bool  _arg0) {
    obj->setFixedPitch(_arg0);
}
static PyObject *_wrap_QFont_setFixedPitch(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont * _arg0;
    bool  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:QFont_setFixedPitch",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_setFixedPitch. Expected _QFont_p.");
        return NULL;
        }
    }
    QFont_setFixedPitch(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static QFont::StyleHint  QFont_styleHint(QFont *obj) {
    QFont::StyleHint  _result = (QFont::StyleHint )obj->styleHint();
    return _result;
}
static PyObject *_wrap_QFont_styleHint(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont::StyleHint  _result;
    QFont * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QFont_styleHint",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_styleHint. Expected _QFont_p.");
        return NULL;
        }
    }
    _result = (QFont::StyleHint )QFont_styleHint(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  QFont_setStyleHint(QFont *obj,QFont::StyleHint  _arg0) {
    obj->setStyleHint(_arg0);
}
static PyObject *_wrap_QFont_setStyleHint(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont * _arg0;
    QFont::StyleHint  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:QFont_setStyleHint",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_setStyleHint. Expected _QFont_p.");
        return NULL;
        }
    }
    QFont_setStyleHint(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static QFont::CharSet  QFont_charSet(QFont *obj) {
    QFont::CharSet  _result = (QFont::CharSet )obj->charSet();
    return _result;
}
static PyObject *_wrap_QFont_charSet(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont::CharSet  _result;
    QFont * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QFont_charSet",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_charSet. Expected _QFont_p.");
        return NULL;
        }
    }
    _result = (QFont::CharSet )QFont_charSet(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  QFont_setCharSet(QFont *obj,QFont::CharSet  _arg0) {
    obj->setCharSet(_arg0);
}
static PyObject *_wrap_QFont_setCharSet(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont * _arg0;
    QFont::CharSet  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:QFont_setCharSet",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_setCharSet. Expected _QFont_p.");
        return NULL;
        }
    }
    QFont_setCharSet(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  QFont_rawMode(QFont *obj) {
    bool  _result = (bool )obj->rawMode();
    return _result;
}
static PyObject *_wrap_QFont_rawMode(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QFont * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QFont_rawMode",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_rawMode. Expected _QFont_p.");
        return NULL;
        }
    }
    _result = (bool )QFont_rawMode(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  QFont_setRawMode(QFont *obj,bool  _arg0) {
    obj->setRawMode(_arg0);
}
static PyObject *_wrap_QFont_setRawMode(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont * _arg0;
    bool  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:QFont_setRawMode",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_setRawMode. Expected _QFont_p.");
        return NULL;
        }
    }
    QFont_setRawMode(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  QFont_exactMatch(QFont *obj) {
    bool  _result = (bool )obj->exactMatch();
    return _result;
}
static PyObject *_wrap_QFont_exactMatch(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QFont * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QFont_exactMatch",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_exactMatch. Expected _QFont_p.");
        return NULL;
        }
    }
    _result = (bool )QFont_exactMatch(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static PyObject *_wrap_QFont_defaultFont(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont * _result;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,":QFont_defaultFont")) 
        return NULL;
    const QFont & _result_ref = QFont::defaultFont();
    _result = (QFont *) &_result_ref;
    SWIG_MakePtr(_ptemp, (char *) _result,"_QFont_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static PyObject *_wrap_QFont_setDefaultFont(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QFont_setDefaultFont",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_setDefaultFont. Expected _QFont_p.");
        return NULL;
        }
    }
    QFont::setDefaultFont(*_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static PyObject *_wrap_QFont_substitute(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    char * _arg0;

    if(!PyArg_ParseTuple(args,"s:QFont_substitute",&_arg0)) 
        return NULL;
    _result = (char *)QFont::substitute(_arg0);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

static PyObject *_wrap_QFont_insertSubstitution(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _arg0;
    char * _arg1;

    if(!PyArg_ParseTuple(args,"ss:QFont_insertSubstitution",&_arg0,&_arg1)) 
        return NULL;
    QFont::insertSubstitution(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static PyObject *_wrap_QFont_removeSubstitution(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _arg0;

    if(!PyArg_ParseTuple(args,"s:QFont_removeSubstitution",&_arg0)) 
        return NULL;
    QFont::removeSubstitution(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static QFontInfo *new_QFontInfo(const QFont * _arg0) {
    return new QFontInfo(*_arg0);
}
static PyObject *_wrap_new_QFontInfo(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFontInfo * _result;
    QFont * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:new_QFontInfo",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_QFontInfo. Expected _QFont_p.");
        return NULL;
        }
    }
    _result = (QFontInfo *)new_QFontInfo(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QFontInfo_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QFontInfo *new_QFontInfo(const QFontInfo * _arg0) {
    return new QFontInfo(*_arg0);
}
static PyObject *_wrap_new_QFontInfoCopy(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFontInfo * _result;
    QFontInfo * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:new_QFontInfoCopy",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontInfo_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_QFontInfoCopy. Expected _QFontInfo_p.");
        return NULL;
        }
    }
    _result = (QFontInfo *)new_QFontInfo(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QFontInfo_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void delete_QFontInfo(QFontInfo *obj) {
    delete obj;
}
static PyObject *_wrap_delete_QFontInfo(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFontInfo * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:delete_QFontInfo",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontInfo_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_QFontInfo. Expected _QFontInfo_p.");
        return NULL;
        }
    }
    delete_QFontInfo(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static char * QFontInfo_family(QFontInfo *obj) {
    char * _result = (char *)obj->family();
    return _result;
}
static PyObject *_wrap_QFontInfo_family(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    QFontInfo * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QFontInfo_family",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontInfo_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontInfo_family. Expected _QFontInfo_p.");
        return NULL;
        }
    }
    _result = (char *)QFontInfo_family(_arg0);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

static int  QFontInfo_pointSize(QFontInfo *obj) {
    int  _result = (int )obj->pointSize();
    return _result;
}
static PyObject *_wrap_QFontInfo_pointSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QFontInfo * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QFontInfo_pointSize",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontInfo_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontInfo_pointSize. Expected _QFontInfo_p.");
        return NULL;
        }
    }
    _result = (int )QFontInfo_pointSize(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static bool  QFontInfo_italic(QFontInfo *obj) {
    bool  _result = (bool )obj->italic();
    return _result;
}
static PyObject *_wrap_QFontInfo_italic(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QFontInfo * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QFontInfo_italic",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontInfo_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontInfo_italic. Expected _QFontInfo_p.");
        return NULL;
        }
    }
    _result = (bool )QFontInfo_italic(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  QFontInfo_weight(QFontInfo *obj) {
    int  _result = (int )obj->weight();
    return _result;
}
static PyObject *_wrap_QFontInfo_weight(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QFontInfo * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QFontInfo_weight",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontInfo_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontInfo_weight. Expected _QFontInfo_p.");
        return NULL;
        }
    }
    _result = (int )QFontInfo_weight(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static bool  QFontInfo_bold(QFontInfo *obj) {
    bool  _result = (bool )obj->bold();
    return _result;
}
static PyObject *_wrap_QFontInfo_bold(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QFontInfo * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QFontInfo_bold",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontInfo_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontInfo_bold. Expected _QFontInfo_p.");
        return NULL;
        }
    }
    _result = (bool )QFontInfo_bold(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static bool  QFontInfo_underline(QFontInfo *obj) {
    bool  _result = (bool )obj->underline();
    return _result;
}
static PyObject *_wrap_QFontInfo_underline(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QFontInfo * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QFontInfo_underline",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontInfo_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontInfo_underline. Expected _QFontInfo_p.");
        return NULL;
        }
    }
    _result = (bool )QFontInfo_underline(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static bool  QFontInfo_strikeOut(QFontInfo *obj) {
    bool  _result = (bool )obj->strikeOut();
    return _result;
}
static PyObject *_wrap_QFontInfo_strikeOut(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QFontInfo * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QFontInfo_strikeOut",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontInfo_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontInfo_strikeOut. Expected _QFontInfo_p.");
        return NULL;
        }
    }
    _result = (bool )QFontInfo_strikeOut(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static bool  QFontInfo_fixedPitch(QFontInfo *obj) {
    bool  _result = (bool )obj->fixedPitch();
    return _result;
}
static PyObject *_wrap_QFontInfo_fixedPitch(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QFontInfo * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QFontInfo_fixedPitch",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontInfo_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontInfo_fixedPitch. Expected _QFontInfo_p.");
        return NULL;
        }
    }
    _result = (bool )QFontInfo_fixedPitch(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static QFont::StyleHint  QFontInfo_styleHint(QFontInfo *obj) {
    QFont::StyleHint  _result = (QFont::StyleHint )obj->styleHint();
    return _result;
}
static PyObject *_wrap_QFontInfo_styleHint(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont::StyleHint  _result;
    QFontInfo * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QFontInfo_styleHint",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontInfo_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontInfo_styleHint. Expected _QFontInfo_p.");
        return NULL;
        }
    }
    _result = (QFont::StyleHint )QFontInfo_styleHint(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static QFont::CharSet  QFontInfo_charSet(QFontInfo *obj) {
    QFont::CharSet  _result = (QFont::CharSet )obj->charSet();
    return _result;
}
static PyObject *_wrap_QFontInfo_charSet(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont::CharSet  _result;
    QFontInfo * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QFontInfo_charSet",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontInfo_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontInfo_charSet. Expected _QFontInfo_p.");
        return NULL;
        }
    }
    _result = (QFont::CharSet )QFontInfo_charSet(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static bool  QFontInfo_rawMode(QFontInfo *obj) {
    bool  _result = (bool )obj->rawMode();
    return _result;
}
static PyObject *_wrap_QFontInfo_rawMode(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QFontInfo * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QFontInfo_rawMode",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontInfo_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontInfo_rawMode. Expected _QFontInfo_p.");
        return NULL;
        }
    }
    _result = (bool )QFontInfo_rawMode(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static bool  QFontInfo_exactMatch(QFontInfo *obj) {
    bool  _result = (bool )obj->exactMatch();
    return _result;
}
static PyObject *_wrap_QFontInfo_exactMatch(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QFontInfo * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QFontInfo_exactMatch",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontInfo_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontInfo_exactMatch. Expected _QFontInfo_p.");
        return NULL;
        }
    }
    _result = (bool )QFontInfo_exactMatch(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static QFontMetrics *new_QFontMetrics(const QFont * _arg0) {
    return new QFontMetrics(*_arg0);
}
static PyObject *_wrap_new_QFontMetrics(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFontMetrics * _result;
    QFont * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:new_QFontMetrics",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_QFontMetrics. Expected _QFont_p.");
        return NULL;
        }
    }
    _result = (QFontMetrics *)new_QFontMetrics(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QFontMetrics_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QFontMetrics *new_QFontMetrics(const QFontMetrics * _arg0) {
    return new QFontMetrics(*_arg0);
}
static PyObject *_wrap_new_QFontMetricsCopy(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFontMetrics * _result;
    QFontMetrics * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:new_QFontMetricsCopy",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontMetrics_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_QFontMetricsCopy. Expected _QFontMetrics_p.");
        return NULL;
        }
    }
    _result = (QFontMetrics *)new_QFontMetrics(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QFontMetrics_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void delete_QFontMetrics(QFontMetrics *obj) {
    delete obj;
}
static PyObject *_wrap_delete_QFontMetrics(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFontMetrics * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:delete_QFontMetrics",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontMetrics_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_QFontMetrics. Expected _QFontMetrics_p.");
        return NULL;
        }
    }
    delete_QFontMetrics(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static int  QFontMetrics_ascent(QFontMetrics *obj) {
    int  _result = (int )obj->ascent();
    return _result;
}
static PyObject *_wrap_QFontMetrics_ascent(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QFontMetrics * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QFontMetrics_ascent",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontMetrics_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontMetrics_ascent. Expected _QFontMetrics_p.");
        return NULL;
        }
    }
    _result = (int )QFontMetrics_ascent(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  QFontMetrics_descent(QFontMetrics *obj) {
    int  _result = (int )obj->descent();
    return _result;
}
static PyObject *_wrap_QFontMetrics_descent(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QFontMetrics * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QFontMetrics_descent",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontMetrics_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontMetrics_descent. Expected _QFontMetrics_p.");
        return NULL;
        }
    }
    _result = (int )QFontMetrics_descent(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  QFontMetrics_height(QFontMetrics *obj) {
    int  _result = (int )obj->height();
    return _result;
}
static PyObject *_wrap_QFontMetrics_height(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QFontMetrics * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QFontMetrics_height",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontMetrics_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontMetrics_height. Expected _QFontMetrics_p.");
        return NULL;
        }
    }
    _result = (int )QFontMetrics_height(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  QFontMetrics_leading(QFontMetrics *obj) {
    int  _result = (int )obj->leading();
    return _result;
}
static PyObject *_wrap_QFontMetrics_leading(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QFontMetrics * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QFontMetrics_leading",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontMetrics_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontMetrics_leading. Expected _QFontMetrics_p.");
        return NULL;
        }
    }
    _result = (int )QFontMetrics_leading(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  QFontMetrics_lineSpacing(QFontMetrics *obj) {
    int  _result = (int )obj->lineSpacing();
    return _result;
}
static PyObject *_wrap_QFontMetrics_lineSpacing(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QFontMetrics * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QFontMetrics_lineSpacing",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontMetrics_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontMetrics_lineSpacing. Expected _QFontMetrics_p.");
        return NULL;
        }
    }
    _result = (int )QFontMetrics_lineSpacing(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  QFontMetrics_width(QFontMetrics *obj,const char * _arg0,int  _arg1) {
    int  _result = (int )obj->width(_arg0,_arg1);
    return _result;
}
static PyObject *_wrap_QFontMetrics_width(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QFontMetrics * _arg0;
    char * _arg1;
    int  _arg2 = -1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"ss|i:QFontMetrics_width",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontMetrics_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontMetrics_width. Expected _QFontMetrics_p.");
        return NULL;
        }
    }
    _result = (int )QFontMetrics_width(_arg0,_arg1,_arg2);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  QFontMetrics_width(QFontMetrics *obj,char  _arg0) {
    int  _result = (int )obj->width(_arg0);
    return _result;
}
static PyObject *_wrap_QFontMetrics_charWidth(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QFontMetrics * _arg0;
    char  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"sc:QFontMetrics_charWidth",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontMetrics_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontMetrics_charWidth. Expected _QFontMetrics_p.");
        return NULL;
        }
    }
    _result = (int )QFontMetrics_width(_arg0,_arg1);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  QFontMetrics_maxWidth(QFontMetrics *obj) {
    int  _result = (int )obj->maxWidth();
    return _result;
}
static PyObject *_wrap_QFontMetrics_maxWidth(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QFontMetrics * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QFontMetrics_maxWidth",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontMetrics_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontMetrics_maxWidth. Expected _QFontMetrics_p.");
        return NULL;
        }
    }
    _result = (int )QFontMetrics_maxWidth(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  QFontMetrics_underlinePos(QFontMetrics *obj) {
    int  _result = (int )obj->underlinePos();
    return _result;
}
static PyObject *_wrap_QFontMetrics_underlinePos(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QFontMetrics * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QFontMetrics_underlinePos",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontMetrics_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontMetrics_underlinePos. Expected _QFontMetrics_p.");
        return NULL;
        }
    }
    _result = (int )QFontMetrics_underlinePos(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  QFontMetrics_strikeOutPos(QFontMetrics *obj) {
    int  _result = (int )obj->strikeOutPos();
    return _result;
}
static PyObject *_wrap_QFontMetrics_strikeOutPos(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QFontMetrics * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QFontMetrics_strikeOutPos",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontMetrics_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontMetrics_strikeOutPos. Expected _QFontMetrics_p.");
        return NULL;
        }
    }
    _result = (int )QFontMetrics_strikeOutPos(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  QFontMetrics_lineWidth(QFontMetrics *obj) {
    int  _result = (int )obj->lineWidth();
    return _result;
}
static PyObject *_wrap_QFontMetrics_lineWidth(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QFontMetrics * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QFontMetrics_lineWidth",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontMetrics_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontMetrics_lineWidth. Expected _QFontMetrics_p.");
        return NULL;
        }
    }
    _result = (int )QFontMetrics_lineWidth(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void delete_QPaintDevice(QPaintDevice *obj) {
    delete obj;
}
static PyObject *_wrap_delete_QPaintDevice(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPaintDevice * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:delete_QPaintDevice",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPaintDevice_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_QPaintDevice. Expected _QPaintDevice_p.");
        return NULL;
        }
    }
    delete_QPaintDevice(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static int  QPaintDevice_devType(QPaintDevice *obj) {
    int  _result = (int )obj->devType();
    return _result;
}
static PyObject *_wrap_QPaintDevice_devType(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QPaintDevice * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QPaintDevice_devType",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPaintDevice_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPaintDevice_devType. Expected _QPaintDevice_p.");
        return NULL;
        }
    }
    _result = (int )QPaintDevice_devType(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static bool  QPaintDevice_isExtDev(QPaintDevice *obj) {
    bool  _result = (bool )obj->isExtDev();
    return _result;
}
static PyObject *_wrap_QPaintDevice_isExtDev(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QPaintDevice * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QPaintDevice_isExtDev",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPaintDevice_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPaintDevice_isExtDev. Expected _QPaintDevice_p.");
        return NULL;
        }
    }
    _result = (bool )QPaintDevice_isExtDev(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static bool  QPaintDevice_paintingActive(QPaintDevice *obj) {
    bool  _result = (bool )obj->paintingActive();
    return _result;
}
static PyObject *_wrap_QPaintDevice_paintingActive(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QPaintDevice * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QPaintDevice_paintingActive",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPaintDevice_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPaintDevice_paintingActive. Expected _QPaintDevice_p.");
        return NULL;
        }
    }
    _result = (bool )QPaintDevice_paintingActive(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void *SwigQPixmapToQPaintDevice(void *ptr) {
    QPixmap *src;
    QPaintDevice *dest;
    src = (QPixmap *) ptr;
    dest = (QPaintDevice *) src;
    return (void *) dest;
}

static QPixmap *new_QPixmap() {
    return new QPixmap();
}
static PyObject *_wrap_new_QPixmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPixmap * _result;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,":new_QPixmap")) 
        return NULL;
    _result = (QPixmap *)new_QPixmap();
    SWIG_MakePtr(_ptemp, (char *) _result,"_QPixmap_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QPixmap *new_QPixmap(int  _arg0,int  _arg1,int  _arg2) {
    return new QPixmap(_arg0,_arg1,_arg2);
}
static PyObject *_wrap_new_QPixmapSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPixmap * _result;
    int  _arg0;
    int  _arg1;
    int  _arg2 = -1;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"ii|i:new_QPixmapSize",&_arg0,&_arg1,&_arg2)) 
        return NULL;
    _result = (QPixmap *)new_QPixmap(_arg0,_arg1,_arg2);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QPixmap_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QPixmap *new_QPixmap(const char * _arg0,const char * _arg1,QPixmap::ColorMode  _arg2) {
    return new QPixmap(_arg0,_arg1,_arg2);
}
static PyObject *_wrap_new_PixmapFile(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPixmap * _result;
    char * _arg0;
    char * _arg1 = 0;
    QPixmap::ColorMode  _arg2 = QPixmap::Auto;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s|si:new_PixmapFile",&_arg0,&_arg1,&_arg2)) 
        return NULL;
    _result = (QPixmap *)new_QPixmap(_arg0,_arg1,_arg2);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QPixmap_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QPixmap *new_QPixmap(const QPixmap * _arg0) {
    return new QPixmap(*_arg0);
}
static PyObject *_wrap_new_PixmapCopy(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPixmap * _result;
    QPixmap * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:new_PixmapCopy",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_PixmapCopy. Expected _QPixmap_p.");
        return NULL;
        }
    }
    _result = (QPixmap *)new_QPixmap(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QPixmap_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void delete_QPixmap(QPixmap *obj) {
    delete obj;
}
static PyObject *_wrap_delete_QPixmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPixmap * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:delete_QPixmap",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_QPixmap. Expected _QPixmap_p.");
        return NULL;
        }
    }
    delete_QPixmap(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  QPixmap_isNull(QPixmap *obj) {
    bool  _result = (bool )obj->isNull();
    return _result;
}
static PyObject *_wrap_QPixmap_isNull(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QPixmap * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QPixmap_isNull",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_isNull. Expected _QPixmap_p.");
        return NULL;
        }
    }
    _result = (bool )QPixmap_isNull(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  QPixmap_width(QPixmap *obj) {
    int  _result = (int )obj->width();
    return _result;
}
static PyObject *_wrap_QPixmap_width(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QPixmap * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QPixmap_width",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_width. Expected _QPixmap_p.");
        return NULL;
        }
    }
    _result = (int )QPixmap_width(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  QPixmap_height(QPixmap *obj) {
    int  _result = (int )obj->height();
    return _result;
}
static PyObject *_wrap_QPixmap_height(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QPixmap * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QPixmap_height",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_height. Expected _QPixmap_p.");
        return NULL;
        }
    }
    _result = (int )QPixmap_height(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  QPixmap_depth(QPixmap *obj) {
    int  _result = (int )obj->depth();
    return _result;
}
static PyObject *_wrap_QPixmap_depth(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QPixmap * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QPixmap_depth",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_depth. Expected _QPixmap_p.");
        return NULL;
        }
    }
    _result = (int )QPixmap_depth(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  QPixmap_resize(QPixmap *obj,int  _arg0,int  _arg1) {
    obj->resize(_arg0,_arg1);
}
static PyObject *_wrap_QPixmap_resize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPixmap * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"sii:QPixmap_resize",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_resize. Expected _QPixmap_p.");
        return NULL;
        }
    }
    QPixmap_resize(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static QBitmap * QPixmap_mask(QPixmap *obj) {
    QBitmap * _result = (QBitmap *)obj->mask();
    return _result;
}
static PyObject *_wrap_QPixmap_mask(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QBitmap * _result;
    QPixmap * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:QPixmap_mask",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_mask. Expected _QPixmap_p.");
        return NULL;
        }
    }
    _result = (QBitmap *)QPixmap_mask(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QBitmap_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void  QPixmap_setMask(QPixmap *obj,const QBitmap * _arg0) {
    obj->setMask(*_arg0);
}
static PyObject *_wrap_QPixmap_setMask(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPixmap * _arg0;
    QBitmap * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:QPixmap_setMask",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_setMask. Expected _QPixmap_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QBitmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QPixmap_setMask. Expected _QBitmap_p.");
        return NULL;
        }
    }
    QPixmap_setMask(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  QPixmap_selfMask(QPixmap *obj) {
    bool  _result = (bool )obj->selfMask();
    return _result;
}
static PyObject *_wrap_QPixmap_selfMask(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QPixmap * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QPixmap_selfMask",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_selfMask. Expected _QPixmap_p.");
        return NULL;
        }
    }
    _result = (bool )QPixmap_selfMask(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static QBitmap  QPixmap_createHeuristicMask(QPixmap *obj,bool  _arg0) {
    QBitmap  _result = (QBitmap )obj->createHeuristicMask(_arg0);
    return _result;
}
static PyObject *_wrap_QPixmap_createHeuristicMask(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QBitmap * _result;
    QPixmap * _arg0;
    bool  _arg1 = TRUE;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s|i:QPixmap_createHeuristicMask",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_createHeuristicMask. Expected _QPixmap_p.");
        return NULL;
        }
    }
    _result = new QBitmap (QPixmap_createHeuristicMask(_arg0,_arg1));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QBitmap_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static bool  QPixmap_load(QPixmap *obj,const char * _arg0,const char * _arg1,QPixmap::ColorMode  _arg2) {
    bool  _result = (bool )obj->load(_arg0,_arg1,_arg2);
    return _result;
}
static PyObject *_wrap_QPixmap_load(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QPixmap * _arg0;
    char * _arg1;
    char * _arg2 = 0;
    QPixmap::ColorMode  _arg3 = QPixmap::Auto;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"ss|si:QPixmap_load",&_argc0,&_arg1,&_arg2,&_arg3)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_load. Expected _QPixmap_p.");
        return NULL;
        }
    }
    _result = (bool )QPixmap_load(_arg0,_arg1,_arg2,_arg3);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static bool  QPixmap_loadFromData(QPixmap *obj,const uchar * _arg0,uint  _arg1,const char * _arg2,QPixmap::ColorMode  _arg3) {
    bool  _result = (bool )obj->loadFromData(_arg0,_arg1,_arg2,_arg3);
    return _result;
}
static PyObject *_wrap_QPixmap_loadFromData(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QPixmap * _arg0;
    uchar * _arg1;
    uint * _arg2;
    char * _arg3 = 0;
    QPixmap::ColorMode  _arg4 = QPixmap::Auto;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char * _argc2 = 0;

    if(!PyArg_ParseTuple(args,"sss|si:QPixmap_loadFromData",&_argc0,&_argc1,&_argc2,&_arg3,&_arg4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_loadFromData. Expected _QPixmap_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_uchar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QPixmap_loadFromData. Expected _uchar_p.");
        return NULL;
        }
    }
    if (_argc2) {
        if (SWIG_GetPtr(_argc2,(void **) &_arg2,"_uint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 3 of QPixmap_loadFromData. Expected _uint_p.");
        return NULL;
        }
    }
    _result = (bool )QPixmap_loadFromData(_arg0,_arg1,*_arg2,_arg3,_arg4);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static bool  QPixmap_save(QPixmap *obj,const char * _arg0,const char * _arg1) {
    bool  _result = (bool )obj->save(_arg0,_arg1);
    return _result;
}
static PyObject *_wrap_QPixmap_save(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QPixmap * _arg0;
    char * _arg1;
    char * _arg2;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"sss:QPixmap_save",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_save. Expected _QPixmap_p.");
        return NULL;
        }
    }
    _result = (bool )QPixmap_save(_arg0,_arg1,_arg2);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  QPixmap_serialNumber(QPixmap *obj) {
    int  _result = (int )obj->serialNumber();
    return _result;
}
static PyObject *_wrap_QPixmap_serialNumber(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QPixmap * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QPixmap_serialNumber",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_serialNumber. Expected _QPixmap_p.");
        return NULL;
        }
    }
    _result = (int )QPixmap_serialNumber(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static bool  QPixmap_isOptimized(QPixmap *obj) {
    bool  _result = (bool )obj->isOptimized();
    return _result;
}
static PyObject *_wrap_QPixmap_isOptimized(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QPixmap * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QPixmap_isOptimized",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_isOptimized. Expected _QPixmap_p.");
        return NULL;
        }
    }
    _result = (bool )QPixmap_isOptimized(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  QPixmap_optimize(QPixmap *obj,bool  _arg0) {
    obj->optimize(_arg0);
}
static PyObject *_wrap_QPixmap_optimize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPixmap * _arg0;
    bool  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:QPixmap_optimize",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_optimize. Expected _QPixmap_p.");
        return NULL;
        }
    }
    QPixmap_optimize(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  QPixmap_detach(QPixmap *obj) {
    obj->detach();
}
static PyObject *_wrap_QPixmap_detach(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPixmap * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QPixmap_detach",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_detach. Expected _QPixmap_p.");
        return NULL;
        }
    }
    QPixmap_detach(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  QPixmap_isQBitmap(QPixmap *obj) {
    bool  _result = (bool )obj->isQBitmap();
    return _result;
}
static PyObject *_wrap_QPixmap_isQBitmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QPixmap * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QPixmap_isQBitmap",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_isQBitmap. Expected _QPixmap_p.");
        return NULL;
        }
    }
    _result = (bool )QPixmap_isQBitmap(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static PyObject *_wrap_QPixmap_defaultDepth(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;

    if(!PyArg_ParseTuple(args,":QPixmap_defaultDepth")) 
        return NULL;
    _result = (int )QPixmap::defaultDepth();
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static char * QPixmap_imageFormat(QPixmap *obj,const char * _arg0) {
    char * _result = (char *)obj->imageFormat(_arg0);
    return _result;
}
static PyObject *_wrap_QPixmap_imageFormat(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    QPixmap * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"ss:QPixmap_imageFormat",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_imageFormat. Expected _QPixmap_p.");
        return NULL;
        }
    }
    _result = (char *)QPixmap_imageFormat(_arg0,_arg1);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

static bool  QPixmap_isGloballyOptimized(QPixmap *obj) {
    bool  _result = (bool )obj->isGloballyOptimized();
    return _result;
}
static PyObject *_wrap_QPixmap_isGloballyOptimized(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QPixmap * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QPixmap_isGloballyOptimized",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_isGloballyOptimized. Expected _QPixmap_p.");
        return NULL;
        }
    }
    _result = (bool )QPixmap_isGloballyOptimized(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  QPixmap_optimizeGlobally(QPixmap *obj,bool  _arg0) {
    obj->optimizeGlobally(_arg0);
}
static PyObject *_wrap_QPixmap_optimizeGlobally(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPixmap * _arg0;
    bool  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:QPixmap_optimizeGlobally",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_optimizeGlobally. Expected _QPixmap_p.");
        return NULL;
        }
    }
    QPixmap_optimizeGlobally(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigQBitmapToQPixmap(void *ptr) {
    QBitmap *src;
    QPixmap *dest;
    src = (QBitmap *) ptr;
    dest = (QPixmap *) src;
    return (void *) dest;
}

static void *SwigQBitmapToQPaintDevice(void *ptr) {
    QBitmap *src;
    QPaintDevice *dest;
    src = (QBitmap *) ptr;
    dest = (QPaintDevice *) src;
    return (void *) dest;
}

static QBitmap *new_QBitmap() {
    return new QBitmap();
}
static PyObject *_wrap_new_QBitmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QBitmap * _result;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,":new_QBitmap")) 
        return NULL;
    _result = (QBitmap *)new_QBitmap();
    SWIG_MakePtr(_ptemp, (char *) _result,"_QBitmap_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QBitmap *new_QBitmap(int  _arg0,int  _arg1,bool  _arg2) {
    return new QBitmap(_arg0,_arg1,_arg2);
}
static PyObject *_wrap_new_QBitmapSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QBitmap * _result;
    int  _arg0;
    int  _arg1;
    bool  _arg2 = FALSE;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"ii|i:new_QBitmapSize",&_arg0,&_arg1,&_arg2)) 
        return NULL;
    _result = (QBitmap *)new_QBitmap(_arg0,_arg1,_arg2);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QBitmap_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QBitmap *new_QBitmap(int  _arg0,int  _arg1,const uchar * _arg2,bool  _arg3) {
    return new QBitmap(_arg0,_arg1,_arg2,_arg3);
}
static PyObject *_wrap_new_QBitmapSizeData(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QBitmap * _result;
    int  _arg0;
    int  _arg1;
    uchar * _arg2;
    bool  _arg3 = FALSE;
    char * _argc2 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"iis|i:new_QBitmapSizeData",&_arg0,&_arg1,&_argc2,&_arg3)) 
        return NULL;
    if (_argc2) {
        if (SWIG_GetPtr(_argc2,(void **) &_arg2,"_uchar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 3 of new_QBitmapSizeData. Expected _uchar_p.");
        return NULL;
        }
    }
    _result = (QBitmap *)new_QBitmap(_arg0,_arg1,_arg2,_arg3);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QBitmap_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QBitmap *new_QBitmap(const QBitmap * _arg0) {
    return new QBitmap(*_arg0);
}
static PyObject *_wrap_new_QBitmapCopy(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QBitmap * _result;
    QBitmap * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:new_QBitmapCopy",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QBitmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_QBitmapCopy. Expected _QBitmap_p.");
        return NULL;
        }
    }
    _result = (QBitmap *)new_QBitmap(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QBitmap_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QBitmap *new_QBitmap(const char * _arg0,const char * _arg1) {
    return new QBitmap(_arg0,_arg1);
}
static PyObject *_wrap_new_QBitmapLoad(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QBitmap * _result;
    char * _arg0;
    char * _arg1 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s|s:new_QBitmapLoad",&_arg0,&_arg1)) 
        return NULL;
    _result = (QBitmap *)new_QBitmap(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QBitmap_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QPoint *new_QPoint() {
    return new QPoint();
}
static PyObject *_wrap_new_QPoint(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPoint * _result;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,":new_QPoint")) 
        return NULL;
    _result = (QPoint *)new_QPoint();
    SWIG_MakePtr(_ptemp, (char *) _result,"_QPoint_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QPoint *new_QPoint(int  _arg0,int  _arg1) {
    return new QPoint(_arg0,_arg1);
}
static PyObject *_wrap_new_QPointV(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPoint * _result;
    int  _arg0;
    int  _arg1;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"ii:new_QPointV",&_arg0,&_arg1)) 
        return NULL;
    _result = (QPoint *)new_QPoint(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QPoint_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static bool  QPoint_isNull(QPoint *obj) {
    bool  _result = (bool )obj->isNull();
    return _result;
}
static PyObject *_wrap_QPoint_isNull(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QPoint * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QPoint_isNull",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPoint_isNull. Expected _QPoint_p.");
        return NULL;
        }
    }
    _result = (bool )QPoint_isNull(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  QPoint_x(QPoint *obj) {
    int  _result = (int )obj->x();
    return _result;
}
static PyObject *_wrap_QPoint_x(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QPoint * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QPoint_x",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPoint_x. Expected _QPoint_p.");
        return NULL;
        }
    }
    _result = (int )QPoint_x(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  QPoint_y(QPoint *obj) {
    int  _result = (int )obj->y();
    return _result;
}
static PyObject *_wrap_QPoint_y(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QPoint * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QPoint_y",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPoint_y. Expected _QPoint_p.");
        return NULL;
        }
    }
    _result = (int )QPoint_y(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  QPoint_setX(QPoint *obj,int  _arg0) {
    obj->setX(_arg0);
}
static PyObject *_wrap_QPoint_setX(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPoint * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:QPoint_setX",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPoint_setX. Expected _QPoint_p.");
        return NULL;
        }
    }
    QPoint_setX(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  QPoint_setY(QPoint *obj,int  _arg0) {
    obj->setY(_arg0);
}
static PyObject *_wrap_QPoint_setY(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPoint * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:QPoint_setY",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPoint_setY. Expected _QPoint_p.");
        return NULL;
        }
    }
    QPoint_setY(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static QRect *new_QRect() {
    return new QRect();
}
static PyObject *_wrap_new_QRect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _result;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,":new_QRect")) 
        return NULL;
    _result = (QRect *)new_QRect();
    SWIG_MakePtr(_ptemp, (char *) _result,"_QRect_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QRect *new_QRect(const QPoint * _arg0,const QPoint * _arg1) {
    return new QRect(*_arg0,*_arg1);
}
static PyObject *_wrap_new_QRectPoints(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _result;
    QPoint * _arg0;
    QPoint * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"ss:new_QRectPoints",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_QRectPoints. Expected _QPoint_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of new_QRectPoints. Expected _QPoint_p.");
        return NULL;
        }
    }
    _result = (QRect *)new_QRect(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QRect_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QRect *new_QRect(const QPoint * _arg0,const QSize * _arg1) {
    return new QRect(*_arg0,*_arg1);
}
static PyObject *_wrap_new_QRectPointSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _result;
    QPoint * _arg0;
    QSize * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"ss:new_QRectPointSize",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_QRectPointSize. Expected _QPoint_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QSize_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of new_QRectPointSize. Expected _QSize_p.");
        return NULL;
        }
    }
    _result = (QRect *)new_QRect(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QRect_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QRect *new_QRect(int  _arg0,int  _arg1,int  _arg2,int  _arg3) {
    return new QRect(_arg0,_arg1,_arg2,_arg3);
}
static PyObject *_wrap_new_QRectLTWH(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _result;
    int  _arg0;
    int  _arg1;
    int  _arg2;
    int  _arg3;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"iiii:new_QRectLTWH",&_arg0,&_arg1,&_arg2,&_arg3)) 
        return NULL;
    _result = (QRect *)new_QRect(_arg0,_arg1,_arg2,_arg3);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QRect_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static bool  QRect_isNull(QRect *obj) {
    bool  _result = (bool )obj->isNull();
    return _result;
}
static PyObject *_wrap_QRect_isNull(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QRect * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QRect_isNull",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_isNull. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = (bool )QRect_isNull(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static bool  QRect_isEmpty(QRect *obj) {
    bool  _result = (bool )obj->isEmpty();
    return _result;
}
static PyObject *_wrap_QRect_isEmpty(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QRect * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QRect_isEmpty",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_isEmpty. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = (bool )QRect_isEmpty(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static bool  QRect_isValid(QRect *obj) {
    bool  _result = (bool )obj->isValid();
    return _result;
}
static PyObject *_wrap_QRect_isValid(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QRect * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QRect_isValid",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_isValid. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = (bool )QRect_isValid(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static QRect  QRect_normalize(QRect *obj) {
    QRect  _result = (QRect )obj->normalize();
    return _result;
}
static PyObject *_wrap_QRect_normalize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _result;
    QRect * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:QRect_normalize",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_normalize. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = new QRect (QRect_normalize(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QRect_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static int  QRect_left(QRect *obj) {
    int  _result = (int )obj->left();
    return _result;
}
static PyObject *_wrap_QRect_left(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QRect * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QRect_left",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_left. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = (int )QRect_left(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  QRect_top(QRect *obj) {
    int  _result = (int )obj->top();
    return _result;
}
static PyObject *_wrap_QRect_top(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QRect * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QRect_top",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_top. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = (int )QRect_top(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  QRect_right(QRect *obj) {
    int  _result = (int )obj->right();
    return _result;
}
static PyObject *_wrap_QRect_right(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QRect * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QRect_right",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_right. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = (int )QRect_right(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  QRect_bottom(QRect *obj) {
    int  _result = (int )obj->bottom();
    return _result;
}
static PyObject *_wrap_QRect_bottom(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QRect * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QRect_bottom",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_bottom. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = (int )QRect_bottom(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  QRect_x(QRect *obj) {
    int  _result = (int )obj->x();
    return _result;
}
static PyObject *_wrap_QRect_x(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QRect * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QRect_x",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_x. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = (int )QRect_x(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  QRect_y(QRect *obj) {
    int  _result = (int )obj->y();
    return _result;
}
static PyObject *_wrap_QRect_y(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QRect * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QRect_y",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_y. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = (int )QRect_y(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  QRect_setLeft(QRect *obj,int  _arg0) {
    obj->setLeft(_arg0);
}
static PyObject *_wrap_QRect_setLeft(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:QRect_setLeft",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_setLeft. Expected _QRect_p.");
        return NULL;
        }
    }
    QRect_setLeft(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  QRect_setTop(QRect *obj,int  _arg0) {
    obj->setTop(_arg0);
}
static PyObject *_wrap_QRect_setTop(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:QRect_setTop",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_setTop. Expected _QRect_p.");
        return NULL;
        }
    }
    QRect_setTop(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  QRect_setRight(QRect *obj,int  _arg0) {
    obj->setRight(_arg0);
}
static PyObject *_wrap_QRect_setRight(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:QRect_setRight",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_setRight. Expected _QRect_p.");
        return NULL;
        }
    }
    QRect_setRight(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  QRect_setBottom(QRect *obj,int  _arg0) {
    obj->setBottom(_arg0);
}
static PyObject *_wrap_QRect_setBottom(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:QRect_setBottom",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_setBottom. Expected _QRect_p.");
        return NULL;
        }
    }
    QRect_setBottom(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  QRect_setX(QRect *obj,int  _arg0) {
    obj->setX(_arg0);
}
static PyObject *_wrap_QRect_setX(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:QRect_setX",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_setX. Expected _QRect_p.");
        return NULL;
        }
    }
    QRect_setX(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  QRect_setY(QRect *obj,int  _arg0) {
    obj->setY(_arg0);
}
static PyObject *_wrap_QRect_setY(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:QRect_setY",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_setY. Expected _QRect_p.");
        return NULL;
        }
    }
    QRect_setY(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static QPoint  QRect_topLeft(QRect *obj) {
    QPoint  _result = (QPoint )obj->topLeft();
    return _result;
}
static PyObject *_wrap_QRect_topLeft(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPoint * _result;
    QRect * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:QRect_topLeft",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_topLeft. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = new QPoint (QRect_topLeft(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QPoint_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QPoint  QRect_bottomRight(QRect *obj) {
    QPoint  _result = (QPoint )obj->bottomRight();
    return _result;
}
static PyObject *_wrap_QRect_bottomRight(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPoint * _result;
    QRect * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:QRect_bottomRight",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_bottomRight. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = new QPoint (QRect_bottomRight(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QPoint_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QPoint  QRect_topRight(QRect *obj) {
    QPoint  _result = (QPoint )obj->topRight();
    return _result;
}
static PyObject *_wrap_QRect_topRight(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPoint * _result;
    QRect * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:QRect_topRight",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_topRight. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = new QPoint (QRect_topRight(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QPoint_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QPoint  QRect_bottomLeft(QRect *obj) {
    QPoint  _result = (QPoint )obj->bottomLeft();
    return _result;
}
static PyObject *_wrap_QRect_bottomLeft(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPoint * _result;
    QRect * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:QRect_bottomLeft",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_bottomLeft. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = new QPoint (QRect_bottomLeft(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QPoint_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QPoint  QRect_center(QRect *obj) {
    QPoint  _result = (QPoint )obj->center();
    return _result;
}
static PyObject *_wrap_QRect_center(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPoint * _result;
    QRect * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:QRect_center",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_center. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = new QPoint (QRect_center(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QPoint_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void  QRect_rect(QRect *obj,int * _arg0,int * _arg1,int * _arg2,int * _arg3) {
    obj->rect(_arg0,_arg1,_arg2,_arg3);
}
static PyObject *_wrap_QRect_rect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    int * _arg1;
    int * _arg2;
    int * _arg3;
    int * _arg4;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char * _argc2 = 0;
    char * _argc3 = 0;
    char * _argc4 = 0;

    if(!PyArg_ParseTuple(args,"sssss:QRect_rect",&_argc0,&_argc1,&_argc2,&_argc3,&_argc4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_rect. Expected _QRect_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_int_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QRect_rect. Expected _int_p.");
        return NULL;
        }
    }
    if (_argc2) {
        if (SWIG_GetPtr(_argc2,(void **) &_arg2,"_int_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 3 of QRect_rect. Expected _int_p.");
        return NULL;
        }
    }
    if (_argc3) {
        if (SWIG_GetPtr(_argc3,(void **) &_arg3,"_int_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 4 of QRect_rect. Expected _int_p.");
        return NULL;
        }
    }
    if (_argc4) {
        if (SWIG_GetPtr(_argc4,(void **) &_arg4,"_int_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 5 of QRect_rect. Expected _int_p.");
        return NULL;
        }
    }
    QRect_rect(_arg0,_arg1,_arg2,_arg3,_arg4);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  QRect_coords(QRect *obj,int * _arg0,int * _arg1,int * _arg2,int * _arg3) {
    obj->coords(_arg0,_arg1,_arg2,_arg3);
}
static PyObject *_wrap_QRect_coords(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    int * _arg1;
    int * _arg2;
    int * _arg3;
    int * _arg4;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char * _argc2 = 0;
    char * _argc3 = 0;
    char * _argc4 = 0;

    if(!PyArg_ParseTuple(args,"sssss:QRect_coords",&_argc0,&_argc1,&_argc2,&_argc3,&_argc4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_coords. Expected _QRect_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_int_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QRect_coords. Expected _int_p.");
        return NULL;
        }
    }
    if (_argc2) {
        if (SWIG_GetPtr(_argc2,(void **) &_arg2,"_int_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 3 of QRect_coords. Expected _int_p.");
        return NULL;
        }
    }
    if (_argc3) {
        if (SWIG_GetPtr(_argc3,(void **) &_arg3,"_int_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 4 of QRect_coords. Expected _int_p.");
        return NULL;
        }
    }
    if (_argc4) {
        if (SWIG_GetPtr(_argc4,(void **) &_arg4,"_int_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 5 of QRect_coords. Expected _int_p.");
        return NULL;
        }
    }
    QRect_coords(_arg0,_arg1,_arg2,_arg3,_arg4);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  QRect_moveTopLeft(QRect *obj,const QPoint * _arg0) {
    obj->moveTopLeft(*_arg0);
}
static PyObject *_wrap_QRect_moveTopLeft(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    QPoint * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:QRect_moveTopLeft",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_moveTopLeft. Expected _QRect_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QRect_moveTopLeft. Expected _QPoint_p.");
        return NULL;
        }
    }
    QRect_moveTopLeft(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  QRect_moveBottomRight(QRect *obj,const QPoint * _arg0) {
    obj->moveBottomRight(*_arg0);
}
static PyObject *_wrap_QRect_moveBottomRight(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    QPoint * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:QRect_moveBottomRight",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_moveBottomRight. Expected _QRect_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QRect_moveBottomRight. Expected _QPoint_p.");
        return NULL;
        }
    }
    QRect_moveBottomRight(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  QRect_moveTopRight(QRect *obj,const QPoint * _arg0) {
    obj->moveTopRight(*_arg0);
}
static PyObject *_wrap_QRect_moveTopRight(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    QPoint * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:QRect_moveTopRight",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_moveTopRight. Expected _QRect_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QRect_moveTopRight. Expected _QPoint_p.");
        return NULL;
        }
    }
    QRect_moveTopRight(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  QRect_moveBottomLeft(QRect *obj,const QPoint * _arg0) {
    obj->moveBottomLeft(*_arg0);
}
static PyObject *_wrap_QRect_moveBottomLeft(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    QPoint * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:QRect_moveBottomLeft",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_moveBottomLeft. Expected _QRect_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QRect_moveBottomLeft. Expected _QPoint_p.");
        return NULL;
        }
    }
    QRect_moveBottomLeft(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  QRect_moveCenter(QRect *obj,const QPoint * _arg0) {
    obj->moveCenter(*_arg0);
}
static PyObject *_wrap_QRect_moveCenter(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    QPoint * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:QRect_moveCenter",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_moveCenter. Expected _QRect_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QRect_moveCenter. Expected _QPoint_p.");
        return NULL;
        }
    }
    QRect_moveCenter(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  QRect_moveBy(QRect *obj,int  _arg0,int  _arg1) {
    obj->moveBy(_arg0,_arg1);
}
static PyObject *_wrap_QRect_moveBy(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"sii:QRect_moveBy",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_moveBy. Expected _QRect_p.");
        return NULL;
        }
    }
    QRect_moveBy(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  QRect_setRect(QRect *obj,int  _arg0,int  _arg1,int  _arg2,int  _arg3) {
    obj->setRect(_arg0,_arg1,_arg2,_arg3);
}
static PyObject *_wrap_QRect_setRect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    int  _arg1;
    int  _arg2;
    int  _arg3;
    int  _arg4;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"siiii:QRect_setRect",&_argc0,&_arg1,&_arg2,&_arg3,&_arg4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_setRect. Expected _QRect_p.");
        return NULL;
        }
    }
    QRect_setRect(_arg0,_arg1,_arg2,_arg3,_arg4);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  QRect_setCoords(QRect *obj,int  _arg0,int  _arg1,int  _arg2,int  _arg3) {
    obj->setCoords(_arg0,_arg1,_arg2,_arg3);
}
static PyObject *_wrap_QRect_setCoords(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    int  _arg1;
    int  _arg2;
    int  _arg3;
    int  _arg4;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"siiii:QRect_setCoords",&_argc0,&_arg1,&_arg2,&_arg3,&_arg4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_setCoords. Expected _QRect_p.");
        return NULL;
        }
    }
    QRect_setCoords(_arg0,_arg1,_arg2,_arg3,_arg4);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static QSize  QRect_size(QRect *obj) {
    QSize  _result = (QSize )obj->size();
    return _result;
}
static PyObject *_wrap_QRect_size(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QSize * _result;
    QRect * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:QRect_size",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_size. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = new QSize (QRect_size(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QSize_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static int  QRect_width(QRect *obj) {
    int  _result = (int )obj->width();
    return _result;
}
static PyObject *_wrap_QRect_width(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QRect * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QRect_width",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_width. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = (int )QRect_width(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  QRect_height(QRect *obj) {
    int  _result = (int )obj->height();
    return _result;
}
static PyObject *_wrap_QRect_height(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QRect * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QRect_height",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_height. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = (int )QRect_height(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  QRect_setWidth(QRect *obj,int  _arg0) {
    obj->setWidth(_arg0);
}
static PyObject *_wrap_QRect_setWidth(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:QRect_setWidth",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_setWidth. Expected _QRect_p.");
        return NULL;
        }
    }
    QRect_setWidth(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  QRect_setHeight(QRect *obj,int  _arg0) {
    obj->setHeight(_arg0);
}
static PyObject *_wrap_QRect_setHeight(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:QRect_setHeight",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_setHeight. Expected _QRect_p.");
        return NULL;
        }
    }
    QRect_setHeight(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  QRect_setSize(QRect *obj,const QSize * _arg0) {
    obj->setSize(*_arg0);
}
static PyObject *_wrap_QRect_setSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    QSize * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:QRect_setSize",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_setSize. Expected _QRect_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QSize_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QRect_setSize. Expected _QSize_p.");
        return NULL;
        }
    }
    QRect_setSize(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  QRect_contains(QRect *obj,const QPoint * _arg0,bool  _arg1) {
    bool  _result = (bool )obj->contains(*_arg0,_arg1);
    return _result;
}
static PyObject *_wrap_QRect_containsPoint(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QRect * _arg0;
    QPoint * _arg1;
    bool  _arg2 = FALSE;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss|i:QRect_containsPoint",&_argc0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_containsPoint. Expected _QRect_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QRect_containsPoint. Expected _QPoint_p.");
        return NULL;
        }
    }
    _result = (bool )QRect_contains(_arg0,_arg1,_arg2);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static bool  QRect_contains(QRect *obj,const QRect * _arg0,bool  _arg1) {
    bool  _result = (bool )obj->contains(*_arg0,_arg1);
    return _result;
}
static PyObject *_wrap_QRect_containsRect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QRect * _arg0;
    QRect * _arg1;
    bool  _arg2 = FALSE;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss|i:QRect_containsRect",&_argc0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_containsRect. Expected _QRect_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QRect_containsRect. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = (bool )QRect_contains(_arg0,_arg1,_arg2);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static QRect  QRect_unite(QRect *obj,const QRect * _arg0) {
    QRect  _result = (QRect )obj->unite(*_arg0);
    return _result;
}
static PyObject *_wrap_QRect_unite(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _result;
    QRect * _arg0;
    QRect * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"ss:QRect_unite",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_unite. Expected _QRect_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QRect_unite. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = new QRect (QRect_unite(_arg0,_arg1));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QRect_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QRect  QRect_intersect(QRect *obj,const QRect * _arg0) {
    QRect  _result = (QRect )obj->intersect(*_arg0);
    return _result;
}
static PyObject *_wrap_QRect_intersect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _result;
    QRect * _arg0;
    QRect * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"ss:QRect_intersect",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_intersect. Expected _QRect_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QRect_intersect. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = new QRect (QRect_intersect(_arg0,_arg1));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QRect_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static bool  QRect_intersects(QRect *obj,const QRect * _arg0) {
    bool  _result = (bool )obj->intersects(*_arg0);
    return _result;
}
static PyObject *_wrap_QRect_intersects(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QRect * _arg0;
    QRect * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:QRect_intersects",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_intersects. Expected _QRect_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QRect_intersects. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = (bool )QRect_intersects(_arg0,_arg1);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static QSize *new_QSize() {
    return new QSize();
}
static PyObject *_wrap_new_QSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QSize * _result;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,":new_QSize")) 
        return NULL;
    _result = (QSize *)new_QSize();
    SWIG_MakePtr(_ptemp, (char *) _result,"_QSize_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QSize *new_QSize(int  _arg0,int  _arg1) {
    return new QSize(_arg0,_arg1);
}
static PyObject *_wrap_new_QSizeV(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QSize * _result;
    int  _arg0;
    int  _arg1;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"ii:new_QSizeV",&_arg0,&_arg1)) 
        return NULL;
    _result = (QSize *)new_QSize(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QSize_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static bool  QSize_isNull(QSize *obj) {
    bool  _result = (bool )obj->isNull();
    return _result;
}
static PyObject *_wrap_QSize_isNull(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QSize * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QSize_isNull",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QSize_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QSize_isNull. Expected _QSize_p.");
        return NULL;
        }
    }
    _result = (bool )QSize_isNull(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static bool  QSize_isEmpty(QSize *obj) {
    bool  _result = (bool )obj->isEmpty();
    return _result;
}
static PyObject *_wrap_QSize_isEmpty(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QSize * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QSize_isEmpty",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QSize_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QSize_isEmpty. Expected _QSize_p.");
        return NULL;
        }
    }
    _result = (bool )QSize_isEmpty(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static bool  QSize_isValid(QSize *obj) {
    bool  _result = (bool )obj->isValid();
    return _result;
}
static PyObject *_wrap_QSize_isValid(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QSize * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QSize_isValid",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QSize_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QSize_isValid. Expected _QSize_p.");
        return NULL;
        }
    }
    _result = (bool )QSize_isValid(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  QSize_width(QSize *obj) {
    int  _result = (int )obj->width();
    return _result;
}
static PyObject *_wrap_QSize_width(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QSize * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QSize_width",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QSize_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QSize_width. Expected _QSize_p.");
        return NULL;
        }
    }
    _result = (int )QSize_width(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  QSize_height(QSize *obj) {
    int  _result = (int )obj->height();
    return _result;
}
static PyObject *_wrap_QSize_height(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QSize * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QSize_height",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QSize_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QSize_height. Expected _QSize_p.");
        return NULL;
        }
    }
    _result = (int )QSize_height(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  QSize_setWidth(QSize *obj,int  _arg0) {
    obj->setWidth(_arg0);
}
static PyObject *_wrap_QSize_setWidth(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QSize * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:QSize_setWidth",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QSize_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QSize_setWidth. Expected _QSize_p.");
        return NULL;
        }
    }
    QSize_setWidth(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  QSize_setHeight(QSize *obj,int  _arg0) {
    obj->setHeight(_arg0);
}
static PyObject *_wrap_QSize_setHeight(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QSize * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:QSize_setHeight",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QSize_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QSize_setHeight. Expected _QSize_p.");
        return NULL;
        }
    }
    QSize_setHeight(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static Object *new_Object() {
    return new Object();
}
static PyObject *_wrap_new_Object(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Object * _result;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,":new_Object")) 
        return NULL;
    _result = (Object *)new_Object();
    SWIG_MakePtr(_ptemp, (char *) _result,"_Object_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void  Object_connect(Object *obj,char * _arg0,PyObject * _arg1,PyObject * _arg2) {
    obj->connect(_arg0,_arg1,_arg2);
}
static PyObject *_wrap_Object_connect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Object * _arg0;
    char * _arg1;
    PyObject * _arg2;
    PyObject * _arg3 = 0;
    char * _argc0 = 0;
    PyObject * _obj2 = 0;
    PyObject * _obj3 = 0;

    if(!PyArg_ParseTuple(args,"ssO|O:Object_connect",&_argc0,&_arg1,&_obj2,&_obj3)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Object_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Object_connect. Expected _Object_p.");
        return NULL;
        }
    }
{
  if(!PyCallable_Check(_obj2))
  {
    PyErr_SetString(PyExc_TypeError, "Need a callable object!");
    return NULL;
  }
  _arg2 = _obj2;
}
    if (_obj3)
{
  _arg3 = _obj3;
}
    Object_connect(_arg0,_arg1,_arg2,_arg3);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Object_disconnect(Object *obj,PyObject * _arg0,char * _arg1) {
    obj->disconnect(_arg0,_arg1);
}
static PyObject *_wrap_Object_disconnect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Object * _arg0;
    PyObject * _arg1;
    char * _arg2 = "";
    char * _argc0 = 0;
    PyObject * _obj1 = 0;

    if(!PyArg_ParseTuple(args,"sO|s:Object_disconnect",&_argc0,&_obj1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Object_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Object_disconnect. Expected _Object_p.");
        return NULL;
        }
    }
{
  if(!PyCallable_Check(_obj1))
  {
    PyErr_SetString(PyExc_TypeError, "Need a callable object!");
    return NULL;
  }
  _arg1 = _obj1;
}
    Object_disconnect(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Object_emit(Object *obj,char * _arg0,PyObject * _arg1) {
    obj->emit(_arg0,_arg1);
}
static PyObject *_wrap_Object_emit(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Object * _arg0;
    char * _arg1;
    PyObject * _arg2;
    char * _argc0 = 0;
    PyObject * _obj2 = 0;

    if(!PyArg_ParseTuple(args,"ssO:Object_emit",&_argc0,&_arg1,&_obj2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Object_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Object_emit. Expected _Object_p.");
        return NULL;
        }
    }
{
  _arg2 = _obj2;
}
    Object_emit(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Object_timerConnection(Object *obj,char * _arg0,int  _arg1,PyObject * _arg2,PyObject * _arg3) {
    obj->timerConnection(_arg0,_arg1,_arg2,_arg3);
}
static PyObject *_wrap_Object_timerConnection(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Object * _arg0;
    char * _arg1;
    int  _arg2;
    PyObject * _arg3;
    PyObject * _arg4 = 0;
    char * _argc0 = 0;
    PyObject * _obj3 = 0;
    PyObject * _obj4 = 0;

    if(!PyArg_ParseTuple(args,"ssiO|O:Object_timerConnection",&_argc0,&_arg1,&_arg2,&_obj3,&_obj4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Object_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Object_timerConnection. Expected _Object_p.");
        return NULL;
        }
    }
{
  if(!PyCallable_Check(_obj3))
  {
    PyErr_SetString(PyExc_TypeError, "Need a callable object!");
    return NULL;
  }
  _arg3 = _obj3;
}
    if (_obj4)
{
  _arg4 = _obj4;
}
    Object_timerConnection(_arg0,_arg1,_arg2,_arg3,_arg4);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Object_killTimer(Object *obj,char * _arg0) {
    obj->killTimer(_arg0);
}
static PyObject *_wrap_Object_killTimer(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Object * _arg0;
    char * _arg1 = "";
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s|s:Object_killTimer",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Object_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Object_killTimer. Expected _Object_p.");
        return NULL;
        }
    }
    Object_killTimer(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigApplicationToObject(void *ptr) {
    Application *src;
    Object *dest;
    src = (Application *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

static Application *new_Application() {
    return new Application();
}
static PyObject *_wrap_new_Application(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Application * _result;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,":new_Application")) 
        return NULL;
    _result = (Application *)new_Application();
    SWIG_MakePtr(_ptemp, (char *) _result,"_Application_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void delete_Application(Application *obj) {
    delete obj;
}
static PyObject *_wrap_delete_Application(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Application * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:delete_Application",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Application_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_Application. Expected _Application_p.");
        return NULL;
        }
    }
    delete_Application(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static int  Application_argc(Application *obj) {
    int  _result = (int )obj->argc();
    return _result;
}
static PyObject *_wrap_Application_argc(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    Application * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Application_argc",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Application_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Application_argc. Expected _Application_p.");
        return NULL;
        }
    }
    _result = (int )Application_argc(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static char ** Application_argv(Application *obj) {
    char ** _result = (char **)obj->argv();
    return _result;
}
static PyObject *_wrap_Application_argv(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char ** _result;
    Application * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:Application_argv",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Application_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Application_argv. Expected _Application_p.");
        return NULL;
        }
    }
    _result = (char **)Application_argv(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_char_pp");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static Widget * Application_mainWidget(Application *obj) {
    Widget * _result = (Widget *)obj->mainWidget();
    return _result;
}
static PyObject *_wrap_Application_mainWidget(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _result;
    Application * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:Application_mainWidget",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Application_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Application_mainWidget. Expected _Application_p.");
        return NULL;
        }
    }
    _result = (Widget *)Application_mainWidget(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_Widget_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void  Application_setMainWidget(Application *obj,Widget * _arg0) {
    obj->setMainWidget(_arg0);
}
static PyObject *_wrap_Application_setMainWidget(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Application * _arg0;
    Widget * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:Application_setMainWidget",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Application_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Application_setMainWidget. Expected _Application_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Application_setMainWidget. Expected _Widget_p.");
        return NULL;
        }
    }
    Application_setMainWidget(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static Widget * Application_focusWidget(Application *obj) {
    Widget * _result = (Widget *)obj->focusWidget();
    return _result;
}
static PyObject *_wrap_Application_focusWidget(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _result;
    Application * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:Application_focusWidget",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Application_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Application_focusWidget. Expected _Application_p.");
        return NULL;
        }
    }
    _result = (Widget *)Application_focusWidget(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_Widget_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static int  Application_exec(Application *obj) {
    int  _result = (int )obj->exec();
    return _result;
}
static PyObject *_wrap_Application_execLoop(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    Application * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Application_execLoop",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Application_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Application_execLoop. Expected _Application_p.");
        return NULL;
        }
    }
    _result = (int )Application_exec(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  Application_processEvents(Application *obj) {
    obj->processEvents();
}
static PyObject *_wrap_Application_processEvents(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Application * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Application_processEvents",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Application_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Application_processEvents. Expected _Application_p.");
        return NULL;
        }
    }
    Application_processEvents(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static int  Application_enter_loop(Application *obj) {
    int  _result = (int )obj->enter_loop();
    return _result;
}
static PyObject *_wrap_Application_enter_loop(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    Application * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Application_enter_loop",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Application_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Application_enter_loop. Expected _Application_p.");
        return NULL;
        }
    }
    _result = (int )Application_enter_loop(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  Application_exit_loop(Application *obj) {
    obj->exit_loop();
}
static PyObject *_wrap_Application_exit_loop(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Application * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Application_exit_loop",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Application_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Application_exit_loop. Expected _Application_p.");
        return NULL;
        }
    }
    Application_exit_loop(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Application_quit(Application *obj) {
    obj->quit();
}
static PyObject *_wrap_Application_quit(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Application * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Application_quit",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Application_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Application_quit. Expected _Application_p.");
        return NULL;
        }
    }
    Application_quit(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Application_lastWindowClosed(Application *obj) {
    obj->lastWindowClosed();
}
static PyObject *_wrap_Application_lastWindowClosed(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Application * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Application_lastWindowClosed",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Application_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Application_lastWindowClosed. Expected _Application_p.");
        return NULL;
        }
    }
    Application_lastWindowClosed(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigLayoutToObject(void *ptr) {
    Layout *src;
    Object *dest;
    src = (Layout *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

static void delete_Layout(Layout *obj) {
    delete obj;
}
static PyObject *_wrap_delete_Layout(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Layout * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:delete_Layout",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Layout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_Layout. Expected _Layout_p.");
        return NULL;
        }
    }
    delete_Layout(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static int  Layout_defaultBorder(Layout *obj) {
    int  _result = (int )obj->defaultBorder();
    return _result;
}
static PyObject *_wrap_Layout_defaultBorder(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    Layout * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Layout_defaultBorder",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Layout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Layout_defaultBorder. Expected _Layout_p.");
        return NULL;
        }
    }
    _result = (int )Layout_defaultBorder(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static bool  Layout_activate(Layout *obj) {
    bool  _result = (bool )obj->activate();
    return _result;
}
static PyObject *_wrap_Layout_activate(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Layout * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Layout_activate",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Layout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Layout_activate. Expected _Layout_p.");
        return NULL;
        }
    }
    _result = (bool )Layout_activate(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  Layout_freeze(Layout *obj,int  _arg0,int  _arg1) {
    obj->freeze(_arg0,_arg1);
}
static PyObject *_wrap_Layout_freeze(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Layout * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"sii:Layout_freeze",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Layout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Layout_freeze. Expected _Layout_p.");
        return NULL;
        }
    }
    Layout_freeze(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static Widget * Layout_mainWidget(Layout *obj) {
    Widget * _result = (Widget *)obj->mainWidget();
    return _result;
}
static PyObject *_wrap_Layout_mainWidget(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _result;
    Layout * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:Layout_mainWidget",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Layout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Layout_mainWidget. Expected _Layout_p.");
        return NULL;
        }
    }
    _result = (Widget *)Layout_mainWidget(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_Widget_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void *SwigBoxLayoutToLayout(void *ptr) {
    BoxLayout *src;
    Layout *dest;
    src = (BoxLayout *) ptr;
    dest = (Layout *) src;
    return (void *) dest;
}

static void *SwigBoxLayoutToObject(void *ptr) {
    BoxLayout *src;
    Object *dest;
    src = (BoxLayout *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

static BoxLayout *new_BoxLayout(Widget * _arg0,BoxLayout::Direction  _arg1,int  _arg2,int  _arg3,const char * _arg4) {
    return new BoxLayout(_arg0,_arg1,_arg2,_arg3,_arg4);
}
static PyObject *_wrap_new_BoxLayout(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    BoxLayout * _result;
    Widget * _arg0;
    BoxLayout::Direction  _arg1;
    int  _arg2 = 0;
    int  _arg3 = -1;
    char * _arg4 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"si|iis:new_BoxLayout",&_argc0,&_arg1,&_arg2,&_arg3,&_arg4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_BoxLayout. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (BoxLayout *)new_BoxLayout(_arg0,_arg1,_arg2,_arg3,_arg4);
    SWIG_MakePtr(_ptemp, (char *) _result,"_BoxLayout_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static BoxLayout *new_BoxLayout(BoxLayout::Direction  _arg0,int  _arg1,const char * _arg2) {
    return new BoxLayout(_arg0,_arg1,_arg2);
}
static PyObject *_wrap_new_BoxSubLayout(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    BoxLayout * _result;
    BoxLayout::Direction  _arg0;
    int  _arg1 = -1;
    char * _arg2 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"i|is:new_BoxSubLayout",&_arg0,&_arg1,&_arg2)) 
        return NULL;
    _result = (BoxLayout *)new_BoxLayout(_arg0,_arg1,_arg2);
    SWIG_MakePtr(_ptemp, (char *) _result,"_BoxLayout_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void delete_BoxLayout(BoxLayout *obj) {
    delete obj;
}
static PyObject *_wrap_delete_BoxLayout(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    BoxLayout * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:delete_BoxLayout",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_BoxLayout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_BoxLayout. Expected _BoxLayout_p.");
        return NULL;
        }
    }
    delete_BoxLayout(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  BoxLayout_addWidget(BoxLayout *obj,Widget * _arg0,int  _arg1,int  _arg2) {
    obj->addWidget(_arg0,_arg1,_arg2);
}
static PyObject *_wrap_BoxLayout_addWidget(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    BoxLayout * _arg0;
    Widget * _arg1;
    int  _arg2 = 0;
    int  _arg3 = AlignCenter;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss|ii:BoxLayout_addWidget",&_argc0,&_argc1,&_arg2,&_arg3)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_BoxLayout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of BoxLayout_addWidget. Expected _BoxLayout_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of BoxLayout_addWidget. Expected _Widget_p.");
        return NULL;
        }
    }
    BoxLayout_addWidget(_arg0,_arg1,_arg2,_arg3);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  BoxLayout_addSpacing(BoxLayout *obj,int  _arg0) {
    obj->addSpacing(_arg0);
}
static PyObject *_wrap_BoxLayout_addSpacing(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    BoxLayout * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:BoxLayout_addSpacing",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_BoxLayout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of BoxLayout_addSpacing. Expected _BoxLayout_p.");
        return NULL;
        }
    }
    BoxLayout_addSpacing(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  BoxLayout_addStretch(BoxLayout *obj,int  _arg0) {
    obj->addStretch(_arg0);
}
static PyObject *_wrap_BoxLayout_addStretch(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    BoxLayout * _arg0;
    int  _arg1 = 0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s|i:BoxLayout_addStretch",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_BoxLayout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of BoxLayout_addStretch. Expected _BoxLayout_p.");
        return NULL;
        }
    }
    BoxLayout_addStretch(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  BoxLayout_addLayout(BoxLayout *obj,Layout * _arg0,int  _arg1) {
    obj->addLayout(_arg0,_arg1);
}
static PyObject *_wrap_BoxLayout_addLayout(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    BoxLayout * _arg0;
    Layout * _arg1;
    int  _arg2 = 0;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss|i:BoxLayout_addLayout",&_argc0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_BoxLayout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of BoxLayout_addLayout. Expected _BoxLayout_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Layout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of BoxLayout_addLayout. Expected _Layout_p.");
        return NULL;
        }
    }
    BoxLayout_addLayout(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static BoxLayout::Direction  BoxLayout_direction(BoxLayout *obj) {
    BoxLayout::Direction  _result = (BoxLayout::Direction )obj->direction();
    return _result;
}
static PyObject *_wrap_BoxLayout_direction(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    BoxLayout::Direction  _result;
    BoxLayout * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:BoxLayout_direction",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_BoxLayout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of BoxLayout_direction. Expected _BoxLayout_p.");
        return NULL;
        }
    }
    _result = (BoxLayout::Direction )BoxLayout_direction(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  BoxLayout_addStrut(BoxLayout *obj,int  _arg0) {
    obj->addStrut(_arg0);
}
static PyObject *_wrap_BoxLayout_addStrut(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    BoxLayout * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:BoxLayout_addStrut",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_BoxLayout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of BoxLayout_addStrut. Expected _BoxLayout_p.");
        return NULL;
        }
    }
    BoxLayout_addStrut(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigGridLayoutToLayout(void *ptr) {
    GridLayout *src;
    Layout *dest;
    src = (GridLayout *) ptr;
    dest = (Layout *) src;
    return (void *) dest;
}

static void *SwigGridLayoutToObject(void *ptr) {
    GridLayout *src;
    Object *dest;
    src = (GridLayout *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

static GridLayout *new_GridLayout(Widget * _arg0,int  _arg1,int  _arg2,int  _arg3,int  _arg4,const char * _arg5) {
    return new GridLayout(_arg0,_arg1,_arg2,_arg3,_arg4,_arg5);
}
static PyObject *_wrap_new_GridLayout(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    GridLayout * _result;
    Widget * _arg0;
    int  _arg1;
    int  _arg2;
    int  _arg3 = 0;
    int  _arg4 = -1;
    char * _arg5 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"sii|iis:new_GridLayout",&_argc0,&_arg1,&_arg2,&_arg3,&_arg4,&_arg5)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_GridLayout. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (GridLayout *)new_GridLayout(_arg0,_arg1,_arg2,_arg3,_arg4,_arg5);
    SWIG_MakePtr(_ptemp, (char *) _result,"_GridLayout_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static GridLayout *new_GridLayout(int  _arg0,int  _arg1,int  _arg2,const char * _arg3) {
    return new GridLayout(_arg0,_arg1,_arg2,_arg3);
}
static PyObject *_wrap_new_GridSubLayout(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    GridLayout * _result;
    int  _arg0;
    int  _arg1;
    int  _arg2 = -1;
    char * _arg3 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"ii|is:new_GridSubLayout",&_arg0,&_arg1,&_arg2,&_arg3)) 
        return NULL;
    _result = (GridLayout *)new_GridLayout(_arg0,_arg1,_arg2,_arg3);
    SWIG_MakePtr(_ptemp, (char *) _result,"_GridLayout_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void delete_GridLayout(GridLayout *obj) {
    delete obj;
}
static PyObject *_wrap_delete_GridLayout(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    GridLayout * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:delete_GridLayout",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_GridLayout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_GridLayout. Expected _GridLayout_p.");
        return NULL;
        }
    }
    delete_GridLayout(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  GridLayout_addWidget(GridLayout *obj,Widget * _arg0,int  _arg1,int  _arg2,int  _arg3) {
    obj->addWidget(_arg0,_arg1,_arg2,_arg3);
}
static PyObject *_wrap_GridLayout_addWidget(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    GridLayout * _arg0;
    Widget * _arg1;
    int  _arg2;
    int  _arg3;
    int  _arg4 = 0;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ssii|i:GridLayout_addWidget",&_argc0,&_argc1,&_arg2,&_arg3,&_arg4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_GridLayout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of GridLayout_addWidget. Expected _GridLayout_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of GridLayout_addWidget. Expected _Widget_p.");
        return NULL;
        }
    }
    GridLayout_addWidget(_arg0,_arg1,_arg2,_arg3,_arg4);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  GridLayout_addMultiCellWidget(GridLayout *obj,Widget * _arg0,int  _arg1,int  _arg2,int  _arg3,int  _arg4,int  _arg5) {
    obj->addMultiCellWidget(_arg0,_arg1,_arg2,_arg3,_arg4,_arg5);
}
static PyObject *_wrap_GridLayout_addMultiCellWidget(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    GridLayout * _arg0;
    Widget * _arg1;
    int  _arg2;
    int  _arg3;
    int  _arg4;
    int  _arg5;
    int  _arg6 = 0;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ssiiii|i:GridLayout_addMultiCellWidget",&_argc0,&_argc1,&_arg2,&_arg3,&_arg4,&_arg5,&_arg6)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_GridLayout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of GridLayout_addMultiCellWidget. Expected _GridLayout_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of GridLayout_addMultiCellWidget. Expected _Widget_p.");
        return NULL;
        }
    }
    GridLayout_addMultiCellWidget(_arg0,_arg1,_arg2,_arg3,_arg4,_arg5,_arg6);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  GridLayout_addLayout(GridLayout *obj,Layout * _arg0,int  _arg1,int  _arg2) {
    obj->addLayout(_arg0,_arg1,_arg2);
}
static PyObject *_wrap_GridLayout_addLayout(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    GridLayout * _arg0;
    Layout * _arg1;
    int  _arg2;
    int  _arg3;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ssii:GridLayout_addLayout",&_argc0,&_argc1,&_arg2,&_arg3)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_GridLayout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of GridLayout_addLayout. Expected _GridLayout_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Layout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of GridLayout_addLayout. Expected _Layout_p.");
        return NULL;
        }
    }
    GridLayout_addLayout(_arg0,_arg1,_arg2,_arg3);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  GridLayout_setRowStretch(GridLayout *obj,int  _arg0,int  _arg1) {
    obj->setRowStretch(_arg0,_arg1);
}
static PyObject *_wrap_GridLayout_setRowStretch(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    GridLayout * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"sii:GridLayout_setRowStretch",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_GridLayout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of GridLayout_setRowStretch. Expected _GridLayout_p.");
        return NULL;
        }
    }
    GridLayout_setRowStretch(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  GridLayout_setColStretch(GridLayout *obj,int  _arg0,int  _arg1) {
    obj->setColStretch(_arg0,_arg1);
}
static PyObject *_wrap_GridLayout_setColStretch(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    GridLayout * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"sii:GridLayout_setColStretch",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_GridLayout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of GridLayout_setColStretch. Expected _GridLayout_p.");
        return NULL;
        }
    }
    GridLayout_setColStretch(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigWidgetToObject(void *ptr) {
    Widget *src;
    Object *dest;
    src = (Widget *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

static Widget *new_Widget(Widget * _arg0,const char * _arg1) {
    return new Widget(_arg0,_arg1);
}
static PyObject *_wrap_new_Widget(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"|ss:new_Widget",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_Widget. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (Widget *)new_Widget(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_Widget_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void delete_Widget(Widget *obj) {
    delete obj;
}
static PyObject *_wrap_delete_Widget(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:delete_Widget",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_Widget. Expected _Widget_p.");
        return NULL;
        }
    }
    delete_Widget(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  Widget_isTopLevel(Widget *obj) {
    bool  _result = (bool )obj->isTopLevel();
    return _result;
}
static PyObject *_wrap_Widget_isTopLevel(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Widget * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Widget_isTopLevel",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_isTopLevel. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (bool )Widget_isTopLevel(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static bool  Widget_isModal(Widget *obj) {
    bool  _result = (bool )obj->isModal();
    return _result;
}
static PyObject *_wrap_Widget_isModal(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Widget * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Widget_isModal",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_isModal. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (bool )Widget_isModal(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static bool  Widget_isPopup(Widget *obj) {
    bool  _result = (bool )obj->isPopup();
    return _result;
}
static PyObject *_wrap_Widget_isPopup(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Widget * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Widget_isPopup",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_isPopup. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (bool )Widget_isPopup(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static bool  Widget_isDesktop(Widget *obj) {
    bool  _result = (bool )obj->isDesktop();
    return _result;
}
static PyObject *_wrap_Widget_isDesktop(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Widget * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Widget_isDesktop",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_isDesktop. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (bool )Widget_isDesktop(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static bool  Widget_isEnabled(Widget *obj) {
    bool  _result = (bool )obj->isEnabled();
    return _result;
}
static PyObject *_wrap_Widget_isEnabled(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Widget * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Widget_isEnabled",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_isEnabled. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (bool )Widget_isEnabled(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  Widget_setEnabled(Widget *obj,int  _arg0) {
    obj->setEnabled(_arg0);
}
static PyObject *_wrap_Widget_setEnabled(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:Widget_setEnabled",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setEnabled. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_setEnabled(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static QRect * Widget_frameGeometry(Widget *obj) {
    const QRect & _result = obj->frameGeometry();
    return (QRect *) &_result;
}
static PyObject *_wrap_Widget_frameGeometry(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:Widget_frameGeometry",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_frameGeometry. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (QRect *)Widget_frameGeometry(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QRect_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QRect * Widget_geometry(Widget *obj) {
    const QRect & _result = obj->geometry();
    return (QRect *) &_result;
}
static PyObject *_wrap_Widget_geometry(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:Widget_geometry",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_geometry. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (QRect *)Widget_geometry(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QRect_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static int  Widget_x(Widget *obj) {
    int  _result = (int )obj->x();
    return _result;
}
static PyObject *_wrap_Widget_x(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    Widget * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Widget_x",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_x. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (int )Widget_x(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  Widget_y(Widget *obj) {
    int  _result = (int )obj->y();
    return _result;
}
static PyObject *_wrap_Widget_y(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    Widget * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Widget_y",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_y. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (int )Widget_y(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static QPoint  Widget_pos(Widget *obj) {
    QPoint  _result = (QPoint )obj->pos();
    return _result;
}
static PyObject *_wrap_Widget_pos(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPoint * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:Widget_pos",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_pos. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = new QPoint (Widget_pos(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QPoint_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QSize  Widget_size(Widget *obj) {
    QSize  _result = (QSize )obj->size();
    return _result;
}
static PyObject *_wrap_Widget_size(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QSize * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:Widget_size",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_size. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = new QSize (Widget_size(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QSize_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static int  Widget_width(Widget *obj) {
    int  _result = (int )obj->width();
    return _result;
}
static PyObject *_wrap_Widget_width(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    Widget * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Widget_width",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_width. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (int )Widget_width(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  Widget_height(Widget *obj) {
    int  _result = (int )obj->height();
    return _result;
}
static PyObject *_wrap_Widget_height(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    Widget * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Widget_height",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_height. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (int )Widget_height(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static QRect  Widget_rect(Widget *obj) {
    QRect  _result = (QRect )obj->rect();
    return _result;
}
static PyObject *_wrap_Widget_rect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:Widget_rect",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_rect. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = new QRect (Widget_rect(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QRect_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QRect  Widget_childrenRect(Widget *obj) {
    QRect  _result = (QRect )obj->childrenRect();
    return _result;
}
static PyObject *_wrap_Widget_childrenRect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:Widget_childrenRect",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_childrenRect. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = new QRect (Widget_childrenRect(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QRect_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QSize  Widget_minimumSize(Widget *obj) {
    QSize  _result = (QSize )obj->minimumSize();
    return _result;
}
static PyObject *_wrap_Widget_minimumSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QSize * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:Widget_minimumSize",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_minimumSize. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = new QSize (Widget_minimumSize(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QSize_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QSize  Widget_maximumSize(Widget *obj) {
    QSize  _result = (QSize )obj->maximumSize();
    return _result;
}
static PyObject *_wrap_Widget_maximumSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QSize * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:Widget_maximumSize",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_maximumSize. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = new QSize (Widget_maximumSize(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QSize_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void  Widget_setMinimumSize(Widget *obj,const QSize * _arg0) {
    obj->setMinimumSize(*_arg0);
}
static PyObject *_wrap_Widget_setMinimumQSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    QSize * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:Widget_setMinimumQSize",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setMinimumQSize. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QSize_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_setMinimumQSize. Expected _QSize_p.");
        return NULL;
        }
    }
    Widget_setMinimumSize(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Widget_setMinimumSize(Widget *obj,int  _arg0,int  _arg1) {
    obj->setMinimumSize(_arg0,_arg1);
}
static PyObject *_wrap_Widget_setMinimumSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"sii:Widget_setMinimumSize",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setMinimumSize. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_setMinimumSize(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Widget_setMaximumSize(Widget *obj,const QSize * _arg0) {
    obj->setMaximumSize(*_arg0);
}
static PyObject *_wrap_Widget_setMaximumQSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    QSize * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:Widget_setMaximumQSize",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setMaximumQSize. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QSize_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_setMaximumQSize. Expected _QSize_p.");
        return NULL;
        }
    }
    Widget_setMaximumSize(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Widget_setMaximumSize(Widget *obj,int  _arg0,int  _arg1) {
    obj->setMaximumSize(_arg0,_arg1);
}
static PyObject *_wrap_Widget_setMaximumSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"sii:Widget_setMaximumSize",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setMaximumSize. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_setMaximumSize(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static QSize  Widget_sizeIncrement(Widget *obj) {
    QSize  _result = (QSize )obj->sizeIncrement();
    return _result;
}
static PyObject *_wrap_Widget_sizeIncrement(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QSize * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:Widget_sizeIncrement",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_sizeIncrement. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = new QSize (Widget_sizeIncrement(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QSize_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void  Widget_setSizeIncrement(Widget *obj,const QSize * _arg0) {
    obj->setSizeIncrement(*_arg0);
}
static PyObject *_wrap_Widget_setQSizeIncrement(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    QSize * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:Widget_setQSizeIncrement",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setQSizeIncrement. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QSize_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_setQSizeIncrement. Expected _QSize_p.");
        return NULL;
        }
    }
    Widget_setSizeIncrement(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Widget_setSizeIncrement(Widget *obj,int  _arg0,int  _arg1) {
    obj->setSizeIncrement(_arg0,_arg1);
}
static PyObject *_wrap_Widget_setSizeIncrement(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"sii:Widget_setSizeIncrement",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setSizeIncrement. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_setSizeIncrement(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Widget_setFixedSize(Widget *obj,const QSize * _arg0) {
    obj->setFixedSize(*_arg0);
}
static PyObject *_wrap_Widget_setFixedQSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    QSize * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:Widget_setFixedQSize",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setFixedQSize. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QSize_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_setFixedQSize. Expected _QSize_p.");
        return NULL;
        }
    }
    Widget_setFixedSize(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Widget_setFixedSize(Widget *obj,int  _arg0,int  _arg1) {
    obj->setFixedSize(_arg0,_arg1);
}
static PyObject *_wrap_Widget_setFixedSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"sii:Widget_setFixedSize",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setFixedSize. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_setFixedSize(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static QPoint  Widget_mapToGlobal(Widget *obj,const QPoint * _arg0) {
    QPoint  _result = (QPoint )obj->mapToGlobal(*_arg0);
    return _result;
}
static PyObject *_wrap_Widget_mapToGlobal(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPoint * _result;
    Widget * _arg0;
    QPoint * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"ss:Widget_mapToGlobal",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_mapToGlobal. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_mapToGlobal. Expected _QPoint_p.");
        return NULL;
        }
    }
    _result = new QPoint (Widget_mapToGlobal(_arg0,_arg1));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QPoint_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QPoint  Widget_mapFromGlobal(Widget *obj,const QPoint * _arg0) {
    QPoint  _result = (QPoint )obj->mapFromGlobal(*_arg0);
    return _result;
}
static PyObject *_wrap_Widget_mapFromGlobal(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPoint * _result;
    Widget * _arg0;
    QPoint * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"ss:Widget_mapFromGlobal",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_mapFromGlobal. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_mapFromGlobal. Expected _QPoint_p.");
        return NULL;
        }
    }
    _result = new QPoint (Widget_mapFromGlobal(_arg0,_arg1));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QPoint_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QPoint  Widget_mapToParent(Widget *obj,const QPoint * _arg0) {
    QPoint  _result = (QPoint )obj->mapToParent(*_arg0);
    return _result;
}
static PyObject *_wrap_Widget_mapToParent(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPoint * _result;
    Widget * _arg0;
    QPoint * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"ss:Widget_mapToParent",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_mapToParent. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_mapToParent. Expected _QPoint_p.");
        return NULL;
        }
    }
    _result = new QPoint (Widget_mapToParent(_arg0,_arg1));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QPoint_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QPoint  Widget_mapFromParent(Widget *obj,const QPoint * _arg0) {
    QPoint  _result = (QPoint )obj->mapFromParent(*_arg0);
    return _result;
}
static PyObject *_wrap_Widget_mapFromParent(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPoint * _result;
    Widget * _arg0;
    QPoint * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"ss:Widget_mapFromParent",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_mapFromParent. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_mapFromParent. Expected _QPoint_p.");
        return NULL;
        }
    }
    _result = new QPoint (Widget_mapFromParent(_arg0,_arg1));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QPoint_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static Widget * Widget_topLevelWidget(Widget *obj) {
    Widget * _result = (Widget *)obj->topLevelWidget();
    return _result;
}
static PyObject *_wrap_Widget_topLevelWidget(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:Widget_topLevelWidget",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_topLevelWidget. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (Widget *)Widget_topLevelWidget(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_Widget_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QColor * Widget_backgroundColor(Widget *obj) {
    const QColor & _result = obj->backgroundColor();
    return (QColor *) &_result;
}
static PyObject *_wrap_Widget_backgroundColor(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:Widget_backgroundColor",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_backgroundColor. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (QColor *)Widget_backgroundColor(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColor_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QColor * Widget_foregroundColor(Widget *obj) {
    const QColor & _result = obj->foregroundColor();
    return (QColor *) &_result;
}
static PyObject *_wrap_Widget_foregroundColor(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:Widget_foregroundColor",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_foregroundColor. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (QColor *)Widget_foregroundColor(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColor_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void  Widget_setBackgroundColor(Widget *obj,const QColor * _arg0) {
    obj->setBackgroundColor(*_arg0);
}
static PyObject *_wrap_Widget_setBackgroundColor(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    QColor * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:Widget_setBackgroundColor",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setBackgroundColor. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_setBackgroundColor. Expected _QColor_p.");
        return NULL;
        }
    }
    Widget_setBackgroundColor(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static QPixmap * Widget_backgroundPixmap(Widget *obj) {
    QPixmap * _result = (QPixmap *)obj->backgroundPixmap();
    return _result;
}
static PyObject *_wrap_Widget_backgroundPixmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPixmap * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:Widget_backgroundPixmap",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_backgroundPixmap. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (QPixmap *)Widget_backgroundPixmap(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QPixmap_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void  Widget_setBackgroundPixmap(Widget *obj,const QPixmap * _arg0) {
    obj->setBackgroundPixmap(*_arg0);
}
static PyObject *_wrap_Widget_setBackgroundPixmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    QPixmap * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:Widget_setBackgroundPixmap",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setBackgroundPixmap. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_setBackgroundPixmap. Expected _QPixmap_p.");
        return NULL;
        }
    }
    Widget_setBackgroundPixmap(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static QColorGroup * Widget_colorGroup(Widget *obj) {
    const QColorGroup & _result = obj->colorGroup();
    return (QColorGroup *) &_result;
}
static PyObject *_wrap_Widget_colorGroup(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColorGroup * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:Widget_colorGroup",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_colorGroup. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (QColorGroup *)Widget_colorGroup(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColorGroup_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QPalette * Widget_palette(Widget *obj) {
    const QPalette & _result = obj->palette();
    return (QPalette *) &_result;
}
static PyObject *_wrap_Widget_palette(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPalette * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:Widget_palette",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_palette. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (QPalette *)Widget_palette(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QPalette_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void  Widget_setPalette(Widget *obj,const QPalette * _arg0) {
    obj->setPalette(*_arg0);
}
static PyObject *_wrap_Widget_setPalette(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    QPalette * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:Widget_setPalette",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setPalette. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPalette_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_setPalette. Expected _QPalette_p.");
        return NULL;
        }
    }
    Widget_setPalette(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static QFont * Widget_font(Widget *obj) {
    const QFont & _result = obj->font();
    return (QFont *) &_result;
}
static PyObject *_wrap_Widget_font(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:Widget_font",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_font. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (QFont *)Widget_font(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QFont_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void  Widget_setFont(Widget *obj,const QFont * _arg0) {
    obj->setFont(*_arg0);
}
static PyObject *_wrap_Widget_setFont(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    QFont * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:Widget_setFont",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setFont. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_setFont. Expected _QFont_p.");
        return NULL;
        }
    }
    Widget_setFont(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static QFontMetrics  Widget_fontMetrics(Widget *obj) {
    QFontMetrics  _result = (QFontMetrics )obj->fontMetrics();
    return _result;
}
static PyObject *_wrap_Widget_fontMetrics(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFontMetrics * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:Widget_fontMetrics",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_fontMetrics. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = new QFontMetrics (Widget_fontMetrics(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QFontMetrics_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QFontInfo  Widget_fontInfo(Widget *obj) {
    QFontInfo  _result = (QFontInfo )obj->fontInfo();
    return _result;
}
static PyObject *_wrap_Widget_fontInfo(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFontInfo * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:Widget_fontInfo",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_fontInfo. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = new QFontInfo (Widget_fontInfo(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QFontInfo_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QCursor * Widget_cursor(Widget *obj) {
    const QCursor & _result = obj->cursor();
    return (QCursor *) &_result;
}
static PyObject *_wrap_Widget_cursor(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QCursor * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:Widget_cursor",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_cursor. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (QCursor *)Widget_cursor(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QCursor_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void  Widget_setCursor(Widget *obj,const QCursor * _arg0) {
    obj->setCursor(*_arg0);
}
static PyObject *_wrap_Widget_setCursor(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    QCursor * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:Widget_setCursor",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setCursor. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QCursor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_setCursor. Expected _QCursor_p.");
        return NULL;
        }
    }
    Widget_setCursor(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static char * Widget_caption(Widget *obj) {
    char * _result = (char *)obj->caption();
    return _result;
}
static PyObject *_wrap_Widget_caption(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    Widget * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Widget_caption",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_caption. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (char *)Widget_caption(_arg0);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

static void  Widget_setCaption(Widget *obj,const char * _arg0) {
    obj->setCaption(_arg0);
}
static PyObject *_wrap_Widget_setCaption(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"ss:Widget_setCaption",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setCaption. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_setCaption(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static QPixmap * Widget_icon(Widget *obj) {
    QPixmap * _result = (QPixmap *)obj->icon();
    return _result;
}
static PyObject *_wrap_Widget_icon(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPixmap * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:Widget_icon",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_icon. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (QPixmap *)Widget_icon(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QPixmap_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void  Widget_setIcon(Widget *obj,const QPixmap * _arg0) {
    obj->setIcon(*_arg0);
}
static PyObject *_wrap_Widget_setIcon(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    QPixmap * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:Widget_setIcon",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setIcon. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_setIcon. Expected _QPixmap_p.");
        return NULL;
        }
    }
    Widget_setIcon(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static char * Widget_iconText(Widget *obj) {
    char * _result = (char *)obj->iconText();
    return _result;
}
static PyObject *_wrap_Widget_iconText(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    Widget * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Widget_iconText",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_iconText. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (char *)Widget_iconText(_arg0);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

static void  Widget_setIconText(Widget *obj,const char * _arg0) {
    obj->setIconText(_arg0);
}
static PyObject *_wrap_Widget_setIconText(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"ss:Widget_setIconText",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setIconText. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_setIconText(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  Widget_hasMouseTracking(Widget *obj) {
    bool  _result = (bool )obj->hasMouseTracking();
    return _result;
}
static PyObject *_wrap_Widget_hasMouseTracking(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Widget * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Widget_hasMouseTracking",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_hasMouseTracking. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (bool )Widget_hasMouseTracking(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  Widget_setMouseTracking(Widget *obj,int  _arg0) {
    obj->setMouseTracking(_arg0);
}
static PyObject *_wrap_Widget_setMouseTracking(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:Widget_setMouseTracking",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setMouseTracking. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_setMouseTracking(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  Widget_isActiveWindow(Widget *obj) {
    bool  _result = (bool )obj->isActiveWindow();
    return _result;
}
static PyObject *_wrap_Widget_isActiveWindow(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Widget * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Widget_isActiveWindow",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_isActiveWindow. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (bool )Widget_isActiveWindow(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  Widget_setActiveWindow(Widget *obj) {
    obj->setActiveWindow();
}
static PyObject *_wrap_Widget_setActiveWindow(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Widget_setActiveWindow",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setActiveWindow. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_setActiveWindow(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  Widget_isFocusEnabled(Widget *obj) {
    bool  _result = (bool )obj->isFocusEnabled();
    return _result;
}
static PyObject *_wrap_Widget_isFocusEnabled(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Widget * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Widget_isFocusEnabled",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_isFocusEnabled. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (bool )Widget_isFocusEnabled(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static Widget::FocusPolicy  Widget_focusPolicy(Widget *obj) {
    Widget::FocusPolicy  _result = (Widget::FocusPolicy )obj->focusPolicy();
    return _result;
}
static PyObject *_wrap_Widget_focusPolicy(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget::FocusPolicy  _result;
    Widget * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Widget_focusPolicy",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_focusPolicy. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (Widget::FocusPolicy )Widget_focusPolicy(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  Widget_setFocusPolicy(Widget *obj,Widget::FocusPolicy  _arg0) {
    obj->setFocusPolicy(_arg0);
}
static PyObject *_wrap_Widget_setFocusPolicy(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    Widget::FocusPolicy  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:Widget_setFocusPolicy",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setFocusPolicy. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_setFocusPolicy(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  Widget_hasFocus(Widget *obj) {
    bool  _result = (bool )obj->hasFocus();
    return _result;
}
static PyObject *_wrap_Widget_hasFocus(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Widget * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Widget_hasFocus",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_hasFocus. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (bool )Widget_hasFocus(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  Widget_setFocus(Widget *obj) {
    obj->setFocus();
}
static PyObject *_wrap_Widget_setFocus(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Widget_setFocus",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setFocus. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_setFocus(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Widget_clearFocus(Widget *obj) {
    obj->clearFocus();
}
static PyObject *_wrap_Widget_clearFocus(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Widget_clearFocus",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_clearFocus. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_clearFocus(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Widget_grabMouse(Widget *obj) {
    obj->grabMouse();
}
static PyObject *_wrap_Widget_grabMouse(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Widget_grabMouse",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_grabMouse. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_grabMouse(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Widget_grabMouse(Widget *obj,const QCursor * _arg0) {
    obj->grabMouse(*_arg0);
}
static PyObject *_wrap_Widget_grabMouseCursor(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    QCursor * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:Widget_grabMouseCursor",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_grabMouseCursor. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QCursor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_grabMouseCursor. Expected _QCursor_p.");
        return NULL;
        }
    }
    Widget_grabMouse(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Widget_releaseMouse(Widget *obj) {
    obj->releaseMouse();
}
static PyObject *_wrap_Widget_releaseMouse(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Widget_releaseMouse",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_releaseMouse. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_releaseMouse(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Widget_grabKeyboard(Widget *obj) {
    obj->grabKeyboard();
}
static PyObject *_wrap_Widget_grabKeyboard(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Widget_grabKeyboard",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_grabKeyboard. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_grabKeyboard(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Widget_releaseKeyboard(Widget *obj) {
    obj->releaseKeyboard();
}
static PyObject *_wrap_Widget_releaseKeyboard(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Widget_releaseKeyboard",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_releaseKeyboard. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_releaseKeyboard(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  Widget_isUpdatesEnabled(Widget *obj) {
    bool  _result = (bool )obj->isUpdatesEnabled();
    return _result;
}
static PyObject *_wrap_Widget_isUpdatesEnabled(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Widget * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Widget_isUpdatesEnabled",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_isUpdatesEnabled. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (bool )Widget_isUpdatesEnabled(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  Widget_setUpdatesEnabled(Widget *obj,int  _arg0) {
    obj->setUpdatesEnabled(_arg0);
}
static PyObject *_wrap_Widget_setUpdatesEnabled(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:Widget_setUpdatesEnabled",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setUpdatesEnabled. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_setUpdatesEnabled(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Widget_update(Widget *obj) {
    obj->update();
}
static PyObject *_wrap_Widget_update(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Widget_update",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_update. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_update(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Widget_update(Widget *obj,int  _arg0,int  _arg1,int  _arg2,int  _arg3) {
    obj->update(_arg0,_arg1,_arg2,_arg3);
}
static PyObject *_wrap_Widget_updateRegion(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    int  _arg1;
    int  _arg2;
    int  _arg3;
    int  _arg4;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"siiii:Widget_updateRegion",&_argc0,&_arg1,&_arg2,&_arg3,&_arg4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_updateRegion. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_update(_arg0,_arg1,_arg2,_arg3,_arg4);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Widget_repaint(Widget *obj,int  _arg0) {
    obj->repaint(_arg0);
}
static PyObject *_wrap_Widget_repaint(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    int  _arg1 = 1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s|i:Widget_repaint",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_repaint. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_repaint(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Widget_repaint(Widget *obj,int  _arg0,int  _arg1,int  _arg2,int  _arg3,int  _arg4) {
    obj->repaint(_arg0,_arg1,_arg2,_arg3,_arg4);
}
static PyObject *_wrap_Widget_repaintRegion(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    int  _arg1;
    int  _arg2;
    int  _arg3;
    int  _arg4;
    int  _arg5 = 1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"siiii|i:Widget_repaintRegion",&_argc0,&_arg1,&_arg2,&_arg3,&_arg4,&_arg5)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_repaintRegion. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_repaint(_arg0,_arg1,_arg2,_arg3,_arg4,_arg5);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Widget_repaint(Widget *obj,const QRect * _arg0,int  _arg1) {
    obj->repaint(*_arg0,_arg1);
}
static PyObject *_wrap_Widget_repaintRect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    QRect * _arg1;
    int  _arg2 = 1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss|i:Widget_repaintRect",&_argc0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_repaintRect. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_repaintRect. Expected _QRect_p.");
        return NULL;
        }
    }
    Widget_repaint(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Widget_show(Widget *obj) {
    obj->show();
}
static PyObject *_wrap_Widget_show(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Widget_show",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_show. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_show(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Widget_hide(Widget *obj) {
    obj->hide();
}
static PyObject *_wrap_Widget_hide(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Widget_hide",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_hide. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_hide(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Widget_iconify(Widget *obj) {
    obj->iconify();
}
static PyObject *_wrap_Widget_iconify(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Widget_iconify",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_iconify. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_iconify(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  Widget_close(Widget *obj,int  _arg0) {
    bool  _result = (bool )obj->close(_arg0);
    return _result;
}
static PyObject *_wrap_Widget_close(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Widget * _arg0;
    int  _arg1 = 0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s|i:Widget_close",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_close. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (bool )Widget_close(_arg0,_arg1);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static bool  Widget_isVisible(Widget *obj) {
    bool  _result = (bool )obj->isVisible();
    return _result;
}
static PyObject *_wrap_Widget_isVisible(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Widget * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Widget_isVisible",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_isVisible. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (bool )Widget_isVisible(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  Widget_raise(Widget *obj) {
    obj->raise();
}
static PyObject *_wrap_Widget_raiseWidget(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Widget_raiseWidget",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_raiseWidget. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_raise(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Widget_lower(Widget *obj) {
    obj->lower();
}
static PyObject *_wrap_Widget_lowerWidget(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Widget_lowerWidget",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_lowerWidget. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_lower(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Widget_move(Widget *obj,int  _arg0,int  _arg1) {
    obj->move(_arg0,_arg1);
}
static PyObject *_wrap_Widget_move(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"sii:Widget_move",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_move. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_move(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Widget_move(Widget *obj,const QPoint * _arg0) {
    obj->move(*_arg0);
}
static PyObject *_wrap_Widget_movePoint(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    QPoint * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:Widget_movePoint",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_movePoint. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_movePoint. Expected _QPoint_p.");
        return NULL;
        }
    }
    Widget_move(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Widget_resize(Widget *obj,int  _arg0,int  _arg1) {
    obj->resize(_arg0,_arg1);
}
static PyObject *_wrap_Widget_resize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"sii:Widget_resize",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_resize. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_resize(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Widget_resize(Widget *obj,const QSize * _arg0) {
    obj->resize(*_arg0);
}
static PyObject *_wrap_Widget_resizeSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    QSize * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:Widget_resizeSize",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_resizeSize. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QSize_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_resizeSize. Expected _QSize_p.");
        return NULL;
        }
    }
    Widget_resize(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Widget_setGeometry(Widget *obj,int  _arg0,int  _arg1,int  _arg2,int  _arg3) {
    obj->setGeometry(_arg0,_arg1,_arg2,_arg3);
}
static PyObject *_wrap_Widget_setGeometry(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    int  _arg1;
    int  _arg2;
    int  _arg3;
    int  _arg4;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"siiii:Widget_setGeometry",&_argc0,&_arg1,&_arg2,&_arg3,&_arg4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setGeometry. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_setGeometry(_arg0,_arg1,_arg2,_arg3,_arg4);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Widget_setGeometry(Widget *obj,const QRect * _arg0) {
    obj->setGeometry(*_arg0);
}
static PyObject *_wrap_Widget_setGeometryRect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    QRect * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:Widget_setGeometryRect",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setGeometryRect. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_setGeometryRect. Expected _QRect_p.");
        return NULL;
        }
    }
    Widget_setGeometry(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static QSize  Widget_sizeHint(Widget *obj) {
    QSize  _result = (QSize )obj->sizeHint();
    return _result;
}
static PyObject *_wrap_Widget_sizeHint(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QSize * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:Widget_sizeHint",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_sizeHint. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = new QSize (Widget_sizeHint(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QSize_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void  Widget_adjustSize(Widget *obj) {
    obj->adjustSize();
}
static PyObject *_wrap_Widget_adjustSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Widget_adjustSize",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_adjustSize. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_adjustSize(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Widget_recreate(Widget *obj,Widget * _arg0,WFlags  _arg1,const QPoint * _arg2,int  _arg3) {
    obj->recreate(_arg0,_arg1,*_arg2,_arg3);
}
static PyObject *_wrap_Widget_recreate(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    Widget * _arg1;
    WFlags * _arg2;
    QPoint * _arg3;
    int  _arg4 = 1;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char * _argc2 = 0;
    char * _argc3 = 0;

    if(!PyArg_ParseTuple(args,"ssss|i:Widget_recreate",&_argc0,&_argc1,&_argc2,&_argc3,&_arg4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_recreate. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_recreate. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc2) {
        if (SWIG_GetPtr(_argc2,(void **) &_arg2,"_WFlags_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 3 of Widget_recreate. Expected _WFlags_p.");
        return NULL;
        }
    }
    if (_argc3) {
        if (SWIG_GetPtr(_argc3,(void **) &_arg3,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 4 of Widget_recreate. Expected _QPoint_p.");
        return NULL;
        }
    }
    Widget_recreate(_arg0,_arg1,*_arg2,_arg3,_arg4);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Widget_erase(Widget *obj) {
    obj->erase();
}
static PyObject *_wrap_Widget_erase(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Widget_erase",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_erase. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_erase(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Widget_erase(Widget *obj,int  _arg0,int  _arg1,int  _arg2,int  _arg3) {
    obj->erase(_arg0,_arg1,_arg2,_arg3);
}
static PyObject *_wrap_Widget_eraseRection(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    int  _arg1;
    int  _arg2;
    int  _arg3;
    int  _arg4;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"siiii:Widget_eraseRection",&_argc0,&_arg1,&_arg2,&_arg3,&_arg4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_eraseRection. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_erase(_arg0,_arg1,_arg2,_arg3,_arg4);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Widget_erase(Widget *obj,const QRect * _arg0) {
    obj->erase(*_arg0);
}
static PyObject *_wrap_Widget_eraseRect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    QRect * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:Widget_eraseRect",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_eraseRect. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_eraseRect. Expected _QRect_p.");
        return NULL;
        }
    }
    Widget_erase(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Widget_scroll(Widget *obj,int  _arg0,int  _arg1) {
    obj->scroll(_arg0,_arg1);
}
static PyObject *_wrap_Widget_scroll(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"sii:Widget_scroll",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_scroll. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_scroll(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Widget_drawText(Widget *obj,int  _arg0,int  _arg1,const char * _arg2) {
    obj->drawText(_arg0,_arg1,_arg2);
}
static PyObject *_wrap_Widget_drawText(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    int  _arg1;
    int  _arg2;
    char * _arg3;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"siis:Widget_drawText",&_argc0,&_arg1,&_arg2,&_arg3)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_drawText. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_drawText(_arg0,_arg1,_arg2,_arg3);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Widget_drawText(Widget *obj,const QPoint * _arg0,const char * _arg1) {
    obj->drawText(*_arg0,_arg1);
}
static PyObject *_wrap_Widget_drawTextPoint(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    QPoint * _arg1;
    char * _arg2;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"sss:Widget_drawTextPoint",&_argc0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_drawTextPoint. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_drawTextPoint. Expected _QPoint_p.");
        return NULL;
        }
    }
    Widget_drawText(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static Widget * Widget_parentWidget(Widget *obj) {
    Widget * _result = (Widget *)obj->parentWidget();
    return _result;
}
static PyObject *_wrap_Widget_parentWidget(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:Widget_parentWidget",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_parentWidget. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (Widget *)Widget_parentWidget(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_Widget_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void  Widget_addPopupMenu(Widget *obj,const char * _arg0,PopupMenu * _arg1) {
    obj->addPopupMenu(_arg0,_arg1);
}
static PyObject *_wrap_Widget_addPopupMenu(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _arg1;
    PopupMenu * _arg2;
    char * _argc0 = 0;
    char * _argc2 = 0;

    if(!PyArg_ParseTuple(args,"sss:Widget_addPopupMenu",&_argc0,&_arg1,&_argc2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_addPopupMenu. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc2) {
        if (SWIG_GetPtr(_argc2,(void **) &_arg2,"_PopupMenu_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 3 of Widget_addPopupMenu. Expected _PopupMenu_p.");
        return NULL;
        }
    }
    Widget_addPopupMenu(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Widget_addSeparator(Widget *obj) {
    obj->addSeparator();
}
static PyObject *_wrap_Widget_addSeparator(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Widget_addSeparator",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_addSeparator. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_addSeparator(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigButtonToWidget(void *ptr) {
    Button *src;
    Widget *dest;
    src = (Button *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *SwigButtonToObject(void *ptr) {
    Button *src;
    Object *dest;
    src = (Button *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

static Button *new_Button(Widget * _arg0,const char * _arg1) {
    return new Button(_arg0,_arg1);
}
static PyObject *_wrap_new_Button(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Button * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"|ss:new_Button",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_Button. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (Button *)new_Button(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_Button_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void delete_Button(Button *obj) {
    delete obj;
}
static PyObject *_wrap_delete_Button(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Button * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:delete_Button",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Button_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_Button. Expected _Button_p.");
        return NULL;
        }
    }
    delete_Button(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static char * Button_text(Button *obj) {
    char * _result = (char *)obj->text();
    return _result;
}
static PyObject *_wrap_Button_text(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    Button * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Button_text",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Button_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Button_text. Expected _Button_p.");
        return NULL;
        }
    }
    _result = (char *)Button_text(_arg0);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

static void  Button_setText(Button *obj,const char * _arg0) {
    obj->setText(_arg0);
}
static PyObject *_wrap_Button_setText(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Button * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"ss:Button_setText",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Button_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Button_setText. Expected _Button_p.");
        return NULL;
        }
    }
    Button_setText(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static QPixmap * Button_pixmap(Button *obj) {
    QPixmap * _result = (QPixmap *)obj->pixmap();
    return _result;
}
static PyObject *_wrap_Button_pixmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPixmap * _result;
    Button * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:Button_pixmap",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Button_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Button_pixmap. Expected _Button_p.");
        return NULL;
        }
    }
    _result = (QPixmap *)Button_pixmap(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QPixmap_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void  Button_setPixmap(Button *obj,const QPixmap * _arg0) {
    obj->setPixmap(*_arg0);
}
static PyObject *_wrap_Button_setPixmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Button * _arg0;
    QPixmap * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:Button_setPixmap",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Button_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Button_setPixmap. Expected _Button_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Button_setPixmap. Expected _QPixmap_p.");
        return NULL;
        }
    }
    Button_setPixmap(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  Button_isToggleButton(Button *obj) {
    bool  _result = (bool )obj->isToggleButton();
    return _result;
}
static PyObject *_wrap_Button_isToggleButton(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Button * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Button_isToggleButton",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Button_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Button_isToggleButton. Expected _Button_p.");
        return NULL;
        }
    }
    _result = (bool )Button_isToggleButton(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static bool  Button_isDown(Button *obj) {
    bool  _result = (bool )obj->isDown();
    return _result;
}
static PyObject *_wrap_Button_isDown(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Button * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Button_isDown",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Button_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Button_isDown. Expected _Button_p.");
        return NULL;
        }
    }
    _result = (bool )Button_isDown(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static bool  Button_isOn(Button *obj) {
    bool  _result = (bool )obj->isOn();
    return _result;
}
static PyObject *_wrap_Button_isOn(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Button * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Button_isOn",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Button_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Button_isOn. Expected _Button_p.");
        return NULL;
        }
    }
    _result = (bool )Button_isOn(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static bool  Button_autoResize(Button *obj) {
    bool  _result = (bool )obj->autoResize();
    return _result;
}
static PyObject *_wrap_Button_autoResize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Button * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Button_autoResize",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Button_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Button_autoResize. Expected _Button_p.");
        return NULL;
        }
    }
    _result = (bool )Button_autoResize(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  Button_setAutoResize(Button *obj,int  _arg0) {
    obj->setAutoResize(_arg0);
}
static PyObject *_wrap_Button_setAutoResize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Button * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:Button_setAutoResize",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Button_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Button_setAutoResize. Expected _Button_p.");
        return NULL;
        }
    }
    Button_setAutoResize(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Button_setAutoRepeat(Button *obj,int  _arg0) {
    obj->setAutoRepeat(_arg0);
}
static PyObject *_wrap_Button_setAutoRepeat(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Button * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:Button_setAutoRepeat",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Button_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Button_setAutoRepeat. Expected _Button_p.");
        return NULL;
        }
    }
    Button_setAutoRepeat(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  Button_autoRepeat(Button *obj) {
    bool  _result = (bool )obj->autoRepeat();
    return _result;
}
static PyObject *_wrap_Button_autoRepeat(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Button * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Button_autoRepeat",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Button_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Button_autoRepeat. Expected _Button_p.");
        return NULL;
        }
    }
    _result = (bool )Button_autoRepeat(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  Button_pressed(Button *obj) {
    obj->pressed();
}
static PyObject *_wrap_Button_pressed(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Button * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Button_pressed",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Button_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Button_pressed. Expected _Button_p.");
        return NULL;
        }
    }
    Button_pressed(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Button_released(Button *obj) {
    obj->released();
}
static PyObject *_wrap_Button_released(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Button * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Button_released",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Button_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Button_released. Expected _Button_p.");
        return NULL;
        }
    }
    Button_released(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Button_clicked(Button *obj) {
    obj->clicked();
}
static PyObject *_wrap_Button_clicked(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Button * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Button_clicked",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Button_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Button_clicked. Expected _Button_p.");
        return NULL;
        }
    }
    Button_clicked(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Button_toggled(Button *obj,int  _arg0) {
    obj->toggled(_arg0);
}
static PyObject *_wrap_Button_toggled(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Button * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:Button_toggled",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Button_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Button_toggled. Expected _Button_p.");
        return NULL;
        }
    }
    Button_toggled(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigCheckBoxToButton(void *ptr) {
    CheckBox *src;
    Button *dest;
    src = (CheckBox *) ptr;
    dest = (Button *) src;
    return (void *) dest;
}

static void *SwigCheckBoxToWidget(void *ptr) {
    CheckBox *src;
    Widget *dest;
    src = (CheckBox *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *SwigCheckBoxToObject(void *ptr) {
    CheckBox *src;
    Object *dest;
    src = (CheckBox *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

static CheckBox *new_CheckBox(const char * _arg0,Widget * _arg1,const char * _arg2) {
    return new CheckBox(_arg0,_arg1,_arg2);
}
static PyObject *_wrap_new_CheckBox(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    CheckBox * _result;
    char * _arg0;
    Widget * _arg1;
    char * _arg2 = 0;
    char * _argc1 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"ss|s:new_CheckBox",&_arg0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of new_CheckBox. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (CheckBox *)new_CheckBox(_arg0,_arg1,_arg2);
    SWIG_MakePtr(_ptemp, (char *) _result,"_CheckBox_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static CheckBox *new_CheckBox(Widget * _arg0,const char * _arg1) {
    return new CheckBox(_arg0,_arg1);
}
static PyObject *_wrap_new_CheckBoxN(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    CheckBox * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"|ss:new_CheckBoxN",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_CheckBoxN. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (CheckBox *)new_CheckBox(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_CheckBox_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static bool  CheckBox_isChecked(CheckBox *obj) {
    bool  _result = (bool )obj->isChecked();
    return _result;
}
static PyObject *_wrap_CheckBox_isChecked(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    CheckBox * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:CheckBox_isChecked",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_CheckBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of CheckBox_isChecked. Expected _CheckBox_p.");
        return NULL;
        }
    }
    _result = (bool )CheckBox_isChecked(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  CheckBox_setChecked(CheckBox *obj,int  _arg0) {
    obj->setChecked(_arg0);
}
static PyObject *_wrap_CheckBox_setChecked(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    CheckBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:CheckBox_setChecked",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_CheckBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of CheckBox_setChecked. Expected _CheckBox_p.");
        return NULL;
        }
    }
    CheckBox_setChecked(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static QSize  CheckBox_sizeHint(CheckBox *obj) {
    QSize  _result = (QSize )obj->sizeHint();
    return _result;
}
static PyObject *_wrap_CheckBox_sizeHint(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QSize * _result;
    CheckBox * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:CheckBox_sizeHint",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_CheckBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of CheckBox_sizeHint. Expected _CheckBox_p.");
        return NULL;
        }
    }
    _result = new QSize (CheckBox_sizeHint(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QSize_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void *SwigPushButtonToButton(void *ptr) {
    PushButton *src;
    Button *dest;
    src = (PushButton *) ptr;
    dest = (Button *) src;
    return (void *) dest;
}

static void *SwigPushButtonToWidget(void *ptr) {
    PushButton *src;
    Widget *dest;
    src = (PushButton *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *SwigPushButtonToObject(void *ptr) {
    PushButton *src;
    Object *dest;
    src = (PushButton *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

static PushButton *new_PushButton(Widget * _arg0,const char * _arg1) {
    return new PushButton(_arg0,_arg1);
}
static PyObject *_wrap_new_PushButtonN(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PushButton * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"|ss:new_PushButtonN",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_PushButtonN. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (PushButton *)new_PushButton(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_PushButton_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static PushButton *new_PushButton(const char * _arg0,Widget * _arg1,const char * _arg2) {
    return new PushButton(_arg0,_arg1,_arg2);
}
static PyObject *_wrap_new_PushButton(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PushButton * _result;
    char * _arg0;
    Widget * _arg1 = 0;
    char * _arg2 = 0;
    char * _argc1 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s|ss:new_PushButton",&_arg0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of new_PushButton. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (PushButton *)new_PushButton(_arg0,_arg1,_arg2);
    SWIG_MakePtr(_ptemp, (char *) _result,"_PushButton_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void  PushButton_setToggleButton(PushButton *obj,int  _arg0) {
    obj->setToggleButton(_arg0);
}
static PyObject *_wrap_PushButton_setToggleButton(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PushButton * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:PushButton_setToggleButton",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PushButton_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PushButton_setToggleButton. Expected _PushButton_p.");
        return NULL;
        }
    }
    PushButton_setToggleButton(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  PushButton_autoDefault(PushButton *obj) {
    bool  _result = (bool )obj->autoDefault();
    return _result;
}
static PyObject *_wrap_PushButton_autoDefault(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    PushButton * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:PushButton_autoDefault",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PushButton_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PushButton_autoDefault. Expected _PushButton_p.");
        return NULL;
        }
    }
    _result = (bool )PushButton_autoDefault(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  PushButton_setAutoDefault(PushButton *obj,int  _arg0) {
    obj->setAutoDefault(_arg0);
}
static PyObject *_wrap_PushButton_setAutoDefault(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PushButton * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:PushButton_setAutoDefault",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PushButton_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PushButton_setAutoDefault. Expected _PushButton_p.");
        return NULL;
        }
    }
    PushButton_setAutoDefault(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  PushButton_isDefault(PushButton *obj) {
    bool  _result = (bool )obj->isDefault();
    return _result;
}
static PyObject *_wrap_PushButton_isDefault(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    PushButton * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:PushButton_isDefault",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PushButton_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PushButton_isDefault. Expected _PushButton_p.");
        return NULL;
        }
    }
    _result = (bool )PushButton_isDefault(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  PushButton_setDefault(PushButton *obj,int  _arg0) {
    obj->setDefault(_arg0);
}
static PyObject *_wrap_PushButton_setDefault(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PushButton * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:PushButton_setDefault",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PushButton_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PushButton_setDefault. Expected _PushButton_p.");
        return NULL;
        }
    }
    PushButton_setDefault(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static QSize  PushButton_sizeHint(PushButton *obj) {
    QSize  _result = (QSize )obj->sizeHint();
    return _result;
}
static PyObject *_wrap_PushButton_sizeHint(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QSize * _result;
    PushButton * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:PushButton_sizeHint",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PushButton_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PushButton_sizeHint. Expected _PushButton_p.");
        return NULL;
        }
    }
    _result = new QSize (PushButton_sizeHint(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QSize_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void  PushButton_move(PushButton *obj,int  _arg0,int  _arg1) {
    obj->move(_arg0,_arg1);
}
static PyObject *_wrap_PushButton_move(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PushButton * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"sii:PushButton_move",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PushButton_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PushButton_move. Expected _PushButton_p.");
        return NULL;
        }
    }
    PushButton_move(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  PushButton_move(PushButton *obj,const QPoint * _arg0) {
    obj->move(*_arg0);
}
static PyObject *_wrap_PushButton_movePoint(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PushButton * _arg0;
    QPoint * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:PushButton_movePoint",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PushButton_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PushButton_movePoint. Expected _PushButton_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of PushButton_movePoint. Expected _QPoint_p.");
        return NULL;
        }
    }
    PushButton_move(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  PushButton_resize(PushButton *obj,int  _arg0,int  _arg1) {
    obj->resize(_arg0,_arg1);
}
static PyObject *_wrap_PushButton_resize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PushButton * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"sii:PushButton_resize",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PushButton_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PushButton_resize. Expected _PushButton_p.");
        return NULL;
        }
    }
    PushButton_resize(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  PushButton_resize(PushButton *obj,const QSize * _arg0) {
    obj->resize(*_arg0);
}
static PyObject *_wrap_PushButton_resizeSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PushButton * _arg0;
    QSize * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:PushButton_resizeSize",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PushButton_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PushButton_resizeSize. Expected _PushButton_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QSize_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of PushButton_resizeSize. Expected _QSize_p.");
        return NULL;
        }
    }
    PushButton_resize(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  PushButton_setGeometry(PushButton *obj,int  _arg0,int  _arg1,int  _arg2,int  _arg3) {
    obj->setGeometry(_arg0,_arg1,_arg2,_arg3);
}
static PyObject *_wrap_PushButton_setGeometry(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PushButton * _arg0;
    int  _arg1;
    int  _arg2;
    int  _arg3;
    int  _arg4;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"siiii:PushButton_setGeometry",&_argc0,&_arg1,&_arg2,&_arg3,&_arg4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PushButton_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PushButton_setGeometry. Expected _PushButton_p.");
        return NULL;
        }
    }
    PushButton_setGeometry(_arg0,_arg1,_arg2,_arg3,_arg4);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  PushButton_setGeometry(PushButton *obj,const QRect * _arg0) {
    obj->setGeometry(*_arg0);
}
static PyObject *_wrap_PushButton_setGeometryRect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PushButton * _arg0;
    QRect * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:PushButton_setGeometryRect",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PushButton_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PushButton_setGeometryRect. Expected _PushButton_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of PushButton_setGeometryRect. Expected _QRect_p.");
        return NULL;
        }
    }
    PushButton_setGeometry(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  PushButton_setOn(PushButton *obj,int  _arg0) {
    obj->setOn(_arg0);
}
static PyObject *_wrap_PushButton_setOn(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PushButton * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:PushButton_setOn",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PushButton_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PushButton_setOn. Expected _PushButton_p.");
        return NULL;
        }
    }
    PushButton_setOn(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  PushButton_toggle(PushButton *obj) {
    obj->toggle();
}
static PyObject *_wrap_PushButton_toggle(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PushButton * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:PushButton_toggle",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PushButton_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PushButton_toggle. Expected _PushButton_p.");
        return NULL;
        }
    }
    PushButton_toggle(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigRadioButtonToButton(void *ptr) {
    RadioButton *src;
    Button *dest;
    src = (RadioButton *) ptr;
    dest = (Button *) src;
    return (void *) dest;
}

static void *SwigRadioButtonToWidget(void *ptr) {
    RadioButton *src;
    Widget *dest;
    src = (RadioButton *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *SwigRadioButtonToObject(void *ptr) {
    RadioButton *src;
    Object *dest;
    src = (RadioButton *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

static RadioButton *new_RadioButton(const char * _arg0,Widget * _arg1,const char * _arg2) {
    return new RadioButton(_arg0,_arg1,_arg2);
}
static PyObject *_wrap_new_RadioButton(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    RadioButton * _result;
    char * _arg0;
    Widget * _arg1 = 0;
    char * _arg2 = 0;
    char * _argc1 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s|ss:new_RadioButton",&_arg0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of new_RadioButton. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (RadioButton *)new_RadioButton(_arg0,_arg1,_arg2);
    SWIG_MakePtr(_ptemp, (char *) _result,"_RadioButton_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static RadioButton *new_RadioButton(Widget * _arg0,const char * _arg1) {
    return new RadioButton(_arg0,_arg1);
}
static PyObject *_wrap_new_RadioButtonN(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    RadioButton * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"|ss:new_RadioButtonN",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_RadioButtonN. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (RadioButton *)new_RadioButton(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_RadioButton_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static bool  RadioButton_isChecked(RadioButton *obj) {
    bool  _result = (bool )obj->isChecked();
    return _result;
}
static PyObject *_wrap_RadioButton_isChecked(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    RadioButton * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:RadioButton_isChecked",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_RadioButton_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of RadioButton_isChecked. Expected _RadioButton_p.");
        return NULL;
        }
    }
    _result = (bool )RadioButton_isChecked(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  RadioButton_setChecked(RadioButton *obj,int  _arg0) {
    obj->setChecked(_arg0);
}
static PyObject *_wrap_RadioButton_setChecked(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    RadioButton * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:RadioButton_setChecked",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_RadioButton_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of RadioButton_setChecked. Expected _RadioButton_p.");
        return NULL;
        }
    }
    RadioButton_setChecked(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static QSize  RadioButton_sizeHint(RadioButton *obj) {
    QSize  _result = (QSize )obj->sizeHint();
    return _result;
}
static PyObject *_wrap_RadioButton_sizeHint(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QSize * _result;
    RadioButton * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:RadioButton_sizeHint",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_RadioButton_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of RadioButton_sizeHint. Expected _RadioButton_p.");
        return NULL;
        }
    }
    _result = new QSize (RadioButton_sizeHint(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QSize_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void *SwigComboBoxToWidget(void *ptr) {
    ComboBox *src;
    Widget *dest;
    src = (ComboBox *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *SwigComboBoxToObject(void *ptr) {
    ComboBox *src;
    Object *dest;
    src = (ComboBox *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

static ComboBox *new_ComboBox(int  _arg0,Widget * _arg1,const char * _arg2) {
    return new ComboBox(_arg0,_arg1,_arg2);
}
static PyObject *_wrap_new_ComboBox(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _result;
    int  _arg0;
    Widget * _arg1 = 0;
    char * _arg2 = 0;
    char * _argc1 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"i|ss:new_ComboBox",&_arg0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of new_ComboBox. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (ComboBox *)new_ComboBox(_arg0,_arg1,_arg2);
    SWIG_MakePtr(_ptemp, (char *) _result,"_ComboBox_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static ComboBox *new_ComboBox(Widget * _arg0,const char * _arg1) {
    return new ComboBox(_arg0,_arg1);
}
static PyObject *_wrap_new_ComboBoxOld(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"|ss:new_ComboBoxOld",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_ComboBoxOld. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (ComboBox *)new_ComboBox(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_ComboBox_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void delete_ComboBox(ComboBox *obj) {
    delete obj;
}
static PyObject *_wrap_delete_ComboBox(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:delete_ComboBox",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_ComboBox. Expected _ComboBox_p.");
        return NULL;
        }
    }
    delete_ComboBox(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static int  ComboBox_count(ComboBox *obj) {
    int  _result = (int )obj->count();
    return _result;
}
static PyObject *_wrap_ComboBox_count(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    ComboBox * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:ComboBox_count",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_count. Expected _ComboBox_p.");
        return NULL;
        }
    }
    _result = (int )ComboBox_count(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  ComboBox_insertList(ComboBox *obj,PyObject * _arg0) {
    obj->insertList(_arg0);
}
static PyObject *_wrap_ComboBox_insertList(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _arg0;
    PyObject * _arg1;
    char * _argc0 = 0;
    PyObject * _obj1 = 0;

    if(!PyArg_ParseTuple(args,"sO:ComboBox_insertList",&_argc0,&_obj1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_insertList. Expected _ComboBox_p.");
        return NULL;
        }
    }
{
  if(!PySequence_Check(_obj1))
  {
    PyErr_SetString(PyExc_TypeError, "Need a list!");
    return NULL;
  }
  _arg1 = _obj1;
}
    ComboBox_insertList(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  ComboBox_insertItem(ComboBox *obj,const char * _arg0,int  _arg1) {
    obj->insertItem(_arg0,_arg1);
}
static PyObject *_wrap_ComboBox_insertText(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _arg0;
    char * _arg1;
    int  _arg2 = -1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"ss|i:ComboBox_insertText",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_insertText. Expected _ComboBox_p.");
        return NULL;
        }
    }
    ComboBox_insertItem(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  ComboBox_insertItem(ComboBox *obj,const QPixmap * _arg0,int  _arg1) {
    obj->insertItem(*_arg0,_arg1);
}
static PyObject *_wrap_ComboBox_insertPixmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _arg0;
    QPixmap * _arg1;
    int  _arg2 = -1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss|i:ComboBox_insertPixmap",&_argc0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_insertPixmap. Expected _ComboBox_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of ComboBox_insertPixmap. Expected _QPixmap_p.");
        return NULL;
        }
    }
    ComboBox_insertItem(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  ComboBox_removeItem(ComboBox *obj,int  _arg0) {
    obj->removeItem(_arg0);
}
static PyObject *_wrap_ComboBox_removeItem(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:ComboBox_removeItem",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_removeItem. Expected _ComboBox_p.");
        return NULL;
        }
    }
    ComboBox_removeItem(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  ComboBox_clear(ComboBox *obj) {
    obj->clear();
}
static PyObject *_wrap_ComboBox_clear(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:ComboBox_clear",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_clear. Expected _ComboBox_p.");
        return NULL;
        }
    }
    ComboBox_clear(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static char * ComboBox_currentText(ComboBox *obj) {
    char * _result = (char *)obj->currentText();
    return _result;
}
static PyObject *_wrap_ComboBox_currentText(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    ComboBox * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:ComboBox_currentText",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_currentText. Expected _ComboBox_p.");
        return NULL;
        }
    }
    _result = (char *)ComboBox_currentText(_arg0);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

static char * ComboBox_text(ComboBox *obj,int  _arg0) {
    char * _result = (char *)obj->text(_arg0);
    return _result;
}
static PyObject *_wrap_ComboBox_text(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    ComboBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:ComboBox_text",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_text. Expected _ComboBox_p.");
        return NULL;
        }
    }
    _result = (char *)ComboBox_text(_arg0,_arg1);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

static QPixmap * ComboBox_pixmap(ComboBox *obj,int  _arg0) {
    QPixmap * _result = (QPixmap *)obj->pixmap(_arg0);
    return _result;
}
static PyObject *_wrap_ComboBox_pixmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPixmap * _result;
    ComboBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"si:ComboBox_pixmap",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_pixmap. Expected _ComboBox_p.");
        return NULL;
        }
    }
    _result = (QPixmap *)ComboBox_pixmap(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QPixmap_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void  ComboBox_changeItem(ComboBox *obj,const char * _arg0,int  _arg1) {
    obj->changeItem(_arg0,_arg1);
}
static PyObject *_wrap_ComboBox_changeText(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _arg0;
    char * _arg1;
    int  _arg2;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"ssi:ComboBox_changeText",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_changeText. Expected _ComboBox_p.");
        return NULL;
        }
    }
    ComboBox_changeItem(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  ComboBox_changeItem(ComboBox *obj,const QPixmap * _arg0,int  _arg1) {
    obj->changeItem(*_arg0,_arg1);
}
static PyObject *_wrap_ComboBox_changePixmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _arg0;
    QPixmap * _arg1;
    int  _arg2;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ssi:ComboBox_changePixmap",&_argc0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_changePixmap. Expected _ComboBox_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of ComboBox_changePixmap. Expected _QPixmap_p.");
        return NULL;
        }
    }
    ComboBox_changeItem(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static int  ComboBox_currentItem(ComboBox *obj) {
    int  _result = (int )obj->currentItem();
    return _result;
}
static PyObject *_wrap_ComboBox_currentItem(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    ComboBox * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:ComboBox_currentItem",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_currentItem. Expected _ComboBox_p.");
        return NULL;
        }
    }
    _result = (int )ComboBox_currentItem(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  ComboBox_setCurrentItem(ComboBox *obj,int  _arg0) {
    obj->setCurrentItem(_arg0);
}
static PyObject *_wrap_ComboBox_setCurrentItem(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:ComboBox_setCurrentItem",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_setCurrentItem. Expected _ComboBox_p.");
        return NULL;
        }
    }
    ComboBox_setCurrentItem(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  ComboBox_autoResize(ComboBox *obj) {
    bool  _result = (bool )obj->autoResize();
    return _result;
}
static PyObject *_wrap_ComboBox_autoResize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    ComboBox * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:ComboBox_autoResize",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_autoResize. Expected _ComboBox_p.");
        return NULL;
        }
    }
    _result = (bool )ComboBox_autoResize(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  ComboBox_setAutoResize(ComboBox *obj,int  _arg0) {
    obj->setAutoResize(_arg0);
}
static PyObject *_wrap_ComboBox_setAutoResize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:ComboBox_setAutoResize",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_setAutoResize. Expected _ComboBox_p.");
        return NULL;
        }
    }
    ComboBox_setAutoResize(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static QSize  ComboBox_sizeHint(ComboBox *obj) {
    QSize  _result = (QSize )obj->sizeHint();
    return _result;
}
static PyObject *_wrap_ComboBox_sizeHint(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QSize * _result;
    ComboBox * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:ComboBox_sizeHint",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_sizeHint. Expected _ComboBox_p.");
        return NULL;
        }
    }
    _result = new QSize (ComboBox_sizeHint(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QSize_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void  ComboBox_setBackgroundColor(ComboBox *obj,const QColor * _arg0) {
    obj->setBackgroundColor(*_arg0);
}
static PyObject *_wrap_ComboBox_setBackgroundColor(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _arg0;
    QColor * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:ComboBox_setBackgroundColor",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_setBackgroundColor. Expected _ComboBox_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of ComboBox_setBackgroundColor. Expected _QColor_p.");
        return NULL;
        }
    }
    ComboBox_setBackgroundColor(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  ComboBox_setPalette(ComboBox *obj,const QPalette * _arg0) {
    obj->setPalette(*_arg0);
}
static PyObject *_wrap_ComboBox_setPalette(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _arg0;
    QPalette * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:ComboBox_setPalette",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_setPalette. Expected _ComboBox_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPalette_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of ComboBox_setPalette. Expected _QPalette_p.");
        return NULL;
        }
    }
    ComboBox_setPalette(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  ComboBox_setFont(ComboBox *obj,const QFont * _arg0) {
    obj->setFont(*_arg0);
}
static PyObject *_wrap_ComboBox_setFont(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _arg0;
    QFont * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:ComboBox_setFont",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_setFont. Expected _ComboBox_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of ComboBox_setFont. Expected _QFont_p.");
        return NULL;
        }
    }
    ComboBox_setFont(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  ComboBox_setEnabled(ComboBox *obj,int  _arg0) {
    obj->setEnabled(_arg0);
}
static PyObject *_wrap_ComboBox_setEnabled(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:ComboBox_setEnabled",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_setEnabled. Expected _ComboBox_p.");
        return NULL;
        }
    }
    ComboBox_setEnabled(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  ComboBox_setSizeLimit(ComboBox *obj,int  _arg0) {
    obj->setSizeLimit(_arg0);
}
static PyObject *_wrap_ComboBox_setSizeLimit(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:ComboBox_setSizeLimit",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_setSizeLimit. Expected _ComboBox_p.");
        return NULL;
        }
    }
    ComboBox_setSizeLimit(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static int  ComboBox_sizeLimit(ComboBox *obj) {
    int  _result = (int )obj->sizeLimit();
    return _result;
}
static PyObject *_wrap_ComboBox_sizeLimit(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    ComboBox * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:ComboBox_sizeLimit",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_sizeLimit. Expected _ComboBox_p.");
        return NULL;
        }
    }
    _result = (int )ComboBox_sizeLimit(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  ComboBox_setMaxCount(ComboBox *obj,int  _arg0) {
    obj->setMaxCount(_arg0);
}
static PyObject *_wrap_ComboBox_setMaxCount(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:ComboBox_setMaxCount",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_setMaxCount. Expected _ComboBox_p.");
        return NULL;
        }
    }
    ComboBox_setMaxCount(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static int  ComboBox_maxCount(ComboBox *obj) {
    int  _result = (int )obj->maxCount();
    return _result;
}
static PyObject *_wrap_ComboBox_maxCount(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    ComboBox * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:ComboBox_maxCount",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_maxCount. Expected _ComboBox_p.");
        return NULL;
        }
    }
    _result = (int )ComboBox_maxCount(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  ComboBox_setInsertionPolicy(ComboBox *obj,ComboBox::Policy  _arg0) {
    obj->setInsertionPolicy(_arg0);
}
static PyObject *_wrap_ComboBox_setInsertionPolicy(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _arg0;
    ComboBox::Policy * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:ComboBox_setInsertionPolicy",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_setInsertionPolicy. Expected _ComboBox_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_ComboBox::Policy_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of ComboBox_setInsertionPolicy. Expected _ComboBox::Policy_p.");
        return NULL;
        }
    }
    ComboBox_setInsertionPolicy(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static ComboBox::Policy  ComboBox_insertionPolicy(ComboBox *obj) {
    ComboBox::Policy  _result = (ComboBox::Policy )obj->insertionPolicy();
    return _result;
}
static PyObject *_wrap_ComboBox_insertionPolicy(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox::Policy * _result;
    ComboBox * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:ComboBox_insertionPolicy",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_insertionPolicy. Expected _ComboBox_p.");
        return NULL;
        }
    }
    _result = new ComboBox::Policy (ComboBox_insertionPolicy(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_ComboBox::Policy_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void *SwigDialogToWidget(void *ptr) {
    Dialog *src;
    Widget *dest;
    src = (Dialog *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *SwigDialogToObject(void *ptr) {
    Dialog *src;
    Object *dest;
    src = (Dialog *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

static Dialog *new_Dialog(Widget * _arg0,const char * _arg1,int  _arg2) {
    return new Dialog(_arg0,_arg1,_arg2);
}
static PyObject *_wrap_new_Dialog(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Dialog * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    int  _arg2 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"|ssi:new_Dialog",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_Dialog. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (Dialog *)new_Dialog(_arg0,_arg1,_arg2);
    SWIG_MakePtr(_ptemp, (char *) _result,"_Dialog_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void delete_Dialog(Dialog *obj) {
    delete obj;
}
static PyObject *_wrap_delete_Dialog(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Dialog * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:delete_Dialog",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Dialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_Dialog. Expected _Dialog_p.");
        return NULL;
        }
    }
    delete_Dialog(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static int  Dialog_exec(Dialog *obj) {
    int  _result = (int )obj->exec();
    return _result;
}
static PyObject *_wrap_Dialog_execDialog(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    Dialog * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Dialog_execDialog",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Dialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Dialog_execDialog. Expected _Dialog_p.");
        return NULL;
        }
    }
    _result = (int )Dialog_exec(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  Dialog_result(Dialog *obj) {
    int  _result = (int )obj->result();
    return _result;
}
static PyObject *_wrap_Dialog_result(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    Dialog * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Dialog_result",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Dialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Dialog_result. Expected _Dialog_p.");
        return NULL;
        }
    }
    _result = (int )Dialog_result(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  Dialog_show(Dialog *obj) {
    obj->show();
}
static PyObject *_wrap_Dialog_show(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Dialog * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Dialog_show",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Dialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Dialog_show. Expected _Dialog_p.");
        return NULL;
        }
    }
    Dialog_show(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Dialog_move(Dialog *obj,int  _arg0,int  _arg1) {
    obj->move(_arg0,_arg1);
}
static PyObject *_wrap_Dialog_move(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Dialog * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"sii:Dialog_move",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Dialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Dialog_move. Expected _Dialog_p.");
        return NULL;
        }
    }
    Dialog_move(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Dialog_move(Dialog *obj,const QPoint * _arg0) {
    obj->move(*_arg0);
}
static PyObject *_wrap_Dialog_movePoint(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Dialog * _arg0;
    QPoint * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:Dialog_movePoint",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Dialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Dialog_movePoint. Expected _Dialog_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Dialog_movePoint. Expected _QPoint_p.");
        return NULL;
        }
    }
    Dialog_move(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Dialog_resize(Dialog *obj,int  _arg0,int  _arg1) {
    obj->resize(_arg0,_arg1);
}
static PyObject *_wrap_Dialog_resize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Dialog * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"sii:Dialog_resize",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Dialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Dialog_resize. Expected _Dialog_p.");
        return NULL;
        }
    }
    Dialog_resize(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Dialog_resize(Dialog *obj,const QSize * _arg0) {
    obj->resize(*_arg0);
}
static PyObject *_wrap_Dialog_resizeSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Dialog * _arg0;
    QSize * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:Dialog_resizeSize",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Dialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Dialog_resizeSize. Expected _Dialog_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QSize_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Dialog_resizeSize. Expected _QSize_p.");
        return NULL;
        }
    }
    Dialog_resize(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Dialog_setGeometry(Dialog *obj,int  _arg0,int  _arg1,int  _arg2,int  _arg3) {
    obj->setGeometry(_arg0,_arg1,_arg2,_arg3);
}
static PyObject *_wrap_Dialog_setGeometry(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Dialog * _arg0;
    int  _arg1;
    int  _arg2;
    int  _arg3;
    int  _arg4;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"siiii:Dialog_setGeometry",&_argc0,&_arg1,&_arg2,&_arg3,&_arg4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Dialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Dialog_setGeometry. Expected _Dialog_p.");
        return NULL;
        }
    }
    Dialog_setGeometry(_arg0,_arg1,_arg2,_arg3,_arg4);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Dialog_setGeometry(Dialog *obj,const QRect * _arg0) {
    obj->setGeometry(*_arg0);
}
static PyObject *_wrap_Dialog_setGeometryRect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Dialog * _arg0;
    QRect * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:Dialog_setGeometryRect",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Dialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Dialog_setGeometryRect. Expected _Dialog_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Dialog_setGeometryRect. Expected _QRect_p.");
        return NULL;
        }
    }
    Dialog_setGeometry(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigTabDialogToDialog(void *ptr) {
    TabDialog *src;
    Dialog *dest;
    src = (TabDialog *) ptr;
    dest = (Dialog *) src;
    return (void *) dest;
}

static void *SwigTabDialogToWidget(void *ptr) {
    TabDialog *src;
    Widget *dest;
    src = (TabDialog *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *SwigTabDialogToObject(void *ptr) {
    TabDialog *src;
    Object *dest;
    src = (TabDialog *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

static TabDialog *new_TabDialog(Widget * _arg0,const char * _arg1,int  _arg2) {
    return new TabDialog(_arg0,_arg1,_arg2);
}
static PyObject *_wrap_new_TabDialog(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    TabDialog * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    int  _arg2 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"|ssi:new_TabDialog",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_TabDialog. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (TabDialog *)new_TabDialog(_arg0,_arg1,_arg2);
    SWIG_MakePtr(_ptemp, (char *) _result,"_TabDialog_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void delete_TabDialog(TabDialog *obj) {
    delete obj;
}
static PyObject *_wrap_delete_TabDialog(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    TabDialog * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:delete_TabDialog",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_TabDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_TabDialog. Expected _TabDialog_p.");
        return NULL;
        }
    }
    delete_TabDialog(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  TabDialog_show(TabDialog *obj) {
    obj->show();
}
static PyObject *_wrap_TabDialog_show(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    TabDialog * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:TabDialog_show",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_TabDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of TabDialog_show. Expected _TabDialog_p.");
        return NULL;
        }
    }
    TabDialog_show(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  TabDialog_setFont(TabDialog *obj,const QFont * _arg0) {
    obj->setFont(*_arg0);
}
static PyObject *_wrap_TabDialog_setFont(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    TabDialog * _arg0;
    QFont * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:TabDialog_setFont",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_TabDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of TabDialog_setFont. Expected _TabDialog_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of TabDialog_setFont. Expected _QFont_p.");
        return NULL;
        }
    }
    TabDialog_setFont(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  TabDialog_addTab(TabDialog *obj,Widget * _arg0,const char * _arg1) {
    obj->addTab(_arg0,_arg1);
}
static PyObject *_wrap_TabDialog_addTab(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    TabDialog * _arg0;
    Widget * _arg1;
    char * _arg2;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"sss:TabDialog_addTab",&_argc0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_TabDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of TabDialog_addTab. Expected _TabDialog_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of TabDialog_addTab. Expected _Widget_p.");
        return NULL;
        }
    }
    TabDialog_addTab(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  TabDialog_isTabEnabled(TabDialog *obj,const char * _arg0) {
    bool  _result = (bool )obj->isTabEnabled(_arg0);
    return _result;
}
static PyObject *_wrap_TabDialog_isTabEnabled(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    TabDialog * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"ss:TabDialog_isTabEnabled",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_TabDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of TabDialog_isTabEnabled. Expected _TabDialog_p.");
        return NULL;
        }
    }
    _result = (bool )TabDialog_isTabEnabled(_arg0,_arg1);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  TabDialog_setDefaultButton(TabDialog *obj,const char * _arg0) {
    obj->setDefaultButton(_arg0);
}
static PyObject *_wrap_TabDialog_setDefaultButton(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    TabDialog * _arg0;
    char * _arg1 = "Defaults";
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s|s:TabDialog_setDefaultButton",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_TabDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of TabDialog_setDefaultButton. Expected _TabDialog_p.");
        return NULL;
        }
    }
    TabDialog_setDefaultButton(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  TabDialog_hasDefaultButton(TabDialog *obj) {
    bool  _result = (bool )obj->hasDefaultButton();
    return _result;
}
static PyObject *_wrap_TabDialog_hasDefaultButton(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    TabDialog * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:TabDialog_hasDefaultButton",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_TabDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of TabDialog_hasDefaultButton. Expected _TabDialog_p.");
        return NULL;
        }
    }
    _result = (bool )TabDialog_hasDefaultButton(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  TabDialog_setCancelButton(TabDialog *obj,const char * _arg0) {
    obj->setCancelButton(_arg0);
}
static PyObject *_wrap_TabDialog_setCancelButton(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    TabDialog * _arg0;
    char * _arg1 = "Cancel";
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s|s:TabDialog_setCancelButton",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_TabDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of TabDialog_setCancelButton. Expected _TabDialog_p.");
        return NULL;
        }
    }
    TabDialog_setCancelButton(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  TabDialog_hasCancelButton(TabDialog *obj) {
    bool  _result = (bool )obj->hasCancelButton();
    return _result;
}
static PyObject *_wrap_TabDialog_hasCancelButton(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    TabDialog * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:TabDialog_hasCancelButton",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_TabDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of TabDialog_hasCancelButton. Expected _TabDialog_p.");
        return NULL;
        }
    }
    _result = (bool )TabDialog_hasCancelButton(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  TabDialog_setApplyButton(TabDialog *obj,const char * _arg0) {
    obj->setApplyButton(_arg0);
}
static PyObject *_wrap_TabDialog_setApplyButton(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    TabDialog * _arg0;
    char * _arg1 = "Apply";
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s|s:TabDialog_setApplyButton",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_TabDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of TabDialog_setApplyButton. Expected _TabDialog_p.");
        return NULL;
        }
    }
    TabDialog_setApplyButton(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  TabDialog_hasApplyButton(TabDialog *obj) {
    bool  _result = (bool )obj->hasApplyButton();
    return _result;
}
static PyObject *_wrap_TabDialog_hasApplyButton(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    TabDialog * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:TabDialog_hasApplyButton",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_TabDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of TabDialog_hasApplyButton. Expected _TabDialog_p.");
        return NULL;
        }
    }
    _result = (bool )TabDialog_hasApplyButton(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  TabDialog_setOKButton(TabDialog *obj,const char * _arg0) {
    obj->setOKButton(_arg0);
}
static PyObject *_wrap_TabDialog_setOKButton(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    TabDialog * _arg0;
    char * _arg1 = "OK";
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s|s:TabDialog_setOKButton",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_TabDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of TabDialog_setOKButton. Expected _TabDialog_p.");
        return NULL;
        }
    }
    TabDialog_setOKButton(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  TabDialog_aboutToShow(TabDialog *obj) {
    obj->aboutToShow();
}
static PyObject *_wrap_TabDialog_aboutToShow(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    TabDialog * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:TabDialog_aboutToShow",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_TabDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of TabDialog_aboutToShow. Expected _TabDialog_p.");
        return NULL;
        }
    }
    TabDialog_aboutToShow(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  TabDialog_applyButtonPressed(TabDialog *obj) {
    obj->applyButtonPressed();
}
static PyObject *_wrap_TabDialog_applyButtonPressed(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    TabDialog * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:TabDialog_applyButtonPressed",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_TabDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of TabDialog_applyButtonPressed. Expected _TabDialog_p.");
        return NULL;
        }
    }
    TabDialog_applyButtonPressed(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  TabDialog_cancelButtonPressed(TabDialog *obj) {
    obj->cancelButtonPressed();
}
static PyObject *_wrap_TabDialog_cancelButtonPressed(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    TabDialog * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:TabDialog_cancelButtonPressed",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_TabDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of TabDialog_cancelButtonPressed. Expected _TabDialog_p.");
        return NULL;
        }
    }
    TabDialog_cancelButtonPressed(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  TabDialog_defaultButtonPressed(TabDialog *obj) {
    obj->defaultButtonPressed();
}
static PyObject *_wrap_TabDialog_defaultButtonPressed(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    TabDialog * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:TabDialog_defaultButtonPressed",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_TabDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of TabDialog_defaultButtonPressed. Expected _TabDialog_p.");
        return NULL;
        }
    }
    TabDialog_defaultButtonPressed(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigLineEditToWidget(void *ptr) {
    LineEdit *src;
    Widget *dest;
    src = (LineEdit *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *SwigLineEditToObject(void *ptr) {
    LineEdit *src;
    Object *dest;
    src = (LineEdit *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

static LineEdit *new_LineEdit(Widget * _arg0,const char * _arg1) {
    return new LineEdit(_arg0,_arg1);
}
static PyObject *_wrap_new_LineEdit(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    LineEdit * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"|ss:new_LineEdit",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_LineEdit. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (LineEdit *)new_LineEdit(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_LineEdit_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void delete_LineEdit(LineEdit *obj) {
    delete obj;
}
static PyObject *_wrap_delete_LineEdit(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    LineEdit * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:delete_LineEdit",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_LineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_LineEdit. Expected _LineEdit_p.");
        return NULL;
        }
    }
    delete_LineEdit(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static char * LineEdit_text(LineEdit *obj) {
    char * _result = (char *)obj->text();
    return _result;
}
static PyObject *_wrap_LineEdit_text(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    LineEdit * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:LineEdit_text",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_LineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of LineEdit_text. Expected _LineEdit_p.");
        return NULL;
        }
    }
    _result = (char *)LineEdit_text(_arg0);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

static int  LineEdit_maxLength(LineEdit *obj) {
    int  _result = (int )obj->maxLength();
    return _result;
}
static PyObject *_wrap_LineEdit_maxLength(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    LineEdit * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:LineEdit_maxLength",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_LineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of LineEdit_maxLength. Expected _LineEdit_p.");
        return NULL;
        }
    }
    _result = (int )LineEdit_maxLength(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  LineEdit_setMaxLength(LineEdit *obj,int  _arg0) {
    obj->setMaxLength(_arg0);
}
static PyObject *_wrap_LineEdit_setMaxLength(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    LineEdit * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:LineEdit_setMaxLength",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_LineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of LineEdit_setMaxLength. Expected _LineEdit_p.");
        return NULL;
        }
    }
    LineEdit_setMaxLength(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  LineEdit_setFrame(LineEdit *obj,int  _arg0) {
    obj->setFrame(_arg0);
}
static PyObject *_wrap_LineEdit_setFrame(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    LineEdit * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:LineEdit_setFrame",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_LineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of LineEdit_setFrame. Expected _LineEdit_p.");
        return NULL;
        }
    }
    LineEdit_setFrame(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  LineEdit_frame(LineEdit *obj) {
    bool  _result = (bool )obj->frame();
    return _result;
}
static PyObject *_wrap_LineEdit_frame(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    LineEdit * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:LineEdit_frame",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_LineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of LineEdit_frame. Expected _LineEdit_p.");
        return NULL;
        }
    }
    _result = (bool )LineEdit_frame(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  LineEdit_setEchoMode(LineEdit *obj,LineEdit::EchoMode  _arg0) {
    obj->setEchoMode(_arg0);
}
static PyObject *_wrap_LineEdit_setEchoMode(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    LineEdit * _arg0;
    LineEdit::EchoMode  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:LineEdit_setEchoMode",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_LineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of LineEdit_setEchoMode. Expected _LineEdit_p.");
        return NULL;
        }
    }
    LineEdit_setEchoMode(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static LineEdit::EchoMode  LineEdit_echoMode(LineEdit *obj) {
    LineEdit::EchoMode  _result = (LineEdit::EchoMode )obj->echoMode();
    return _result;
}
static PyObject *_wrap_LineEdit_echoMode(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    LineEdit::EchoMode * _result;
    LineEdit * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:LineEdit_echoMode",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_LineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of LineEdit_echoMode. Expected _LineEdit_p.");
        return NULL;
        }
    }
    _result = new LineEdit::EchoMode (LineEdit_echoMode(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_LineEdit::EchoMode_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void  LineEdit_setText(LineEdit *obj,const char * _arg0) {
    obj->setText(_arg0);
}
static PyObject *_wrap_LineEdit_setText(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    LineEdit * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"ss:LineEdit_setText",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_LineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of LineEdit_setText. Expected _LineEdit_p.");
        return NULL;
        }
    }
    LineEdit_setText(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  LineEdit_selectAll(LineEdit *obj) {
    obj->selectAll();
}
static PyObject *_wrap_LineEdit_selectAll(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    LineEdit * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:LineEdit_selectAll",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_LineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of LineEdit_selectAll. Expected _LineEdit_p.");
        return NULL;
        }
    }
    LineEdit_selectAll(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  LineEdit_deselect(LineEdit *obj) {
    obj->deselect();
}
static PyObject *_wrap_LineEdit_deselect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    LineEdit * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:LineEdit_deselect",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_LineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of LineEdit_deselect. Expected _LineEdit_p.");
        return NULL;
        }
    }
    LineEdit_deselect(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigFrameToWidget(void *ptr) {
    Frame *src;
    Widget *dest;
    src = (Frame *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *SwigFrameToObject(void *ptr) {
    Frame *src;
    Object *dest;
    src = (Frame *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

static Frame *new_Frame(Widget * _arg0,const char * _arg1) {
    return new Frame(_arg0,_arg1);
}
static PyObject *_wrap_new_Frame(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Frame * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"|ss:new_Frame",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_Frame. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (Frame *)new_Frame(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_Frame_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static int  Frame_frameStyle(Frame *obj) {
    int  _result = (int )obj->frameStyle();
    return _result;
}
static PyObject *_wrap_Frame_frameStyle(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    Frame * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Frame_frameStyle",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Frame_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Frame_frameStyle. Expected _Frame_p.");
        return NULL;
        }
    }
    _result = (int )Frame_frameStyle(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  Frame_frameShape(Frame *obj) {
    int  _result = (int )obj->frameShape();
    return _result;
}
static PyObject *_wrap_Frame_frameShape(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    Frame * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Frame_frameShape",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Frame_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Frame_frameShape. Expected _Frame_p.");
        return NULL;
        }
    }
    _result = (int )Frame_frameShape(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  Frame_frameShadow(Frame *obj) {
    int  _result = (int )obj->frameShadow();
    return _result;
}
static PyObject *_wrap_Frame_frameShadow(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    Frame * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Frame_frameShadow",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Frame_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Frame_frameShadow. Expected _Frame_p.");
        return NULL;
        }
    }
    _result = (int )Frame_frameShadow(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  Frame_setFrameStyle(Frame *obj,int  _arg0) {
    obj->setFrameStyle(_arg0);
}
static PyObject *_wrap_Frame_setFrameStyle(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Frame * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:Frame_setFrameStyle",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Frame_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Frame_setFrameStyle. Expected _Frame_p.");
        return NULL;
        }
    }
    Frame_setFrameStyle(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  Frame_lineShapesOk(Frame *obj) {
    bool  _result = (bool )obj->lineShapesOk();
    return _result;
}
static PyObject *_wrap_Frame_lineShapesOk(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Frame * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Frame_lineShapesOk",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Frame_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Frame_lineShapesOk. Expected _Frame_p.");
        return NULL;
        }
    }
    _result = (bool )Frame_lineShapesOk(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  Frame_lineWidth(Frame *obj) {
    int  _result = (int )obj->lineWidth();
    return _result;
}
static PyObject *_wrap_Frame_lineWidth(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    Frame * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Frame_lineWidth",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Frame_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Frame_lineWidth. Expected _Frame_p.");
        return NULL;
        }
    }
    _result = (int )Frame_lineWidth(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  Frame_setLineWidth(Frame *obj,int  _arg0) {
    obj->setLineWidth(_arg0);
}
static PyObject *_wrap_Frame_setLineWidth(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Frame * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:Frame_setLineWidth",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Frame_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Frame_setLineWidth. Expected _Frame_p.");
        return NULL;
        }
    }
    Frame_setLineWidth(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static int  Frame_midLineWidth(Frame *obj) {
    int  _result = (int )obj->midLineWidth();
    return _result;
}
static PyObject *_wrap_Frame_midLineWidth(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    Frame * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Frame_midLineWidth",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Frame_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Frame_midLineWidth. Expected _Frame_p.");
        return NULL;
        }
    }
    _result = (int )Frame_midLineWidth(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  Frame_setMidLineWidth(Frame *obj,int  _arg0) {
    obj->setMidLineWidth(_arg0);
}
static PyObject *_wrap_Frame_setMidLineWidth(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Frame * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:Frame_setMidLineWidth",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Frame_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Frame_setMidLineWidth. Expected _Frame_p.");
        return NULL;
        }
    }
    Frame_setMidLineWidth(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static int  Frame_frameWidth(Frame *obj) {
    int  _result = (int )obj->frameWidth();
    return _result;
}
static PyObject *_wrap_Frame_frameWidth(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    Frame * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Frame_frameWidth",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Frame_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Frame_frameWidth. Expected _Frame_p.");
        return NULL;
        }
    }
    _result = (int )Frame_frameWidth(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static QRect  Frame_frameRect(Frame *obj) {
    QRect  _result = (QRect )obj->frameRect();
    return _result;
}
static PyObject *_wrap_Frame_frameRect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _result;
    Frame * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:Frame_frameRect",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Frame_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Frame_frameRect. Expected _Frame_p.");
        return NULL;
        }
    }
    _result = new QRect (Frame_frameRect(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QRect_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static QRect  Frame_contentsRect(Frame *obj) {
    QRect  _result = (QRect )obj->contentsRect();
    return _result;
}
static PyObject *_wrap_Frame_contentsRect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _result;
    Frame * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:Frame_contentsRect",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Frame_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Frame_contentsRect. Expected _Frame_p.");
        return NULL;
        }
    }
    _result = new QRect (Frame_contentsRect(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QRect_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void *SwigGroupBoxToFrame(void *ptr) {
    GroupBox *src;
    Frame *dest;
    src = (GroupBox *) ptr;
    dest = (Frame *) src;
    return (void *) dest;
}

static void *SwigGroupBoxToWidget(void *ptr) {
    GroupBox *src;
    Widget *dest;
    src = (GroupBox *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *SwigGroupBoxToObject(void *ptr) {
    GroupBox *src;
    Object *dest;
    src = (GroupBox *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

static GroupBox *new_GroupBox(Widget * _arg0,const char * _arg1) {
    return new GroupBox(_arg0,_arg1);
}
static PyObject *_wrap_new_GroupBox(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    GroupBox * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"|ss:new_GroupBox",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_GroupBox. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (GroupBox *)new_GroupBox(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_GroupBox_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static GroupBox *new_GroupBox(const char * _arg0,Widget * _arg1,const char * _arg2) {
    return new GroupBox(_arg0,_arg1,_arg2);
}
static PyObject *_wrap_new_GroupBoxTitle(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    GroupBox * _result;
    char * _arg0;
    Widget * _arg1 = 0;
    char * _arg2 = 0;
    char * _argc1 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s|ss:new_GroupBoxTitle",&_arg0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of new_GroupBoxTitle. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (GroupBox *)new_GroupBox(_arg0,_arg1,_arg2);
    SWIG_MakePtr(_ptemp, (char *) _result,"_GroupBox_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static char * GroupBox_title(GroupBox *obj) {
    char * _result = (char *)obj->title();
    return _result;
}
static PyObject *_wrap_GroupBox_title(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    GroupBox * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:GroupBox_title",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_GroupBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of GroupBox_title. Expected _GroupBox_p.");
        return NULL;
        }
    }
    _result = (char *)GroupBox_title(_arg0);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

static void  GroupBox_setTitle(GroupBox *obj,const char * _arg0) {
    obj->setTitle(_arg0);
}
static PyObject *_wrap_GroupBox_setTitle(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    GroupBox * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"ss:GroupBox_setTitle",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_GroupBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of GroupBox_setTitle. Expected _GroupBox_p.");
        return NULL;
        }
    }
    GroupBox_setTitle(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static int  GroupBox_alignment(GroupBox *obj) {
    int  _result = (int )obj->alignment();
    return _result;
}
static PyObject *_wrap_GroupBox_alignment(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    GroupBox * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:GroupBox_alignment",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_GroupBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of GroupBox_alignment. Expected _GroupBox_p.");
        return NULL;
        }
    }
    _result = (int )GroupBox_alignment(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  GroupBox_setAlignment(GroupBox *obj,int  _arg0) {
    obj->setAlignment(_arg0);
}
static PyObject *_wrap_GroupBox_setAlignment(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    GroupBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:GroupBox_setAlignment",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_GroupBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of GroupBox_setAlignment. Expected _GroupBox_p.");
        return NULL;
        }
    }
    GroupBox_setAlignment(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigButtonGroupToGroupBox(void *ptr) {
    ButtonGroup *src;
    GroupBox *dest;
    src = (ButtonGroup *) ptr;
    dest = (GroupBox *) src;
    return (void *) dest;
}

static void *SwigButtonGroupToFrame(void *ptr) {
    ButtonGroup *src;
    Frame *dest;
    src = (ButtonGroup *) ptr;
    dest = (Frame *) src;
    return (void *) dest;
}

static void *SwigButtonGroupToWidget(void *ptr) {
    ButtonGroup *src;
    Widget *dest;
    src = (ButtonGroup *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *SwigButtonGroupToObject(void *ptr) {
    ButtonGroup *src;
    Object *dest;
    src = (ButtonGroup *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

static ButtonGroup *new_ButtonGroup(Widget * _arg0,const char * _arg1) {
    return new ButtonGroup(_arg0,_arg1);
}
static PyObject *_wrap_new_ButtonGroup(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ButtonGroup * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"|ss:new_ButtonGroup",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_ButtonGroup. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (ButtonGroup *)new_ButtonGroup(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_ButtonGroup_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static ButtonGroup *new_ButtonGroup(const char * _arg0,Widget * _arg1,const char * _arg2) {
    return new ButtonGroup(_arg0,_arg1,_arg2);
}
static PyObject *_wrap_new_ButtonGroupTitle(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ButtonGroup * _result;
    char * _arg0;
    Widget * _arg1 = 0;
    char * _arg2 = 0;
    char * _argc1 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s|ss:new_ButtonGroupTitle",&_arg0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of new_ButtonGroupTitle. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (ButtonGroup *)new_ButtonGroup(_arg0,_arg1,_arg2);
    SWIG_MakePtr(_ptemp, (char *) _result,"_ButtonGroup_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void delete_ButtonGroup(ButtonGroup *obj) {
    delete obj;
}
static PyObject *_wrap_delete_ButtonGroup(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ButtonGroup * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:delete_ButtonGroup",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ButtonGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_ButtonGroup. Expected _ButtonGroup_p.");
        return NULL;
        }
    }
    delete_ButtonGroup(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  ButtonGroup_isExclusive(ButtonGroup *obj) {
    bool  _result = (bool )obj->isExclusive();
    return _result;
}
static PyObject *_wrap_ButtonGroup_isExclusive(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    ButtonGroup * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:ButtonGroup_isExclusive",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ButtonGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ButtonGroup_isExclusive. Expected _ButtonGroup_p.");
        return NULL;
        }
    }
    _result = (bool )ButtonGroup_isExclusive(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  ButtonGroup_setExclusive(ButtonGroup *obj,int  _arg0) {
    obj->setExclusive(_arg0);
}
static PyObject *_wrap_ButtonGroup_setExclusive(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ButtonGroup * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:ButtonGroup_setExclusive",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ButtonGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ButtonGroup_setExclusive. Expected _ButtonGroup_p.");
        return NULL;
        }
    }
    ButtonGroup_setExclusive(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static int  ButtonGroup_insert(ButtonGroup *obj,Button * _arg0,int  _arg1) {
    int  _result = (int )obj->insert(_arg0,_arg1);
    return _result;
}
static PyObject *_wrap_ButtonGroup_insert(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    ButtonGroup * _arg0;
    Button * _arg1;
    int  _arg2 = -1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss|i:ButtonGroup_insert",&_argc0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ButtonGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ButtonGroup_insert. Expected _ButtonGroup_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Button_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of ButtonGroup_insert. Expected _Button_p.");
        return NULL;
        }
    }
    _result = (int )ButtonGroup_insert(_arg0,_arg1,_arg2);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  ButtonGroup_remove(ButtonGroup *obj,Button * _arg0) {
    obj->remove(_arg0);
}
static PyObject *_wrap_ButtonGroup_remove(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ButtonGroup * _arg0;
    Button * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:ButtonGroup_remove",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ButtonGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ButtonGroup_remove. Expected _ButtonGroup_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Button_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of ButtonGroup_remove. Expected _Button_p.");
        return NULL;
        }
    }
    ButtonGroup_remove(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static Button * ButtonGroup_find(ButtonGroup *obj,int  _arg0) {
    Button * _result = (Button *)obj->find(_arg0);
    return _result;
}
static PyObject *_wrap_ButtonGroup_find(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Button * _result;
    ButtonGroup * _arg0;
    int  _arg1;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"si:ButtonGroup_find",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ButtonGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ButtonGroup_find. Expected _ButtonGroup_p.");
        return NULL;
        }
    }
    _result = (Button *)ButtonGroup_find(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_Button_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void *SwigLabelToFrame(void *ptr) {
    Label *src;
    Frame *dest;
    src = (Label *) ptr;
    dest = (Frame *) src;
    return (void *) dest;
}

static void *SwigLabelToWidget(void *ptr) {
    Label *src;
    Widget *dest;
    src = (Label *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *SwigLabelToObject(void *ptr) {
    Label *src;
    Object *dest;
    src = (Label *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

static Label *new_Label(Widget * _arg0,const char * _arg1) {
    return new Label(_arg0,_arg1);
}
static PyObject *_wrap_new_Label(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Label * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"|ss:new_Label",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_Label. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (Label *)new_Label(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_Label_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static Label *new_Label(const char * _arg0,Widget * _arg1,const char * _arg2) {
    return new Label(_arg0,_arg1,_arg2);
}
static PyObject *_wrap_new_LabelT(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Label * _result;
    char * _arg0;
    Widget * _arg1 = 0;
    char * _arg2 = 0;
    char * _argc1 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s|ss:new_LabelT",&_arg0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of new_LabelT. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (Label *)new_Label(_arg0,_arg1,_arg2);
    SWIG_MakePtr(_ptemp, (char *) _result,"_Label_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static Label *new_Label(Widget * _arg0,const char * _arg1,Widget * _arg2,const char * _arg3) {
    return new Label(_arg0,_arg1,_arg2,_arg3);
}
static PyObject *_wrap_new_LabelBuddy(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Label * _result;
    Widget * _arg0;
    char * _arg1;
    Widget * _arg2;
    char * _arg3 = 0;
    char * _argc0 = 0;
    char * _argc2 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"sss|s:new_LabelBuddy",&_argc0,&_arg1,&_argc2,&_arg3)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_LabelBuddy. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc2) {
        if (SWIG_GetPtr(_argc2,(void **) &_arg2,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 3 of new_LabelBuddy. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (Label *)new_Label(_arg0,_arg1,_arg2,_arg3);
    SWIG_MakePtr(_ptemp, (char *) _result,"_Label_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void delete_Label(Label *obj) {
    delete obj;
}
static PyObject *_wrap_delete_Label(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Label * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:delete_Label",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Label_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_Label. Expected _Label_p.");
        return NULL;
        }
    }
    delete_Label(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static char * Label_text(Label *obj) {
    char * _result = (char *)obj->text();
    return _result;
}
static PyObject *_wrap_Label_text(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    Label * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Label_text",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Label_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Label_text. Expected _Label_p.");
        return NULL;
        }
    }
    _result = (char *)Label_text(_arg0);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

static QPixmap * Label_pixmap(Label *obj) {
    QPixmap * _result = (QPixmap *)obj->pixmap();
    return _result;
}
static PyObject *_wrap_Label_pixmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPixmap * _result;
    Label * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:Label_pixmap",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Label_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Label_pixmap. Expected _Label_p.");
        return NULL;
        }
    }
    _result = (QPixmap *)Label_pixmap(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QPixmap_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static int  Label_alignment(Label *obj) {
    int  _result = (int )obj->alignment();
    return _result;
}
static PyObject *_wrap_Label_alignment(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    Label * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Label_alignment",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Label_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Label_alignment. Expected _Label_p.");
        return NULL;
        }
    }
    _result = (int )Label_alignment(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  Label_setAlignment(Label *obj,int  _arg0) {
    obj->setAlignment(_arg0);
}
static PyObject *_wrap_Label_setAlignment(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Label * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:Label_setAlignment",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Label_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Label_setAlignment. Expected _Label_p.");
        return NULL;
        }
    }
    Label_setAlignment(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static int  Label_margin(Label *obj) {
    int  _result = (int )obj->margin();
    return _result;
}
static PyObject *_wrap_Label_margin(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    Label * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Label_margin",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Label_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Label_margin. Expected _Label_p.");
        return NULL;
        }
    }
    _result = (int )Label_margin(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  Label_setMargin(Label *obj,int  _arg0) {
    obj->setMargin(_arg0);
}
static PyObject *_wrap_Label_setMargin(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Label * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:Label_setMargin",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Label_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Label_setMargin. Expected _Label_p.");
        return NULL;
        }
    }
    Label_setMargin(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  Label_autoResize(Label *obj) {
    bool  _result = (bool )obj->autoResize();
    return _result;
}
static PyObject *_wrap_Label_autoResize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Label * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:Label_autoResize",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Label_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Label_autoResize. Expected _Label_p.");
        return NULL;
        }
    }
    _result = (bool )Label_autoResize(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  Label_setAutoResize(Label *obj,int  _arg0) {
    obj->setAutoResize(_arg0);
}
static PyObject *_wrap_Label_setAutoResize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Label * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:Label_setAutoResize",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Label_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Label_setAutoResize. Expected _Label_p.");
        return NULL;
        }
    }
    Label_setAutoResize(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static QSize  Label_sizeHint(Label *obj) {
    QSize  _result = (QSize )obj->sizeHint();
    return _result;
}
static PyObject *_wrap_Label_sizeHint(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QSize * _result;
    Label * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:Label_sizeHint",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Label_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Label_sizeHint. Expected _Label_p.");
        return NULL;
        }
    }
    _result = new QSize (Label_sizeHint(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QSize_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void  Label_setBuddy(Label *obj,Widget * _arg0) {
    obj->setBuddy(_arg0);
}
static PyObject *_wrap_Label_setBuddy(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Label * _arg0;
    Widget * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:Label_setBuddy",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Label_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Label_setBuddy. Expected _Label_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Label_setBuddy. Expected _Widget_p.");
        return NULL;
        }
    }
    Label_setBuddy(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static Widget * Label_buddy(Label *obj) {
    Widget * _result = (Widget *)obj->buddy();
    return _result;
}
static PyObject *_wrap_Label_buddy(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _result;
    Label * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:Label_buddy",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Label_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Label_buddy. Expected _Label_p.");
        return NULL;
        }
    }
    _result = (Widget *)Label_buddy(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_Widget_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void  Label_setText(Label *obj,const char * _arg0) {
    obj->setText(_arg0);
}
static PyObject *_wrap_Label_setText(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Label * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"ss:Label_setText",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Label_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Label_setText. Expected _Label_p.");
        return NULL;
        }
    }
    Label_setText(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Label_setPixmap(Label *obj,const QPixmap * _arg0) {
    obj->setPixmap(*_arg0);
}
static PyObject *_wrap_Label_setPixmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Label * _arg0;
    QPixmap * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:Label_setPixmap",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Label_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Label_setPixmap. Expected _Label_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Label_setPixmap. Expected _QPixmap_p.");
        return NULL;
        }
    }
    Label_setPixmap(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Label_setNum(Label *obj,int  _arg0) {
    obj->setNum(_arg0);
}
static PyObject *_wrap_Label_setInt(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Label * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:Label_setInt",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Label_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Label_setInt. Expected _Label_p.");
        return NULL;
        }
    }
    Label_setNum(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  Label_setNum(Label *obj,double  _arg0) {
    obj->setNum(_arg0);
}
static PyObject *_wrap_Label_setDouble(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Label * _arg0;
    double  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"sd:Label_setDouble",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Label_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Label_setDouble. Expected _Label_p.");
        return NULL;
        }
    }
    Label_setNum(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigTableViewToFrame(void *ptr) {
    TableView *src;
    Frame *dest;
    src = (TableView *) ptr;
    dest = (Frame *) src;
    return (void *) dest;
}

static void *SwigTableViewToWidget(void *ptr) {
    TableView *src;
    Widget *dest;
    src = (TableView *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *SwigTableViewToObject(void *ptr) {
    TableView *src;
    Object *dest;
    src = (TableView *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

static TableView *new_TableView(Widget * _arg0,const char * _arg1) {
    return new TableView(_arg0,_arg1);
}
static PyObject *_wrap_new_TableView(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    TableView * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"|ss:new_TableView",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_TableView. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (TableView *)new_TableView(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_TableView_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void delete_TableView(TableView *obj) {
    delete obj;
}
static PyObject *_wrap_delete_TableView(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    TableView * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:delete_TableView",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_TableView_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_TableView. Expected _TableView_p.");
        return NULL;
        }
    }
    delete_TableView(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigListBoxToTableView(void *ptr) {
    ListBox *src;
    TableView *dest;
    src = (ListBox *) ptr;
    dest = (TableView *) src;
    return (void *) dest;
}

static void *SwigListBoxToFrame(void *ptr) {
    ListBox *src;
    Frame *dest;
    src = (ListBox *) ptr;
    dest = (Frame *) src;
    return (void *) dest;
}

static void *SwigListBoxToWidget(void *ptr) {
    ListBox *src;
    Widget *dest;
    src = (ListBox *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *SwigListBoxToObject(void *ptr) {
    ListBox *src;
    Object *dest;
    src = (ListBox *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

static ListBox *new_ListBox(Widget * _arg0,const char * _arg1) {
    return new ListBox(_arg0,_arg1);
}
static PyObject *_wrap_new_ListBox(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"|ss:new_ListBox",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_ListBox. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (ListBox *)new_ListBox(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_ListBox_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void delete_ListBox(ListBox *obj) {
    delete obj;
}
static PyObject *_wrap_delete_ListBox(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:delete_ListBox",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_ListBox. Expected _ListBox_p.");
        return NULL;
        }
    }
    delete_ListBox(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  ListBox_setFont(ListBox *obj,const QFont * _arg0) {
    obj->setFont(*_arg0);
}
static PyObject *_wrap_ListBox_setFont(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    QFont * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:ListBox_setFont",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_setFont. Expected _ListBox_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of ListBox_setFont. Expected _QFont_p.");
        return NULL;
        }
    }
    ListBox_setFont(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static unsigned int  ListBox_count(ListBox *obj) {
    unsigned int  _result = (unsigned int )obj->count();
    return _result;
}
static PyObject *_wrap_ListBox_count(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    unsigned int  _result;
    ListBox * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:ListBox_count",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_count. Expected _ListBox_p.");
        return NULL;
        }
    }
    _result = (unsigned int )ListBox_count(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  ListBox_insertStrList(ListBox *obj,PyObject * _arg0,int  _arg1) {
    obj->insertStrList(_arg0,_arg1);
}
static PyObject *_wrap_ListBox_insertStrList(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    PyObject * _arg1;
    int  _arg2 = -1;
    char * _argc0 = 0;
    PyObject * _obj1 = 0;

    if(!PyArg_ParseTuple(args,"sO|i:ListBox_insertStrList",&_argc0,&_obj1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_insertStrList. Expected _ListBox_p.");
        return NULL;
        }
    }
{
  if(!PySequence_Check(_obj1))
  {
    PyErr_SetString(PyExc_TypeError, "Need a list!");
    return NULL;
  }
  _arg1 = _obj1;
}
    ListBox_insertStrList(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  ListBox_insertItem(ListBox *obj,const char * _arg0,int  _arg1) {
    obj->insertItem(_arg0,_arg1);
}
static PyObject *_wrap_ListBox_insertText(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    char * _arg1;
    int  _arg2 = -1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"ss|i:ListBox_insertText",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_insertText. Expected _ListBox_p.");
        return NULL;
        }
    }
    ListBox_insertItem(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  ListBox_insertItem(ListBox *obj,const QPixmap * _arg0,int  _arg1) {
    obj->insertItem(*_arg0,_arg1);
}
static PyObject *_wrap_ListBox_insertPixmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    QPixmap * _arg1;
    int  _arg2 = -1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss|i:ListBox_insertPixmap",&_argc0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_insertPixmap. Expected _ListBox_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of ListBox_insertPixmap. Expected _QPixmap_p.");
        return NULL;
        }
    }
    ListBox_insertItem(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  ListBox_inSort(ListBox *obj,const char * _arg0) {
    obj->inSort(_arg0);
}
static PyObject *_wrap_ListBox_inSort(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"ss:ListBox_inSort",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_inSort. Expected _ListBox_p.");
        return NULL;
        }
    }
    ListBox_inSort(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  ListBox_removeItem(ListBox *obj,int  _arg0) {
    obj->removeItem(_arg0);
}
static PyObject *_wrap_ListBox_removeItem(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:ListBox_removeItem",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_removeItem. Expected _ListBox_p.");
        return NULL;
        }
    }
    ListBox_removeItem(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  ListBox_clear(ListBox *obj) {
    obj->clear();
}
static PyObject *_wrap_ListBox_clear(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:ListBox_clear",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_clear. Expected _ListBox_p.");
        return NULL;
        }
    }
    ListBox_clear(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static char * ListBox_text(ListBox *obj,int  _arg0) {
    char * _result = (char *)obj->text(_arg0);
    return _result;
}
static PyObject *_wrap_ListBox_text(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    ListBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:ListBox_text",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_text. Expected _ListBox_p.");
        return NULL;
        }
    }
    _result = (char *)ListBox_text(_arg0,_arg1);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

static QPixmap * ListBox_pixmap(ListBox *obj,int  _arg0) {
    QPixmap * _result = (QPixmap *)obj->pixmap(_arg0);
    return _result;
}
static PyObject *_wrap_ListBox_pixmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPixmap * _result;
    ListBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"si:ListBox_pixmap",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_pixmap. Expected _ListBox_p.");
        return NULL;
        }
    }
    _result = (QPixmap *)ListBox_pixmap(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QPixmap_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void  ListBox_changeItem(ListBox *obj,const char * _arg0,int  _arg1) {
    obj->changeItem(_arg0,_arg1);
}
static PyObject *_wrap_ListBox_changeText(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    char * _arg1;
    int  _arg2;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"ssi:ListBox_changeText",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_changeText. Expected _ListBox_p.");
        return NULL;
        }
    }
    ListBox_changeItem(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  ListBox_changeItem(ListBox *obj,const QPixmap * _arg0,int  _arg1) {
    obj->changeItem(*_arg0,_arg1);
}
static PyObject *_wrap_ListBox_changePixmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    QPixmap * _arg1;
    int  _arg2;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ssi:ListBox_changePixmap",&_argc0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_changePixmap. Expected _ListBox_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of ListBox_changePixmap. Expected _QPixmap_p.");
        return NULL;
        }
    }
    ListBox_changeItem(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  ListBox_autoUpdate(ListBox *obj) {
    bool  _result = (bool )obj->autoUpdate();
    return _result;
}
static PyObject *_wrap_ListBox_autoUpdate(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    ListBox * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:ListBox_autoUpdate",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_autoUpdate. Expected _ListBox_p.");
        return NULL;
        }
    }
    _result = (bool )ListBox_autoUpdate(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  ListBox_setAutoUpdate(ListBox *obj,int  _arg0) {
    obj->setAutoUpdate(_arg0);
}
static PyObject *_wrap_ListBox_setAutoUpdate(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:ListBox_setAutoUpdate",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_setAutoUpdate. Expected _ListBox_p.");
        return NULL;
        }
    }
    ListBox_setAutoUpdate(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static int  ListBox_numItemsVisible(ListBox *obj) {
    int  _result = (int )obj->numItemsVisible();
    return _result;
}
static PyObject *_wrap_ListBox_numItemsVisible(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    ListBox * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:ListBox_numItemsVisible",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_numItemsVisible. Expected _ListBox_p.");
        return NULL;
        }
    }
    _result = (int )ListBox_numItemsVisible(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  ListBox_currentItem(ListBox *obj) {
    int  _result = (int )obj->currentItem();
    return _result;
}
static PyObject *_wrap_ListBox_currentItem(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    ListBox * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:ListBox_currentItem",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_currentItem. Expected _ListBox_p.");
        return NULL;
        }
    }
    _result = (int )ListBox_currentItem(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  ListBox_setCurrentItem(ListBox *obj,int  _arg0) {
    obj->setCurrentItem(_arg0);
}
static PyObject *_wrap_ListBox_setCurrentItem(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:ListBox_setCurrentItem",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_setCurrentItem. Expected _ListBox_p.");
        return NULL;
        }
    }
    ListBox_setCurrentItem(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  ListBox_centerCurrentItem(ListBox *obj) {
    obj->centerCurrentItem();
}
static PyObject *_wrap_ListBox_centerCurrentItem(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:ListBox_centerCurrentItem",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_centerCurrentItem. Expected _ListBox_p.");
        return NULL;
        }
    }
    ListBox_centerCurrentItem(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static int  ListBox_topItem(ListBox *obj) {
    int  _result = (int )obj->topItem();
    return _result;
}
static PyObject *_wrap_ListBox_topItem(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    ListBox * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:ListBox_topItem",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_topItem. Expected _ListBox_p.");
        return NULL;
        }
    }
    _result = (int )ListBox_topItem(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  ListBox_setTopItem(ListBox *obj,int  _arg0) {
    obj->setTopItem(_arg0);
}
static PyObject *_wrap_ListBox_setTopItem(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:ListBox_setTopItem",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_setTopItem. Expected _ListBox_p.");
        return NULL;
        }
    }
    ListBox_setTopItem(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  ListBox_dragSelect(ListBox *obj) {
    bool  _result = (bool )obj->dragSelect();
    return _result;
}
static PyObject *_wrap_ListBox_dragSelect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    ListBox * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:ListBox_dragSelect",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_dragSelect. Expected _ListBox_p.");
        return NULL;
        }
    }
    _result = (bool )ListBox_dragSelect(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  ListBox_setDragSelect(ListBox *obj,int  _arg0) {
    obj->setDragSelect(_arg0);
}
static PyObject *_wrap_ListBox_setDragSelect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:ListBox_setDragSelect",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_setDragSelect. Expected _ListBox_p.");
        return NULL;
        }
    }
    ListBox_setDragSelect(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  ListBox_autoScroll(ListBox *obj) {
    bool  _result = (bool )obj->autoScroll();
    return _result;
}
static PyObject *_wrap_ListBox_autoScroll(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    ListBox * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:ListBox_autoScroll",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_autoScroll. Expected _ListBox_p.");
        return NULL;
        }
    }
    _result = (bool )ListBox_autoScroll(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  ListBox_setAutoScroll(ListBox *obj,int  _arg0) {
    obj->setAutoScroll(_arg0);
}
static PyObject *_wrap_ListBox_setAutoScroll(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:ListBox_setAutoScroll",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_setAutoScroll. Expected _ListBox_p.");
        return NULL;
        }
    }
    ListBox_setAutoScroll(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  ListBox_autoScrollBar(ListBox *obj) {
    bool  _result = (bool )obj->autoScrollBar();
    return _result;
}
static PyObject *_wrap_ListBox_autoScrollBar(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    ListBox * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:ListBox_autoScrollBar",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_autoScrollBar. Expected _ListBox_p.");
        return NULL;
        }
    }
    _result = (bool )ListBox_autoScrollBar(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  ListBox_setAutoScrollBar(ListBox *obj,int  _arg0) {
    obj->setAutoScrollBar(_arg0);
}
static PyObject *_wrap_ListBox_setAutoScrollBar(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:ListBox_setAutoScrollBar",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_setAutoScrollBar. Expected _ListBox_p.");
        return NULL;
        }
    }
    ListBox_setAutoScrollBar(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  ListBox_scrollBar(ListBox *obj) {
    bool  _result = (bool )obj->scrollBar();
    return _result;
}
static PyObject *_wrap_ListBox_scrollBar(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    ListBox * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:ListBox_scrollBar",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_scrollBar. Expected _ListBox_p.");
        return NULL;
        }
    }
    _result = (bool )ListBox_scrollBar(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  ListBox_setScrollBar(ListBox *obj,int  _arg0) {
    obj->setScrollBar(_arg0);
}
static PyObject *_wrap_ListBox_setScrollBar(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:ListBox_setScrollBar",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_setScrollBar. Expected _ListBox_p.");
        return NULL;
        }
    }
    ListBox_setScrollBar(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  ListBox_autoBottomScrollBar(ListBox *obj) {
    bool  _result = (bool )obj->autoBottomScrollBar();
    return _result;
}
static PyObject *_wrap_ListBox_autoBottomScrollBar(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    ListBox * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:ListBox_autoBottomScrollBar",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_autoBottomScrollBar. Expected _ListBox_p.");
        return NULL;
        }
    }
    _result = (bool )ListBox_autoBottomScrollBar(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  ListBox_setAutoBottomScrollBar(ListBox *obj,int  _arg0) {
    obj->setAutoBottomScrollBar(_arg0);
}
static PyObject *_wrap_ListBox_setAutoBottomScrollBar(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:ListBox_setAutoBottomScrollBar",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_setAutoBottomScrollBar. Expected _ListBox_p.");
        return NULL;
        }
    }
    ListBox_setAutoBottomScrollBar(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  ListBox_bottomScrollBar(ListBox *obj) {
    bool  _result = (bool )obj->bottomScrollBar();
    return _result;
}
static PyObject *_wrap_ListBox_bottomScrollBar(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    ListBox * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:ListBox_bottomScrollBar",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_bottomScrollBar. Expected _ListBox_p.");
        return NULL;
        }
    }
    _result = (bool )ListBox_bottomScrollBar(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  ListBox_setBottomScrollBar(ListBox *obj,int  _arg0) {
    obj->setBottomScrollBar(_arg0);
}
static PyObject *_wrap_ListBox_setBottomScrollBar(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:ListBox_setBottomScrollBar",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_setBottomScrollBar. Expected _ListBox_p.");
        return NULL;
        }
    }
    ListBox_setBottomScrollBar(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  ListBox_smoothScrolling(ListBox *obj) {
    bool  _result = (bool )obj->smoothScrolling();
    return _result;
}
static PyObject *_wrap_ListBox_smoothScrolling(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    ListBox * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:ListBox_smoothScrolling",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_smoothScrolling. Expected _ListBox_p.");
        return NULL;
        }
    }
    _result = (bool )ListBox_smoothScrolling(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  ListBox_setSmoothScrolling(ListBox *obj,int  _arg0) {
    obj->setSmoothScrolling(_arg0);
}
static PyObject *_wrap_ListBox_setSmoothScrolling(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:ListBox_setSmoothScrolling",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_setSmoothScrolling. Expected _ListBox_p.");
        return NULL;
        }
    }
    ListBox_setSmoothScrolling(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static int  ListBox_itemHeight(ListBox *obj) {
    int  _result = (int )obj->itemHeight();
    return _result;
}
static PyObject *_wrap_ListBox_standardItemHeight(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    ListBox * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:ListBox_standardItemHeight",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_standardItemHeight. Expected _ListBox_p.");
        return NULL;
        }
    }
    _result = (int )ListBox_itemHeight(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  ListBox_itemHeight(ListBox *obj,int  _arg0) {
    int  _result = (int )obj->itemHeight(_arg0);
    return _result;
}
static PyObject *_wrap_ListBox_itemHeight(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    ListBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:ListBox_itemHeight",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_itemHeight. Expected _ListBox_p.");
        return NULL;
        }
    }
    _result = (int )ListBox_itemHeight(_arg0,_arg1);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static long  ListBox_maxItemWidth(ListBox *obj) {
    long  _result = (long )obj->maxItemWidth();
    return _result;
}
static PyObject *_wrap_ListBox_maxItemWidth(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    long  _result;
    ListBox * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:ListBox_maxItemWidth",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_maxItemWidth. Expected _ListBox_p.");
        return NULL;
        }
    }
    _result = (long )ListBox_maxItemWidth(_arg0);
    _resultobj = Py_BuildValue("l",_result);
    return _resultobj;
}

static void  ListBox_setMultiSelection(ListBox *obj,int  _arg0) {
    obj->setMultiSelection(_arg0);
}
static PyObject *_wrap_ListBox_setMultiSelection(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:ListBox_setMultiSelection",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_setMultiSelection. Expected _ListBox_p.");
        return NULL;
        }
    }
    ListBox_setMultiSelection(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigMultiLineEditToTableView(void *ptr) {
    MultiLineEdit *src;
    TableView *dest;
    src = (MultiLineEdit *) ptr;
    dest = (TableView *) src;
    return (void *) dest;
}

static void *SwigMultiLineEditToFrame(void *ptr) {
    MultiLineEdit *src;
    Frame *dest;
    src = (MultiLineEdit *) ptr;
    dest = (Frame *) src;
    return (void *) dest;
}

static void *SwigMultiLineEditToWidget(void *ptr) {
    MultiLineEdit *src;
    Widget *dest;
    src = (MultiLineEdit *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *SwigMultiLineEditToObject(void *ptr) {
    MultiLineEdit *src;
    Object *dest;
    src = (MultiLineEdit *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

static MultiLineEdit *new_MultiLineEdit(Widget * _arg0,const char * _arg1) {
    return new MultiLineEdit(_arg0,_arg1);
}
static PyObject *_wrap_new_MultiLineEdit(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"|ss:new_MultiLineEdit",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_MultiLineEdit. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (MultiLineEdit *)new_MultiLineEdit(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_MultiLineEdit_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void delete_MultiLineEdit(MultiLineEdit *obj) {
    delete obj;
}
static PyObject *_wrap_delete_MultiLineEdit(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:delete_MultiLineEdit",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_MultiLineEdit. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    delete_MultiLineEdit(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static char * MultiLineEdit_textLine(MultiLineEdit *obj,int  _arg0) {
    char * _result = (char *)obj->textLine(_arg0);
    return _result;
}
static PyObject *_wrap_MultiLineEdit_textLine(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    MultiLineEdit * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:MultiLineEdit_textLine",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_textLine. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    _result = (char *)MultiLineEdit_textLine(_arg0,_arg1);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

static char * MultiLineEdit_text(MultiLineEdit *obj) {
    char * _result = (char *)obj->text();
    return _result;
}
static PyObject *_wrap_MultiLineEdit_text(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    MultiLineEdit * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:MultiLineEdit_text",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_text. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    _result = (char *)MultiLineEdit_text(_arg0);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

static int  MultiLineEdit_numLines(MultiLineEdit *obj) {
    int  _result = (int )obj->numLines();
    return _result;
}
static PyObject *_wrap_MultiLineEdit_numLines(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    MultiLineEdit * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:MultiLineEdit_numLines",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_numLines. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    _result = (int )MultiLineEdit_numLines(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static bool  MultiLineEdit_isReadOnly(MultiLineEdit *obj) {
    bool  _result = (bool )obj->isReadOnly();
    return _result;
}
static PyObject *_wrap_MultiLineEdit_isReadOnly(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    MultiLineEdit * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:MultiLineEdit_isReadOnly",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_isReadOnly. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    _result = (bool )MultiLineEdit_isReadOnly(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static bool  MultiLineEdit_isOverwriteMode(MultiLineEdit *obj) {
    bool  _result = (bool )obj->isOverwriteMode();
    return _result;
}
static PyObject *_wrap_MultiLineEdit_isOverwriteMode(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    MultiLineEdit * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:MultiLineEdit_isOverwriteMode",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_isOverwriteMode. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    _result = (bool )MultiLineEdit_isOverwriteMode(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  MultiLineEdit_setFont(MultiLineEdit *obj,const QFont * _arg0) {
    obj->setFont(*_arg0);
}
static PyObject *_wrap_MultiLineEdit_setFont(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    QFont * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:MultiLineEdit_setFont",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_setFont. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of MultiLineEdit_setFont. Expected _QFont_p.");
        return NULL;
        }
    }
    MultiLineEdit_setFont(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  MultiLineEdit_insertLine(MultiLineEdit *obj,const char * _arg0,int  _arg1) {
    obj->insertLine(_arg0,_arg1);
}
static PyObject *_wrap_MultiLineEdit_insertLine(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    char * _arg1;
    int  _arg2 = -1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"ss|i:MultiLineEdit_insertLine",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_insertLine. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    MultiLineEdit_insertLine(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  MultiLineEdit_insertAt(MultiLineEdit *obj,const char * _arg0,int  _arg1,int  _arg2) {
    obj->insertAt(_arg0,_arg1,_arg2);
}
static PyObject *_wrap_MultiLineEdit_insertAt(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    char * _arg1;
    int  _arg2;
    int  _arg3;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"ssii:MultiLineEdit_insertAt",&_argc0,&_arg1,&_arg2,&_arg3)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_insertAt. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    MultiLineEdit_insertAt(_arg0,_arg1,_arg2,_arg3);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  MultiLineEdit_removeLine(MultiLineEdit *obj,int  _arg0) {
    obj->removeLine(_arg0);
}
static PyObject *_wrap_MultiLineEdit_removeLine(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:MultiLineEdit_removeLine",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_removeLine. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    MultiLineEdit_removeLine(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  MultiLineEdit_setCursorPosition(MultiLineEdit *obj,int  _arg0,int  _arg1,int  _arg2) {
    obj->setCursorPosition(_arg0,_arg1,_arg2);
}
static PyObject *_wrap_MultiLineEdit_setCursorPosition(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    int  _arg1;
    int  _arg2;
    int  _arg3 = FALSE;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"sii|i:MultiLineEdit_setCursorPosition",&_argc0,&_arg1,&_arg2,&_arg3)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_setCursorPosition. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    MultiLineEdit_setCursorPosition(_arg0,_arg1,_arg2,_arg3);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  MultiLineEdit_getCursorPosition(MultiLineEdit *obj,int * _arg0,int * _arg1) {
    obj->getCursorPosition(_arg0,_arg1);
}
static PyObject *_wrap_MultiLineEdit_getCursorPosition(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    int * _arg1;
    int * _arg2;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char * _argc2 = 0;

    if(!PyArg_ParseTuple(args,"sss:MultiLineEdit_getCursorPosition",&_argc0,&_argc1,&_argc2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_getCursorPosition. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_int_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of MultiLineEdit_getCursorPosition. Expected _int_p.");
        return NULL;
        }
    }
    if (_argc2) {
        if (SWIG_GetPtr(_argc2,(void **) &_arg2,"_int_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 3 of MultiLineEdit_getCursorPosition. Expected _int_p.");
        return NULL;
        }
    }
    MultiLineEdit_getCursorPosition(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  MultiLineEdit_atBeginning(MultiLineEdit *obj) {
    bool  _result = (bool )obj->atBeginning();
    return _result;
}
static PyObject *_wrap_MultiLineEdit_atBeginning(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    MultiLineEdit * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:MultiLineEdit_atBeginning",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_atBeginning. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    _result = (bool )MultiLineEdit_atBeginning(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static bool  MultiLineEdit_atEnd(MultiLineEdit *obj) {
    bool  _result = (bool )obj->atEnd();
    return _result;
}
static PyObject *_wrap_MultiLineEdit_atEnd(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    MultiLineEdit * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:MultiLineEdit_atEnd",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_atEnd. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    _result = (bool )MultiLineEdit_atEnd(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static bool  MultiLineEdit_autoUpdate(MultiLineEdit *obj) {
    bool  _result = (bool )obj->autoUpdate();
    return _result;
}
static PyObject *_wrap_MultiLineEdit_autoUpdate(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    MultiLineEdit * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:MultiLineEdit_autoUpdate",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_autoUpdate. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    _result = (bool )MultiLineEdit_autoUpdate(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  MultiLineEdit_setAutoUpdate(MultiLineEdit *obj,int  _arg0) {
    obj->setAutoUpdate(_arg0);
}
static PyObject *_wrap_MultiLineEdit_setAutoUpdate(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:MultiLineEdit_setAutoUpdate",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_setAutoUpdate. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    MultiLineEdit_setAutoUpdate(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  MultiLineEdit_clear(MultiLineEdit *obj) {
    obj->clear();
}
static PyObject *_wrap_MultiLineEdit_clear(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:MultiLineEdit_clear",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_clear. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    MultiLineEdit_clear(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  MultiLineEdit_setText(MultiLineEdit *obj,const char * _arg0) {
    obj->setText(_arg0);
}
static PyObject *_wrap_MultiLineEdit_setText(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"ss:MultiLineEdit_setText",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_setText. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    MultiLineEdit_setText(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  MultiLineEdit_append(MultiLineEdit *obj,const char * _arg0) {
    obj->append(_arg0);
}
static PyObject *_wrap_MultiLineEdit_append(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"ss:MultiLineEdit_append",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_append. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    MultiLineEdit_append(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  MultiLineEdit_deselect(MultiLineEdit *obj) {
    obj->deselect();
}
static PyObject *_wrap_MultiLineEdit_deselect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:MultiLineEdit_deselect",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_deselect. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    MultiLineEdit_deselect(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  MultiLineEdit_selectAll(MultiLineEdit *obj) {
    obj->selectAll();
}
static PyObject *_wrap_MultiLineEdit_selectAll(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:MultiLineEdit_selectAll",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_selectAll. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    MultiLineEdit_selectAll(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  MultiLineEdit_setReadOnly(MultiLineEdit *obj,int  _arg0) {
    obj->setReadOnly(_arg0);
}
static PyObject *_wrap_MultiLineEdit_setReadOnly(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:MultiLineEdit_setReadOnly",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_setReadOnly. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    MultiLineEdit_setReadOnly(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  MultiLineEdit_setOverwriteMode(MultiLineEdit *obj,int  _arg0) {
    obj->setOverwriteMode(_arg0);
}
static PyObject *_wrap_MultiLineEdit_setOverwriteMode(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:MultiLineEdit_setOverwriteMode",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_setOverwriteMode. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    MultiLineEdit_setOverwriteMode(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  MultiLineEdit_paste(MultiLineEdit *obj) {
    obj->paste();
}
static PyObject *_wrap_MultiLineEdit_paste(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:MultiLineEdit_paste",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_paste. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    MultiLineEdit_paste(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  MultiLineEdit_copyText(MultiLineEdit *obj) {
    obj->copyText();
}
static PyObject *_wrap_MultiLineEdit_copyText(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:MultiLineEdit_copyText",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_copyText. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    MultiLineEdit_copyText(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  MultiLineEdit_cut(MultiLineEdit *obj) {
    obj->cut();
}
static PyObject *_wrap_MultiLineEdit_cut(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:MultiLineEdit_cut",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_cut. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    MultiLineEdit_cut(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  MultiLineEdit_textChanged(MultiLineEdit *obj) {
    obj->textChanged();
}
static PyObject *_wrap_MultiLineEdit_textChanged(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:MultiLineEdit_textChanged",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_textChanged. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    MultiLineEdit_textChanged(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  MultiLineEdit_returnPressed(MultiLineEdit *obj) {
    obj->returnPressed();
}
static PyObject *_wrap_MultiLineEdit_returnPressed(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:MultiLineEdit_returnPressed",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_returnPressed. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    MultiLineEdit_returnPressed(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigScrollBarToWidget(void *ptr) {
    ScrollBar *src;
    Widget *dest;
    src = (ScrollBar *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *SwigScrollBarToObject(void *ptr) {
    ScrollBar *src;
    Object *dest;
    src = (ScrollBar *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

static ScrollBar *new_ScrollBar(Widget * _arg0,const char * _arg1) {
    return new ScrollBar(_arg0,_arg1);
}
static PyObject *_wrap_new_ScrollBar(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ScrollBar * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"|ss:new_ScrollBar",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_ScrollBar. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (ScrollBar *)new_ScrollBar(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_ScrollBar_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static ScrollBar *new_ScrollBar(ScrollBar::Orientation  _arg0,Widget * _arg1,const char * _arg2) {
    return new ScrollBar(_arg0,_arg1,_arg2);
}
static PyObject *_wrap_new_ScrollBarOrientation(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ScrollBar * _result;
    ScrollBar::Orientation  _arg0;
    Widget * _arg1 = 0;
    char * _arg2 = 0;
    char * _argc1 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"i|ss:new_ScrollBarOrientation",&_arg0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of new_ScrollBarOrientation. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (ScrollBar *)new_ScrollBar(_arg0,_arg1,_arg2);
    SWIG_MakePtr(_ptemp, (char *) _result,"_ScrollBar_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static ScrollBar *new_ScrollBar(int  _arg0,int  _arg1,int  _arg2,int  _arg3,int  _arg4,ScrollBar::Orientation  _arg5,Widget * _arg6,const char * _arg7) {
    return new ScrollBar(_arg0,_arg1,_arg2,_arg3,_arg4,_arg5,_arg6,_arg7);
}
static PyObject *_wrap_new_ScrollBarValues(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ScrollBar * _result;
    int  _arg0;
    int  _arg1;
    int  _arg2;
    int  _arg3;
    int  _arg4;
    ScrollBar::Orientation  _arg5;
    Widget * _arg6 = 0;
    char * _arg7 = 0;
    char * _argc6 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"iiiiii|ss:new_ScrollBarValues",&_arg0,&_arg1,&_arg2,&_arg3,&_arg4,&_arg5,&_argc6,&_arg7)) 
        return NULL;
    if (_argc6) {
        if (SWIG_GetPtr(_argc6,(void **) &_arg6,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 7 of new_ScrollBarValues. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (ScrollBar *)new_ScrollBar(_arg0,_arg1,_arg2,_arg3,_arg4,_arg5,_arg6,_arg7);
    SWIG_MakePtr(_ptemp, (char *) _result,"_ScrollBar_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void  ScrollBar_setOrientation(ScrollBar *obj,ScrollBar::Orientation  _arg0) {
    obj->setOrientation(_arg0);
}
static PyObject *_wrap_ScrollBar_setOrientation(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ScrollBar * _arg0;
    ScrollBar::Orientation  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:ScrollBar_setOrientation",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_setOrientation. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    ScrollBar_setOrientation(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static ScrollBar::Orientation  ScrollBar_orientation(ScrollBar *obj) {
    ScrollBar::Orientation  _result = (ScrollBar::Orientation )obj->orientation();
    return _result;
}
static PyObject *_wrap_ScrollBar_orientation(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ScrollBar::Orientation  _result;
    ScrollBar * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:ScrollBar_orientation",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_orientation. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    _result = (ScrollBar::Orientation )ScrollBar_orientation(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  ScrollBar_setTracking(ScrollBar *obj,int  _arg0) {
    obj->setTracking(_arg0);
}
static PyObject *_wrap_ScrollBar_setTracking(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ScrollBar * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:ScrollBar_setTracking",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_setTracking. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    ScrollBar_setTracking(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  ScrollBar_tracking(ScrollBar *obj) {
    bool  _result = (bool )obj->tracking();
    return _result;
}
static PyObject *_wrap_ScrollBar_tracking(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    ScrollBar * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:ScrollBar_tracking",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_tracking. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    _result = (bool )ScrollBar_tracking(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static bool  ScrollBar_draggingSlider(ScrollBar *obj) {
    bool  _result = (bool )obj->draggingSlider();
    return _result;
}
static PyObject *_wrap_ScrollBar_draggingSlider(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    ScrollBar * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:ScrollBar_draggingSlider",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_draggingSlider. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    _result = (bool )ScrollBar_draggingSlider(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  ScrollBar_setPalette(ScrollBar *obj,const QPalette * _arg0) {
    obj->setPalette(*_arg0);
}
static PyObject *_wrap_ScrollBar_setPalette(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ScrollBar * _arg0;
    QPalette * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    if(!PyArg_ParseTuple(args,"ss:ScrollBar_setPalette",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_setPalette. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPalette_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of ScrollBar_setPalette. Expected _QPalette_p.");
        return NULL;
        }
    }
    ScrollBar_setPalette(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static QSize  ScrollBar_sizeHint(ScrollBar *obj) {
    QSize  _result = (QSize )obj->sizeHint();
    return _result;
}
static PyObject *_wrap_ScrollBar_sizeHint(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QSize * _result;
    ScrollBar * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"s:ScrollBar_sizeHint",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_sizeHint. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    _result = new QSize (ScrollBar_sizeHint(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QSize_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static int  ScrollBar_value(ScrollBar *obj) {
    int  _result = (int )obj->value();
    return _result;
}
static PyObject *_wrap_ScrollBar_value(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    ScrollBar * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:ScrollBar_value",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_value. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    _result = (int )ScrollBar_value(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  ScrollBar_setValue(ScrollBar *obj,int  _arg0) {
    obj->setValue(_arg0);
}
static PyObject *_wrap_ScrollBar_setValue(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ScrollBar * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:ScrollBar_setValue",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_setValue. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    ScrollBar_setValue(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  ScrollBar_addPage(ScrollBar *obj) {
    obj->addPage();
}
static PyObject *_wrap_ScrollBar_addPage(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ScrollBar * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:ScrollBar_addPage",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_addPage. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    ScrollBar_addPage(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  ScrollBar_subtractPage(ScrollBar *obj) {
    obj->subtractPage();
}
static PyObject *_wrap_ScrollBar_subtractPage(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ScrollBar * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:ScrollBar_subtractPage",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_subtractPage. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    ScrollBar_subtractPage(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  ScrollBar_addLine(ScrollBar *obj) {
    obj->addLine();
}
static PyObject *_wrap_ScrollBar_addLine(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ScrollBar * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:ScrollBar_addLine",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_addLine. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    ScrollBar_addLine(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  ScrollBar_subtractLine(ScrollBar *obj) {
    obj->subtractLine();
}
static PyObject *_wrap_ScrollBar_subtractLine(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ScrollBar * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:ScrollBar_subtractLine",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_subtractLine. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    ScrollBar_subtractLine(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static int  ScrollBar_minValue(ScrollBar *obj) {
    int  _result = (int )obj->minValue();
    return _result;
}
static PyObject *_wrap_ScrollBar_minValue(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    ScrollBar * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:ScrollBar_minValue",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_minValue. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    _result = (int )ScrollBar_minValue(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  ScrollBar_maxValue(ScrollBar *obj) {
    int  _result = (int )obj->maxValue();
    return _result;
}
static PyObject *_wrap_ScrollBar_maxValue(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    ScrollBar * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:ScrollBar_maxValue",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_maxValue. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    _result = (int )ScrollBar_maxValue(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  ScrollBar_setRange(ScrollBar *obj,int  _arg0,int  _arg1) {
    obj->setRange(_arg0,_arg1);
}
static PyObject *_wrap_ScrollBar_setRange(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ScrollBar * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"sii:ScrollBar_setRange",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_setRange. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    ScrollBar_setRange(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static int  ScrollBar_lineStep(ScrollBar *obj) {
    int  _result = (int )obj->lineStep();
    return _result;
}
static PyObject *_wrap_ScrollBar_lineStep(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    ScrollBar * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:ScrollBar_lineStep",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_lineStep. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    _result = (int )ScrollBar_lineStep(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  ScrollBar_pageStep(ScrollBar *obj) {
    int  _result = (int )obj->pageStep();
    return _result;
}
static PyObject *_wrap_ScrollBar_pageStep(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    ScrollBar * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:ScrollBar_pageStep",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_pageStep. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    _result = (int )ScrollBar_pageStep(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  ScrollBar_setSteps(ScrollBar *obj,int  _arg0,int  _arg1) {
    obj->setSteps(_arg0,_arg1);
}
static PyObject *_wrap_ScrollBar_setSteps(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ScrollBar * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"sii:ScrollBar_setSteps",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_setSteps. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    ScrollBar_setSteps(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigFileDialogToObject(void *ptr) {
    FileDialog *src;
    Object *dest;
    src = (FileDialog *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

static FileDialog *new_FileDialog() {
    return new FileDialog();
}
static PyObject *_wrap_new_FileDilogN(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    FileDialog * _result;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,":new_FileDilogN")) 
        return NULL;
    _result = (FileDialog *)new_FileDialog();
    SWIG_MakePtr(_ptemp, (char *) _result,"_FileDialog_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void delete_FileDialog(FileDialog *obj) {
    delete obj;
}
static PyObject *_wrap_delete_FileDilogN(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    FileDialog * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:delete_FileDilogN",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_FileDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_FileDilogN. Expected _FileDialog_p.");
        return NULL;
        }
    }
    delete_FileDialog(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static int  FileDialog_left(FileDialog *obj) {
    int  _result = (int )obj->left();
    return _result;
}
static PyObject *_wrap_FileDialog_left(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    FileDialog * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:FileDialog_left",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_FileDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of FileDialog_left. Expected _FileDialog_p.");
        return NULL;
        }
    }
    _result = (int )FileDialog_left(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  FileDialog_top(FileDialog *obj) {
    int  _result = (int )obj->top();
    return _result;
}
static PyObject *_wrap_FileDialog_top(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    FileDialog * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:FileDialog_top",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_FileDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of FileDialog_top. Expected _FileDialog_p.");
        return NULL;
        }
    }
    _result = (int )FileDialog_top(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  FileDialog_width(FileDialog *obj) {
    int  _result = (int )obj->width();
    return _result;
}
static PyObject *_wrap_FileDialog_width(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    FileDialog * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:FileDialog_width",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_FileDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of FileDialog_width. Expected _FileDialog_p.");
        return NULL;
        }
    }
    _result = (int )FileDialog_width(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  FileDialog_height(FileDialog *obj) {
    int  _result = (int )obj->height();
    return _result;
}
static PyObject *_wrap_FileDialog_height(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    FileDialog * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:FileDialog_height",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_FileDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of FileDialog_height. Expected _FileDialog_p.");
        return NULL;
        }
    }
    _result = (int )FileDialog_height(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  FileDialog_show(FileDialog *obj) {
    obj->show();
}
static PyObject *_wrap_FileDialog_show(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    FileDialog * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:FileDialog_show",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_FileDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of FileDialog_show. Expected _FileDialog_p.");
        return NULL;
        }
    }
    FileDialog_show(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  FileDialog_create(FileDialog *obj,const char * _arg0,const char * _arg1,QWidget * _arg2,const char * _arg3,bool  _arg4) {
    obj->create(_arg0,_arg1,_arg2,_arg3,_arg4);
}
static PyObject *_wrap_FileDialog_create(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    FileDialog * _arg0;
    char * _arg1;
    char * _arg2 = 0;
    QWidget * _arg3 = 0;
    char * _arg4 = 0;
    bool  _arg5 = FALSE;
    char * _argc0 = 0;
    char * _argc3 = 0;

    if(!PyArg_ParseTuple(args,"ss|sssi:FileDialog_create",&_argc0,&_arg1,&_arg2,&_argc3,&_arg4,&_arg5)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_FileDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of FileDialog_create. Expected _FileDialog_p.");
        return NULL;
        }
    }
    if (_argc3) {
        if (SWIG_GetPtr(_argc3,(void **) &_arg3,"_QWidget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 4 of FileDialog_create. Expected _QWidget_p.");
        return NULL;
        }
    }
    FileDialog_create(_arg0,_arg1,_arg2,_arg3,_arg4,_arg5);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static char * FileDialog_path(FileDialog *obj) {
    char * _result = (char *)obj->path();
    return _result;
}
static PyObject *_wrap_FileDialog_path(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    FileDialog * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:FileDialog_path",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_FileDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of FileDialog_path. Expected _FileDialog_p.");
        return NULL;
        }
    }
    _result = (char *)FileDialog_path(_arg0);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

static void  FileDialog_fileHighlighted(FileDialog *obj,const char * _arg0) {
    obj->fileHighlighted(_arg0);
}
static PyObject *_wrap_FileDialog_fileHighlighted(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    FileDialog * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"ss:FileDialog_fileHighlighted",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_FileDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of FileDialog_fileHighlighted. Expected _FileDialog_p.");
        return NULL;
        }
    }
    FileDialog_fileHighlighted(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  FileDialog_fileSelected(FileDialog *obj,const char * _arg0) {
    obj->fileSelected(_arg0);
}
static PyObject *_wrap_FileDialog_fileSelected(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    FileDialog * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"ss:FileDialog_fileSelected",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_FileDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of FileDialog_fileSelected. Expected _FileDialog_p.");
        return NULL;
        }
    }
    FileDialog_fileSelected(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  FileDialog_dirEntered(FileDialog *obj,const char * _arg0) {
    obj->dirEntered(_arg0);
}
static PyObject *_wrap_FileDialog_dirEntered(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    FileDialog * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"ss:FileDialog_dirEntered",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_FileDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of FileDialog_dirEntered. Expected _FileDialog_p.");
        return NULL;
        }
    }
    FileDialog_dirEntered(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static QMenuBar *new_QMenuBar(Object * _arg0,const char * _arg1) {
    return new QMenuBar(_arg0,_arg1);
}
static PyObject *_wrap_new_QMenuBar(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QMenuBar * _result;
    Object * _arg0 = 0;
    char * _arg1 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"|ss:new_QMenuBar",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Object_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_QMenuBar. Expected _Object_p.");
        return NULL;
        }
    }
    _result = (QMenuBar *)new_QMenuBar(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QMenuBar_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void delete_QMenuBar(QMenuBar *obj) {
    delete obj;
}
static PyObject *_wrap_delete_QMenuBar(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QMenuBar * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:delete_QMenuBar",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QMenuBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_QMenuBar. Expected _QMenuBar_p.");
        return NULL;
        }
    }
    delete_QMenuBar(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  QMenuBar_updateItem(QMenuBar *obj,int  _arg0) {
    obj->updateItem(_arg0);
}
static PyObject *_wrap_QMenuBar_updateItem(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QMenuBar * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:QMenuBar_updateItem",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QMenuBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QMenuBar_updateItem. Expected _QMenuBar_p.");
        return NULL;
        }
    }
    QMenuBar_updateItem(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  QMenuBar_show(QMenuBar *obj) {
    obj->show();
}
static PyObject *_wrap_QMenuBar_show(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QMenuBar * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QMenuBar_show",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QMenuBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QMenuBar_show. Expected _QMenuBar_p.");
        return NULL;
        }
    }
    QMenuBar_show(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  QMenuBar_hide(QMenuBar *obj) {
    obj->hide();
}
static PyObject *_wrap_QMenuBar_hide(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QMenuBar * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QMenuBar_hide",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QMenuBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QMenuBar_hide. Expected _QMenuBar_p.");
        return NULL;
        }
    }
    QMenuBar_hide(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static bool  QMenuBar_eventFilter(QMenuBar *obj,QObject * _arg0,QEvent * _arg1) {
    bool  _result = (bool )obj->eventFilter(_arg0,_arg1);
    return _result;
}
static PyObject *_wrap_QMenuBar_eventFilter(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QMenuBar * _arg0;
    QObject * _arg1;
    QEvent * _arg2;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char * _argc2 = 0;

    if(!PyArg_ParseTuple(args,"sss:QMenuBar_eventFilter",&_argc0,&_argc1,&_argc2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QMenuBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QMenuBar_eventFilter. Expected _QMenuBar_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QObject_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QMenuBar_eventFilter. Expected _QObject_p.");
        return NULL;
        }
    }
    if (_argc2) {
        if (SWIG_GetPtr(_argc2,(void **) &_arg2,"_QEvent_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 3 of QMenuBar_eventFilter. Expected _QEvent_p.");
        return NULL;
        }
    }
    _result = (bool )QMenuBar_eventFilter(_arg0,_arg1,_arg2);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  QMenuBar_heightForWidth(QMenuBar *obj,int  _arg0) {
    int  _result = (int )obj->heightForWidth(_arg0);
    return _result;
}
static PyObject *_wrap_QMenuBar_heightForWidth(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QMenuBar * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:QMenuBar_heightForWidth",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QMenuBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QMenuBar_heightForWidth. Expected _QMenuBar_p.");
        return NULL;
        }
    }
    _result = (int )QMenuBar_heightForWidth(_arg0,_arg1);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static QMenuBar::Separator  QMenuBar_separator(QMenuBar *obj) {
    QMenuBar::Separator  _result = (QMenuBar::Separator )obj->separator();
    return _result;
}
static PyObject *_wrap_QMenuBar_separator(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QMenuBar::Separator  _result;
    QMenuBar * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:QMenuBar_separator",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QMenuBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QMenuBar_separator. Expected _QMenuBar_p.");
        return NULL;
        }
    }
    _result = (QMenuBar::Separator )QMenuBar_separator(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  QMenuBar_setSeparator(QMenuBar *obj,QMenuBar::Separator  _arg0) {
    obj->setSeparator(_arg0);
}
static PyObject *_wrap_QMenuBar_setSeparator(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QMenuBar * _arg0;
    QMenuBar::Separator  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:QMenuBar_setSeparator",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QMenuBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QMenuBar_setSeparator. Expected _QMenuBar_p.");
        return NULL;
        }
    }
    QMenuBar_setSeparator(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static int  QMenuBar_insertItem(QMenuBar *obj,char * _arg0,PopupMenu * _arg1) {
    int  _result = (int )obj->insertItem(_arg0,_arg1);
    return _result;
}
static PyObject *_wrap_QMenuBar_insertItem(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QMenuBar * _arg0;
    char * _arg1;
    PopupMenu * _arg2;
    char * _argc0 = 0;
    char * _argc2 = 0;

    if(!PyArg_ParseTuple(args,"sss:QMenuBar_insertItem",&_argc0,&_arg1,&_argc2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QMenuBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QMenuBar_insertItem. Expected _QMenuBar_p.");
        return NULL;
        }
    }
    if (_argc2) {
        if (SWIG_GetPtr(_argc2,(void **) &_arg2,"_PopupMenu_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 3 of QMenuBar_insertItem. Expected _PopupMenu_p.");
        return NULL;
        }
    }
    _result = (int )QMenuBar_insertItem(_arg0,_arg1,_arg2);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static PopupMenu *new_PopupMenu(Widget * _arg0,const char * _arg1) {
    return new PopupMenu(_arg0,_arg1);
}
static PyObject *_wrap_new_PopupMenu(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PopupMenu * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,"|ss:new_PopupMenu",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_PopupMenu. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (PopupMenu *)new_PopupMenu(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_PopupMenu_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void delete_PopupMenu(PopupMenu *obj) {
    delete obj;
}
static PyObject *_wrap_delete_PopupMenu(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PopupMenu * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:delete_PopupMenu",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PopupMenu_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_PopupMenu. Expected _PopupMenu_p.");
        return NULL;
        }
    }
    delete_PopupMenu(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  PopupMenu_insert(PopupMenu *obj,int  _arg0,const char * _arg1,QPixmap * _arg2,PopupMenu * _arg3,PyObject * _arg4) {
    obj->insert(_arg0,_arg1,_arg2,_arg3,_arg4);
}
static PyObject *_wrap_PopupMenu_insert(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PopupMenu * _arg0;
    int  _arg1;
    char * _arg2;
    QPixmap * _arg3;
    PopupMenu * _arg4;
    PyObject * _arg5;
    char * _argc0 = 0;
    char * _argc3 = 0;
    char * _argc4 = 0;
    PyObject * _obj5 = 0;

    if(!PyArg_ParseTuple(args,"sisssO:PopupMenu_insert",&_argc0,&_arg1,&_arg2,&_argc3,&_argc4,&_obj5)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PopupMenu_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PopupMenu_insert. Expected _PopupMenu_p.");
        return NULL;
        }
    }
    if (_argc3) {
        if (SWIG_GetPtr(_argc3,(void **) &_arg3,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 4 of PopupMenu_insert. Expected _QPixmap_p.");
        return NULL;
        }
    }
    if (_argc4) {
        if (SWIG_GetPtr(_argc4,(void **) &_arg4,"_PopupMenu_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 5 of PopupMenu_insert. Expected _PopupMenu_p.");
        return NULL;
        }
    }
{
  /*
if(!PyCFunction_Check(_obj5))
  {
    PyErr_SetString(PyExc_TypeError, "Function object expected!");
    return NULL;	
  }
  */ 	
  _arg5 = _obj5;
}
    PopupMenu_insert(_arg0,_arg1,_arg2,_arg3,_arg4,_arg5);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  PopupMenu_move(PopupMenu *obj,int  _arg0,int  _arg1) {
    obj->move(_arg0,_arg1);
}
static PyObject *_wrap_PopupMenu_move(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PopupMenu * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"sii:PopupMenu_move",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PopupMenu_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PopupMenu_move. Expected _PopupMenu_p.");
        return NULL;
        }
    }
    PopupMenu_move(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static int  PopupMenu_modal(PopupMenu *obj) {
    int  _result = (int )obj->modal();
    return _result;
}
static PyObject *_wrap_PopupMenu_modal(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    PopupMenu * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:PopupMenu_modal",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PopupMenu_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PopupMenu_modal. Expected _PopupMenu_p.");
        return NULL;
        }
    }
    _result = (int )PopupMenu_modal(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  PopupMenu_show(PopupMenu *obj) {
    obj->show();
}
static PyObject *_wrap_PopupMenu_show(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PopupMenu * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:PopupMenu_show",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PopupMenu_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PopupMenu_show. Expected _PopupMenu_p.");
        return NULL;
        }
    }
    PopupMenu_show(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  PopupMenu_hide(PopupMenu *obj) {
    obj->hide();
}
static PyObject *_wrap_PopupMenu_hide(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PopupMenu * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:PopupMenu_hide",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PopupMenu_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PopupMenu_hide. Expected _PopupMenu_p.");
        return NULL;
        }
    }
    PopupMenu_hide(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  PopupMenu_popup(PopupMenu *obj,int  _arg0,int  _arg1,int  _arg2) {
    obj->popup(_arg0,_arg1,_arg2);
}
static PyObject *_wrap_PopupMenu_popup(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PopupMenu * _arg0;
    int  _arg1;
    int  _arg2;
    int  _arg3 = 0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"sii|i:PopupMenu_popup",&_argc0,&_arg1,&_arg2,&_arg3)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PopupMenu_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PopupMenu_popup. Expected _PopupMenu_p.");
        return NULL;
        }
    }
    PopupMenu_popup(_arg0,_arg1,_arg2,_arg3);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void  PopupMenu_selected(PopupMenu *obj,int  _arg0) {
    obj->selected(_arg0);
}
static PyObject *_wrap_PopupMenu_selected(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PopupMenu * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"si:PopupMenu_selected",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PopupMenu_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PopupMenu_selected. Expected _PopupMenu_p.");
        return NULL;
        }
    }
    PopupMenu_selected(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static MenuData *new_MenuData() {
    return new MenuData();
}
static PyObject *_wrap_new_MenuData(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MenuData * _result;
    char _ptemp[128];

    if(!PyArg_ParseTuple(args,":new_MenuData")) 
        return NULL;
    _result = (MenuData *)new_MenuData();
    SWIG_MakePtr(_ptemp, (char *) _result,"_MenuData_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void delete_MenuData(MenuData *obj) {
    delete obj;
}
static PyObject *_wrap_delete_MenuData(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MenuData * _arg0;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s:delete_MenuData",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MenuData_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_MenuData. Expected _MenuData_p.");
        return NULL;
        }
    }
    delete_MenuData(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static int  MenuData_insertItemText(MenuData *obj,const char * _arg0,const QObject * _arg1,const char * _arg2,int  _arg3) {
    int  _result = (int )obj->insertItemText(_arg0,_arg1,_arg2,_arg3);
    return _result;
}
static PyObject *_wrap_MenuData_insertItemText(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    MenuData * _arg0;
    char * _arg1;
    QObject * _arg2;
    char * _arg3;
    int  _arg4 = 0;
    char * _argc0 = 0;
    char * _argc2 = 0;

    if(!PyArg_ParseTuple(args,"ssss|i:MenuData_insertItemText",&_argc0,&_arg1,&_argc2,&_arg3,&_arg4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MenuData_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MenuData_insertItemText. Expected _MenuData_p.");
        return NULL;
        }
    }
    if (_argc2) {
        if (SWIG_GetPtr(_argc2,(void **) &_arg2,"_QObject_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 3 of MenuData_insertItemText. Expected _QObject_p.");
        return NULL;
        }
    }
    _result = (int )MenuData_insertItemText(_arg0,_arg1,_arg2,_arg3,_arg4);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  MenuData_insertItemQPixmap(MenuData *obj,const QPixmap * _arg0,const QObject * _arg1,const char * _arg2,int  _arg3) {
    int  _result = (int )obj->insertItemQPixmap(*_arg0,_arg1,_arg2,_arg3);
    return _result;
}
static PyObject *_wrap_MenuData_insertItemQPixmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    MenuData * _arg0;
    QPixmap * _arg1;
    QObject * _arg2;
    char * _arg3;
    int  _arg4 = 0;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char * _argc2 = 0;

    if(!PyArg_ParseTuple(args,"ssss|i:MenuData_insertItemQPixmap",&_argc0,&_argc1,&_argc2,&_arg3,&_arg4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MenuData_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MenuData_insertItemQPixmap. Expected _MenuData_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of MenuData_insertItemQPixmap. Expected _QPixmap_p.");
        return NULL;
        }
    }
    if (_argc2) {
        if (SWIG_GetPtr(_argc2,(void **) &_arg2,"_QObject_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 3 of MenuData_insertItemQPixmap. Expected _QObject_p.");
        return NULL;
        }
    }
    _result = (int )MenuData_insertItemQPixmap(_arg0,_arg1,_arg2,_arg3,_arg4);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static int  MenuData_insertItemQPixmapText(MenuData *obj,const QPixmap * _arg0,const char * _arg1,const QObject * _arg2,const char * _arg3,int  _arg4) {
    int  _result = (int )obj->insertItemQPixmapText(*_arg0,_arg1,_arg2,_arg3,_arg4);
    return _result;
}
static PyObject *_wrap_MenuData_insertItemQPixmapText(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    MenuData * _arg0;
    QPixmap * _arg1;
    char * _arg2;
    QObject * _arg3;
    char * _arg4;
    int  _arg5 = 0;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char * _argc3 = 0;

    if(!PyArg_ParseTuple(args,"sssss|i:MenuData_insertItemQPixmapText",&_argc0,&_argc1,&_arg2,&_argc3,&_arg4,&_arg5)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MenuData_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MenuData_insertItemQPixmapText. Expected _MenuData_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of MenuData_insertItemQPixmapText. Expected _QPixmap_p.");
        return NULL;
        }
    }
    if (_argc3) {
        if (SWIG_GetPtr(_argc3,(void **) &_arg3,"_QObject_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 4 of MenuData_insertItemQPixmapText. Expected _QObject_p.");
        return NULL;
        }
    }
    _result = (int )MenuData_insertItemQPixmapText(_arg0,_arg1,_arg2,_arg3,_arg4,_arg5);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void  MenuData_insertSeparator(MenuData *obj,int  _arg0) {
    obj->insertSeparator(_arg0);
}
static PyObject *_wrap_MenuData_insertSeparator(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MenuData * _arg0;
    int  _arg1 = -1;
    char * _argc0 = 0;

    if(!PyArg_ParseTuple(args,"s|i:MenuData_insertSeparator",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MenuData_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MenuData_insertSeparator. Expected _MenuData_p.");
        return NULL;
        }
    }
    MenuData_insertSeparator(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static PyMethodDef pythonqtcMethods[] = {
	 { "MenuData_insertSeparator", _wrap_MenuData_insertSeparator, 1 },
	 { "MenuData_insertItemQPixmapText", _wrap_MenuData_insertItemQPixmapText, 1 },
	 { "MenuData_insertItemQPixmap", _wrap_MenuData_insertItemQPixmap, 1 },
	 { "MenuData_insertItemText", _wrap_MenuData_insertItemText, 1 },
	 { "delete_MenuData", _wrap_delete_MenuData, 1 },
	 { "new_MenuData", _wrap_new_MenuData, 1 },
	 { "PopupMenu_selected", _wrap_PopupMenu_selected, 1 },
	 { "PopupMenu_popup", _wrap_PopupMenu_popup, 1 },
	 { "PopupMenu_hide", _wrap_PopupMenu_hide, 1 },
	 { "PopupMenu_show", _wrap_PopupMenu_show, 1 },
	 { "PopupMenu_modal", _wrap_PopupMenu_modal, 1 },
	 { "PopupMenu_move", _wrap_PopupMenu_move, 1 },
	 { "PopupMenu_insert", _wrap_PopupMenu_insert, 1 },
	 { "delete_PopupMenu", _wrap_delete_PopupMenu, 1 },
	 { "new_PopupMenu", _wrap_new_PopupMenu, 1 },
	 { "QMenuBar_insertItem", _wrap_QMenuBar_insertItem, 1 },
	 { "QMenuBar_setSeparator", _wrap_QMenuBar_setSeparator, 1 },
	 { "QMenuBar_separator", _wrap_QMenuBar_separator, 1 },
	 { "QMenuBar_heightForWidth", _wrap_QMenuBar_heightForWidth, 1 },
	 { "QMenuBar_eventFilter", _wrap_QMenuBar_eventFilter, 1 },
	 { "QMenuBar_hide", _wrap_QMenuBar_hide, 1 },
	 { "QMenuBar_show", _wrap_QMenuBar_show, 1 },
	 { "QMenuBar_updateItem", _wrap_QMenuBar_updateItem, 1 },
	 { "delete_QMenuBar", _wrap_delete_QMenuBar, 1 },
	 { "new_QMenuBar", _wrap_new_QMenuBar, 1 },
	 { "FileDialog_dirEntered", _wrap_FileDialog_dirEntered, 1 },
	 { "FileDialog_fileSelected", _wrap_FileDialog_fileSelected, 1 },
	 { "FileDialog_fileHighlighted", _wrap_FileDialog_fileHighlighted, 1 },
	 { "FileDialog_path", _wrap_FileDialog_path, 1 },
	 { "FileDialog_create", _wrap_FileDialog_create, 1 },
	 { "FileDialog_show", _wrap_FileDialog_show, 1 },
	 { "FileDialog_height", _wrap_FileDialog_height, 1 },
	 { "FileDialog_width", _wrap_FileDialog_width, 1 },
	 { "FileDialog_top", _wrap_FileDialog_top, 1 },
	 { "FileDialog_left", _wrap_FileDialog_left, 1 },
	 { "delete_FileDilogN", _wrap_delete_FileDilogN, 1 },
	 { "new_FileDilogN", _wrap_new_FileDilogN, 1 },
	 { "ScrollBar_setSteps", _wrap_ScrollBar_setSteps, 1 },
	 { "ScrollBar_pageStep", _wrap_ScrollBar_pageStep, 1 },
	 { "ScrollBar_lineStep", _wrap_ScrollBar_lineStep, 1 },
	 { "ScrollBar_setRange", _wrap_ScrollBar_setRange, 1 },
	 { "ScrollBar_maxValue", _wrap_ScrollBar_maxValue, 1 },
	 { "ScrollBar_minValue", _wrap_ScrollBar_minValue, 1 },
	 { "ScrollBar_subtractLine", _wrap_ScrollBar_subtractLine, 1 },
	 { "ScrollBar_addLine", _wrap_ScrollBar_addLine, 1 },
	 { "ScrollBar_subtractPage", _wrap_ScrollBar_subtractPage, 1 },
	 { "ScrollBar_addPage", _wrap_ScrollBar_addPage, 1 },
	 { "ScrollBar_setValue", _wrap_ScrollBar_setValue, 1 },
	 { "ScrollBar_value", _wrap_ScrollBar_value, 1 },
	 { "ScrollBar_sizeHint", _wrap_ScrollBar_sizeHint, 1 },
	 { "ScrollBar_setPalette", _wrap_ScrollBar_setPalette, 1 },
	 { "ScrollBar_draggingSlider", _wrap_ScrollBar_draggingSlider, 1 },
	 { "ScrollBar_tracking", _wrap_ScrollBar_tracking, 1 },
	 { "ScrollBar_setTracking", _wrap_ScrollBar_setTracking, 1 },
	 { "ScrollBar_orientation", _wrap_ScrollBar_orientation, 1 },
	 { "ScrollBar_setOrientation", _wrap_ScrollBar_setOrientation, 1 },
	 { "new_ScrollBarValues", _wrap_new_ScrollBarValues, 1 },
	 { "new_ScrollBarOrientation", _wrap_new_ScrollBarOrientation, 1 },
	 { "new_ScrollBar", _wrap_new_ScrollBar, 1 },
	 { "MultiLineEdit_returnPressed", _wrap_MultiLineEdit_returnPressed, 1 },
	 { "MultiLineEdit_textChanged", _wrap_MultiLineEdit_textChanged, 1 },
	 { "MultiLineEdit_cut", _wrap_MultiLineEdit_cut, 1 },
	 { "MultiLineEdit_copyText", _wrap_MultiLineEdit_copyText, 1 },
	 { "MultiLineEdit_paste", _wrap_MultiLineEdit_paste, 1 },
	 { "MultiLineEdit_setOverwriteMode", _wrap_MultiLineEdit_setOverwriteMode, 1 },
	 { "MultiLineEdit_setReadOnly", _wrap_MultiLineEdit_setReadOnly, 1 },
	 { "MultiLineEdit_selectAll", _wrap_MultiLineEdit_selectAll, 1 },
	 { "MultiLineEdit_deselect", _wrap_MultiLineEdit_deselect, 1 },
	 { "MultiLineEdit_append", _wrap_MultiLineEdit_append, 1 },
	 { "MultiLineEdit_setText", _wrap_MultiLineEdit_setText, 1 },
	 { "MultiLineEdit_clear", _wrap_MultiLineEdit_clear, 1 },
	 { "MultiLineEdit_setAutoUpdate", _wrap_MultiLineEdit_setAutoUpdate, 1 },
	 { "MultiLineEdit_autoUpdate", _wrap_MultiLineEdit_autoUpdate, 1 },
	 { "MultiLineEdit_atEnd", _wrap_MultiLineEdit_atEnd, 1 },
	 { "MultiLineEdit_atBeginning", _wrap_MultiLineEdit_atBeginning, 1 },
	 { "MultiLineEdit_getCursorPosition", _wrap_MultiLineEdit_getCursorPosition, 1 },
	 { "MultiLineEdit_setCursorPosition", _wrap_MultiLineEdit_setCursorPosition, 1 },
	 { "MultiLineEdit_removeLine", _wrap_MultiLineEdit_removeLine, 1 },
	 { "MultiLineEdit_insertAt", _wrap_MultiLineEdit_insertAt, 1 },
	 { "MultiLineEdit_insertLine", _wrap_MultiLineEdit_insertLine, 1 },
	 { "MultiLineEdit_setFont", _wrap_MultiLineEdit_setFont, 1 },
	 { "MultiLineEdit_isOverwriteMode", _wrap_MultiLineEdit_isOverwriteMode, 1 },
	 { "MultiLineEdit_isReadOnly", _wrap_MultiLineEdit_isReadOnly, 1 },
	 { "MultiLineEdit_numLines", _wrap_MultiLineEdit_numLines, 1 },
	 { "MultiLineEdit_text", _wrap_MultiLineEdit_text, 1 },
	 { "MultiLineEdit_textLine", _wrap_MultiLineEdit_textLine, 1 },
	 { "delete_MultiLineEdit", _wrap_delete_MultiLineEdit, 1 },
	 { "new_MultiLineEdit", _wrap_new_MultiLineEdit, 1 },
	 { "ListBox_setMultiSelection", _wrap_ListBox_setMultiSelection, 1 },
	 { "ListBox_maxItemWidth", _wrap_ListBox_maxItemWidth, 1 },
	 { "ListBox_itemHeight", _wrap_ListBox_itemHeight, 1 },
	 { "ListBox_standardItemHeight", _wrap_ListBox_standardItemHeight, 1 },
	 { "ListBox_setSmoothScrolling", _wrap_ListBox_setSmoothScrolling, 1 },
	 { "ListBox_smoothScrolling", _wrap_ListBox_smoothScrolling, 1 },
	 { "ListBox_setBottomScrollBar", _wrap_ListBox_setBottomScrollBar, 1 },
	 { "ListBox_bottomScrollBar", _wrap_ListBox_bottomScrollBar, 1 },
	 { "ListBox_setAutoBottomScrollBar", _wrap_ListBox_setAutoBottomScrollBar, 1 },
	 { "ListBox_autoBottomScrollBar", _wrap_ListBox_autoBottomScrollBar, 1 },
	 { "ListBox_setScrollBar", _wrap_ListBox_setScrollBar, 1 },
	 { "ListBox_scrollBar", _wrap_ListBox_scrollBar, 1 },
	 { "ListBox_setAutoScrollBar", _wrap_ListBox_setAutoScrollBar, 1 },
	 { "ListBox_autoScrollBar", _wrap_ListBox_autoScrollBar, 1 },
	 { "ListBox_setAutoScroll", _wrap_ListBox_setAutoScroll, 1 },
	 { "ListBox_autoScroll", _wrap_ListBox_autoScroll, 1 },
	 { "ListBox_setDragSelect", _wrap_ListBox_setDragSelect, 1 },
	 { "ListBox_dragSelect", _wrap_ListBox_dragSelect, 1 },
	 { "ListBox_setTopItem", _wrap_ListBox_setTopItem, 1 },
	 { "ListBox_topItem", _wrap_ListBox_topItem, 1 },
	 { "ListBox_centerCurrentItem", _wrap_ListBox_centerCurrentItem, 1 },
	 { "ListBox_setCurrentItem", _wrap_ListBox_setCurrentItem, 1 },
	 { "ListBox_currentItem", _wrap_ListBox_currentItem, 1 },
	 { "ListBox_numItemsVisible", _wrap_ListBox_numItemsVisible, 1 },
	 { "ListBox_setAutoUpdate", _wrap_ListBox_setAutoUpdate, 1 },
	 { "ListBox_autoUpdate", _wrap_ListBox_autoUpdate, 1 },
	 { "ListBox_changePixmap", _wrap_ListBox_changePixmap, 1 },
	 { "ListBox_changeText", _wrap_ListBox_changeText, 1 },
	 { "ListBox_pixmap", _wrap_ListBox_pixmap, 1 },
	 { "ListBox_text", _wrap_ListBox_text, 1 },
	 { "ListBox_clear", _wrap_ListBox_clear, 1 },
	 { "ListBox_removeItem", _wrap_ListBox_removeItem, 1 },
	 { "ListBox_inSort", _wrap_ListBox_inSort, 1 },
	 { "ListBox_insertPixmap", _wrap_ListBox_insertPixmap, 1 },
	 { "ListBox_insertText", _wrap_ListBox_insertText, 1 },
	 { "ListBox_insertStrList", _wrap_ListBox_insertStrList, 1 },
	 { "ListBox_count", _wrap_ListBox_count, 1 },
	 { "ListBox_setFont", _wrap_ListBox_setFont, 1 },
	 { "delete_ListBox", _wrap_delete_ListBox, 1 },
	 { "new_ListBox", _wrap_new_ListBox, 1 },
	 { "delete_TableView", _wrap_delete_TableView, 1 },
	 { "new_TableView", _wrap_new_TableView, 1 },
	 { "Label_setDouble", _wrap_Label_setDouble, 1 },
	 { "Label_setInt", _wrap_Label_setInt, 1 },
	 { "Label_setPixmap", _wrap_Label_setPixmap, 1 },
	 { "Label_setText", _wrap_Label_setText, 1 },
	 { "Label_buddy", _wrap_Label_buddy, 1 },
	 { "Label_setBuddy", _wrap_Label_setBuddy, 1 },
	 { "Label_sizeHint", _wrap_Label_sizeHint, 1 },
	 { "Label_setAutoResize", _wrap_Label_setAutoResize, 1 },
	 { "Label_autoResize", _wrap_Label_autoResize, 1 },
	 { "Label_setMargin", _wrap_Label_setMargin, 1 },
	 { "Label_margin", _wrap_Label_margin, 1 },
	 { "Label_setAlignment", _wrap_Label_setAlignment, 1 },
	 { "Label_alignment", _wrap_Label_alignment, 1 },
	 { "Label_pixmap", _wrap_Label_pixmap, 1 },
	 { "Label_text", _wrap_Label_text, 1 },
	 { "delete_Label", _wrap_delete_Label, 1 },
	 { "new_LabelBuddy", _wrap_new_LabelBuddy, 1 },
	 { "new_LabelT", _wrap_new_LabelT, 1 },
	 { "new_Label", _wrap_new_Label, 1 },
	 { "ButtonGroup_find", _wrap_ButtonGroup_find, 1 },
	 { "ButtonGroup_remove", _wrap_ButtonGroup_remove, 1 },
	 { "ButtonGroup_insert", _wrap_ButtonGroup_insert, 1 },
	 { "ButtonGroup_setExclusive", _wrap_ButtonGroup_setExclusive, 1 },
	 { "ButtonGroup_isExclusive", _wrap_ButtonGroup_isExclusive, 1 },
	 { "delete_ButtonGroup", _wrap_delete_ButtonGroup, 1 },
	 { "new_ButtonGroupTitle", _wrap_new_ButtonGroupTitle, 1 },
	 { "new_ButtonGroup", _wrap_new_ButtonGroup, 1 },
	 { "GroupBox_setAlignment", _wrap_GroupBox_setAlignment, 1 },
	 { "GroupBox_alignment", _wrap_GroupBox_alignment, 1 },
	 { "GroupBox_setTitle", _wrap_GroupBox_setTitle, 1 },
	 { "GroupBox_title", _wrap_GroupBox_title, 1 },
	 { "new_GroupBoxTitle", _wrap_new_GroupBoxTitle, 1 },
	 { "new_GroupBox", _wrap_new_GroupBox, 1 },
	 { "Frame_contentsRect", _wrap_Frame_contentsRect, 1 },
	 { "Frame_frameRect", _wrap_Frame_frameRect, 1 },
	 { "Frame_frameWidth", _wrap_Frame_frameWidth, 1 },
	 { "Frame_setMidLineWidth", _wrap_Frame_setMidLineWidth, 1 },
	 { "Frame_midLineWidth", _wrap_Frame_midLineWidth, 1 },
	 { "Frame_setLineWidth", _wrap_Frame_setLineWidth, 1 },
	 { "Frame_lineWidth", _wrap_Frame_lineWidth, 1 },
	 { "Frame_lineShapesOk", _wrap_Frame_lineShapesOk, 1 },
	 { "Frame_setFrameStyle", _wrap_Frame_setFrameStyle, 1 },
	 { "Frame_frameShadow", _wrap_Frame_frameShadow, 1 },
	 { "Frame_frameShape", _wrap_Frame_frameShape, 1 },
	 { "Frame_frameStyle", _wrap_Frame_frameStyle, 1 },
	 { "new_Frame", _wrap_new_Frame, 1 },
	 { "LineEdit_deselect", _wrap_LineEdit_deselect, 1 },
	 { "LineEdit_selectAll", _wrap_LineEdit_selectAll, 1 },
	 { "LineEdit_setText", _wrap_LineEdit_setText, 1 },
	 { "LineEdit_echoMode", _wrap_LineEdit_echoMode, 1 },
	 { "LineEdit_setEchoMode", _wrap_LineEdit_setEchoMode, 1 },
	 { "LineEdit_frame", _wrap_LineEdit_frame, 1 },
	 { "LineEdit_setFrame", _wrap_LineEdit_setFrame, 1 },
	 { "LineEdit_setMaxLength", _wrap_LineEdit_setMaxLength, 1 },
	 { "LineEdit_maxLength", _wrap_LineEdit_maxLength, 1 },
	 { "LineEdit_text", _wrap_LineEdit_text, 1 },
	 { "delete_LineEdit", _wrap_delete_LineEdit, 1 },
	 { "new_LineEdit", _wrap_new_LineEdit, 1 },
	 { "TabDialog_defaultButtonPressed", _wrap_TabDialog_defaultButtonPressed, 1 },
	 { "TabDialog_cancelButtonPressed", _wrap_TabDialog_cancelButtonPressed, 1 },
	 { "TabDialog_applyButtonPressed", _wrap_TabDialog_applyButtonPressed, 1 },
	 { "TabDialog_aboutToShow", _wrap_TabDialog_aboutToShow, 1 },
	 { "TabDialog_setOKButton", _wrap_TabDialog_setOKButton, 1 },
	 { "TabDialog_hasApplyButton", _wrap_TabDialog_hasApplyButton, 1 },
	 { "TabDialog_setApplyButton", _wrap_TabDialog_setApplyButton, 1 },
	 { "TabDialog_hasCancelButton", _wrap_TabDialog_hasCancelButton, 1 },
	 { "TabDialog_setCancelButton", _wrap_TabDialog_setCancelButton, 1 },
	 { "TabDialog_hasDefaultButton", _wrap_TabDialog_hasDefaultButton, 1 },
	 { "TabDialog_setDefaultButton", _wrap_TabDialog_setDefaultButton, 1 },
	 { "TabDialog_isTabEnabled", _wrap_TabDialog_isTabEnabled, 1 },
	 { "TabDialog_addTab", _wrap_TabDialog_addTab, 1 },
	 { "TabDialog_setFont", _wrap_TabDialog_setFont, 1 },
	 { "TabDialog_show", _wrap_TabDialog_show, 1 },
	 { "delete_TabDialog", _wrap_delete_TabDialog, 1 },
	 { "new_TabDialog", _wrap_new_TabDialog, 1 },
	 { "Dialog_setGeometryRect", _wrap_Dialog_setGeometryRect, 1 },
	 { "Dialog_setGeometry", _wrap_Dialog_setGeometry, 1 },
	 { "Dialog_resizeSize", _wrap_Dialog_resizeSize, 1 },
	 { "Dialog_resize", _wrap_Dialog_resize, 1 },
	 { "Dialog_movePoint", _wrap_Dialog_movePoint, 1 },
	 { "Dialog_move", _wrap_Dialog_move, 1 },
	 { "Dialog_show", _wrap_Dialog_show, 1 },
	 { "Dialog_result", _wrap_Dialog_result, 1 },
	 { "Dialog_execDialog", _wrap_Dialog_execDialog, 1 },
	 { "delete_Dialog", _wrap_delete_Dialog, 1 },
	 { "new_Dialog", _wrap_new_Dialog, 1 },
	 { "ComboBox_insertionPolicy", _wrap_ComboBox_insertionPolicy, 1 },
	 { "ComboBox_setInsertionPolicy", _wrap_ComboBox_setInsertionPolicy, 1 },
	 { "ComboBox_maxCount", _wrap_ComboBox_maxCount, 1 },
	 { "ComboBox_setMaxCount", _wrap_ComboBox_setMaxCount, 1 },
	 { "ComboBox_sizeLimit", _wrap_ComboBox_sizeLimit, 1 },
	 { "ComboBox_setSizeLimit", _wrap_ComboBox_setSizeLimit, 1 },
	 { "ComboBox_setEnabled", _wrap_ComboBox_setEnabled, 1 },
	 { "ComboBox_setFont", _wrap_ComboBox_setFont, 1 },
	 { "ComboBox_setPalette", _wrap_ComboBox_setPalette, 1 },
	 { "ComboBox_setBackgroundColor", _wrap_ComboBox_setBackgroundColor, 1 },
	 { "ComboBox_sizeHint", _wrap_ComboBox_sizeHint, 1 },
	 { "ComboBox_setAutoResize", _wrap_ComboBox_setAutoResize, 1 },
	 { "ComboBox_autoResize", _wrap_ComboBox_autoResize, 1 },
	 { "ComboBox_setCurrentItem", _wrap_ComboBox_setCurrentItem, 1 },
	 { "ComboBox_currentItem", _wrap_ComboBox_currentItem, 1 },
	 { "ComboBox_changePixmap", _wrap_ComboBox_changePixmap, 1 },
	 { "ComboBox_changeText", _wrap_ComboBox_changeText, 1 },
	 { "ComboBox_pixmap", _wrap_ComboBox_pixmap, 1 },
	 { "ComboBox_text", _wrap_ComboBox_text, 1 },
	 { "ComboBox_currentText", _wrap_ComboBox_currentText, 1 },
	 { "ComboBox_clear", _wrap_ComboBox_clear, 1 },
	 { "ComboBox_removeItem", _wrap_ComboBox_removeItem, 1 },
	 { "ComboBox_insertPixmap", _wrap_ComboBox_insertPixmap, 1 },
	 { "ComboBox_insertText", _wrap_ComboBox_insertText, 1 },
	 { "ComboBox_insertList", _wrap_ComboBox_insertList, 1 },
	 { "ComboBox_count", _wrap_ComboBox_count, 1 },
	 { "delete_ComboBox", _wrap_delete_ComboBox, 1 },
	 { "new_ComboBoxOld", _wrap_new_ComboBoxOld, 1 },
	 { "new_ComboBox", _wrap_new_ComboBox, 1 },
	 { "RadioButton_sizeHint", _wrap_RadioButton_sizeHint, 1 },
	 { "RadioButton_setChecked", _wrap_RadioButton_setChecked, 1 },
	 { "RadioButton_isChecked", _wrap_RadioButton_isChecked, 1 },
	 { "new_RadioButtonN", _wrap_new_RadioButtonN, 1 },
	 { "new_RadioButton", _wrap_new_RadioButton, 1 },
	 { "PushButton_toggle", _wrap_PushButton_toggle, 1 },
	 { "PushButton_setOn", _wrap_PushButton_setOn, 1 },
	 { "PushButton_setGeometryRect", _wrap_PushButton_setGeometryRect, 1 },
	 { "PushButton_setGeometry", _wrap_PushButton_setGeometry, 1 },
	 { "PushButton_resizeSize", _wrap_PushButton_resizeSize, 1 },
	 { "PushButton_resize", _wrap_PushButton_resize, 1 },
	 { "PushButton_movePoint", _wrap_PushButton_movePoint, 1 },
	 { "PushButton_move", _wrap_PushButton_move, 1 },
	 { "PushButton_sizeHint", _wrap_PushButton_sizeHint, 1 },
	 { "PushButton_setDefault", _wrap_PushButton_setDefault, 1 },
	 { "PushButton_isDefault", _wrap_PushButton_isDefault, 1 },
	 { "PushButton_setAutoDefault", _wrap_PushButton_setAutoDefault, 1 },
	 { "PushButton_autoDefault", _wrap_PushButton_autoDefault, 1 },
	 { "PushButton_setToggleButton", _wrap_PushButton_setToggleButton, 1 },
	 { "new_PushButton", _wrap_new_PushButton, 1 },
	 { "new_PushButtonN", _wrap_new_PushButtonN, 1 },
	 { "CheckBox_sizeHint", _wrap_CheckBox_sizeHint, 1 },
	 { "CheckBox_setChecked", _wrap_CheckBox_setChecked, 1 },
	 { "CheckBox_isChecked", _wrap_CheckBox_isChecked, 1 },
	 { "new_CheckBoxN", _wrap_new_CheckBoxN, 1 },
	 { "new_CheckBox", _wrap_new_CheckBox, 1 },
	 { "Button_toggled", _wrap_Button_toggled, 1 },
	 { "Button_clicked", _wrap_Button_clicked, 1 },
	 { "Button_released", _wrap_Button_released, 1 },
	 { "Button_pressed", _wrap_Button_pressed, 1 },
	 { "Button_autoRepeat", _wrap_Button_autoRepeat, 1 },
	 { "Button_setAutoRepeat", _wrap_Button_setAutoRepeat, 1 },
	 { "Button_setAutoResize", _wrap_Button_setAutoResize, 1 },
	 { "Button_autoResize", _wrap_Button_autoResize, 1 },
	 { "Button_isOn", _wrap_Button_isOn, 1 },
	 { "Button_isDown", _wrap_Button_isDown, 1 },
	 { "Button_isToggleButton", _wrap_Button_isToggleButton, 1 },
	 { "Button_setPixmap", _wrap_Button_setPixmap, 1 },
	 { "Button_pixmap", _wrap_Button_pixmap, 1 },
	 { "Button_setText", _wrap_Button_setText, 1 },
	 { "Button_text", _wrap_Button_text, 1 },
	 { "delete_Button", _wrap_delete_Button, 1 },
	 { "new_Button", _wrap_new_Button, 1 },
	 { "Widget_addSeparator", _wrap_Widget_addSeparator, 1 },
	 { "Widget_addPopupMenu", _wrap_Widget_addPopupMenu, 1 },
	 { "Widget_parentWidget", _wrap_Widget_parentWidget, 1 },
	 { "Widget_drawTextPoint", _wrap_Widget_drawTextPoint, 1 },
	 { "Widget_drawText", _wrap_Widget_drawText, 1 },
	 { "Widget_scroll", _wrap_Widget_scroll, 1 },
	 { "Widget_eraseRect", _wrap_Widget_eraseRect, 1 },
	 { "Widget_eraseRection", _wrap_Widget_eraseRection, 1 },
	 { "Widget_erase", _wrap_Widget_erase, 1 },
	 { "Widget_recreate", _wrap_Widget_recreate, 1 },
	 { "Widget_adjustSize", _wrap_Widget_adjustSize, 1 },
	 { "Widget_sizeHint", _wrap_Widget_sizeHint, 1 },
	 { "Widget_setGeometryRect", _wrap_Widget_setGeometryRect, 1 },
	 { "Widget_setGeometry", _wrap_Widget_setGeometry, 1 },
	 { "Widget_resizeSize", _wrap_Widget_resizeSize, 1 },
	 { "Widget_resize", _wrap_Widget_resize, 1 },
	 { "Widget_movePoint", _wrap_Widget_movePoint, 1 },
	 { "Widget_move", _wrap_Widget_move, 1 },
	 { "Widget_lowerWidget", _wrap_Widget_lowerWidget, 1 },
	 { "Widget_raiseWidget", _wrap_Widget_raiseWidget, 1 },
	 { "Widget_isVisible", _wrap_Widget_isVisible, 1 },
	 { "Widget_close", _wrap_Widget_close, 1 },
	 { "Widget_iconify", _wrap_Widget_iconify, 1 },
	 { "Widget_hide", _wrap_Widget_hide, 1 },
	 { "Widget_show", _wrap_Widget_show, 1 },
	 { "Widget_repaintRect", _wrap_Widget_repaintRect, 1 },
	 { "Widget_repaintRegion", _wrap_Widget_repaintRegion, 1 },
	 { "Widget_repaint", _wrap_Widget_repaint, 1 },
	 { "Widget_updateRegion", _wrap_Widget_updateRegion, 1 },
	 { "Widget_update", _wrap_Widget_update, 1 },
	 { "Widget_setUpdatesEnabled", _wrap_Widget_setUpdatesEnabled, 1 },
	 { "Widget_isUpdatesEnabled", _wrap_Widget_isUpdatesEnabled, 1 },
	 { "Widget_releaseKeyboard", _wrap_Widget_releaseKeyboard, 1 },
	 { "Widget_grabKeyboard", _wrap_Widget_grabKeyboard, 1 },
	 { "Widget_releaseMouse", _wrap_Widget_releaseMouse, 1 },
	 { "Widget_grabMouseCursor", _wrap_Widget_grabMouseCursor, 1 },
	 { "Widget_grabMouse", _wrap_Widget_grabMouse, 1 },
	 { "Widget_clearFocus", _wrap_Widget_clearFocus, 1 },
	 { "Widget_setFocus", _wrap_Widget_setFocus, 1 },
	 { "Widget_hasFocus", _wrap_Widget_hasFocus, 1 },
	 { "Widget_setFocusPolicy", _wrap_Widget_setFocusPolicy, 1 },
	 { "Widget_focusPolicy", _wrap_Widget_focusPolicy, 1 },
	 { "Widget_isFocusEnabled", _wrap_Widget_isFocusEnabled, 1 },
	 { "Widget_setActiveWindow", _wrap_Widget_setActiveWindow, 1 },
	 { "Widget_isActiveWindow", _wrap_Widget_isActiveWindow, 1 },
	 { "Widget_setMouseTracking", _wrap_Widget_setMouseTracking, 1 },
	 { "Widget_hasMouseTracking", _wrap_Widget_hasMouseTracking, 1 },
	 { "Widget_setIconText", _wrap_Widget_setIconText, 1 },
	 { "Widget_iconText", _wrap_Widget_iconText, 1 },
	 { "Widget_setIcon", _wrap_Widget_setIcon, 1 },
	 { "Widget_icon", _wrap_Widget_icon, 1 },
	 { "Widget_setCaption", _wrap_Widget_setCaption, 1 },
	 { "Widget_caption", _wrap_Widget_caption, 1 },
	 { "Widget_setCursor", _wrap_Widget_setCursor, 1 },
	 { "Widget_cursor", _wrap_Widget_cursor, 1 },
	 { "Widget_fontInfo", _wrap_Widget_fontInfo, 1 },
	 { "Widget_fontMetrics", _wrap_Widget_fontMetrics, 1 },
	 { "Widget_setFont", _wrap_Widget_setFont, 1 },
	 { "Widget_font", _wrap_Widget_font, 1 },
	 { "Widget_setPalette", _wrap_Widget_setPalette, 1 },
	 { "Widget_palette", _wrap_Widget_palette, 1 },
	 { "Widget_colorGroup", _wrap_Widget_colorGroup, 1 },
	 { "Widget_setBackgroundPixmap", _wrap_Widget_setBackgroundPixmap, 1 },
	 { "Widget_backgroundPixmap", _wrap_Widget_backgroundPixmap, 1 },
	 { "Widget_setBackgroundColor", _wrap_Widget_setBackgroundColor, 1 },
	 { "Widget_foregroundColor", _wrap_Widget_foregroundColor, 1 },
	 { "Widget_backgroundColor", _wrap_Widget_backgroundColor, 1 },
	 { "Widget_topLevelWidget", _wrap_Widget_topLevelWidget, 1 },
	 { "Widget_mapFromParent", _wrap_Widget_mapFromParent, 1 },
	 { "Widget_mapToParent", _wrap_Widget_mapToParent, 1 },
	 { "Widget_mapFromGlobal", _wrap_Widget_mapFromGlobal, 1 },
	 { "Widget_mapToGlobal", _wrap_Widget_mapToGlobal, 1 },
	 { "Widget_setFixedSize", _wrap_Widget_setFixedSize, 1 },
	 { "Widget_setFixedQSize", _wrap_Widget_setFixedQSize, 1 },
	 { "Widget_setSizeIncrement", _wrap_Widget_setSizeIncrement, 1 },
	 { "Widget_setQSizeIncrement", _wrap_Widget_setQSizeIncrement, 1 },
	 { "Widget_sizeIncrement", _wrap_Widget_sizeIncrement, 1 },
	 { "Widget_setMaximumSize", _wrap_Widget_setMaximumSize, 1 },
	 { "Widget_setMaximumQSize", _wrap_Widget_setMaximumQSize, 1 },
	 { "Widget_setMinimumSize", _wrap_Widget_setMinimumSize, 1 },
	 { "Widget_setMinimumQSize", _wrap_Widget_setMinimumQSize, 1 },
	 { "Widget_maximumSize", _wrap_Widget_maximumSize, 1 },
	 { "Widget_minimumSize", _wrap_Widget_minimumSize, 1 },
	 { "Widget_childrenRect", _wrap_Widget_childrenRect, 1 },
	 { "Widget_rect", _wrap_Widget_rect, 1 },
	 { "Widget_height", _wrap_Widget_height, 1 },
	 { "Widget_width", _wrap_Widget_width, 1 },
	 { "Widget_size", _wrap_Widget_size, 1 },
	 { "Widget_pos", _wrap_Widget_pos, 1 },
	 { "Widget_y", _wrap_Widget_y, 1 },
	 { "Widget_x", _wrap_Widget_x, 1 },
	 { "Widget_geometry", _wrap_Widget_geometry, 1 },
	 { "Widget_frameGeometry", _wrap_Widget_frameGeometry, 1 },
	 { "Widget_setEnabled", _wrap_Widget_setEnabled, 1 },
	 { "Widget_isEnabled", _wrap_Widget_isEnabled, 1 },
	 { "Widget_isDesktop", _wrap_Widget_isDesktop, 1 },
	 { "Widget_isPopup", _wrap_Widget_isPopup, 1 },
	 { "Widget_isModal", _wrap_Widget_isModal, 1 },
	 { "Widget_isTopLevel", _wrap_Widget_isTopLevel, 1 },
	 { "delete_Widget", _wrap_delete_Widget, 1 },
	 { "new_Widget", _wrap_new_Widget, 1 },
	 { "GridLayout_setColStretch", _wrap_GridLayout_setColStretch, 1 },
	 { "GridLayout_setRowStretch", _wrap_GridLayout_setRowStretch, 1 },
	 { "GridLayout_addLayout", _wrap_GridLayout_addLayout, 1 },
	 { "GridLayout_addMultiCellWidget", _wrap_GridLayout_addMultiCellWidget, 1 },
	 { "GridLayout_addWidget", _wrap_GridLayout_addWidget, 1 },
	 { "delete_GridLayout", _wrap_delete_GridLayout, 1 },
	 { "new_GridSubLayout", _wrap_new_GridSubLayout, 1 },
	 { "new_GridLayout", _wrap_new_GridLayout, 1 },
	 { "BoxLayout_addStrut", _wrap_BoxLayout_addStrut, 1 },
	 { "BoxLayout_direction", _wrap_BoxLayout_direction, 1 },
	 { "BoxLayout_addLayout", _wrap_BoxLayout_addLayout, 1 },
	 { "BoxLayout_addStretch", _wrap_BoxLayout_addStretch, 1 },
	 { "BoxLayout_addSpacing", _wrap_BoxLayout_addSpacing, 1 },
	 { "BoxLayout_addWidget", _wrap_BoxLayout_addWidget, 1 },
	 { "delete_BoxLayout", _wrap_delete_BoxLayout, 1 },
	 { "new_BoxSubLayout", _wrap_new_BoxSubLayout, 1 },
	 { "new_BoxLayout", _wrap_new_BoxLayout, 1 },
	 { "Layout_mainWidget", _wrap_Layout_mainWidget, 1 },
	 { "Layout_freeze", _wrap_Layout_freeze, 1 },
	 { "Layout_activate", _wrap_Layout_activate, 1 },
	 { "Layout_defaultBorder", _wrap_Layout_defaultBorder, 1 },
	 { "delete_Layout", _wrap_delete_Layout, 1 },
	 { "Application_lastWindowClosed", _wrap_Application_lastWindowClosed, 1 },
	 { "Application_quit", _wrap_Application_quit, 1 },
	 { "Application_exit_loop", _wrap_Application_exit_loop, 1 },
	 { "Application_enter_loop", _wrap_Application_enter_loop, 1 },
	 { "Application_processEvents", _wrap_Application_processEvents, 1 },
	 { "Application_execLoop", _wrap_Application_execLoop, 1 },
	 { "Application_focusWidget", _wrap_Application_focusWidget, 1 },
	 { "Application_setMainWidget", _wrap_Application_setMainWidget, 1 },
	 { "Application_mainWidget", _wrap_Application_mainWidget, 1 },
	 { "Application_argv", _wrap_Application_argv, 1 },
	 { "Application_argc", _wrap_Application_argc, 1 },
	 { "delete_Application", _wrap_delete_Application, 1 },
	 { "new_Application", _wrap_new_Application, 1 },
	 { "Object_killTimer", _wrap_Object_killTimer, 1 },
	 { "Object_timerConnection", _wrap_Object_timerConnection, 1 },
	 { "Object_emit", _wrap_Object_emit, 1 },
	 { "Object_disconnect", _wrap_Object_disconnect, 1 },
	 { "Object_connect", _wrap_Object_connect, 1 },
	 { "new_Object", _wrap_new_Object, 1 },
	 { "QSize_setHeight", _wrap_QSize_setHeight, 1 },
	 { "QSize_setWidth", _wrap_QSize_setWidth, 1 },
	 { "QSize_height", _wrap_QSize_height, 1 },
	 { "QSize_width", _wrap_QSize_width, 1 },
	 { "QSize_isValid", _wrap_QSize_isValid, 1 },
	 { "QSize_isEmpty", _wrap_QSize_isEmpty, 1 },
	 { "QSize_isNull", _wrap_QSize_isNull, 1 },
	 { "new_QSizeV", _wrap_new_QSizeV, 1 },
	 { "new_QSize", _wrap_new_QSize, 1 },
	 { "QRect_intersects", _wrap_QRect_intersects, 1 },
	 { "QRect_intersect", _wrap_QRect_intersect, 1 },
	 { "QRect_unite", _wrap_QRect_unite, 1 },
	 { "QRect_containsRect", _wrap_QRect_containsRect, 1 },
	 { "QRect_containsPoint", _wrap_QRect_containsPoint, 1 },
	 { "QRect_setSize", _wrap_QRect_setSize, 1 },
	 { "QRect_setHeight", _wrap_QRect_setHeight, 1 },
	 { "QRect_setWidth", _wrap_QRect_setWidth, 1 },
	 { "QRect_height", _wrap_QRect_height, 1 },
	 { "QRect_width", _wrap_QRect_width, 1 },
	 { "QRect_size", _wrap_QRect_size, 1 },
	 { "QRect_setCoords", _wrap_QRect_setCoords, 1 },
	 { "QRect_setRect", _wrap_QRect_setRect, 1 },
	 { "QRect_moveBy", _wrap_QRect_moveBy, 1 },
	 { "QRect_moveCenter", _wrap_QRect_moveCenter, 1 },
	 { "QRect_moveBottomLeft", _wrap_QRect_moveBottomLeft, 1 },
	 { "QRect_moveTopRight", _wrap_QRect_moveTopRight, 1 },
	 { "QRect_moveBottomRight", _wrap_QRect_moveBottomRight, 1 },
	 { "QRect_moveTopLeft", _wrap_QRect_moveTopLeft, 1 },
	 { "QRect_coords", _wrap_QRect_coords, 1 },
	 { "QRect_rect", _wrap_QRect_rect, 1 },
	 { "QRect_center", _wrap_QRect_center, 1 },
	 { "QRect_bottomLeft", _wrap_QRect_bottomLeft, 1 },
	 { "QRect_topRight", _wrap_QRect_topRight, 1 },
	 { "QRect_bottomRight", _wrap_QRect_bottomRight, 1 },
	 { "QRect_topLeft", _wrap_QRect_topLeft, 1 },
	 { "QRect_setY", _wrap_QRect_setY, 1 },
	 { "QRect_setX", _wrap_QRect_setX, 1 },
	 { "QRect_setBottom", _wrap_QRect_setBottom, 1 },
	 { "QRect_setRight", _wrap_QRect_setRight, 1 },
	 { "QRect_setTop", _wrap_QRect_setTop, 1 },
	 { "QRect_setLeft", _wrap_QRect_setLeft, 1 },
	 { "QRect_y", _wrap_QRect_y, 1 },
	 { "QRect_x", _wrap_QRect_x, 1 },
	 { "QRect_bottom", _wrap_QRect_bottom, 1 },
	 { "QRect_right", _wrap_QRect_right, 1 },
	 { "QRect_top", _wrap_QRect_top, 1 },
	 { "QRect_left", _wrap_QRect_left, 1 },
	 { "QRect_normalize", _wrap_QRect_normalize, 1 },
	 { "QRect_isValid", _wrap_QRect_isValid, 1 },
	 { "QRect_isEmpty", _wrap_QRect_isEmpty, 1 },
	 { "QRect_isNull", _wrap_QRect_isNull, 1 },
	 { "new_QRectLTWH", _wrap_new_QRectLTWH, 1 },
	 { "new_QRectPointSize", _wrap_new_QRectPointSize, 1 },
	 { "new_QRectPoints", _wrap_new_QRectPoints, 1 },
	 { "new_QRect", _wrap_new_QRect, 1 },
	 { "QPoint_setY", _wrap_QPoint_setY, 1 },
	 { "QPoint_setX", _wrap_QPoint_setX, 1 },
	 { "QPoint_y", _wrap_QPoint_y, 1 },
	 { "QPoint_x", _wrap_QPoint_x, 1 },
	 { "QPoint_isNull", _wrap_QPoint_isNull, 1 },
	 { "new_QPointV", _wrap_new_QPointV, 1 },
	 { "new_QPoint", _wrap_new_QPoint, 1 },
	 { "new_QBitmapLoad", _wrap_new_QBitmapLoad, 1 },
	 { "new_QBitmapCopy", _wrap_new_QBitmapCopy, 1 },
	 { "new_QBitmapSizeData", _wrap_new_QBitmapSizeData, 1 },
	 { "new_QBitmapSize", _wrap_new_QBitmapSize, 1 },
	 { "new_QBitmap", _wrap_new_QBitmap, 1 },
	 { "QPixmap_optimizeGlobally", _wrap_QPixmap_optimizeGlobally, 1 },
	 { "QPixmap_isGloballyOptimized", _wrap_QPixmap_isGloballyOptimized, 1 },
	 { "QPixmap_imageFormat", _wrap_QPixmap_imageFormat, 1 },
	 { "QPixmap_defaultDepth", _wrap_QPixmap_defaultDepth, 1 },
	 { "QPixmap_isQBitmap", _wrap_QPixmap_isQBitmap, 1 },
	 { "QPixmap_detach", _wrap_QPixmap_detach, 1 },
	 { "QPixmap_optimize", _wrap_QPixmap_optimize, 1 },
	 { "QPixmap_isOptimized", _wrap_QPixmap_isOptimized, 1 },
	 { "QPixmap_serialNumber", _wrap_QPixmap_serialNumber, 1 },
	 { "QPixmap_save", _wrap_QPixmap_save, 1 },
	 { "QPixmap_loadFromData", _wrap_QPixmap_loadFromData, 1 },
	 { "QPixmap_load", _wrap_QPixmap_load, 1 },
	 { "QPixmap_createHeuristicMask", _wrap_QPixmap_createHeuristicMask, 1 },
	 { "QPixmap_selfMask", _wrap_QPixmap_selfMask, 1 },
	 { "QPixmap_setMask", _wrap_QPixmap_setMask, 1 },
	 { "QPixmap_mask", _wrap_QPixmap_mask, 1 },
	 { "QPixmap_resize", _wrap_QPixmap_resize, 1 },
	 { "QPixmap_depth", _wrap_QPixmap_depth, 1 },
	 { "QPixmap_height", _wrap_QPixmap_height, 1 },
	 { "QPixmap_width", _wrap_QPixmap_width, 1 },
	 { "QPixmap_isNull", _wrap_QPixmap_isNull, 1 },
	 { "delete_QPixmap", _wrap_delete_QPixmap, 1 },
	 { "new_PixmapCopy", _wrap_new_PixmapCopy, 1 },
	 { "new_PixmapFile", _wrap_new_PixmapFile, 1 },
	 { "new_QPixmapSize", _wrap_new_QPixmapSize, 1 },
	 { "new_QPixmap", _wrap_new_QPixmap, 1 },
	 { "QPaintDevice_paintingActive", _wrap_QPaintDevice_paintingActive, 1 },
	 { "QPaintDevice_isExtDev", _wrap_QPaintDevice_isExtDev, 1 },
	 { "QPaintDevice_devType", _wrap_QPaintDevice_devType, 1 },
	 { "delete_QPaintDevice", _wrap_delete_QPaintDevice, 1 },
	 { "QFontMetrics_lineWidth", _wrap_QFontMetrics_lineWidth, 1 },
	 { "QFontMetrics_strikeOutPos", _wrap_QFontMetrics_strikeOutPos, 1 },
	 { "QFontMetrics_underlinePos", _wrap_QFontMetrics_underlinePos, 1 },
	 { "QFontMetrics_maxWidth", _wrap_QFontMetrics_maxWidth, 1 },
	 { "QFontMetrics_charWidth", _wrap_QFontMetrics_charWidth, 1 },
	 { "QFontMetrics_width", _wrap_QFontMetrics_width, 1 },
	 { "QFontMetrics_lineSpacing", _wrap_QFontMetrics_lineSpacing, 1 },
	 { "QFontMetrics_leading", _wrap_QFontMetrics_leading, 1 },
	 { "QFontMetrics_height", _wrap_QFontMetrics_height, 1 },
	 { "QFontMetrics_descent", _wrap_QFontMetrics_descent, 1 },
	 { "QFontMetrics_ascent", _wrap_QFontMetrics_ascent, 1 },
	 { "delete_QFontMetrics", _wrap_delete_QFontMetrics, 1 },
	 { "new_QFontMetricsCopy", _wrap_new_QFontMetricsCopy, 1 },
	 { "new_QFontMetrics", _wrap_new_QFontMetrics, 1 },
	 { "QFontInfo_exactMatch", _wrap_QFontInfo_exactMatch, 1 },
	 { "QFontInfo_rawMode", _wrap_QFontInfo_rawMode, 1 },
	 { "QFontInfo_charSet", _wrap_QFontInfo_charSet, 1 },
	 { "QFontInfo_styleHint", _wrap_QFontInfo_styleHint, 1 },
	 { "QFontInfo_fixedPitch", _wrap_QFontInfo_fixedPitch, 1 },
	 { "QFontInfo_strikeOut", _wrap_QFontInfo_strikeOut, 1 },
	 { "QFontInfo_underline", _wrap_QFontInfo_underline, 1 },
	 { "QFontInfo_bold", _wrap_QFontInfo_bold, 1 },
	 { "QFontInfo_weight", _wrap_QFontInfo_weight, 1 },
	 { "QFontInfo_italic", _wrap_QFontInfo_italic, 1 },
	 { "QFontInfo_pointSize", _wrap_QFontInfo_pointSize, 1 },
	 { "QFontInfo_family", _wrap_QFontInfo_family, 1 },
	 { "delete_QFontInfo", _wrap_delete_QFontInfo, 1 },
	 { "new_QFontInfoCopy", _wrap_new_QFontInfoCopy, 1 },
	 { "new_QFontInfo", _wrap_new_QFontInfo, 1 },
	 { "QFont_removeSubstitution", _wrap_QFont_removeSubstitution, 1 },
	 { "QFont_insertSubstitution", _wrap_QFont_insertSubstitution, 1 },
	 { "QFont_substitute", _wrap_QFont_substitute, 1 },
	 { "QFont_setDefaultFont", _wrap_QFont_setDefaultFont, 1 },
	 { "QFont_defaultFont", _wrap_QFont_defaultFont, 1 },
	 { "QFont_exactMatch", _wrap_QFont_exactMatch, 1 },
	 { "QFont_setRawMode", _wrap_QFont_setRawMode, 1 },
	 { "QFont_rawMode", _wrap_QFont_rawMode, 1 },
	 { "QFont_setCharSet", _wrap_QFont_setCharSet, 1 },
	 { "QFont_charSet", _wrap_QFont_charSet, 1 },
	 { "QFont_setStyleHint", _wrap_QFont_setStyleHint, 1 },
	 { "QFont_styleHint", _wrap_QFont_styleHint, 1 },
	 { "QFont_setFixedPitch", _wrap_QFont_setFixedPitch, 1 },
	 { "QFont_fixedPitch", _wrap_QFont_fixedPitch, 1 },
	 { "QFont_setStrikeOut", _wrap_QFont_setStrikeOut, 1 },
	 { "QFont_strikeOut", _wrap_QFont_strikeOut, 1 },
	 { "QFont_setUnderline", _wrap_QFont_setUnderline, 1 },
	 { "QFont_underline", _wrap_QFont_underline, 1 },
	 { "QFont_setItalic", _wrap_QFont_setItalic, 1 },
	 { "QFont_italic", _wrap_QFont_italic, 1 },
	 { "QFont_setBold", _wrap_QFont_setBold, 1 },
	 { "QFont_bold", _wrap_QFont_bold, 1 },
	 { "QFont_setWeight", _wrap_QFont_setWeight, 1 },
	 { "QFont_weight", _wrap_QFont_weight, 1 },
	 { "QFont_setPointSize", _wrap_QFont_setPointSize, 1 },
	 { "QFont_pointSize", _wrap_QFont_pointSize, 1 },
	 { "QFont_setFamily", _wrap_QFont_setFamily, 1 },
	 { "QFont_family", _wrap_QFont_family, 1 },
	 { "new_QFontCopy", _wrap_new_QFontCopy, 1 },
	 { "new_QFontV", _wrap_new_QFontV, 1 },
	 { "new_QFont", _wrap_new_QFont, 1 },
	 { "QCursor_setPos", _wrap_QCursor_setPos, 1 },
	 { "QCursor_setShape", _wrap_QCursor_setShape, 1 },
	 { "QCursor_shape", _wrap_QCursor_shape, 1 },
	 { "delete_QCursor", _wrap_delete_QCursor, 1 },
	 { "new_QCursorShape", _wrap_new_QCursorShape, 1 },
	 { "new_QCursor", _wrap_new_QCursor, 1 },
	 { "QPalette_serialNumber", _wrap_QPalette_serialNumber, 1 },
	 { "QPalette_setActive", _wrap_QPalette_setActive, 1 },
	 { "QPalette_setDisabled", _wrap_QPalette_setDisabled, 1 },
	 { "QPalette_setNormal", _wrap_QPalette_setNormal, 1 },
	 { "QPalette_active", _wrap_QPalette_active, 1 },
	 { "QPalette_disabled", _wrap_QPalette_disabled, 1 },
	 { "QPalette_normal", _wrap_QPalette_normal, 1 },
	 { "QPalette_copy", _wrap_QPalette_copy, 1 },
	 { "delete_QPalette", _wrap_delete_QPalette, 1 },
	 { "new_QPaletteCopy", _wrap_new_QPaletteCopy, 1 },
	 { "new_QPaletteCG", _wrap_new_QPaletteCG, 1 },
	 { "new_QPaletteColor", _wrap_new_QPaletteColor, 1 },
	 { "new_QPalette", _wrap_new_QPalette, 1 },
	 { "QColorGroup_base", _wrap_QColorGroup_base, 1 },
	 { "QColorGroup_text", _wrap_QColorGroup_text, 1 },
	 { "QColorGroup_mid", _wrap_QColorGroup_mid, 1 },
	 { "QColorGroup_dark", _wrap_QColorGroup_dark, 1 },
	 { "QColorGroup_light", _wrap_QColorGroup_light, 1 },
	 { "QColorGroup_background", _wrap_QColorGroup_background, 1 },
	 { "QColorGroup_foreground", _wrap_QColorGroup_foreground, 1 },
	 { "new_QColorGroupV", _wrap_new_QColorGroupV, 1 },
	 { "new_QColorGroup", _wrap_new_QColorGroup, 1 },
	 { "QColor_destroyAllocContext", _wrap_QColor_destroyAllocContext, 1 },
	 { "QColor_currentAllocContext", _wrap_QColor_currentAllocContext, 1 },
	 { "QColor_leaveAllocContext", _wrap_QColor_leaveAllocContext, 1 },
	 { "QColor_enterAllocContext", _wrap_QColor_enterAllocContext, 1 },
	 { "QColor_numBitPlanes", _wrap_QColor_numBitPlanes, 1 },
	 { "QColor_maxColors", _wrap_QColor_maxColors, 1 },
	 { "QColor_setLazyAlloc", _wrap_QColor_setLazyAlloc, 1 },
	 { "QColor_lazyAlloc", _wrap_QColor_lazyAlloc, 1 },
	 { "QColor_pixel", _wrap_QColor_pixel, 1 },
	 { "QColor_alloc", _wrap_QColor_alloc, 1 },
	 { "QColor_dark", _wrap_QColor_dark, 1 },
	 { "QColor_light", _wrap_QColor_light, 1 },
	 { "QColor_setHsv", _wrap_QColor_setHsv, 1 },
	 { "QColor_hsv", _wrap_QColor_hsv, 1 },
	 { "QColor_blue", _wrap_QColor_blue, 1 },
	 { "QColor_green", _wrap_QColor_green, 1 },
	 { "QColor_red", _wrap_QColor_red, 1 },
	 { "QColor_setRgb", _wrap_QColor_setRgb, 1 },
	 { "QColor_rgb", _wrap_QColor_rgb, 1 },
	 { "QColor_setNamedColor", _wrap_QColor_setNamedColor, 1 },
	 { "QColor_isDirty", _wrap_QColor_isDirty, 1 },
	 { "QColor_isValid", _wrap_QColor_isValid, 1 },
	 { "new_QColorCopy", _wrap_new_QColorCopy, 1 },
	 { "new_QColorName", _wrap_new_QColorName, 1 },
	 { "new_QColorRGB", _wrap_new_QColorRGB, 1 },
	 { "new_QColor", _wrap_new_QColor, 1 },
	 { "ModalFileDialog", _wrap_ModalFileDialog, 1 },
	 { "bitBlt", _wrap_bitBlt, 1 },
	 { NULL, NULL }
};
static PyObject *SWIG_globals;
#ifdef __cplusplus
extern "C" 
#endif
EXPORT(void,initpythonqtc)() {
	 PyObject *m, *d;
	 SWIG_globals = SWIG_newvarlink();
	 m = Py_InitModule("pythonqtc", pythonqtcMethods);
	 d = PyModule_GetDict(m);
	 _wrap_python_const_ArrowCursor = PyInt_FromLong(ArrowCursor);
	 PyDict_SetItemString(d,"ArrowCursor", _wrap_python_const_ArrowCursor);
	 _wrap_python_const_UpArrowCursor = PyInt_FromLong(UpArrowCursor);
	 PyDict_SetItemString(d,"UpArrowCursor", _wrap_python_const_UpArrowCursor);
	 _wrap_python_const_CrossCursor = PyInt_FromLong(CrossCursor);
	 PyDict_SetItemString(d,"CrossCursor", _wrap_python_const_CrossCursor);
	 _wrap_python_const_WaitCursor = PyInt_FromLong(WaitCursor);
	 PyDict_SetItemString(d,"WaitCursor", _wrap_python_const_WaitCursor);
	 _wrap_python_const_IbeamCursor = PyInt_FromLong(IbeamCursor);
	 PyDict_SetItemString(d,"IbeamCursor", _wrap_python_const_IbeamCursor);
	 _wrap_python_const_SizeVerCursor = PyInt_FromLong(SizeVerCursor);
	 PyDict_SetItemString(d,"SizeVerCursor", _wrap_python_const_SizeVerCursor);
	 _wrap_python_const_SizeHorCursor = PyInt_FromLong(SizeHorCursor);
	 PyDict_SetItemString(d,"SizeHorCursor", _wrap_python_const_SizeHorCursor);
	 _wrap_python_const_SizeBDiagCursor = PyInt_FromLong(SizeBDiagCursor);
	 PyDict_SetItemString(d,"SizeBDiagCursor", _wrap_python_const_SizeBDiagCursor);
	 _wrap_python_const_SizeFDiagCursor = PyInt_FromLong(SizeFDiagCursor);
	 PyDict_SetItemString(d,"SizeFDiagCursor", _wrap_python_const_SizeFDiagCursor);
	 _wrap_python_const_SizeAllCursor = PyInt_FromLong(SizeAllCursor);
	 PyDict_SetItemString(d,"SizeAllCursor", _wrap_python_const_SizeAllCursor);
	 _wrap_python_const_BlankCursor = PyInt_FromLong(BlankCursor);
	 PyDict_SetItemString(d,"BlankCursor", _wrap_python_const_BlankCursor);
	 _wrap_python_const_LastCursor = PyInt_FromLong(LastCursor);
	 PyDict_SetItemString(d,"LastCursor", _wrap_python_const_LastCursor);
	 _wrap_python_const_BitmapCursor = PyInt_FromLong(BitmapCursor);
	 PyDict_SetItemString(d,"BitmapCursor", _wrap_python_const_BitmapCursor);
	 _wrap_python_const_CopyROP = PyInt_FromLong(CopyROP);
	 PyDict_SetItemString(d,"CopyROP", _wrap_python_const_CopyROP);
	 _wrap_python_const_OrROP = PyInt_FromLong(OrROP);
	 PyDict_SetItemString(d,"OrROP", _wrap_python_const_OrROP);
	 _wrap_python_const_XorROP = PyInt_FromLong(XorROP);
	 PyDict_SetItemString(d,"XorROP", _wrap_python_const_XorROP);
	 _wrap_python_const_EraseROP = PyInt_FromLong(EraseROP);
	 PyDict_SetItemString(d,"EraseROP", _wrap_python_const_EraseROP);
	 _wrap_python_const_NotCopyROP = PyInt_FromLong(NotCopyROP);
	 PyDict_SetItemString(d,"NotCopyROP", _wrap_python_const_NotCopyROP);
	 _wrap_python_const_NotOrROP = PyInt_FromLong(NotOrROP);
	 PyDict_SetItemString(d,"NotOrROP", _wrap_python_const_NotOrROP);
	 _wrap_python_const_NotXorROP = PyInt_FromLong(NotXorROP);
	 PyDict_SetItemString(d,"NotXorROP", _wrap_python_const_NotXorROP);
	 _wrap_python_const_NotEraseROP = PyInt_FromLong(NotEraseROP);
	 PyDict_SetItemString(d,"NotEraseROP", _wrap_python_const_NotEraseROP);
	 _wrap_python_const_NotROP = PyInt_FromLong(NotROP);
	 PyDict_SetItemString(d,"NotROP", _wrap_python_const_NotROP);
	 _wrap_python_const_QFont_Helvetica = PyInt_FromLong(QFont::Helvetica);
	 PyDict_SetItemString(d,"QFont_Helvetica", _wrap_python_const_QFont_Helvetica);
	 _wrap_python_const_QFont_Times = PyInt_FromLong(QFont::Times);
	 PyDict_SetItemString(d,"QFont_Times", _wrap_python_const_QFont_Times);
	 _wrap_python_const_QFont_Courier = PyInt_FromLong(QFont::Courier);
	 PyDict_SetItemString(d,"QFont_Courier", _wrap_python_const_QFont_Courier);
	 _wrap_python_const_QFont_OldEnglish = PyInt_FromLong(QFont::OldEnglish);
	 PyDict_SetItemString(d,"QFont_OldEnglish", _wrap_python_const_QFont_OldEnglish);
	 _wrap_python_const_QFont_System = PyInt_FromLong(QFont::System);
	 PyDict_SetItemString(d,"QFont_System", _wrap_python_const_QFont_System);
	 _wrap_python_const_QFont_AnyStyle = PyInt_FromLong(QFont::AnyStyle);
	 PyDict_SetItemString(d,"QFont_AnyStyle", _wrap_python_const_QFont_AnyStyle);
	 _wrap_python_const_QFont_SansSerif = PyInt_FromLong(QFont::SansSerif);
	 PyDict_SetItemString(d,"QFont_SansSerif", _wrap_python_const_QFont_SansSerif);
	 _wrap_python_const_QFont_Serif = PyInt_FromLong(QFont::Serif);
	 PyDict_SetItemString(d,"QFont_Serif", _wrap_python_const_QFont_Serif);
	 _wrap_python_const_QFont_TypeWriter = PyInt_FromLong(QFont::TypeWriter);
	 PyDict_SetItemString(d,"QFont_TypeWriter", _wrap_python_const_QFont_TypeWriter);
	 _wrap_python_const_QFont_Decorative = PyInt_FromLong(QFont::Decorative);
	 PyDict_SetItemString(d,"QFont_Decorative", _wrap_python_const_QFont_Decorative);
	 _wrap_python_const_QFont_Light = PyInt_FromLong(QFont::Light);
	 PyDict_SetItemString(d,"QFont_Light", _wrap_python_const_QFont_Light);
	 _wrap_python_const_QFont_Normal = PyInt_FromLong(QFont::Normal);
	 PyDict_SetItemString(d,"QFont_Normal", _wrap_python_const_QFont_Normal);
	 _wrap_python_const_QFont_DemiBold = PyInt_FromLong(QFont::DemiBold);
	 PyDict_SetItemString(d,"QFont_DemiBold", _wrap_python_const_QFont_DemiBold);
	 _wrap_python_const_QFont_Bold = PyInt_FromLong(QFont::Bold);
	 PyDict_SetItemString(d,"QFont_Bold", _wrap_python_const_QFont_Bold);
	 _wrap_python_const_QFont_Black = PyInt_FromLong(QFont::Black);
	 PyDict_SetItemString(d,"QFont_Black", _wrap_python_const_QFont_Black);
	 _wrap_python_const_QFont_Latin1 = PyInt_FromLong(QFont::Latin1);
	 PyDict_SetItemString(d,"QFont_Latin1", _wrap_python_const_QFont_Latin1);
	 _wrap_python_const_QFont_ISO_8859_1 = PyInt_FromLong(QFont::ISO_8859_1);
	 PyDict_SetItemString(d,"QFont_ISO_8859_1", _wrap_python_const_QFont_ISO_8859_1);
	 _wrap_python_const_QFont_AnyCharSet = PyInt_FromLong(QFont::AnyCharSet);
	 PyDict_SetItemString(d,"QFont_AnyCharSet", _wrap_python_const_QFont_AnyCharSet);
	 _wrap_python_const_QPixmap_Auto = PyInt_FromLong(QPixmap::Auto);
	 PyDict_SetItemString(d,"QPixmap_Auto", _wrap_python_const_QPixmap_Auto);
	 _wrap_python_const_QPixmap_Color = PyInt_FromLong(QPixmap::Color);
	 PyDict_SetItemString(d,"QPixmap_Color", _wrap_python_const_QPixmap_Color);
	 _wrap_python_const_QPixmap_Mono = PyInt_FromLong(QPixmap::Mono);
	 PyDict_SetItemString(d,"QPixmap_Mono", _wrap_python_const_QPixmap_Mono);
	 _wrap_python_const_QBitmap_Auto = PyInt_FromLong(QBitmap::Auto);
	 PyDict_SetItemString(d,"QBitmap_Auto", _wrap_python_const_QBitmap_Auto);
	 _wrap_python_const_QBitmap_Color = PyInt_FromLong(QBitmap::Color);
	 PyDict_SetItemString(d,"QBitmap_Color", _wrap_python_const_QBitmap_Color);
	 _wrap_python_const_QBitmap_Mono = PyInt_FromLong(QBitmap::Mono);
	 PyDict_SetItemString(d,"QBitmap_Mono", _wrap_python_const_QBitmap_Mono);
	 _wrap_python_const_BoxLayout_LeftToRight = PyInt_FromLong(BoxLayout::LeftToRight);
	 PyDict_SetItemString(d,"BoxLayout_LeftToRight", _wrap_python_const_BoxLayout_LeftToRight);
	 _wrap_python_const_BoxLayout_RightToLeft = PyInt_FromLong(BoxLayout::RightToLeft);
	 PyDict_SetItemString(d,"BoxLayout_RightToLeft", _wrap_python_const_BoxLayout_RightToLeft);
	 _wrap_python_const_BoxLayout_TopToBottom = PyInt_FromLong(BoxLayout::TopToBottom);
	 PyDict_SetItemString(d,"BoxLayout_TopToBottom", _wrap_python_const_BoxLayout_TopToBottom);
	 _wrap_python_const_BoxLayout_BottomToTop = PyInt_FromLong(BoxLayout::BottomToTop);
	 PyDict_SetItemString(d,"BoxLayout_BottomToTop", _wrap_python_const_BoxLayout_BottomToTop);
	 _wrap_python_const_BoxLayout_Down = PyInt_FromLong(BoxLayout::Down);
	 PyDict_SetItemString(d,"BoxLayout_Down", _wrap_python_const_BoxLayout_Down);
	 _wrap_python_const_BoxLayout_Up = PyInt_FromLong(BoxLayout::Up);
	 PyDict_SetItemString(d,"BoxLayout_Up", _wrap_python_const_BoxLayout_Up);
	 _wrap_python_const_Widget_NoFocus = PyInt_FromLong(Widget::NoFocus);
	 PyDict_SetItemString(d,"Widget_NoFocus", _wrap_python_const_Widget_NoFocus);
	 _wrap_python_const_Widget_TabFocus = PyInt_FromLong(Widget::TabFocus);
	 PyDict_SetItemString(d,"Widget_TabFocus", _wrap_python_const_Widget_TabFocus);
	 _wrap_python_const_Widget_ClickFocus = PyInt_FromLong(Widget::ClickFocus);
	 PyDict_SetItemString(d,"Widget_ClickFocus", _wrap_python_const_Widget_ClickFocus);
	 _wrap_python_const_Widget_StrongFocus = PyInt_FromLong(Widget::StrongFocus);
	 PyDict_SetItemString(d,"Widget_StrongFocus", _wrap_python_const_Widget_StrongFocus);
	 _wrap_python_const_Button_NoFocus = PyInt_FromLong(Button::NoFocus);
	 PyDict_SetItemString(d,"Button_NoFocus", _wrap_python_const_Button_NoFocus);
	 _wrap_python_const_Button_TabFocus = PyInt_FromLong(Button::TabFocus);
	 PyDict_SetItemString(d,"Button_TabFocus", _wrap_python_const_Button_TabFocus);
	 _wrap_python_const_Button_ClickFocus = PyInt_FromLong(Button::ClickFocus);
	 PyDict_SetItemString(d,"Button_ClickFocus", _wrap_python_const_Button_ClickFocus);
	 _wrap_python_const_Button_StrongFocus = PyInt_FromLong(Button::StrongFocus);
	 PyDict_SetItemString(d,"Button_StrongFocus", _wrap_python_const_Button_StrongFocus);
	 _wrap_python_const_CheckBox_NoFocus = PyInt_FromLong(CheckBox::NoFocus);
	 PyDict_SetItemString(d,"CheckBox_NoFocus", _wrap_python_const_CheckBox_NoFocus);
	 _wrap_python_const_CheckBox_TabFocus = PyInt_FromLong(CheckBox::TabFocus);
	 PyDict_SetItemString(d,"CheckBox_TabFocus", _wrap_python_const_CheckBox_TabFocus);
	 _wrap_python_const_CheckBox_ClickFocus = PyInt_FromLong(CheckBox::ClickFocus);
	 PyDict_SetItemString(d,"CheckBox_ClickFocus", _wrap_python_const_CheckBox_ClickFocus);
	 _wrap_python_const_CheckBox_StrongFocus = PyInt_FromLong(CheckBox::StrongFocus);
	 PyDict_SetItemString(d,"CheckBox_StrongFocus", _wrap_python_const_CheckBox_StrongFocus);
	 _wrap_python_const_PushButton_NoFocus = PyInt_FromLong(PushButton::NoFocus);
	 PyDict_SetItemString(d,"PushButton_NoFocus", _wrap_python_const_PushButton_NoFocus);
	 _wrap_python_const_PushButton_TabFocus = PyInt_FromLong(PushButton::TabFocus);
	 PyDict_SetItemString(d,"PushButton_TabFocus", _wrap_python_const_PushButton_TabFocus);
	 _wrap_python_const_PushButton_ClickFocus = PyInt_FromLong(PushButton::ClickFocus);
	 PyDict_SetItemString(d,"PushButton_ClickFocus", _wrap_python_const_PushButton_ClickFocus);
	 _wrap_python_const_PushButton_StrongFocus = PyInt_FromLong(PushButton::StrongFocus);
	 PyDict_SetItemString(d,"PushButton_StrongFocus", _wrap_python_const_PushButton_StrongFocus);
	 _wrap_python_const_RadioButton_NoFocus = PyInt_FromLong(RadioButton::NoFocus);
	 PyDict_SetItemString(d,"RadioButton_NoFocus", _wrap_python_const_RadioButton_NoFocus);
	 _wrap_python_const_RadioButton_TabFocus = PyInt_FromLong(RadioButton::TabFocus);
	 PyDict_SetItemString(d,"RadioButton_TabFocus", _wrap_python_const_RadioButton_TabFocus);
	 _wrap_python_const_RadioButton_ClickFocus = PyInt_FromLong(RadioButton::ClickFocus);
	 PyDict_SetItemString(d,"RadioButton_ClickFocus", _wrap_python_const_RadioButton_ClickFocus);
	 _wrap_python_const_RadioButton_StrongFocus = PyInt_FromLong(RadioButton::StrongFocus);
	 PyDict_SetItemString(d,"RadioButton_StrongFocus", _wrap_python_const_RadioButton_StrongFocus);
	 _wrap_python_const_ComboBox_NoInsertion = PyInt_FromLong(ComboBox::NoInsertion);
	 PyDict_SetItemString(d,"ComboBox_NoInsertion", _wrap_python_const_ComboBox_NoInsertion);
	 _wrap_python_const_ComboBox_AtTop = PyInt_FromLong(ComboBox::AtTop);
	 PyDict_SetItemString(d,"ComboBox_AtTop", _wrap_python_const_ComboBox_AtTop);
	 _wrap_python_const_ComboBox_AtCurrent = PyInt_FromLong(ComboBox::AtCurrent);
	 PyDict_SetItemString(d,"ComboBox_AtCurrent", _wrap_python_const_ComboBox_AtCurrent);
	 _wrap_python_const_ComboBox_AtBottom = PyInt_FromLong(ComboBox::AtBottom);
	 PyDict_SetItemString(d,"ComboBox_AtBottom", _wrap_python_const_ComboBox_AtBottom);
	 _wrap_python_const_ComboBox_AfterCurrent = PyInt_FromLong(ComboBox::AfterCurrent);
	 PyDict_SetItemString(d,"ComboBox_AfterCurrent", _wrap_python_const_ComboBox_AfterCurrent);
	 _wrap_python_const_ComboBox_BeforeCurrent = PyInt_FromLong(ComboBox::BeforeCurrent);
	 PyDict_SetItemString(d,"ComboBox_BeforeCurrent", _wrap_python_const_ComboBox_BeforeCurrent);
	 _wrap_python_const_ComboBox_NoFocus = PyInt_FromLong(ComboBox::NoFocus);
	 PyDict_SetItemString(d,"ComboBox_NoFocus", _wrap_python_const_ComboBox_NoFocus);
	 _wrap_python_const_ComboBox_TabFocus = PyInt_FromLong(ComboBox::TabFocus);
	 PyDict_SetItemString(d,"ComboBox_TabFocus", _wrap_python_const_ComboBox_TabFocus);
	 _wrap_python_const_ComboBox_ClickFocus = PyInt_FromLong(ComboBox::ClickFocus);
	 PyDict_SetItemString(d,"ComboBox_ClickFocus", _wrap_python_const_ComboBox_ClickFocus);
	 _wrap_python_const_ComboBox_StrongFocus = PyInt_FromLong(ComboBox::StrongFocus);
	 PyDict_SetItemString(d,"ComboBox_StrongFocus", _wrap_python_const_ComboBox_StrongFocus);
	 _wrap_python_const_Dialog_NoFocus = PyInt_FromLong(Dialog::NoFocus);
	 PyDict_SetItemString(d,"Dialog_NoFocus", _wrap_python_const_Dialog_NoFocus);
	 _wrap_python_const_Dialog_TabFocus = PyInt_FromLong(Dialog::TabFocus);
	 PyDict_SetItemString(d,"Dialog_TabFocus", _wrap_python_const_Dialog_TabFocus);
	 _wrap_python_const_Dialog_ClickFocus = PyInt_FromLong(Dialog::ClickFocus);
	 PyDict_SetItemString(d,"Dialog_ClickFocus", _wrap_python_const_Dialog_ClickFocus);
	 _wrap_python_const_Dialog_StrongFocus = PyInt_FromLong(Dialog::StrongFocus);
	 PyDict_SetItemString(d,"Dialog_StrongFocus", _wrap_python_const_Dialog_StrongFocus);
	 _wrap_python_const_TabDialog_NoFocus = PyInt_FromLong(TabDialog::NoFocus);
	 PyDict_SetItemString(d,"TabDialog_NoFocus", _wrap_python_const_TabDialog_NoFocus);
	 _wrap_python_const_TabDialog_TabFocus = PyInt_FromLong(TabDialog::TabFocus);
	 PyDict_SetItemString(d,"TabDialog_TabFocus", _wrap_python_const_TabDialog_TabFocus);
	 _wrap_python_const_TabDialog_ClickFocus = PyInt_FromLong(TabDialog::ClickFocus);
	 PyDict_SetItemString(d,"TabDialog_ClickFocus", _wrap_python_const_TabDialog_ClickFocus);
	 _wrap_python_const_TabDialog_StrongFocus = PyInt_FromLong(TabDialog::StrongFocus);
	 PyDict_SetItemString(d,"TabDialog_StrongFocus", _wrap_python_const_TabDialog_StrongFocus);
	 _wrap_python_const_LineEdit_Normal = PyInt_FromLong(LineEdit::Normal);
	 PyDict_SetItemString(d,"LineEdit_Normal", _wrap_python_const_LineEdit_Normal);
	 _wrap_python_const_LineEdit_NoEcho = PyInt_FromLong(LineEdit::NoEcho);
	 PyDict_SetItemString(d,"LineEdit_NoEcho", _wrap_python_const_LineEdit_NoEcho);
	 _wrap_python_const_LineEdit_Password = PyInt_FromLong(LineEdit::Password);
	 PyDict_SetItemString(d,"LineEdit_Password", _wrap_python_const_LineEdit_Password);
	 _wrap_python_const_LineEdit_NoFocus = PyInt_FromLong(LineEdit::NoFocus);
	 PyDict_SetItemString(d,"LineEdit_NoFocus", _wrap_python_const_LineEdit_NoFocus);
	 _wrap_python_const_LineEdit_TabFocus = PyInt_FromLong(LineEdit::TabFocus);
	 PyDict_SetItemString(d,"LineEdit_TabFocus", _wrap_python_const_LineEdit_TabFocus);
	 _wrap_python_const_LineEdit_ClickFocus = PyInt_FromLong(LineEdit::ClickFocus);
	 PyDict_SetItemString(d,"LineEdit_ClickFocus", _wrap_python_const_LineEdit_ClickFocus);
	 _wrap_python_const_LineEdit_StrongFocus = PyInt_FromLong(LineEdit::StrongFocus);
	 PyDict_SetItemString(d,"LineEdit_StrongFocus", _wrap_python_const_LineEdit_StrongFocus);
	 _wrap_python_const_Frame_NoFrame = PyInt_FromLong(Frame::NoFrame);
	 PyDict_SetItemString(d,"Frame_NoFrame", _wrap_python_const_Frame_NoFrame);
	 _wrap_python_const_Frame_Box = PyInt_FromLong(Frame::Box);
	 PyDict_SetItemString(d,"Frame_Box", _wrap_python_const_Frame_Box);
	 _wrap_python_const_Frame_Panel = PyInt_FromLong(Frame::Panel);
	 PyDict_SetItemString(d,"Frame_Panel", _wrap_python_const_Frame_Panel);
	 _wrap_python_const_Frame_WinPanel = PyInt_FromLong(Frame::WinPanel);
	 PyDict_SetItemString(d,"Frame_WinPanel", _wrap_python_const_Frame_WinPanel);
	 _wrap_python_const_Frame_HLine = PyInt_FromLong(Frame::HLine);
	 PyDict_SetItemString(d,"Frame_HLine", _wrap_python_const_Frame_HLine);
	 _wrap_python_const_Frame_VLine = PyInt_FromLong(Frame::VLine);
	 PyDict_SetItemString(d,"Frame_VLine", _wrap_python_const_Frame_VLine);
	 _wrap_python_const_Frame_MShape = PyInt_FromLong(Frame::MShape);
	 PyDict_SetItemString(d,"Frame_MShape", _wrap_python_const_Frame_MShape);
	 _wrap_python_const_Frame_Plain = PyInt_FromLong(Frame::Plain);
	 PyDict_SetItemString(d,"Frame_Plain", _wrap_python_const_Frame_Plain);
	 _wrap_python_const_Frame_Raised = PyInt_FromLong(Frame::Raised);
	 PyDict_SetItemString(d,"Frame_Raised", _wrap_python_const_Frame_Raised);
	 _wrap_python_const_Frame_Sunken = PyInt_FromLong(Frame::Sunken);
	 PyDict_SetItemString(d,"Frame_Sunken", _wrap_python_const_Frame_Sunken);
	 _wrap_python_const_Frame_MShadow = PyInt_FromLong(Frame::MShadow);
	 PyDict_SetItemString(d,"Frame_MShadow", _wrap_python_const_Frame_MShadow);
	 _wrap_python_const_Frame_NoFocus = PyInt_FromLong(Frame::NoFocus);
	 PyDict_SetItemString(d,"Frame_NoFocus", _wrap_python_const_Frame_NoFocus);
	 _wrap_python_const_Frame_TabFocus = PyInt_FromLong(Frame::TabFocus);
	 PyDict_SetItemString(d,"Frame_TabFocus", _wrap_python_const_Frame_TabFocus);
	 _wrap_python_const_Frame_ClickFocus = PyInt_FromLong(Frame::ClickFocus);
	 PyDict_SetItemString(d,"Frame_ClickFocus", _wrap_python_const_Frame_ClickFocus);
	 _wrap_python_const_Frame_StrongFocus = PyInt_FromLong(Frame::StrongFocus);
	 PyDict_SetItemString(d,"Frame_StrongFocus", _wrap_python_const_Frame_StrongFocus);
	 _wrap_python_const_GroupBox_NoFrame = PyInt_FromLong(GroupBox::NoFrame);
	 PyDict_SetItemString(d,"GroupBox_NoFrame", _wrap_python_const_GroupBox_NoFrame);
	 _wrap_python_const_GroupBox_Box = PyInt_FromLong(GroupBox::Box);
	 PyDict_SetItemString(d,"GroupBox_Box", _wrap_python_const_GroupBox_Box);
	 _wrap_python_const_GroupBox_Panel = PyInt_FromLong(GroupBox::Panel);
	 PyDict_SetItemString(d,"GroupBox_Panel", _wrap_python_const_GroupBox_Panel);
	 _wrap_python_const_GroupBox_WinPanel = PyInt_FromLong(GroupBox::WinPanel);
	 PyDict_SetItemString(d,"GroupBox_WinPanel", _wrap_python_const_GroupBox_WinPanel);
	 _wrap_python_const_GroupBox_HLine = PyInt_FromLong(GroupBox::HLine);
	 PyDict_SetItemString(d,"GroupBox_HLine", _wrap_python_const_GroupBox_HLine);
	 _wrap_python_const_GroupBox_VLine = PyInt_FromLong(GroupBox::VLine);
	 PyDict_SetItemString(d,"GroupBox_VLine", _wrap_python_const_GroupBox_VLine);
	 _wrap_python_const_GroupBox_MShape = PyInt_FromLong(GroupBox::MShape);
	 PyDict_SetItemString(d,"GroupBox_MShape", _wrap_python_const_GroupBox_MShape);
	 _wrap_python_const_GroupBox_Plain = PyInt_FromLong(GroupBox::Plain);
	 PyDict_SetItemString(d,"GroupBox_Plain", _wrap_python_const_GroupBox_Plain);
	 _wrap_python_const_GroupBox_Raised = PyInt_FromLong(GroupBox::Raised);
	 PyDict_SetItemString(d,"GroupBox_Raised", _wrap_python_const_GroupBox_Raised);
	 _wrap_python_const_GroupBox_Sunken = PyInt_FromLong(GroupBox::Sunken);
	 PyDict_SetItemString(d,"GroupBox_Sunken", _wrap_python_const_GroupBox_Sunken);
	 _wrap_python_const_GroupBox_MShadow = PyInt_FromLong(GroupBox::MShadow);
	 PyDict_SetItemString(d,"GroupBox_MShadow", _wrap_python_const_GroupBox_MShadow);
	 _wrap_python_const_GroupBox_NoFocus = PyInt_FromLong(GroupBox::NoFocus);
	 PyDict_SetItemString(d,"GroupBox_NoFocus", _wrap_python_const_GroupBox_NoFocus);
	 _wrap_python_const_GroupBox_TabFocus = PyInt_FromLong(GroupBox::TabFocus);
	 PyDict_SetItemString(d,"GroupBox_TabFocus", _wrap_python_const_GroupBox_TabFocus);
	 _wrap_python_const_GroupBox_ClickFocus = PyInt_FromLong(GroupBox::ClickFocus);
	 PyDict_SetItemString(d,"GroupBox_ClickFocus", _wrap_python_const_GroupBox_ClickFocus);
	 _wrap_python_const_GroupBox_StrongFocus = PyInt_FromLong(GroupBox::StrongFocus);
	 PyDict_SetItemString(d,"GroupBox_StrongFocus", _wrap_python_const_GroupBox_StrongFocus);
	 _wrap_python_const_ButtonGroup_NoFrame = PyInt_FromLong(ButtonGroup::NoFrame);
	 PyDict_SetItemString(d,"ButtonGroup_NoFrame", _wrap_python_const_ButtonGroup_NoFrame);
	 _wrap_python_const_ButtonGroup_Box = PyInt_FromLong(ButtonGroup::Box);
	 PyDict_SetItemString(d,"ButtonGroup_Box", _wrap_python_const_ButtonGroup_Box);
	 _wrap_python_const_ButtonGroup_Panel = PyInt_FromLong(ButtonGroup::Panel);
	 PyDict_SetItemString(d,"ButtonGroup_Panel", _wrap_python_const_ButtonGroup_Panel);
	 _wrap_python_const_ButtonGroup_WinPanel = PyInt_FromLong(ButtonGroup::WinPanel);
	 PyDict_SetItemString(d,"ButtonGroup_WinPanel", _wrap_python_const_ButtonGroup_WinPanel);
	 _wrap_python_const_ButtonGroup_HLine = PyInt_FromLong(ButtonGroup::HLine);
	 PyDict_SetItemString(d,"ButtonGroup_HLine", _wrap_python_const_ButtonGroup_HLine);
	 _wrap_python_const_ButtonGroup_VLine = PyInt_FromLong(ButtonGroup::VLine);
	 PyDict_SetItemString(d,"ButtonGroup_VLine", _wrap_python_const_ButtonGroup_VLine);
	 _wrap_python_const_ButtonGroup_MShape = PyInt_FromLong(ButtonGroup::MShape);
	 PyDict_SetItemString(d,"ButtonGroup_MShape", _wrap_python_const_ButtonGroup_MShape);
	 _wrap_python_const_ButtonGroup_Plain = PyInt_FromLong(ButtonGroup::Plain);
	 PyDict_SetItemString(d,"ButtonGroup_Plain", _wrap_python_const_ButtonGroup_Plain);
	 _wrap_python_const_ButtonGroup_Raised = PyInt_FromLong(ButtonGroup::Raised);
	 PyDict_SetItemString(d,"ButtonGroup_Raised", _wrap_python_const_ButtonGroup_Raised);
	 _wrap_python_const_ButtonGroup_Sunken = PyInt_FromLong(ButtonGroup::Sunken);
	 PyDict_SetItemString(d,"ButtonGroup_Sunken", _wrap_python_const_ButtonGroup_Sunken);
	 _wrap_python_const_ButtonGroup_MShadow = PyInt_FromLong(ButtonGroup::MShadow);
	 PyDict_SetItemString(d,"ButtonGroup_MShadow", _wrap_python_const_ButtonGroup_MShadow);
	 _wrap_python_const_ButtonGroup_NoFocus = PyInt_FromLong(ButtonGroup::NoFocus);
	 PyDict_SetItemString(d,"ButtonGroup_NoFocus", _wrap_python_const_ButtonGroup_NoFocus);
	 _wrap_python_const_ButtonGroup_TabFocus = PyInt_FromLong(ButtonGroup::TabFocus);
	 PyDict_SetItemString(d,"ButtonGroup_TabFocus", _wrap_python_const_ButtonGroup_TabFocus);
	 _wrap_python_const_ButtonGroup_ClickFocus = PyInt_FromLong(ButtonGroup::ClickFocus);
	 PyDict_SetItemString(d,"ButtonGroup_ClickFocus", _wrap_python_const_ButtonGroup_ClickFocus);
	 _wrap_python_const_ButtonGroup_StrongFocus = PyInt_FromLong(ButtonGroup::StrongFocus);
	 PyDict_SetItemString(d,"ButtonGroup_StrongFocus", _wrap_python_const_ButtonGroup_StrongFocus);
	 _wrap_python_const_Label_NoFrame = PyInt_FromLong(Label::NoFrame);
	 PyDict_SetItemString(d,"Label_NoFrame", _wrap_python_const_Label_NoFrame);
	 _wrap_python_const_Label_Box = PyInt_FromLong(Label::Box);
	 PyDict_SetItemString(d,"Label_Box", _wrap_python_const_Label_Box);
	 _wrap_python_const_Label_Panel = PyInt_FromLong(Label::Panel);
	 PyDict_SetItemString(d,"Label_Panel", _wrap_python_const_Label_Panel);
	 _wrap_python_const_Label_WinPanel = PyInt_FromLong(Label::WinPanel);
	 PyDict_SetItemString(d,"Label_WinPanel", _wrap_python_const_Label_WinPanel);
	 _wrap_python_const_Label_HLine = PyInt_FromLong(Label::HLine);
	 PyDict_SetItemString(d,"Label_HLine", _wrap_python_const_Label_HLine);
	 _wrap_python_const_Label_VLine = PyInt_FromLong(Label::VLine);
	 PyDict_SetItemString(d,"Label_VLine", _wrap_python_const_Label_VLine);
	 _wrap_python_const_Label_MShape = PyInt_FromLong(Label::MShape);
	 PyDict_SetItemString(d,"Label_MShape", _wrap_python_const_Label_MShape);
	 _wrap_python_const_Label_Plain = PyInt_FromLong(Label::Plain);
	 PyDict_SetItemString(d,"Label_Plain", _wrap_python_const_Label_Plain);
	 _wrap_python_const_Label_Raised = PyInt_FromLong(Label::Raised);
	 PyDict_SetItemString(d,"Label_Raised", _wrap_python_const_Label_Raised);
	 _wrap_python_const_Label_Sunken = PyInt_FromLong(Label::Sunken);
	 PyDict_SetItemString(d,"Label_Sunken", _wrap_python_const_Label_Sunken);
	 _wrap_python_const_Label_MShadow = PyInt_FromLong(Label::MShadow);
	 PyDict_SetItemString(d,"Label_MShadow", _wrap_python_const_Label_MShadow);
	 _wrap_python_const_Label_NoFocus = PyInt_FromLong(Label::NoFocus);
	 PyDict_SetItemString(d,"Label_NoFocus", _wrap_python_const_Label_NoFocus);
	 _wrap_python_const_Label_TabFocus = PyInt_FromLong(Label::TabFocus);
	 PyDict_SetItemString(d,"Label_TabFocus", _wrap_python_const_Label_TabFocus);
	 _wrap_python_const_Label_ClickFocus = PyInt_FromLong(Label::ClickFocus);
	 PyDict_SetItemString(d,"Label_ClickFocus", _wrap_python_const_Label_ClickFocus);
	 _wrap_python_const_Label_StrongFocus = PyInt_FromLong(Label::StrongFocus);
	 PyDict_SetItemString(d,"Label_StrongFocus", _wrap_python_const_Label_StrongFocus);
	 _wrap_python_const_TableView_NoFrame = PyInt_FromLong(TableView::NoFrame);
	 PyDict_SetItemString(d,"TableView_NoFrame", _wrap_python_const_TableView_NoFrame);
	 _wrap_python_const_TableView_Box = PyInt_FromLong(TableView::Box);
	 PyDict_SetItemString(d,"TableView_Box", _wrap_python_const_TableView_Box);
	 _wrap_python_const_TableView_Panel = PyInt_FromLong(TableView::Panel);
	 PyDict_SetItemString(d,"TableView_Panel", _wrap_python_const_TableView_Panel);
	 _wrap_python_const_TableView_WinPanel = PyInt_FromLong(TableView::WinPanel);
	 PyDict_SetItemString(d,"TableView_WinPanel", _wrap_python_const_TableView_WinPanel);
	 _wrap_python_const_TableView_HLine = PyInt_FromLong(TableView::HLine);
	 PyDict_SetItemString(d,"TableView_HLine", _wrap_python_const_TableView_HLine);
	 _wrap_python_const_TableView_VLine = PyInt_FromLong(TableView::VLine);
	 PyDict_SetItemString(d,"TableView_VLine", _wrap_python_const_TableView_VLine);
	 _wrap_python_const_TableView_MShape = PyInt_FromLong(TableView::MShape);
	 PyDict_SetItemString(d,"TableView_MShape", _wrap_python_const_TableView_MShape);
	 _wrap_python_const_TableView_Plain = PyInt_FromLong(TableView::Plain);
	 PyDict_SetItemString(d,"TableView_Plain", _wrap_python_const_TableView_Plain);
	 _wrap_python_const_TableView_Raised = PyInt_FromLong(TableView::Raised);
	 PyDict_SetItemString(d,"TableView_Raised", _wrap_python_const_TableView_Raised);
	 _wrap_python_const_TableView_Sunken = PyInt_FromLong(TableView::Sunken);
	 PyDict_SetItemString(d,"TableView_Sunken", _wrap_python_const_TableView_Sunken);
	 _wrap_python_const_TableView_MShadow = PyInt_FromLong(TableView::MShadow);
	 PyDict_SetItemString(d,"TableView_MShadow", _wrap_python_const_TableView_MShadow);
	 _wrap_python_const_TableView_NoFocus = PyInt_FromLong(TableView::NoFocus);
	 PyDict_SetItemString(d,"TableView_NoFocus", _wrap_python_const_TableView_NoFocus);
	 _wrap_python_const_TableView_TabFocus = PyInt_FromLong(TableView::TabFocus);
	 PyDict_SetItemString(d,"TableView_TabFocus", _wrap_python_const_TableView_TabFocus);
	 _wrap_python_const_TableView_ClickFocus = PyInt_FromLong(TableView::ClickFocus);
	 PyDict_SetItemString(d,"TableView_ClickFocus", _wrap_python_const_TableView_ClickFocus);
	 _wrap_python_const_TableView_StrongFocus = PyInt_FromLong(TableView::StrongFocus);
	 PyDict_SetItemString(d,"TableView_StrongFocus", _wrap_python_const_TableView_StrongFocus);
	 _wrap_python_const_ListBox_NoFrame = PyInt_FromLong(ListBox::NoFrame);
	 PyDict_SetItemString(d,"ListBox_NoFrame", _wrap_python_const_ListBox_NoFrame);
	 _wrap_python_const_ListBox_Box = PyInt_FromLong(ListBox::Box);
	 PyDict_SetItemString(d,"ListBox_Box", _wrap_python_const_ListBox_Box);
	 _wrap_python_const_ListBox_Panel = PyInt_FromLong(ListBox::Panel);
	 PyDict_SetItemString(d,"ListBox_Panel", _wrap_python_const_ListBox_Panel);
	 _wrap_python_const_ListBox_WinPanel = PyInt_FromLong(ListBox::WinPanel);
	 PyDict_SetItemString(d,"ListBox_WinPanel", _wrap_python_const_ListBox_WinPanel);
	 _wrap_python_const_ListBox_HLine = PyInt_FromLong(ListBox::HLine);
	 PyDict_SetItemString(d,"ListBox_HLine", _wrap_python_const_ListBox_HLine);
	 _wrap_python_const_ListBox_VLine = PyInt_FromLong(ListBox::VLine);
	 PyDict_SetItemString(d,"ListBox_VLine", _wrap_python_const_ListBox_VLine);
	 _wrap_python_const_ListBox_MShape = PyInt_FromLong(ListBox::MShape);
	 PyDict_SetItemString(d,"ListBox_MShape", _wrap_python_const_ListBox_MShape);
	 _wrap_python_const_ListBox_Plain = PyInt_FromLong(ListBox::Plain);
	 PyDict_SetItemString(d,"ListBox_Plain", _wrap_python_const_ListBox_Plain);
	 _wrap_python_const_ListBox_Raised = PyInt_FromLong(ListBox::Raised);
	 PyDict_SetItemString(d,"ListBox_Raised", _wrap_python_const_ListBox_Raised);
	 _wrap_python_const_ListBox_Sunken = PyInt_FromLong(ListBox::Sunken);
	 PyDict_SetItemString(d,"ListBox_Sunken", _wrap_python_const_ListBox_Sunken);
	 _wrap_python_const_ListBox_MShadow = PyInt_FromLong(ListBox::MShadow);
	 PyDict_SetItemString(d,"ListBox_MShadow", _wrap_python_const_ListBox_MShadow);
	 _wrap_python_const_ListBox_NoFocus = PyInt_FromLong(ListBox::NoFocus);
	 PyDict_SetItemString(d,"ListBox_NoFocus", _wrap_python_const_ListBox_NoFocus);
	 _wrap_python_const_ListBox_TabFocus = PyInt_FromLong(ListBox::TabFocus);
	 PyDict_SetItemString(d,"ListBox_TabFocus", _wrap_python_const_ListBox_TabFocus);
	 _wrap_python_const_ListBox_ClickFocus = PyInt_FromLong(ListBox::ClickFocus);
	 PyDict_SetItemString(d,"ListBox_ClickFocus", _wrap_python_const_ListBox_ClickFocus);
	 _wrap_python_const_ListBox_StrongFocus = PyInt_FromLong(ListBox::StrongFocus);
	 PyDict_SetItemString(d,"ListBox_StrongFocus", _wrap_python_const_ListBox_StrongFocus);
	 _wrap_python_const_MultiLineEdit_NoFrame = PyInt_FromLong(MultiLineEdit::NoFrame);
	 PyDict_SetItemString(d,"MultiLineEdit_NoFrame", _wrap_python_const_MultiLineEdit_NoFrame);
	 _wrap_python_const_MultiLineEdit_Box = PyInt_FromLong(MultiLineEdit::Box);
	 PyDict_SetItemString(d,"MultiLineEdit_Box", _wrap_python_const_MultiLineEdit_Box);
	 _wrap_python_const_MultiLineEdit_Panel = PyInt_FromLong(MultiLineEdit::Panel);
	 PyDict_SetItemString(d,"MultiLineEdit_Panel", _wrap_python_const_MultiLineEdit_Panel);
	 _wrap_python_const_MultiLineEdit_WinPanel = PyInt_FromLong(MultiLineEdit::WinPanel);
	 PyDict_SetItemString(d,"MultiLineEdit_WinPanel", _wrap_python_const_MultiLineEdit_WinPanel);
	 _wrap_python_const_MultiLineEdit_HLine = PyInt_FromLong(MultiLineEdit::HLine);
	 PyDict_SetItemString(d,"MultiLineEdit_HLine", _wrap_python_const_MultiLineEdit_HLine);
	 _wrap_python_const_MultiLineEdit_VLine = PyInt_FromLong(MultiLineEdit::VLine);
	 PyDict_SetItemString(d,"MultiLineEdit_VLine", _wrap_python_const_MultiLineEdit_VLine);
	 _wrap_python_const_MultiLineEdit_MShape = PyInt_FromLong(MultiLineEdit::MShape);
	 PyDict_SetItemString(d,"MultiLineEdit_MShape", _wrap_python_const_MultiLineEdit_MShape);
	 _wrap_python_const_MultiLineEdit_Plain = PyInt_FromLong(MultiLineEdit::Plain);
	 PyDict_SetItemString(d,"MultiLineEdit_Plain", _wrap_python_const_MultiLineEdit_Plain);
	 _wrap_python_const_MultiLineEdit_Raised = PyInt_FromLong(MultiLineEdit::Raised);
	 PyDict_SetItemString(d,"MultiLineEdit_Raised", _wrap_python_const_MultiLineEdit_Raised);
	 _wrap_python_const_MultiLineEdit_Sunken = PyInt_FromLong(MultiLineEdit::Sunken);
	 PyDict_SetItemString(d,"MultiLineEdit_Sunken", _wrap_python_const_MultiLineEdit_Sunken);
	 _wrap_python_const_MultiLineEdit_MShadow = PyInt_FromLong(MultiLineEdit::MShadow);
	 PyDict_SetItemString(d,"MultiLineEdit_MShadow", _wrap_python_const_MultiLineEdit_MShadow);
	 _wrap_python_const_MultiLineEdit_NoFocus = PyInt_FromLong(MultiLineEdit::NoFocus);
	 PyDict_SetItemString(d,"MultiLineEdit_NoFocus", _wrap_python_const_MultiLineEdit_NoFocus);
	 _wrap_python_const_MultiLineEdit_TabFocus = PyInt_FromLong(MultiLineEdit::TabFocus);
	 PyDict_SetItemString(d,"MultiLineEdit_TabFocus", _wrap_python_const_MultiLineEdit_TabFocus);
	 _wrap_python_const_MultiLineEdit_ClickFocus = PyInt_FromLong(MultiLineEdit::ClickFocus);
	 PyDict_SetItemString(d,"MultiLineEdit_ClickFocus", _wrap_python_const_MultiLineEdit_ClickFocus);
	 _wrap_python_const_MultiLineEdit_StrongFocus = PyInt_FromLong(MultiLineEdit::StrongFocus);
	 PyDict_SetItemString(d,"MultiLineEdit_StrongFocus", _wrap_python_const_MultiLineEdit_StrongFocus);
	 _wrap_python_const_ScrollBar_Horizontal = PyInt_FromLong(ScrollBar::Horizontal);
	 PyDict_SetItemString(d,"ScrollBar_Horizontal", _wrap_python_const_ScrollBar_Horizontal);
	 _wrap_python_const_ScrollBar_Vertical = PyInt_FromLong(ScrollBar::Vertical);
	 PyDict_SetItemString(d,"ScrollBar_Vertical", _wrap_python_const_ScrollBar_Vertical);
	 _wrap_python_const_ScrollBar_NoFocus = PyInt_FromLong(ScrollBar::NoFocus);
	 PyDict_SetItemString(d,"ScrollBar_NoFocus", _wrap_python_const_ScrollBar_NoFocus);
	 _wrap_python_const_ScrollBar_TabFocus = PyInt_FromLong(ScrollBar::TabFocus);
	 PyDict_SetItemString(d,"ScrollBar_TabFocus", _wrap_python_const_ScrollBar_TabFocus);
	 _wrap_python_const_ScrollBar_ClickFocus = PyInt_FromLong(ScrollBar::ClickFocus);
	 PyDict_SetItemString(d,"ScrollBar_ClickFocus", _wrap_python_const_ScrollBar_ClickFocus);
	 _wrap_python_const_ScrollBar_StrongFocus = PyInt_FromLong(ScrollBar::StrongFocus);
	 PyDict_SetItemString(d,"ScrollBar_StrongFocus", _wrap_python_const_ScrollBar_StrongFocus);
	 _wrap_python_const_QMenuBar_Never = PyInt_FromLong(QMenuBar::Never);
	 PyDict_SetItemString(d,"QMenuBar_Never", _wrap_python_const_QMenuBar_Never);
	 _wrap_python_const_QMenuBar_InWindowsStyle = PyInt_FromLong(QMenuBar::InWindowsStyle);
	 PyDict_SetItemString(d,"QMenuBar_InWindowsStyle", _wrap_python_const_QMenuBar_InWindowsStyle);
/*
 * These are the pointer type-equivalency mappings. 
 * (Used by the SWIG pointer type-checker).
 */
	 SWIG_RegisterMapping("_signed_long","_long",0);
	 SWIG_RegisterMapping("_Dialog","_class_TabDialog",SwigTabDialogToDialog);
	 SWIG_RegisterMapping("_Dialog","_TabDialog",SwigTabDialogToDialog);
	 SWIG_RegisterMapping("_Dialog","_class_Dialog",0);
	 SWIG_RegisterMapping("_class_CheckBox","_CheckBox",0);
	 SWIG_RegisterMapping("_class_ListBox","_ListBox",0);
	 SWIG_RegisterMapping("_QFontInfo","_class_QFontInfo",0);
	 SWIG_RegisterMapping("_class_QFont","_QFont",0);
	 SWIG_RegisterMapping("_class_RadioButton","_RadioButton",0);
	 SWIG_RegisterMapping("_class_QBitmap","_QBitmap",0);
	 SWIG_RegisterMapping("_class_Object","_class_FileDialog",SwigFileDialogToObject);
	 SWIG_RegisterMapping("_class_Object","_FileDialog",SwigFileDialogToObject);
	 SWIG_RegisterMapping("_class_Object","_class_ScrollBar",SwigScrollBarToObject);
	 SWIG_RegisterMapping("_class_Object","_ScrollBar",SwigScrollBarToObject);
	 SWIG_RegisterMapping("_class_Object","_class_MultiLineEdit",SwigMultiLineEditToObject);
	 SWIG_RegisterMapping("_class_Object","_MultiLineEdit",SwigMultiLineEditToObject);
	 SWIG_RegisterMapping("_class_Object","_class_ListBox",SwigListBoxToObject);
	 SWIG_RegisterMapping("_class_Object","_ListBox",SwigListBoxToObject);
	 SWIG_RegisterMapping("_class_Object","_class_TableView",SwigTableViewToObject);
	 SWIG_RegisterMapping("_class_Object","_TableView",SwigTableViewToObject);
	 SWIG_RegisterMapping("_class_Object","_class_Label",SwigLabelToObject);
	 SWIG_RegisterMapping("_class_Object","_Label",SwigLabelToObject);
	 SWIG_RegisterMapping("_class_Object","_class_ButtonGroup",SwigButtonGroupToObject);
	 SWIG_RegisterMapping("_class_Object","_ButtonGroup",SwigButtonGroupToObject);
	 SWIG_RegisterMapping("_class_Object","_class_GroupBox",SwigGroupBoxToObject);
	 SWIG_RegisterMapping("_class_Object","_GroupBox",SwigGroupBoxToObject);
	 SWIG_RegisterMapping("_class_Object","_class_Frame",SwigFrameToObject);
	 SWIG_RegisterMapping("_class_Object","_Frame",SwigFrameToObject);
	 SWIG_RegisterMapping("_class_Object","_class_LineEdit",SwigLineEditToObject);
	 SWIG_RegisterMapping("_class_Object","_LineEdit",SwigLineEditToObject);
	 SWIG_RegisterMapping("_class_Object","_class_TabDialog",SwigTabDialogToObject);
	 SWIG_RegisterMapping("_class_Object","_TabDialog",SwigTabDialogToObject);
	 SWIG_RegisterMapping("_class_Object","_class_Dialog",SwigDialogToObject);
	 SWIG_RegisterMapping("_class_Object","_Dialog",SwigDialogToObject);
	 SWIG_RegisterMapping("_class_Object","_class_ComboBox",SwigComboBoxToObject);
	 SWIG_RegisterMapping("_class_Object","_ComboBox",SwigComboBoxToObject);
	 SWIG_RegisterMapping("_class_Object","_class_RadioButton",SwigRadioButtonToObject);
	 SWIG_RegisterMapping("_class_Object","_RadioButton",SwigRadioButtonToObject);
	 SWIG_RegisterMapping("_class_Object","_class_PushButton",SwigPushButtonToObject);
	 SWIG_RegisterMapping("_class_Object","_PushButton",SwigPushButtonToObject);
	 SWIG_RegisterMapping("_class_Object","_class_CheckBox",SwigCheckBoxToObject);
	 SWIG_RegisterMapping("_class_Object","_CheckBox",SwigCheckBoxToObject);
	 SWIG_RegisterMapping("_class_Object","_class_Button",SwigButtonToObject);
	 SWIG_RegisterMapping("_class_Object","_Button",SwigButtonToObject);
	 SWIG_RegisterMapping("_class_Object","_class_Widget",SwigWidgetToObject);
	 SWIG_RegisterMapping("_class_Object","_Widget",SwigWidgetToObject);
	 SWIG_RegisterMapping("_class_Object","_class_GridLayout",SwigGridLayoutToObject);
	 SWIG_RegisterMapping("_class_Object","_GridLayout",SwigGridLayoutToObject);
	 SWIG_RegisterMapping("_class_Object","_class_BoxLayout",SwigBoxLayoutToObject);
	 SWIG_RegisterMapping("_class_Object","_BoxLayout",SwigBoxLayoutToObject);
	 SWIG_RegisterMapping("_class_Object","_class_Layout",SwigLayoutToObject);
	 SWIG_RegisterMapping("_class_Object","_Layout",SwigLayoutToObject);
	 SWIG_RegisterMapping("_class_Object","_class_Application",SwigApplicationToObject);
	 SWIG_RegisterMapping("_class_Object","_Application",SwigApplicationToObject);
	 SWIG_RegisterMapping("_class_Object","_Object",0);
	 SWIG_RegisterMapping("_Button","_class_RadioButton",SwigRadioButtonToButton);
	 SWIG_RegisterMapping("_Button","_RadioButton",SwigRadioButtonToButton);
	 SWIG_RegisterMapping("_Button","_class_PushButton",SwigPushButtonToButton);
	 SWIG_RegisterMapping("_Button","_PushButton",SwigPushButtonToButton);
	 SWIG_RegisterMapping("_Button","_class_CheckBox",SwigCheckBoxToButton);
	 SWIG_RegisterMapping("_Button","_CheckBox",SwigCheckBoxToButton);
	 SWIG_RegisterMapping("_Button","_class_Button",0);
	 SWIG_RegisterMapping("_class_LineEdit","_LineEdit",0);
	 SWIG_RegisterMapping("_long","_unsigned_long",0);
	 SWIG_RegisterMapping("_long","_signed_long",0);
	 SWIG_RegisterMapping("_QPoint","_class_QPoint",0);
	 SWIG_RegisterMapping("_class_Dialog","_class_TabDialog",SwigTabDialogToDialog);
	 SWIG_RegisterMapping("_class_Dialog","_TabDialog",SwigTabDialogToDialog);
	 SWIG_RegisterMapping("_class_Dialog","_Dialog",0);
	 SWIG_RegisterMapping("_class_GroupBox","_class_ButtonGroup",SwigButtonGroupToGroupBox);
	 SWIG_RegisterMapping("_class_GroupBox","_ButtonGroup",SwigButtonGroupToGroupBox);
	 SWIG_RegisterMapping("_class_GroupBox","_GroupBox",0);
	 SWIG_RegisterMapping("_TableView","_class_MultiLineEdit",SwigMultiLineEditToTableView);
	 SWIG_RegisterMapping("_TableView","_MultiLineEdit",SwigMultiLineEditToTableView);
	 SWIG_RegisterMapping("_TableView","_class_ListBox",SwigListBoxToTableView);
	 SWIG_RegisterMapping("_TableView","_ListBox",SwigListBoxToTableView);
	 SWIG_RegisterMapping("_TableView","_class_TableView",0);
	 SWIG_RegisterMapping("_QPalette","_class_QPalette",0);
	 SWIG_RegisterMapping("_class_QFontInfo","_QFontInfo",0);
	 SWIG_RegisterMapping("_ButtonGroup","_class_ButtonGroup",0);
	 SWIG_RegisterMapping("_class_Label","_Label",0);
	 SWIG_RegisterMapping("_class_MenuData","_MenuData",0);
	 SWIG_RegisterMapping("_Layout","_class_GridLayout",SwigGridLayoutToLayout);
	 SWIG_RegisterMapping("_Layout","_GridLayout",SwigGridLayoutToLayout);
	 SWIG_RegisterMapping("_Layout","_class_BoxLayout",SwigBoxLayoutToLayout);
	 SWIG_RegisterMapping("_Layout","_BoxLayout",SwigBoxLayoutToLayout);
	 SWIG_RegisterMapping("_Layout","_class_Layout",0);
	 SWIG_RegisterMapping("_class_Button","_class_RadioButton",SwigRadioButtonToButton);
	 SWIG_RegisterMapping("_class_Button","_RadioButton",SwigRadioButtonToButton);
	 SWIG_RegisterMapping("_class_Button","_class_PushButton",SwigPushButtonToButton);
	 SWIG_RegisterMapping("_class_Button","_PushButton",SwigPushButtonToButton);
	 SWIG_RegisterMapping("_class_Button","_class_CheckBox",SwigCheckBoxToButton);
	 SWIG_RegisterMapping("_class_Button","_CheckBox",SwigCheckBoxToButton);
	 SWIG_RegisterMapping("_class_Button","_Button",0);
	 SWIG_RegisterMapping("_MultiLineEdit","_class_MultiLineEdit",0);
	 SWIG_RegisterMapping("_QPixmap","_class_QBitmap",SwigQBitmapToQPixmap);
	 SWIG_RegisterMapping("_QPixmap","_QBitmap",SwigQBitmapToQPixmap);
	 SWIG_RegisterMapping("_QPixmap","_class_QPixmap",0);
	 SWIG_RegisterMapping("_class_QPoint","_QPoint",0);
	 SWIG_RegisterMapping("_QMenuBar","_class_QMenuBar",0);
	 SWIG_RegisterMapping("_FileDialog","_class_FileDialog",0);
	 SWIG_RegisterMapping("_class_TableView","_class_MultiLineEdit",SwigMultiLineEditToTableView);
	 SWIG_RegisterMapping("_class_TableView","_MultiLineEdit",SwigMultiLineEditToTableView);
	 SWIG_RegisterMapping("_class_TableView","_class_ListBox",SwigListBoxToTableView);
	 SWIG_RegisterMapping("_class_TableView","_ListBox",SwigListBoxToTableView);
	 SWIG_RegisterMapping("_class_TableView","_TableView",0);
	 SWIG_RegisterMapping("_GridLayout","_class_GridLayout",0);
	 SWIG_RegisterMapping("_class_ComboBox","_ComboBox",0);
	 SWIG_RegisterMapping("_Widget","_class_ScrollBar",SwigScrollBarToWidget);
	 SWIG_RegisterMapping("_Widget","_ScrollBar",SwigScrollBarToWidget);
	 SWIG_RegisterMapping("_Widget","_class_MultiLineEdit",SwigMultiLineEditToWidget);
	 SWIG_RegisterMapping("_Widget","_MultiLineEdit",SwigMultiLineEditToWidget);
	 SWIG_RegisterMapping("_Widget","_class_ListBox",SwigListBoxToWidget);
	 SWIG_RegisterMapping("_Widget","_ListBox",SwigListBoxToWidget);
	 SWIG_RegisterMapping("_Widget","_class_TableView",SwigTableViewToWidget);
	 SWIG_RegisterMapping("_Widget","_TableView",SwigTableViewToWidget);
	 SWIG_RegisterMapping("_Widget","_class_Label",SwigLabelToWidget);
	 SWIG_RegisterMapping("_Widget","_Label",SwigLabelToWidget);
	 SWIG_RegisterMapping("_Widget","_class_ButtonGroup",SwigButtonGroupToWidget);
	 SWIG_RegisterMapping("_Widget","_ButtonGroup",SwigButtonGroupToWidget);
	 SWIG_RegisterMapping("_Widget","_class_GroupBox",SwigGroupBoxToWidget);
	 SWIG_RegisterMapping("_Widget","_GroupBox",SwigGroupBoxToWidget);
	 SWIG_RegisterMapping("_Widget","_class_Frame",SwigFrameToWidget);
	 SWIG_RegisterMapping("_Widget","_Frame",SwigFrameToWidget);
	 SWIG_RegisterMapping("_Widget","_class_LineEdit",SwigLineEditToWidget);
	 SWIG_RegisterMapping("_Widget","_LineEdit",SwigLineEditToWidget);
	 SWIG_RegisterMapping("_Widget","_class_TabDialog",SwigTabDialogToWidget);
	 SWIG_RegisterMapping("_Widget","_TabDialog",SwigTabDialogToWidget);
	 SWIG_RegisterMapping("_Widget","_class_Dialog",SwigDialogToWidget);
	 SWIG_RegisterMapping("_Widget","_Dialog",SwigDialogToWidget);
	 SWIG_RegisterMapping("_Widget","_class_ComboBox",SwigComboBoxToWidget);
	 SWIG_RegisterMapping("_Widget","_ComboBox",SwigComboBoxToWidget);
	 SWIG_RegisterMapping("_Widget","_class_RadioButton",SwigRadioButtonToWidget);
	 SWIG_RegisterMapping("_Widget","_RadioButton",SwigRadioButtonToWidget);
	 SWIG_RegisterMapping("_Widget","_class_PushButton",SwigPushButtonToWidget);
	 SWIG_RegisterMapping("_Widget","_PushButton",SwigPushButtonToWidget);
	 SWIG_RegisterMapping("_Widget","_class_CheckBox",SwigCheckBoxToWidget);
	 SWIG_RegisterMapping("_Widget","_CheckBox",SwigCheckBoxToWidget);
	 SWIG_RegisterMapping("_Widget","_class_Button",SwigButtonToWidget);
	 SWIG_RegisterMapping("_Widget","_Button",SwigButtonToWidget);
	 SWIG_RegisterMapping("_Widget","_class_Widget",0);
	 SWIG_RegisterMapping("_TabDialog","_class_TabDialog",0);
	 SWIG_RegisterMapping("_QRect","_class_QRect",0);
	 SWIG_RegisterMapping("_class_Layout","_class_GridLayout",SwigGridLayoutToLayout);
	 SWIG_RegisterMapping("_class_Layout","_GridLayout",SwigGridLayoutToLayout);
	 SWIG_RegisterMapping("_class_Layout","_class_BoxLayout",SwigBoxLayoutToLayout);
	 SWIG_RegisterMapping("_class_Layout","_BoxLayout",SwigBoxLayoutToLayout);
	 SWIG_RegisterMapping("_class_Layout","_Layout",0);
	 SWIG_RegisterMapping("_class_QSize","_QSize",0);
	 SWIG_RegisterMapping("_class_Frame","_class_MultiLineEdit",SwigMultiLineEditToFrame);
	 SWIG_RegisterMapping("_class_Frame","_MultiLineEdit",SwigMultiLineEditToFrame);
	 SWIG_RegisterMapping("_class_Frame","_class_ListBox",SwigListBoxToFrame);
	 SWIG_RegisterMapping("_class_Frame","_ListBox",SwigListBoxToFrame);
	 SWIG_RegisterMapping("_class_Frame","_class_TableView",SwigTableViewToFrame);
	 SWIG_RegisterMapping("_class_Frame","_TableView",SwigTableViewToFrame);
	 SWIG_RegisterMapping("_class_Frame","_class_Label",SwigLabelToFrame);
	 SWIG_RegisterMapping("_class_Frame","_Label",SwigLabelToFrame);
	 SWIG_RegisterMapping("_class_Frame","_class_ButtonGroup",SwigButtonGroupToFrame);
	 SWIG_RegisterMapping("_class_Frame","_ButtonGroup",SwigButtonGroupToFrame);
	 SWIG_RegisterMapping("_class_Frame","_class_GroupBox",SwigGroupBoxToFrame);
	 SWIG_RegisterMapping("_class_Frame","_GroupBox",SwigGroupBoxToFrame);
	 SWIG_RegisterMapping("_class_Frame","_Frame",0);
	 SWIG_RegisterMapping("_class_QColorGroup","_QColorGroup",0);
	 SWIG_RegisterMapping("_unsigned_long","_long",0);
	 SWIG_RegisterMapping("_PopupMenu","_class_PopupMenu",0);
	 SWIG_RegisterMapping("_CheckBox","_class_CheckBox",0);
	 SWIG_RegisterMapping("_class_Widget","_class_ScrollBar",SwigScrollBarToWidget);
	 SWIG_RegisterMapping("_class_Widget","_ScrollBar",SwigScrollBarToWidget);
	 SWIG_RegisterMapping("_class_Widget","_class_MultiLineEdit",SwigMultiLineEditToWidget);
	 SWIG_RegisterMapping("_class_Widget","_MultiLineEdit",SwigMultiLineEditToWidget);
	 SWIG_RegisterMapping("_class_Widget","_class_ListBox",SwigListBoxToWidget);
	 SWIG_RegisterMapping("_class_Widget","_ListBox",SwigListBoxToWidget);
	 SWIG_RegisterMapping("_class_Widget","_class_TableView",SwigTableViewToWidget);
	 SWIG_RegisterMapping("_class_Widget","_TableView",SwigTableViewToWidget);
	 SWIG_RegisterMapping("_class_Widget","_class_Label",SwigLabelToWidget);
	 SWIG_RegisterMapping("_class_Widget","_Label",SwigLabelToWidget);
	 SWIG_RegisterMapping("_class_Widget","_class_ButtonGroup",SwigButtonGroupToWidget);
	 SWIG_RegisterMapping("_class_Widget","_ButtonGroup",SwigButtonGroupToWidget);
	 SWIG_RegisterMapping("_class_Widget","_class_GroupBox",SwigGroupBoxToWidget);
	 SWIG_RegisterMapping("_class_Widget","_GroupBox",SwigGroupBoxToWidget);
	 SWIG_RegisterMapping("_class_Widget","_class_Frame",SwigFrameToWidget);
	 SWIG_RegisterMapping("_class_Widget","_Frame",SwigFrameToWidget);
	 SWIG_RegisterMapping("_class_Widget","_class_LineEdit",SwigLineEditToWidget);
	 SWIG_RegisterMapping("_class_Widget","_LineEdit",SwigLineEditToWidget);
	 SWIG_RegisterMapping("_class_Widget","_class_TabDialog",SwigTabDialogToWidget);
	 SWIG_RegisterMapping("_class_Widget","_TabDialog",SwigTabDialogToWidget);
	 SWIG_RegisterMapping("_class_Widget","_class_Dialog",SwigDialogToWidget);
	 SWIG_RegisterMapping("_class_Widget","_Dialog",SwigDialogToWidget);
	 SWIG_RegisterMapping("_class_Widget","_class_ComboBox",SwigComboBoxToWidget);
	 SWIG_RegisterMapping("_class_Widget","_ComboBox",SwigComboBoxToWidget);
	 SWIG_RegisterMapping("_class_Widget","_class_RadioButton",SwigRadioButtonToWidget);
	 SWIG_RegisterMapping("_class_Widget","_RadioButton",SwigRadioButtonToWidget);
	 SWIG_RegisterMapping("_class_Widget","_class_PushButton",SwigPushButtonToWidget);
	 SWIG_RegisterMapping("_class_Widget","_PushButton",SwigPushButtonToWidget);
	 SWIG_RegisterMapping("_class_Widget","_class_CheckBox",SwigCheckBoxToWidget);
	 SWIG_RegisterMapping("_class_Widget","_CheckBox",SwigCheckBoxToWidget);
	 SWIG_RegisterMapping("_class_Widget","_class_Button",SwigButtonToWidget);
	 SWIG_RegisterMapping("_class_Widget","_Button",SwigButtonToWidget);
	 SWIG_RegisterMapping("_class_Widget","_Widget",0);
	 SWIG_RegisterMapping("_signed_int","_int",0);
	 SWIG_RegisterMapping("_QColor","_class_QColor",0);
	 SWIG_RegisterMapping("_class_TabDialog","_TabDialog",0);
	 SWIG_RegisterMapping("_class_Application","_Application",0);
	 SWIG_RegisterMapping("_QFont","_class_QFont",0);
	 SWIG_RegisterMapping("_QPaintDevice","_class_QBitmap",SwigQBitmapToQPaintDevice);
	 SWIG_RegisterMapping("_QPaintDevice","_QBitmap",SwigQBitmapToQPaintDevice);
	 SWIG_RegisterMapping("_QPaintDevice","_class_QPixmap",SwigQPixmapToQPaintDevice);
	 SWIG_RegisterMapping("_QPaintDevice","_QPixmap",SwigQPixmapToQPaintDevice);
	 SWIG_RegisterMapping("_QPaintDevice","_class_QPaintDevice",0);
	 SWIG_RegisterMapping("_RadioButton","_class_RadioButton",0);
	 SWIG_RegisterMapping("_LineEdit","_class_LineEdit",0);
	 SWIG_RegisterMapping("_class_MultiLineEdit","_MultiLineEdit",0);
	 SWIG_RegisterMapping("_unsigned_short","_short",0);
	 SWIG_RegisterMapping("_QCursor","_class_QCursor",0);
	 SWIG_RegisterMapping("_class_QPixmap","_class_QBitmap",SwigQBitmapToQPixmap);
	 SWIG_RegisterMapping("_class_QPixmap","_QBitmap",SwigQBitmapToQPixmap);
	 SWIG_RegisterMapping("_class_QPixmap","_QPixmap",0);
	 SWIG_RegisterMapping("_class_FileDialog","_FileDialog",0);
	 SWIG_RegisterMapping("_class_PopupMenu","_PopupMenu",0);
	 SWIG_RegisterMapping("_GroupBox","_class_ButtonGroup",SwigButtonGroupToGroupBox);
	 SWIG_RegisterMapping("_GroupBox","_ButtonGroup",SwigButtonGroupToGroupBox);
	 SWIG_RegisterMapping("_GroupBox","_class_GroupBox",0);
	 SWIG_RegisterMapping("_class_GridLayout","_GridLayout",0);
	 SWIG_RegisterMapping("_signed_short","_short",0);
	 SWIG_RegisterMapping("_PushButton","_class_PushButton",0);
	 SWIG_RegisterMapping("_class_QColor","_QColor",0);
	 SWIG_RegisterMapping("_Label","_class_Label",0);
	 SWIG_RegisterMapping("_MenuData","_class_MenuData",0);
	 SWIG_RegisterMapping("_unsigned_int","_int",0);
	 SWIG_RegisterMapping("_class_QPaintDevice","_class_QBitmap",SwigQBitmapToQPaintDevice);
	 SWIG_RegisterMapping("_class_QPaintDevice","_QBitmap",SwigQBitmapToQPaintDevice);
	 SWIG_RegisterMapping("_class_QPaintDevice","_class_QPixmap",SwigQPixmapToQPaintDevice);
	 SWIG_RegisterMapping("_class_QPaintDevice","_QPixmap",SwigQPixmapToQPaintDevice);
	 SWIG_RegisterMapping("_class_QPaintDevice","_QPaintDevice",0);
	 SWIG_RegisterMapping("_short","_unsigned_short",0);
	 SWIG_RegisterMapping("_short","_signed_short",0);
	 SWIG_RegisterMapping("_BoxLayout","_class_BoxLayout",0);
	 SWIG_RegisterMapping("_int","_unsigned_int",0);
	 SWIG_RegisterMapping("_int","_signed_int",0);
	 SWIG_RegisterMapping("_QFontMetrics","_class_QFontMetrics",0);
	 SWIG_RegisterMapping("_ComboBox","_class_ComboBox",0);
	 SWIG_RegisterMapping("_ListBox","_class_ListBox",0);
	 SWIG_RegisterMapping("_ScrollBar","_class_ScrollBar",0);
	 SWIG_RegisterMapping("_class_QPalette","_QPalette",0);
	 SWIG_RegisterMapping("_class_ButtonGroup","_ButtonGroup",0);
	 SWIG_RegisterMapping("_QBitmap","_class_QBitmap",0);
	 SWIG_RegisterMapping("_class_QCursor","_QCursor",0);
	 SWIG_RegisterMapping("_class_BoxLayout","_BoxLayout",0);
	 SWIG_RegisterMapping("_QSize","_class_QSize",0);
	 SWIG_RegisterMapping("_Frame","_class_MultiLineEdit",SwigMultiLineEditToFrame);
	 SWIG_RegisterMapping("_Frame","_MultiLineEdit",SwigMultiLineEditToFrame);
	 SWIG_RegisterMapping("_Frame","_class_ListBox",SwigListBoxToFrame);
	 SWIG_RegisterMapping("_Frame","_ListBox",SwigListBoxToFrame);
	 SWIG_RegisterMapping("_Frame","_class_TableView",SwigTableViewToFrame);
	 SWIG_RegisterMapping("_Frame","_TableView",SwigTableViewToFrame);
	 SWIG_RegisterMapping("_Frame","_class_Label",SwigLabelToFrame);
	 SWIG_RegisterMapping("_Frame","_Label",SwigLabelToFrame);
	 SWIG_RegisterMapping("_Frame","_class_ButtonGroup",SwigButtonGroupToFrame);
	 SWIG_RegisterMapping("_Frame","_ButtonGroup",SwigButtonGroupToFrame);
	 SWIG_RegisterMapping("_Frame","_class_GroupBox",SwigGroupBoxToFrame);
	 SWIG_RegisterMapping("_Frame","_GroupBox",SwigGroupBoxToFrame);
	 SWIG_RegisterMapping("_Frame","_class_Frame",0);
	 SWIG_RegisterMapping("_QColorGroup","_class_QColorGroup",0);
	 SWIG_RegisterMapping("_class_QMenuBar","_QMenuBar",0);
	 SWIG_RegisterMapping("_class_QFontMetrics","_QFontMetrics",0);
	 SWIG_RegisterMapping("_class_PushButton","_PushButton",0);
	 SWIG_RegisterMapping("_class_ScrollBar","_ScrollBar",0);
	 SWIG_RegisterMapping("_Application","_class_Application",0);
	 SWIG_RegisterMapping("_class_QRect","_QRect",0);
	 SWIG_RegisterMapping("_Object","_class_FileDialog",SwigFileDialogToObject);
	 SWIG_RegisterMapping("_Object","_FileDialog",SwigFileDialogToObject);
	 SWIG_RegisterMapping("_Object","_class_ScrollBar",SwigScrollBarToObject);
	 SWIG_RegisterMapping("_Object","_ScrollBar",SwigScrollBarToObject);
	 SWIG_RegisterMapping("_Object","_class_MultiLineEdit",SwigMultiLineEditToObject);
	 SWIG_RegisterMapping("_Object","_MultiLineEdit",SwigMultiLineEditToObject);
	 SWIG_RegisterMapping("_Object","_class_ListBox",SwigListBoxToObject);
	 SWIG_RegisterMapping("_Object","_ListBox",SwigListBoxToObject);
	 SWIG_RegisterMapping("_Object","_class_TableView",SwigTableViewToObject);
	 SWIG_RegisterMapping("_Object","_TableView",SwigTableViewToObject);
	 SWIG_RegisterMapping("_Object","_class_Label",SwigLabelToObject);
	 SWIG_RegisterMapping("_Object","_Label",SwigLabelToObject);
	 SWIG_RegisterMapping("_Object","_class_ButtonGroup",SwigButtonGroupToObject);
	 SWIG_RegisterMapping("_Object","_ButtonGroup",SwigButtonGroupToObject);
	 SWIG_RegisterMapping("_Object","_class_GroupBox",SwigGroupBoxToObject);
	 SWIG_RegisterMapping("_Object","_GroupBox",SwigGroupBoxToObject);
	 SWIG_RegisterMapping("_Object","_class_Frame",SwigFrameToObject);
	 SWIG_RegisterMapping("_Object","_Frame",SwigFrameToObject);
	 SWIG_RegisterMapping("_Object","_class_LineEdit",SwigLineEditToObject);
	 SWIG_RegisterMapping("_Object","_LineEdit",SwigLineEditToObject);
	 SWIG_RegisterMapping("_Object","_class_TabDialog",SwigTabDialogToObject);
	 SWIG_RegisterMapping("_Object","_TabDialog",SwigTabDialogToObject);
	 SWIG_RegisterMapping("_Object","_class_Dialog",SwigDialogToObject);
	 SWIG_RegisterMapping("_Object","_Dialog",SwigDialogToObject);
	 SWIG_RegisterMapping("_Object","_class_ComboBox",SwigComboBoxToObject);
	 SWIG_RegisterMapping("_Object","_ComboBox",SwigComboBoxToObject);
	 SWIG_RegisterMapping("_Object","_class_RadioButton",SwigRadioButtonToObject);
	 SWIG_RegisterMapping("_Object","_RadioButton",SwigRadioButtonToObject);
	 SWIG_RegisterMapping("_Object","_class_PushButton",SwigPushButtonToObject);
	 SWIG_RegisterMapping("_Object","_PushButton",SwigPushButtonToObject);
	 SWIG_RegisterMapping("_Object","_class_CheckBox",SwigCheckBoxToObject);
	 SWIG_RegisterMapping("_Object","_CheckBox",SwigCheckBoxToObject);
	 SWIG_RegisterMapping("_Object","_class_Button",SwigButtonToObject);
	 SWIG_RegisterMapping("_Object","_Button",SwigButtonToObject);
	 SWIG_RegisterMapping("_Object","_class_Widget",SwigWidgetToObject);
	 SWIG_RegisterMapping("_Object","_Widget",SwigWidgetToObject);
	 SWIG_RegisterMapping("_Object","_class_GridLayout",SwigGridLayoutToObject);
	 SWIG_RegisterMapping("_Object","_GridLayout",SwigGridLayoutToObject);
	 SWIG_RegisterMapping("_Object","_class_BoxLayout",SwigBoxLayoutToObject);
	 SWIG_RegisterMapping("_Object","_BoxLayout",SwigBoxLayoutToObject);
	 SWIG_RegisterMapping("_Object","_class_Layout",SwigLayoutToObject);
	 SWIG_RegisterMapping("_Object","_Layout",SwigLayoutToObject);
	 SWIG_RegisterMapping("_Object","_class_Application",SwigApplicationToObject);
	 SWIG_RegisterMapping("_Object","_Application",SwigApplicationToObject);
	 SWIG_RegisterMapping("_Object","_class_Object",0);
}
